/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/event","vs/base/common/network","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/process","os","vs/platform/environment/common/environment","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/extpath","vs/platform/extensions/common/extensions","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","vs/platform/uriIdentity/common/uriIdentity","vs/server/node/serverEnvironmentService","vs/base/common/codicons","vs/base/common/marshalling","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/base/common/iterator","vs/base/common/stream","vs/base/common/performance","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/base/common/functional","vs/base/common/json","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/base/common/assert","vs/base/common/decorators","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/normalization","vs/base/common/htmlContent","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/telemetry/common/commonProperties","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/extensionGalleryService","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/server/node/extensionHostConnection","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","zlib","vs/server/node/server.main"],we=function(oe){for(var e=[],b=0,t=oe.length;b<t;b++)e[b]=ve[oe[b]];return e};define(ve[132],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class b{static get(){const D=new Map,C=new Map,k=new Map,S=new Map;function p(v,h){v.has(h.detail)||v.set(h.detail,-h.timestamp)}function E(v,h){const I=v.get(h.detail);!I||I>=0||v.set(h.detail,I+h.timestamp)}const T=oe.getStats().slice(0).sort((v,h)=>v.timestamp-h.timestamp);for(const v of T)switch(v.type){case 10:p(D,v);break;case 11:case 12:E(D,v);break;case 21:p(C,v);break;case 22:E(C,v);break;case 33:p(k,v);break;case 34:E(k,v);break;case 31:p(S,v);break;case 32:E(S,v);break}let R=0;k.forEach(v=>R+=v);function w(v){const h=[];return v.forEach((I,y)=>h.push([y,I])),h}return{amdLoad:w(D),amdInvoke:w(C),nodeRequire:w(k),nodeEval:w(S),nodeRequireTotal:R}}static toMarkdownTable(D,C){let k="";const S=[];return D.forEach((p,E)=>{S[E]=p.length}),C.forEach(p=>{p.forEach((E,T)=>{typeof E=="undefined"&&(E=p[T]="-");const R=E.toString().length;S[T]=Math.max(R,S[T])})}),D.forEach((p,E)=>{k+=`| ${p+" ".repeat(S[E]-p.toString().length)} `}),k+=`|
`,D.forEach((p,E)=>{k+=`| ${"-".repeat(S[E])} `}),k+=`|
`,C.forEach(p=>{p.forEach((E,T)=>{typeof E!="undefined"&&(k+=`| ${E+" ".repeat(S[T]-E.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=b}),define(ve[83],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function b(D,C){if(!D)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=b;function t(D,C="Unreachable"){throw new Error(C)}e.assertNever=t}),define(ve[41],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function b(k){return k?k.replace(/\$\((.*?)\)/g,(S,p)=>` ${p} `).trim():""}e.getCodiconAriaLabel=b;class t{constructor(S,p,E){this.id=S,this.definition=p,this.description=E,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(k,S){const p=["codicon","codicon-"+k];return S&&p.push("codicon-modifier-"+S),p}e.getClassNamesArray=D;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function p(R){if(R instanceof t)return["codicon","codicon-"+R.id];const w=S.exec(R.id);if(!w)return p(t.error);const[,v,h]=w,I=["codicon","codicon-"+v];return h&&I.push("codicon-modifier-"+h.substr(1)),I}k.asClassNameArray=p;function E(R){return p(R).join(" ")}k.asClassName=E;function T(R){return"."+p(R).join(".")}k.asCSSSelector=T})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ve[84],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(k){return(S,p,E)=>{let T=null,R=null;if(typeof E.value=="function"?(T="value",R=E.value):typeof E.get=="function"&&(T="get",R=E.get),!R)throw new Error("not supported");E[T]=k(R,p)}}e.createDecorator=b;function t(k,S,p){let E=null,T=null;if(typeof p.value=="function"?(E="value",T=p.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(E="get",T=p.get),!T)throw new Error("not supported");const R=`$memoize$${S}`;p[E]=function(...w){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,w)}),this[R]}}e.memoize=t;function D(k,S,p){return b((E,T)=>{const R=`$debounce$${T}`,w=`$debounce$result$${T}`;return function(...v){this[w]||(this[w]=p?p():void 0),clearTimeout(this[R]),S&&(this[w]=S(this[w],...v),v=[this[w]]),this[R]=setTimeout(()=>{E.apply(this,v),this[w]=p?p():void 0},k)}})}e.debounce=D;function C(k,S,p){return b((E,T)=>{const R=`$throttle$timer$${T}`,w=`$throttle$result$${T}`,v=`$throttle$lastRun$${T}`,h=`$throttle$pending$${T}`;return function(...I){if(this[w]||(this[w]=p?p():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),S&&(this[w]=S(this[w],...I)),this[h])return;const y=this[v]+k;y<=Date.now()?(this[v]=Date.now(),E.apply(this,[this[w]]),this[w]=p?p():void 0):(this[h]=!0,this[R]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),E.apply(this,[this[w]]),this[w]=p?p():void 0},y-Date.now()))}})}e.throttle=C}),define(ve[11],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?c.isErrorNoTelemetry(r)?new c(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=b,e.errorHandler=new b;function t(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=t;function D(f){p(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=D;function C(f){p(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=C;function k(f){if(f instanceof Error){const{name:r,message:o}=f,n=f.stacktrace||f.stack;return{$isError:!0,name:r,message:o,stack:n,noTelemetry:c.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=k;const S="Canceled";function p(f){return f instanceof E?!0:f instanceof Error&&f.name===S&&f.message===S}e.isCancellationError=p;class E extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=E;function T(){const f=new Error(S);return f.name=f.message,f}e.canceled=T;function R(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=R;function w(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=w;function v(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(f){const r=new Error(`${f} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function I(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=I;class y extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=y;class d extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=d;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;class c extends Error{constructor(r){super(r);this.name="CodeExpectedError"}static fromError(r){if(r instanceof c)return r;const o=new c;return o.message=r.message,o.stack=r.stack,o}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class l extends Error{constructor(r){super(r||"An unexpected bug occurred.");Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(ve[18],we([0,1,11]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(W,Z=0){return W[W.length-(1+Z)]}e.tail=t;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function C(W,Z,ie=(z,V)=>z===V){if(W===Z)return!0;if(!W||!Z||W.length!==Z.length)return!1;for(let z=0,V=W.length;z<V;z++)if(!ie(W[z],Z[z]))return!1;return!0}e.equals=C;function k(W,Z){const ie=W.length-1;Z<ie&&(W[Z]=W[ie]),W.pop()}e.removeFastWithoutKeepingOrder=k;function S(W,Z,ie){return p(W.length,z=>ie(W[z],Z))}e.binarySearch=S;function p(W,Z){let ie=0,z=W-1;for(;ie<=z;){const V=(ie+z)/2|0,$=Z(V);if($<0)ie=V+1;else if($>0)z=V-1;else return V}return-(ie+1)}e.binarySearch2=p;function E(W,Z){let ie=0,z=W.length;if(z===0)return 0;for(;ie<z;){const V=Math.floor((ie+z)/2);Z(W[V])?z=V:ie=V+1}return ie}e.findFirstInSorted=E;function T(W,Z,ie){if(W=W|0,W>=Z.length)throw new TypeError("invalid index");const z=Z[Math.floor(Z.length*Math.random())],V=[],$=[],K=[];for(const le of Z){const ge=ie(le,z);ge<0?V.push(le):ge>0?$.push(le):K.push(le)}return W<V.length?T(W,V,ie):W<V.length+K.length?K[0]:T(W-(V.length+K.length),$,ie)}e.quickSelect=T;function R(W,Z){const ie=[];let z;for(const V of W.slice(0).sort(Z))!z||Z(z[0],V)!==0?(z=[V],ie.push(z)):z.push(V);return ie}e.groupBy=R;function w(W,Z,ie){const z=[];function V(le,ge,Pe){if(ge===0&&Pe.length===0)return;const Te=z[z.length-1];Te&&Te.start+Te.deleteCount===le?(Te.deleteCount+=ge,Te.toInsert.push(...Pe)):z.push({start:le,deleteCount:ge,toInsert:Pe})}let $=0,K=0;for(;;){if($===W.length){V($,0,Z.slice(K));break}if(K===Z.length){V($,W.length-$,[]);break}const le=W[$],ge=Z[K],Pe=ie(le,ge);Pe===0?($+=1,K+=1):Pe<0?(V($,1,[]),$+=1):Pe>0&&(V($,0,[ge]),K+=1)}return z}e.sortedDiff=w;function v(W,Z,ie){const z=w(W,Z,ie),V=[],$=[];for(const K of z)V.push(...W.slice(K.start,K.start+K.deleteCount)),$.push(...K.toInsert);return{removed:V,added:$}}e.delta=v;function h(W,Z,ie){if(ie===0)return[];const z=W.slice(0,ie).sort(Z);return y(W,Z,z,ie,W.length),z}e.top=h;function I(W,Z,ie,z,V){return ie===0?Promise.resolve([]):new Promise(($,K)=>{(async()=>{const le=W.length,ge=W.slice(0,ie).sort(Z);for(let Pe=ie,Te=Math.min(ie+z,le);Pe<le;Pe=Te,Te=Math.min(Te+z,le)){if(Pe>ie&&await new Promise(Ne=>setTimeout(Ne)),V&&V.isCancellationRequested)throw new b.CancellationError;y(W,Z,ge,Pe,Te)}return ge})().then($,K)})}e.topAsync=I;function y(W,Z,ie,z,V){for(const $=ie.length;z<V;z++){const K=W[z];if(Z(K,ie[$-1])<0){ie.pop();const le=E(ie,ge=>Z(K,ge)<0);ie.splice(le,0,K)}}}function d(W){return W.filter(Z=>!!Z)}e.coalesce=d;function g(W){let Z=0;for(let ie=0;ie<W.length;ie++)W[ie]&&(W[Z]=W[ie],Z+=1);W.length=Z}e.coalesceInPlace=g;function c(W,Z,ie){W.splice(ie,0,W.splice(Z,1)[0])}e.move=c;function l(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=l;function f(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=f;function r(W,Z=ie=>ie){const ie=new Set;return W.filter(z=>{const V=Z(z);return ie.has(V)?!1:(ie.add(V),!0)})}e.distinct=r;function o(W){const Z=new Set;return ie=>{const z=W(ie);return Z.has(z)?!1:(Z.add(z),!0)}}e.uniqueFilter=o;function n(W,Z){const ie=i(W,Z);if(ie!==-1)return W[ie]}e.findLast=n;function i(W,Z){for(let ie=W.length-1;ie>=0;ie--){const z=W[ie];if(Z(z))return ie}return-1}e.lastIndex=i;function s(W,Z){return W.length>0?W[0]:Z}e.firstOrDefault=s;function a(W,Z){return W.length>0?W[W.length-1]:Z}e.lastOrDefault=a;function u(W,Z,ie=(z,V)=>z===V){let z=0;for(let V=0,$=Math.min(W.length,Z.length);V<$&&ie(W[V],Z[V]);V++)z++;return z}e.commonPrefixLength=u;function m(W){return[].concat(...W)}e.flatten=m;function P(W,Z){let ie=typeof Z=="number"?W:0;typeof Z=="number"?ie=W:(ie=0,Z=W);const z=[];if(ie<=Z)for(let V=ie;V<Z;V++)z.push(V);else for(let V=ie;V>Z;V--)z.push(V);return z}e.range=P;function F(W,Z,ie){return W.reduce((z,V)=>(z[Z(V)]=ie?ie(V):V,z),Object.create(null))}e.index=F;function q(W,Z){return W.push(Z),()=>Y(W,Z)}e.insert=q;function Y(W,Z){const ie=W.indexOf(Z);if(ie>-1)return W.splice(ie,1),Z}e.remove=Y;function se(W,Z,ie){const z=W.slice(0,Z),V=W.slice(Z);return z.concat(ie,V)}e.arrayInsert=se;function _(W,Z){let ie;if(typeof Z=="number"){let z=Z;ie=()=>{const V=Math.sin(z++)*179426549;return V-Math.floor(V)}}else ie=Math.random;for(let z=W.length-1;z>0;z-=1){const V=Math.floor(ie()*(z+1)),$=W[z];W[z]=W[V],W[V]=$}}e.shuffle=_;function G(W,Z){const ie=W.indexOf(Z);ie>-1&&(W.splice(ie,1),W.unshift(Z))}e.pushToStart=G;function te(W,Z){const ie=W.indexOf(Z);ie>-1&&(W.splice(ie,1),W.push(Z))}e.pushToEnd=te;function j(W,Z){for(const ie of Z)W.push(ie)}e.pushMany=j;function he(W,Z){return Array.isArray(W)?W.map(Z):Z(W)}e.mapArrayOrNot=he;function J(W){return Array.isArray(W)?W:[W]}e.asArray=J;function U(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=U;function M(W,Z){for(const ie of W){const z=Z(ie);if(z!==void 0)return z}}e.mapFind=M;function B(W,Z,ie){const z=ae(W,Z),V=W.length,$=ie.length;W.length=V+$;for(let K=V-1;K>=z;K--)W[K+$]=W[K];for(let K=0;K<$;K++)W[K+z]=ie[K]}e.insertInto=B;function Q(W,Z,ie,z){const V=ae(W,Z),$=W.splice(V,ie);return B(W,V,z),$}e.splice=Q;function ae(W,Z){return Z<0?Math.max(Z+W.length,0):Math.min(Z,W.length)}var fe;(function(W){function Z(V){return V<0}W.isLessThan=Z;function ie(V){return V>0}W.isGreaterThan=ie;function z(V){return V===0}W.isNeitherLessOrGreaterThan=z,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(fe=e.CompareResult||(e.CompareResult={}));function X(W,Z){return(ie,z)=>Z(W(ie),W(z))}e.compareBy=X;function re(...W){return(Z,ie)=>{for(const z of W){const V=z(Z,ie);if(!fe.isNeitherLessOrGreaterThan(V))return V}return fe.neitherLessOrGreaterThan}}e.tieBreakComparators=re;const L=(W,Z)=>W-Z;e.numberComparator=L;function O(W,Z){if(W.length===0)return;let ie=W[0];for(let z=1;z<W.length;z++){const V=W[z];Z(V,ie)>0&&(ie=V)}return ie}e.findMaxBy=O;function x(W,Z){if(W.length===0)return;let ie=W[0];for(let z=1;z<W.length;z++){const V=W[z];Z(V,ie)>=0&&(ie=V)}return ie}e.findLastMaxBy=x;function ne(W,Z){return O(W,(ie,z)=>-Z(ie,z))}e.findMinBy=ne;class ue{constructor(Z){this.items=Z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Z){let ie=this.firstIdx;for(;ie<this.items.length&&Z(this.items[ie]);)ie++;const z=ie===this.firstIdx?null:this.items.slice(this.firstIdx,ie);return this.firstIdx=ie,z}takeFromEndWhile(Z){let ie=this.lastIdx;for(;ie>=0&&Z(this.items[ie]);)ie--;const z=ie===this.lastIdx?null:this.items.slice(ie+1,this.lastIdx+1);return this.lastIdx=ie,z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Z=this.items[this.firstIdx];return this.firstIdx++,Z}removeLast(){const Z=this.items[this.lastIdx];return this.lastIdx--,Z}takeCount(Z){const ie=this.items.slice(this.firstIdx,this.firstIdx+Z);return this.firstIdx+=Z,ie}}e.ArrayQueue=ue;class pe{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(ie=>(Z(ie),!0))}toArray(){const Z=[];return this.iterate(ie=>(Z.push(ie),!0)),Z}filter(Z){return new pe(ie=>this.iterate(z=>Z(z)?ie(z):!0))}map(Z){return new pe(ie=>this.iterate(z=>ie(Z(z))))}some(Z){let ie=!1;return this.iterate(z=>(ie=Z(z),!ie)),ie}findFirst(Z){let ie;return this.iterate(z=>Z(z)?(ie=z,!1):!0),ie}findLast(Z){let ie;return this.iterate(z=>(Z(z)&&(ie=z),!0)),ie}findLastMaxBy(Z){let ie,z=!0;return this.iterate(V=>((z||fe.isGreaterThan(Z(V,ie)))&&(z=!1,ie=V),!0)),ie}}e.CallbackIterable=pe,pe.empty=new pe(W=>{})}),define(ve[64],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(t){const D=this;let C=!1,k;return function(){return C||(C=!0,k=t.apply(D,arguments)),k}}e.once=b}),define(ve[45],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(t){function D(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=D;const C=Object.freeze([]);function k(){return C}t.empty=k;function*S(o){yield o}t.single=S;function p(o){return o||C}t.from=p;function E(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=E;function T(o){return o[Symbol.iterator]().next().value}t.first=T;function R(o,n){for(const i of o)if(n(i))return!0;return!1}t.some=R;function w(o,n){for(const i of o)if(n(i))return i}t.find=w;function*v(o,n){for(const i of o)n(i)&&(yield i)}t.filter=v;function*h(o,n){let i=0;for(const s of o)yield n(s,i++)}t.map=h;function*I(...o){for(const n of o)for(const i of n)yield i}t.concat=I;function*y(o){for(const n of o)for(const i of n)yield i}t.concatNested=y;function d(o,n,i){let s=i;for(const a of o)s=n(s,a);return s}t.reduce=d;function g(o,n){let i=0;for(const s of o)n(s,i++)}t.forEach=g;function*c(o,n,i=o.length){for(n<0&&(n+=o.length),i<0?i+=o.length:i>o.length&&(i=o.length);n<i;n++)yield o[n]}t.slice=c;function l(o,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,o];const s=o[Symbol.iterator]();for(let a=0;a<n;a++){const u=s.next();if(u.done)return[i,t.empty()];i.push(u.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=l;function f(o){return l(o)[0]}t.collect=f;function r(o,n,i=(s,a)=>s===a){const s=o[Symbol.iterator](),a=n[Symbol.iterator]();for(;;){const u=s.next(),m=a.next();if(u.done!==m.done)return!1;if(u.done)return!0;if(!i(u.value,m.value))return!1}}t.equals=r})(b=e.Iterable||(e.Iterable={}))}),define(ve[65],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(r){r.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function k(r,o=!1){let n=0;const i=r.length;let s="",a=0,u=16,m=0;function P(te){let j=0,he=0;for(;j<te;){const J=r.charCodeAt(n);if(J>=48&&J<=57)he=he*16+J-48;else if(J>=65&&J<=70)he=he*16+J-65+10;else if(J>=97&&J<=102)he=he*16+J-97+10;else break;n++,j++}return j<te&&(he=-1),he}function F(te){n=te,s="",a=0,u=16,m=0}function q(){const te=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&E(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&E(r.charCodeAt(n)))for(n++;n<r.length&&E(r.charCodeAt(n));)n++;else return m=3,r.substring(te,n);let j=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&E(r.charCodeAt(n))){for(n++;n<r.length&&E(r.charCodeAt(n));)n++;j=n}else m=3;return r.substring(te,j)}function Y(){let te="",j=n;for(;;){if(n>=i){te+=r.substring(j,n),m=2;break}const he=r.charCodeAt(n);if(he===34){te+=r.substring(j,n),n++;break}if(he===92){if(te+=r.substring(j,n),n++,n>=i){m=2;break}switch(r.charCodeAt(n++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const U=P(4);U>=0?te+=String.fromCharCode(U):m=4;break}default:m=5}j=n;continue}if(he>=0&&he<=31)if(p(he)){te+=r.substring(j,n),m=2;break}else m=6;n++}return te}function se(){if(s="",m=0,a=n,n>=i)return a=i,u=17;let te=r.charCodeAt(n);if(S(te)){do n++,s+=String.fromCharCode(te),te=r.charCodeAt(n);while(S(te));return u=15}if(p(te))return n++,s+=String.fromCharCode(te),te===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),u=14;switch(te){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,s=Y(),u=10;case 47:{const j=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<i&&!p(r.charCodeAt(n));)n++;return s=r.substring(j,n),u=12}if(r.charCodeAt(n+1)===42){n+=2;const he=i-1;let J=!1;for(;n<he;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,J=!0;break}n++}return J||(n++,m=1),s=r.substring(j,n),u=13}return s+=String.fromCharCode(te),n++,u=16}case 45:if(s+=String.fromCharCode(te),n++,n===i||!E(r.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=q(),u=11;default:for(;n<i&&_(te);)n++,te=r.charCodeAt(n);if(a!==n){switch(s=r.substring(a,n),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(te),n++,u=16}}function _(te){if(S(te)||p(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let te;do te=se();while(te>=12&&te<=15);return te}return{setPosition:F,getPosition:()=>n,scan:o?G:se,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>m}}e.createScanner=k;function S(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function p(r){return r===10||r===13||r===8232||r===8233}function E(r){return r>=48&&r<=57}var T;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(T||(T={}));function R(r,o){const n=[],i=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function m(P,F,q,Y){a.value=P,a.offset=F,a.length=q,a.type=Y,a.colonOffset=void 0,s=a}try{c(r,{onObjectBegin:(P,F)=>{if(o<=P)throw i;s=void 0,u=o>P,n.push("")},onObjectProperty:(P,F,q)=>{if(o<F||(m(P,F,q,"property"),n[n.length-1]=P,o<=F+q))throw i},onObjectEnd:(P,F)=>{if(o<=P)throw i;s=void 0,n.pop()},onArrayBegin:(P,F)=>{if(o<=P)throw i;s=void 0,n.push(0)},onArrayEnd:(P,F)=>{if(o<=P)throw i;s=void 0,n.pop()},onLiteralValue:(P,F,q)=>{if(o<F||(m(P,F,q,f(P)),o<=F+q))throw i},onSeparator:(P,F,q)=>{if(o<=F)throw i;if(P===":"&&s&&s.type==="property")s.colonOffset=F,u=!1,s=void 0;else if(P===","){const Y=n[n.length-1];typeof Y=="number"?n[n.length-1]=Y+1:(u=!0,n[n.length-1]=""),s=void 0}}})}catch(P){if(P!==i)throw P}return{path:n,previousNode:s,isAtPropertyKey:u,matches:P=>{let F=0;for(let q=0;F<P.length&&q<n.length;q++)if(P[F]===n[q]||P[F]==="*")F++;else if(P[F]!=="**")return!1;return F===P.length}}}e.getLocation=R;function w(r,o=[],n=C.DEFAULT){let i=null,s=[];const a=[];function u(P){Array.isArray(s)?s.push(P):i!==null&&(s[i]=P)}return c(r,{onObjectBegin:()=>{const P={};u(P),a.push(s),s=P,i=null},onObjectProperty:P=>{i=P},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const P=[];u(P),a.push(s),s=P,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:u,onError:(P,F,q)=>{o.push({error:P,offset:F,length:q})}},n),s[0]}e.parse=w;function v(r,o=[],n=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(P){i.type==="property"&&(i.length=P-i.offset,i=i.parent)}function a(P){return i.children.push(P),P}c(r,{onObjectBegin:P=>{i=a({type:"object",offset:P,length:-1,parent:i,children:[]})},onObjectProperty:(P,F,q)=>{i=a({type:"property",offset:F,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:P,offset:F,length:q,parent:i})},onObjectEnd:(P,F)=>{i.length=P+F-i.offset,i=i.parent,s(P+F)},onArrayBegin:(P,F)=>{i=a({type:"array",offset:P,length:-1,parent:i,children:[]})},onArrayEnd:(P,F)=>{i.length=P+F-i.offset,i=i.parent,s(P+F)},onLiteralValue:(P,F,q)=>{a({type:f(P),offset:F,length:q,parent:i,value:P}),s(F+q)},onSeparator:(P,F,q)=>{i.type==="property"&&(P===":"?i.colonOffset=F:P===","&&s(F))},onError:(P,F,q)=>{o.push({error:P,offset:F,length:q})}},n);const m=i.children[0];return m&&delete m.parent,m}e.parseTree=v;function h(r,o){if(!r)return;let n=r;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],s=!0;break}if(!s)return}else{const s=i;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function I(r){if(!r.parent||!r.parent.children)return[];const o=I(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;o.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&o.push(n)}return o}e.getNodePath=I;function y(r){switch(r.type){case"array":return r.children.map(y);case"object":{const o=Object.create(null);for(const n of r.children){const i=n.children[1];i&&(o[n.children[0].value]=y(i))}return o}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=y;function d(r,o,n=!1){return o>=r.offset&&o<r.offset+r.length||n&&o===r.offset+r.length}e.contains=d;function g(r,o,n=!1){if(d(r,o,n)){const i=r.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const a=g(i[s],o,n);if(a)return a}return r}}e.findNodeAtOffset=g;function c(r,o,n=C.DEFAULT){const i=k(r,!1);function s(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(X){return X?re=>X(re,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=s(o.onObjectBegin),m=a(o.onObjectProperty),P=s(o.onObjectEnd),F=s(o.onArrayBegin),q=s(o.onArrayEnd),Y=a(o.onLiteralValue),se=a(o.onSeparator),_=s(o.onComment),G=a(o.onError),te=n&&n.disallowComments,j=n&&n.allowTrailingComma;function he(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:te||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(X){case 12:case 13:te?J(10):_();break;case 16:J(1);break;case 15:case 14:break;default:return X}}}function J(X,re=[],L=[]){if(G(X),re.length+L.length>0){let O=i.getToken();for(;O!==17;){if(re.indexOf(O)!==-1){he();break}else if(L.indexOf(O)!==-1)break;O=he()}}}function U(X){const re=i.getTokenValue();return X?Y(re):m(re),he(),!0}function M(){switch(i.getToken()){case 11:{let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(J(2),X=0)}catch{J(2)}Y(X);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return he(),!0}function B(){return i.getToken()!==10?(J(3,[],[2,5]),!1):(U(!1),i.getToken()===6?(se(":"),he(),fe()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function Q(){u(),he();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||J(4,[],[]),se(","),he(),i.getToken()===2&&j)break}else X&&J(6,[],[]);B()||J(4,[],[2,5]),X=!0}return P(),i.getToken()!==2?J(7,[2],[]):he(),!0}function ae(){F(),he();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||J(4,[],[]),se(","),he(),i.getToken()===4&&j)break}else X&&J(6,[],[]);fe()||J(4,[],[4,5]),X=!0}return q(),i.getToken()!==4?J(8,[4],[]):he(),!0}function fe(){switch(i.getToken()){case 3:return ae();case 1:return Q();case 10:return U(!0);default:return M()}}return he(),i.getToken()===17?n.allowEmptyContent?!0:(J(4,[],[]),!1):fe()?(i.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=c;function l(r,o){const n=k(r),i=[];let s,a=0,u;do switch(u=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:a!==u&&i.push(r.substring(a,u)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(s!==17);return i.join("")}e.stripComments=l;function f(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(ve[133],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new b(()=>D(this.getValue()))}}e.Lazy=b}),define(ve[2],we([0,1,64,45]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function k(a){C=a}if(e.setDisposableTracker=k,D){const a="__is_disposable_tracked__";k(new class{trackDisposable(u){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[a]||console.log(m)},3e3)}setParent(u,m){if(u&&u!==c.None)try{u[a]=!0}catch{}}markAsDisposed(u){if(u&&u!==c.None)try{u[a]=!0}catch{}}markAsSingleton(u){}})}function S(a){return C?.trackDisposable(a),a}function p(a){C?.markAsDisposed(a)}function E(a,u){C?.setParent(a,u)}function T(a,u){if(!!C)for(const m of a)C.setParent(m,u)}function R(a){return C?.markAsSingleton(a),a}e.markAsSingleton=R;class w extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=w;function v(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=v;function h(a){if(t.Iterable.is(a)){const u=[];for(const m of a)if(m)try{m.dispose()}catch(P){u.push(P)}if(u.length===1)throw u[0];if(u.length>1)throw new w(u);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=h;function I(a){for(const u of a)v(u)&&u.dispose();return[]}e.disposeIfDisposable=I;function y(...a){const u=d(()=>h(a));return T(a,u),u}e.combinedDisposable=y;function d(a){const u=S({dispose:(0,b.once)(()=>{p(u),a()})});return u}e.toDisposable=d;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return E(u,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new g,S(this),E(this._store,this)}dispose(){p(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&E(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&E(u,null),u}}e.MutableDisposable=l;class f{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(u){let m=u;return this.unset=()=>m=void 0,this.isset=()=>m!==void 0,this.dispose=()=>{m&&(m(),m=void 0,p(this))},this}}e.SafeDisposable=r;class o{constructor(){this.references=new Map}acquire(u,...m){let P=this.references.get(u);P||(P={counter:0,object:this.createReferencedObject(u,...m)},this.references.set(u,P));const{object:F}=P,q=(0,b.once)(()=>{--P.counter==0&&(this.destroyReferencedObject(u,P.object),this.references.delete(u))});return P.counter++,{object:F,dispose:q}}}e.ReferenceCollection=o;class n{constructor(u){this.referenceCollection=u}async acquire(u,...m){const P=this.referenceCollection.acquire(u,...m);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(F){throw P.dispose(),F}}}e.AsyncReferenceCollection=n;class i{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=i;function s(a){const u=new g;try{a(u)}finally{u.dispose()}}e.disposeOnReturn=s}),define(ve[134],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(C){this.element=C,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class t{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let C=this._first;for(;C!==b.Undefined;){const k=C.next;C.prev=b.Undefined,C.next=b.Undefined,C=k}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,k){const S=new b(C);if(this._first===b.Undefined)this._first=S,this._last=S;else if(k){const E=this._last;this._last=S,S.prev=E,E.next=S}else{const E=this._first;this._first=S,S.next=E,E.prev=S}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(S))}}shift(){if(this._first!==b.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==b.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==b.Undefined&&C.next!==b.Undefined){const k=C.prev;k.next=C.next,C.next.prev=k}else C.prev===b.Undefined&&C.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):C.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):C.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==b.Undefined;)yield C.element,C=C.next}}e.LinkedList=t}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[135],we([1]),e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(W,Z){for(var ie=0;ie<Z.length;ie++){var z=Z[ie];z.enumerable=z.enumerable||!1,z.configurable=!0,"value"in z&&(z.writable=!0),Object.defineProperty(W,z.key,z)}}function b(W,Z,ie){return Z&&e(W.prototype,Z),ie&&e(W,ie),Object.defineProperty(W,"prototype",{writable:!1}),W}function t(W,Z){if(!!W){if(typeof W=="string")return D(W,Z);var ie=Object.prototype.toString.call(W).slice(8,-1);if(ie==="Object"&&W.constructor&&(ie=W.constructor.name),ie==="Map"||ie==="Set")return Array.from(W);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return D(W,Z)}}function D(W,Z){(Z==null||Z>W.length)&&(Z=W.length);for(var ie=0,z=new Array(Z);ie<Z;ie++)z[ie]=W[ie];return z}function C(W,Z){var ie=typeof Symbol!="undefined"&&W[Symbol.iterator]||W["@@iterator"];if(ie)return(ie=ie.call(W)).next.bind(ie);if(Array.isArray(W)||(ie=t(W))||Z&&W&&typeof W.length=="number"){ie&&(W=ie);var z=0;return function(){return z>=W.length?{done:!0}:{done:!1,value:W[z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=k();function S(W){oe.defaults=W}var p=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(Z){return w[Z]};function h(W,Z){if(Z){if(p.test(W))return W.replace(E,v)}else if(T.test(W))return W.replace(R,v);return W}var I=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function y(W){return W.replace(I,function(Z,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var d=/(^|[^\[])\^/g;function g(W,Z){W=typeof W=="string"?W:W.source,Z=Z||"";var ie={replace:function(V,$){return $=$.source||$,$=$.replace(d,"$1"),W=W.replace(V,$),ie},getRegex:function(){return new RegExp(W,Z)}};return ie}var c=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(W,Z,ie){if(W){var z;try{z=decodeURIComponent(y(ie)).replace(c,"").toLowerCase()}catch{return null}if(z.indexOf("javascript:")===0||z.indexOf("vbscript:")===0||z.indexOf("data:")===0)return null}Z&&!l.test(ie)&&(ie=s(Z,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var r={},o=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(W,Z){r[" "+W]||(o.test(W)?r[" "+W]=W+"/":r[" "+W]=P(W,"/",!0)),W=r[" "+W];var ie=W.indexOf(":")===-1;return Z.substring(0,2)==="//"?ie?Z:W.replace(n,"$1")+Z:Z.charAt(0)==="/"?ie?Z:W.replace(i,"$1")+Z:W+Z}var a={exec:function(){}};function u(W){for(var Z=1,ie,z;Z<arguments.length;Z++){ie=arguments[Z];for(z in ie)Object.prototype.hasOwnProperty.call(ie,z)&&(W[z]=ie[z])}return W}function m(W,Z){var ie=W.replace(/\|/g,function($,K,le){for(var ge=!1,Pe=K;--Pe>=0&&le[Pe]==="\\";)ge=!ge;return ge?"|":" |"}),z=ie.split(/ \|/),V=0;if(z[0].trim()||z.shift(),z.length>0&&!z[z.length-1].trim()&&z.pop(),z.length>Z)z.splice(Z);else for(;z.length<Z;)z.push("");for(;V<z.length;V++)z[V]=z[V].trim().replace(/\\\|/g,"|");return z}function P(W,Z,ie){var z=W.length;if(z===0)return"";for(var V=0;V<z;){var $=W.charAt(z-V-1);if($===Z&&!ie)V++;else if($!==Z&&ie)V++;else break}return W.slice(0,z-V)}function F(W,Z){if(W.indexOf(Z[1])===-1)return-1;for(var ie=W.length,z=0,V=0;V<ie;V++)if(W[V]==="\\")V++;else if(W[V]===Z[0])z++;else if(W[V]===Z[1]&&(z--,z<0))return V;return-1}function q(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Y(W,Z){if(Z<1)return"";for(var ie="";Z>1;)Z&1&&(ie+=W),Z>>=1,W+=W;return ie+W}function se(W,Z,ie,z){var V=Z.href,$=Z.title?h(Z.title):null,K=W[1].replace(/\\([\[\]])/g,"$1");if(W[0].charAt(0)!=="!"){z.state.inLink=!0;var le={type:"link",raw:ie,href:V,title:$,text:K,tokens:z.inlineTokens(K,[])};return z.state.inLink=!1,le}return{type:"image",raw:ie,href:V,title:$,text:h(K)}}function _(W,Z){var ie=W.match(/^(\s+)(?:```)/);if(ie===null)return Z;var z=ie[1];return Z.split(`
`).map(function(V){var $=V.match(/^\s+/);if($===null)return V;var K=$[0];return K.length>=z.length?V.slice(z.length):V}).join(`
`)}var G=function(){function W(ie){this.options=ie||oe.defaults}var Z=W.prototype;return Z.space=function(z){var V=this.rules.block.newline.exec(z);if(V&&V[0].length>0)return{type:"space",raw:V[0]}},Z.code=function(z){var V=this.rules.block.code.exec(z);if(V){var $=V[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:V[0],codeBlockStyle:"indented",text:this.options.pedantic?$:P($,`
`)}}},Z.fences=function(z){var V=this.rules.block.fences.exec(z);if(V){var $=V[0],K=_($,V[3]||"");return{type:"code",raw:$,lang:V[2]?V[2].trim():V[2],text:K}}},Z.heading=function(z){var V=this.rules.block.heading.exec(z);if(V){var $=V[2].trim();if(/#$/.test($)){var K=P($,"#");(this.options.pedantic||!K||/ $/.test(K))&&($=K.trim())}var le={type:"heading",raw:V[0],depth:V[1].length,text:$,tokens:[]};return this.lexer.inline(le.text,le.tokens),le}},Z.hr=function(z){var V=this.rules.block.hr.exec(z);if(V)return{type:"hr",raw:V[0]}},Z.blockquote=function(z){var V=this.rules.block.blockquote.exec(z);if(V){var $=V[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:V[0],tokens:this.lexer.blockTokens($,[]),text:$}}},Z.list=function(z){var V=this.rules.block.list.exec(z);if(V){var $,K,le,ge,Pe,Te,Ne,Ue,me,be,ye,Oe,Me=V[1].trim(),Ke=Me.length>1,$e={type:"list",raw:"",ordered:Ke,start:Ke?+Me.slice(0,-1):"",loose:!1,items:[]};Me=Ke?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=Ke?Me:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Me+")((?:[	 ][^\\n]*)?(?:\\n|$))");z&&(Oe=!1,!(!(V=Ze.exec(z))||this.rules.block.hr.test(z)));){if($=V[0],z=z.substring($.length),Ue=V[2].split(`
`,1)[0],me=z.split(`
`,1)[0],this.options.pedantic?(ge=2,ye=Ue.trimLeft()):(ge=V[2].search(/[^ ]/),ge=ge>4?1:ge,ye=Ue.slice(ge),ge+=V[1].length),Te=!1,!Ue&&/^ *$/.test(me)&&($+=me+`
`,z=z.substring(me.length+1),Oe=!0),!Oe)for(var Ge=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),je=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");z&&(be=z.split(`
`,1)[0],Ue=be,this.options.pedantic&&(Ue=Ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ge.test(Ue)||je.test(z)));){if(Ue.search(/[^ ]/)>=ge||!Ue.trim())ye+=`
`+Ue.slice(ge);else if(!Te)ye+=`
`+Ue;else break;!Te&&!Ue.trim()&&(Te=!0),$+=be+`
`,z=z.substring(be.length+1)}$e.loose||(Ne?$e.loose=!0:/\n *\n *$/.test($)&&(Ne=!0)),this.options.gfm&&(K=/^\[[ xX]\] /.exec(ye),K&&(le=K[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),$e.items.push({type:"list_item",raw:$,task:!!K,checked:le,loose:!1,text:ye}),$e.raw+=$}$e.items[$e.items.length-1].raw=$.trimRight(),$e.items[$e.items.length-1].text=ye.trimRight(),$e.raw=$e.raw.trimRight();var We=$e.items.length;for(Pe=0;Pe<We;Pe++){this.lexer.state.top=!1,$e.items[Pe].tokens=this.lexer.blockTokens($e.items[Pe].text,[]);var ce=$e.items[Pe].tokens.filter(function(ke){return ke.type==="space"}),Ce=ce.every(function(ke){for(var Fe=ke.raw.split(""),Re=0,Be=C(Fe),He;!(He=Be()).done;){var Qe=He.value;if(Qe===`
`&&(Re+=1),Re>1)return!0}return!1});!$e.loose&&ce.length&&Ce&&($e.loose=!0,$e.items[Pe].loose=!0)}return $e}},Z.html=function(z){var V=this.rules.block.html.exec(z);if(V){var $={type:"html",raw:V[0],pre:!this.options.sanitizer&&(V[1]==="pre"||V[1]==="script"||V[1]==="style"),text:V[0]};return this.options.sanitize&&($.type="paragraph",$.text=this.options.sanitizer?this.options.sanitizer(V[0]):h(V[0]),$.tokens=[],this.lexer.inline($.text,$.tokens)),$}},Z.def=function(z){var V=this.rules.block.def.exec(z);if(V){V[3]&&(V[3]=V[3].substring(1,V[3].length-1));var $=V[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$,raw:V[0],href:V[2],title:V[3]}}},Z.table=function(z){var V=this.rules.block.table.exec(z);if(V){var $={type:"table",header:m(V[1]).map(function(Ne){return{text:Ne}}),align:V[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:V[3]&&V[3].trim()?V[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($.header.length===$.align.length){$.raw=V[0];var K=$.align.length,le,ge,Pe,Te;for(le=0;le<K;le++)/^ *-+: *$/.test($.align[le])?$.align[le]="right":/^ *:-+: *$/.test($.align[le])?$.align[le]="center":/^ *:-+ *$/.test($.align[le])?$.align[le]="left":$.align[le]=null;for(K=$.rows.length,le=0;le<K;le++)$.rows[le]=m($.rows[le],$.header.length).map(function(Ne){return{text:Ne}});for(K=$.header.length,ge=0;ge<K;ge++)$.header[ge].tokens=[],this.lexer.inline($.header[ge].text,$.header[ge].tokens);for(K=$.rows.length,ge=0;ge<K;ge++)for(Te=$.rows[ge],Pe=0;Pe<Te.length;Pe++)Te[Pe].tokens=[],this.lexer.inline(Te[Pe].text,Te[Pe].tokens);return $}}},Z.lheading=function(z){var V=this.rules.block.lheading.exec(z);if(V){var $={type:"heading",raw:V[0],depth:V[2].charAt(0)==="="?1:2,text:V[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Z.paragraph=function(z){var V=this.rules.block.paragraph.exec(z);if(V){var $={type:"paragraph",raw:V[0],text:V[1].charAt(V[1].length-1)===`
`?V[1].slice(0,-1):V[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Z.text=function(z){var V=this.rules.block.text.exec(z);if(V){var $={type:"text",raw:V[0],text:V[0],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Z.escape=function(z){var V=this.rules.inline.escape.exec(z);if(V)return{type:"escape",raw:V[0],text:h(V[1])}},Z.tag=function(z){var V=this.rules.inline.tag.exec(z);if(V)return!this.lexer.state.inLink&&/^<a /i.test(V[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(V[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(V[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(V[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:V[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(V[0]):h(V[0]):V[0]}},Z.link=function(z){var V=this.rules.inline.link.exec(z);if(V){var $=V[2].trim();if(!this.options.pedantic&&/^</.test($)){if(!/>$/.test($))return;var K=P($.slice(0,-1),"\\");if(($.length-K.length)%2==0)return}else{var le=F(V[2],"()");if(le>-1){var ge=V[0].indexOf("!")===0?5:4,Pe=ge+V[1].length+le;V[2]=V[2].substring(0,le),V[0]=V[0].substring(0,Pe).trim(),V[3]=""}}var Te=V[2],Ne="";if(this.options.pedantic){var Ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Ue&&(Te=Ue[1],Ne=Ue[3])}else Ne=V[3]?V[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test($)?Te=Te.slice(1):Te=Te.slice(1,-1)),se(V,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},V[0],this.lexer)}},Z.reflink=function(z,V){var $;if(($=this.rules.inline.reflink.exec(z))||($=this.rules.inline.nolink.exec(z))){var K=($[2]||$[1]).replace(/\s+/g," ");if(K=V[K.toLowerCase()],!K||!K.href){var le=$[0].charAt(0);return{type:"text",raw:le,text:le}}return se($,K,$[0],this.lexer)}},Z.emStrong=function(z,V,$){$===void 0&&($="");var K=this.rules.inline.emStrong.lDelim.exec(z);if(!!K&&!(K[3]&&$.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=K[1]||K[2]||"";if(!le||le&&($===""||this.rules.inline.punctuation.exec($))){var ge=K[0].length-1,Pe,Te,Ne=ge,Ue=0,me=K[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,V=V.slice(-1*z.length+ge);(K=me.exec(V))!=null;)if(Pe=K[1]||K[2]||K[3]||K[4]||K[5]||K[6],!!Pe){if(Te=Pe.length,K[3]||K[4]){Ne+=Te;continue}else if((K[5]||K[6])&&ge%3&&!((ge+Te)%3)){Ue+=Te;continue}if(Ne-=Te,!(Ne>0)){if(Te=Math.min(Te,Te+Ne+Ue),Math.min(ge,Te)%2){var be=z.slice(1,ge+K.index+Te);return{type:"em",raw:z.slice(0,ge+K.index+Te+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var ye=z.slice(2,ge+K.index+Te-1);return{type:"strong",raw:z.slice(0,ge+K.index+Te+1),text:ye,tokens:this.lexer.inlineTokens(ye,[])}}}}}},Z.codespan=function(z){var V=this.rules.inline.code.exec(z);if(V){var $=V[2].replace(/\n/g," "),K=/[^ ]/.test($),le=/^ /.test($)&&/ $/.test($);return K&&le&&($=$.substring(1,$.length-1)),$=h($,!0),{type:"codespan",raw:V[0],text:$}}},Z.br=function(z){var V=this.rules.inline.br.exec(z);if(V)return{type:"br",raw:V[0]}},Z.del=function(z){var V=this.rules.inline.del.exec(z);if(V)return{type:"del",raw:V[0],text:V[2],tokens:this.lexer.inlineTokens(V[2],[])}},Z.autolink=function(z,V){var $=this.rules.inline.autolink.exec(z);if($){var K,le;return $[2]==="@"?(K=h(this.options.mangle?V($[1]):$[1]),le="mailto:"+K):(K=h($[1]),le=K),{type:"link",raw:$[0],text:K,href:le,tokens:[{type:"text",raw:K,text:K}]}}},Z.url=function(z,V){var $;if($=this.rules.inline.url.exec(z)){var K,le;if($[2]==="@")K=h(this.options.mangle?V($[0]):$[0]),le="mailto:"+K;else{var ge;do ge=$[0],$[0]=this.rules.inline._backpedal.exec($[0])[0];while(ge!==$[0]);K=h($[0]),$[1]==="www."?le="http://"+K:le=K}return{type:"link",raw:$[0],text:K,href:le,tokens:[{type:"text",raw:K,text:K}]}}},Z.inlineText=function(z,V){var $=this.rules.inline.text.exec(z);if($){var K;return this.lexer.state.inRawBlock?K=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($[0]):h($[0]):$[0]:K=h(this.options.smartypants?V($[0]):$[0]),{type:"text",raw:$[0],text:K}}},W}(),te={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};te._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,te._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,te.def=g(te.def).replace("label",te._label).replace("title",te._title).getRegex(),te.bullet=/(?:[*+-]|\d{1,9}[.)])/,te.listItemStart=g(/^( *)(bull) */).replace("bull",te.bullet).getRegex(),te.list=g(te.list).replace(/bull/g,te.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+te.def.source+")").getRegex(),te._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",te._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,te.html=g(te.html,"i").replace("comment",te._comment).replace("tag",te._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),te.paragraph=g(te._paragraph).replace("hr",te.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",te._tag).getRegex(),te.blockquote=g(te.blockquote).replace("paragraph",te.paragraph).getRegex(),te.normal=u({},te),te.gfm=u({},te.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),te.gfm.table=g(te.gfm.table).replace("hr",te.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",te._tag).getRegex(),te.gfm.paragraph=g(te._paragraph).replace("hr",te.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",te.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",te._tag).getRegex(),te.pedantic=u({},te.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",te._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:g(te.normal._paragraph).replace("hr",te.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",te.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=g(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=g(te._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=g(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=g(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=g(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=g(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=g(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=g(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=g(j.reflink).replace("label",j._label).replace("ref",te._label).getRegex(),j.nolink=g(j.nolink).replace("ref",te._label).getRegex(),j.reflinkSearch=g(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=u({},j),j.pedantic=u({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=u({},j.normal,{escape:g(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=g(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=u({},j.gfm,{br:g(j.br).replace("{2,}","*").getRegex(),text:g(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function he(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(W){var Z="",ie,z,V=W.length;for(ie=0;ie<V;ie++)z=W.charCodeAt(ie),Math.random()>.5&&(z="x"+z.toString(16)),Z+="&#"+z+";";return Z}var U=function(){function W(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||oe.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var z={block:te.normal,inline:j.normal};this.options.pedantic?(z.block=te.pedantic,z.inline=j.pedantic):this.options.gfm&&(z.block=te.gfm,this.options.breaks?z.inline=j.breaks:z.inline=j.gfm),this.tokenizer.rules=z}W.lex=function(z,V){var $=new W(V);return $.lex(z)},W.lexInline=function(z,V){var $=new W(V);return $.inlineTokens(z)};var Z=W.prototype;return Z.lex=function(z){z=z.replace(/\r\n|\r/g,`
`),this.blockTokens(z,this.tokens);for(var V;V=this.inlineQueue.shift();)this.inlineTokens(V.src,V.tokens);return this.tokens},Z.blockTokens=function(z,V){var $=this;V===void 0&&(V=[]),this.options.pedantic?z=z.replace(/\t/g,"    ").replace(/^ +$/gm,""):z=z.replace(/^( *)(\t+)/gm,function(Ne,Ue,me){return Ue+"    ".repeat(me.length)});for(var K,le,ge,Pe;z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(K=Ne.call({lexer:$},z,V))?(z=z.substring(K.raw.length),V.push(K),!0):!1}))){if(K=this.tokenizer.space(z)){z=z.substring(K.raw.length),K.raw.length===1&&V.length>0?V[V.length-1].raw+=`
`:V.push(K);continue}if(K=this.tokenizer.code(z)){z=z.substring(K.raw.length),le=V[V.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+K.raw,le.text+=`
`+K.text,this.inlineQueue[this.inlineQueue.length-1].src=le.text):V.push(K);continue}if(K=this.tokenizer.fences(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.heading(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.hr(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.blockquote(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.list(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.html(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.def(z)){z=z.substring(K.raw.length),le=V[V.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+K.raw,le.text+=`
`+K.raw,this.inlineQueue[this.inlineQueue.length-1].src=le.text):this.tokens.links[K.tag]||(this.tokens.links[K.tag]={href:K.href,title:K.title});continue}if(K=this.tokenizer.table(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.lheading(z)){z=z.substring(K.raw.length),V.push(K);continue}if(ge=z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,Ue=z.slice(1),me=void 0;$.options.extensions.startBlock.forEach(function(be){me=be.call({lexer:this},Ue),typeof me=="number"&&me>=0&&(Ne=Math.min(Ne,me))}),Ne<1/0&&Ne>=0&&(ge=z.substring(0,Ne+1))}(),this.state.top&&(K=this.tokenizer.paragraph(ge))){le=V[V.length-1],Pe&&le.type==="paragraph"?(le.raw+=`
`+K.raw,le.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):V.push(K),Pe=ge.length!==z.length,z=z.substring(K.raw.length);continue}if(K=this.tokenizer.text(z)){z=z.substring(K.raw.length),le=V[V.length-1],le&&le.type==="text"?(le.raw+=`
`+K.raw,le.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):V.push(K);continue}if(z){var Te="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,V},Z.inline=function(z,V){this.inlineQueue.push({src:z,tokens:V})},Z.inlineTokens=function(z,V){var $=this;V===void 0&&(V=[]);var K,le,ge,Pe=z,Te,Ne,Ue;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)me.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Te.index)+"["+Y("a",Te[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Te.index)+"["+Y("a",Te[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Te.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;z;)if(Ne||(Ue=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(K=ye.call({lexer:$},z,V))?(z=z.substring(K.raw.length),V.push(K),!0):!1}))){if(K=this.tokenizer.escape(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.tag(z)){z=z.substring(K.raw.length),le=V[V.length-1],le&&K.type==="text"&&le.type==="text"?(le.raw+=K.raw,le.text+=K.text):V.push(K);continue}if(K=this.tokenizer.link(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.reflink(z,this.tokens.links)){z=z.substring(K.raw.length),le=V[V.length-1],le&&K.type==="text"&&le.type==="text"?(le.raw+=K.raw,le.text+=K.text):V.push(K);continue}if(K=this.tokenizer.emStrong(z,Pe,Ue)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.codespan(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.br(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.del(z)){z=z.substring(K.raw.length),V.push(K);continue}if(K=this.tokenizer.autolink(z,J)){z=z.substring(K.raw.length),V.push(K);continue}if(!this.state.inLink&&(K=this.tokenizer.url(z,J))){z=z.substring(K.raw.length),V.push(K);continue}if(ge=z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Oe=z.slice(1),Me=void 0;$.options.extensions.startInline.forEach(function(Ke){Me=Ke.call({lexer:this},Oe),typeof Me=="number"&&Me>=0&&(ye=Math.min(ye,Me))}),ye<1/0&&ye>=0&&(ge=z.substring(0,ye+1))}(),K=this.tokenizer.inlineText(ge,he)){z=z.substring(K.raw.length),K.raw.slice(-1)!=="_"&&(Ue=K.raw.slice(-1)),Ne=!0,le=V[V.length-1],le&&le.type==="text"?(le.raw+=K.raw,le.text+=K.text):V.push(K);continue}if(z){var be="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return V},b(W,null,[{key:"rules",get:function(){return{block:te,inline:j}}}]),W}(),M=function(){function W(ie){this.options=ie||oe.defaults}var Z=W.prototype;return Z.code=function(z,V,$){var K=(V||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(z,K);le!=null&&le!==z&&($=!0,z=le)}return z=z.replace(/\n$/,"")+`
`,K?'<pre><code class="'+this.options.langPrefix+h(K,!0)+'">'+($?z:h(z,!0))+`</code></pre>
`:"<pre><code>"+($?z:h(z,!0))+`</code></pre>
`},Z.blockquote=function(z){return`<blockquote>
`+z+`</blockquote>
`},Z.html=function(z){return z},Z.heading=function(z,V,$,K){if(this.options.headerIds){var le=this.options.headerPrefix+K.slug($);return"<h"+V+' id="'+le+'">'+z+"</h"+V+`>
`}return"<h"+V+">"+z+"</h"+V+`>
`},Z.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Z.list=function(z,V,$){var K=V?"ol":"ul",le=V&&$!==1?' start="'+$+'"':"";return"<"+K+le+`>
`+z+"</"+K+`>
`},Z.listitem=function(z){return"<li>"+z+`</li>
`},Z.checkbox=function(z){return"<input "+(z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Z.paragraph=function(z){return"<p>"+z+`</p>
`},Z.table=function(z,V){return V&&(V="<tbody>"+V+"</tbody>"),`<table>
<thead>
`+z+`</thead>
`+V+`</table>
`},Z.tablerow=function(z){return`<tr>
`+z+`</tr>
`},Z.tablecell=function(z,V){var $=V.header?"th":"td",K=V.align?"<"+$+' align="'+V.align+'">':"<"+$+">";return K+z+("</"+$+`>
`)},Z.strong=function(z){return"<strong>"+z+"</strong>"},Z.em=function(z){return"<em>"+z+"</em>"},Z.codespan=function(z){return"<code>"+z+"</code>"},Z.br=function(){return this.options.xhtml?"<br/>":"<br>"},Z.del=function(z){return"<del>"+z+"</del>"},Z.link=function(z,V,$){if(z=f(this.options.sanitize,this.options.baseUrl,z),z===null)return $;var K='<a href="'+h(z)+'"';return V&&(K+=' title="'+V+'"'),K+=">"+$+"</a>",K},Z.image=function(z,V,$){if(z=f(this.options.sanitize,this.options.baseUrl,z),z===null)return $;var K='<img src="'+z+'" alt="'+$+'"';return V&&(K+=' title="'+V+'"'),K+=this.options.xhtml?"/>":">",K},Z.text=function(z){return z},W}(),B=function(){function W(){}var Z=W.prototype;return Z.strong=function(z){return z},Z.em=function(z){return z},Z.codespan=function(z){return z},Z.del=function(z){return z},Z.html=function(z){return z},Z.text=function(z){return z},Z.link=function(z,V,$){return""+$},Z.image=function(z,V,$){return""+$},Z.br=function(){return""},W}(),Q=function(){function W(){this.seen={}}var Z=W.prototype;return Z.serialize=function(z){return z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Z.getNextSafeSlug=function(z,V){var $=z,K=0;if(this.seen.hasOwnProperty($)){K=this.seen[z];do K++,$=z+"-"+K;while(this.seen.hasOwnProperty($))}return V||(this.seen[z]=K,this.seen[$]=0),$},Z.slug=function(z,V){V===void 0&&(V={});var $=this.serialize(z);return this.getNextSafeSlug($,V.dryrun)},W}(),ae=function(){function W(ie){this.options=ie||oe.defaults,this.options.renderer=this.options.renderer||new M,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new B,this.slugger=new Q}W.parse=function(z,V){var $=new W(V);return $.parse(z)},W.parseInline=function(z,V){var $=new W(V);return $.parseInline(z)};var Z=W.prototype;return Z.parse=function(z,V){V===void 0&&(V=!0);var $="",K,le,ge,Pe,Te,Ne,Ue,me,be,ye,Oe,Me,Ke,$e,Ze,Ge,je,We,ce,Ce=z.length;for(K=0;K<Ce;K++){if(ye=z[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(ce=this.options.extensions.renderers[ye.type].call({parser:this},ye),ce!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){$+=ce||"";continue}switch(ye.type){case"space":continue;case"hr":{$+=this.renderer.hr();continue}case"heading":{$+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,y(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{$+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(me="",Ue="",Pe=ye.header.length,le=0;le<Pe;le++)Ue+=this.renderer.tablecell(this.parseInline(ye.header[le].tokens),{header:!0,align:ye.align[le]});for(me+=this.renderer.tablerow(Ue),be="",Pe=ye.rows.length,le=0;le<Pe;le++){for(Ne=ye.rows[le],Ue="",Te=Ne.length,ge=0;ge<Te;ge++)Ue+=this.renderer.tablecell(this.parseInline(Ne[ge].tokens),{header:!1,align:ye.align[ge]});be+=this.renderer.tablerow(Ue)}$+=this.renderer.table(me,be);continue}case"blockquote":{be=this.parse(ye.tokens),$+=this.renderer.blockquote(be);continue}case"list":{for(Oe=ye.ordered,Me=ye.start,Ke=ye.loose,Pe=ye.items.length,be="",le=0;le<Pe;le++)Ze=ye.items[le],Ge=Ze.checked,je=Ze.task,$e="",Ze.task&&(We=this.renderer.checkbox(Ge),Ke?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=We+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=We+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:We}):$e+=We),$e+=this.parse(Ze.tokens,Ke),be+=this.renderer.listitem($e,je,Ge);$+=this.renderer.list(be,Oe,Me);continue}case"html":{$+=this.renderer.html(ye.text);continue}case"paragraph":{$+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(be=ye.tokens?this.parseInline(ye.tokens):ye.text;K+1<Ce&&z[K+1].type==="text";)ye=z[++K],be+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);$+=V?this.renderer.paragraph(be):be;continue}default:{var ke='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return $},Z.parseInline=function(z,V){V=V||this.renderer;var $="",K,le,ge,Pe=z.length;for(K=0;K<Pe;K++){if(le=z[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(ge=this.options.extensions.renderers[le.type].call({parser:this},le),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(le.type))){$+=ge||"";continue}switch(le.type){case"escape":{$+=V.text(le.text);break}case"html":{$+=V.html(le.text);break}case"link":{$+=V.link(le.href,le.title,this.parseInline(le.tokens,V));break}case"image":{$+=V.image(le.href,le.title,le.text);break}case"strong":{$+=V.strong(this.parseInline(le.tokens,V));break}case"em":{$+=V.em(this.parseInline(le.tokens,V));break}case"codespan":{$+=V.codespan(le.text);break}case"br":{$+=V.br();break}case"del":{$+=V.del(this.parseInline(le.tokens,V));break}case"text":{$+=V.text(le.text);break}default:{var Te='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return $},W}();function fe(W,Z,ie){if(typeof W=="undefined"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof Z=="function"&&(ie=Z,Z=null),Z=u({},fe.defaults,Z||{}),q(Z),ie){var z=Z.highlight,V;try{V=U.lex(W,Z)}catch(ge){return ie(ge)}var $=function(Pe){var Te;if(!Pe)try{Z.walkTokens&&fe.walkTokens(V,Z.walkTokens),Te=ae.parse(V,Z)}catch(Ne){Pe=Ne}return Z.highlight=z,Pe?ie(Pe):ie(null,Te)};if(!z||z.length<3||(delete Z.highlight,!V.length))return $();var K=0;fe.walkTokens(V,function(ge){ge.type==="code"&&(K++,setTimeout(function(){z(ge.text,ge.lang,function(Pe,Te){if(Pe)return $(Pe);Te!=null&&Te!==ge.text&&(ge.text=Te,ge.escaped=!0),K--,K===0&&$()})},0))}),K===0&&$();return}try{var le=U.lex(W,Z);return Z.walkTokens&&fe.walkTokens(le,Z.walkTokens),ae.parse(le,Z)}catch(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+h(ge.message+"",!0)+"</pre>";throw ge}}fe.options=fe.setOptions=function(W){return u(fe.defaults,W),S(fe.defaults),fe},fe.getDefaults=k,fe.defaults=oe.defaults,fe.use=function(){for(var W=arguments.length,Z=new Array(W),ie=0;ie<W;ie++)Z[ie]=arguments[ie];var z=u.apply(void 0,[{}].concat(Z)),V=fe.defaults.extensions||{renderers:{},childTokens:{}},$;Z.forEach(function(K){if(K.extensions&&($=!0,K.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Pe=V.renderers?V.renderers[ge.name]:null;Pe?V.renderers[ge.name]=function(){for(var Te=arguments.length,Ne=new Array(Te),Ue=0;Ue<Te;Ue++)Ne[Ue]=arguments[Ue];var me=ge.renderer.apply(this,Ne);return me===!1&&(me=Pe.apply(this,Ne)),me}:V.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");V[ge.level]?V[ge.level].unshift(ge.tokenizer):V[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?V.startBlock?V.startBlock.push(ge.start):V.startBlock=[ge.start]:ge.level==="inline"&&(V.startInline?V.startInline.push(ge.start):V.startInline=[ge.start]))}ge.childTokens&&(V.childTokens[ge.name]=ge.childTokens)})),K.renderer&&function(){var ge=fe.defaults.renderer||new M,Pe=function(Ue){var me=ge[Ue];ge[Ue]=function(){for(var be=arguments.length,ye=new Array(be),Oe=0;Oe<be;Oe++)ye[Oe]=arguments[Oe];var Me=K.renderer[Ue].apply(ge,ye);return Me===!1&&(Me=me.apply(ge,ye)),Me}};for(var Te in K.renderer)Pe(Te);z.renderer=ge}(),K.tokenizer&&function(){var ge=fe.defaults.tokenizer||new G,Pe=function(Ue){var me=ge[Ue];ge[Ue]=function(){for(var be=arguments.length,ye=new Array(be),Oe=0;Oe<be;Oe++)ye[Oe]=arguments[Oe];var Me=K.tokenizer[Ue].apply(ge,ye);return Me===!1&&(Me=me.apply(ge,ye)),Me}};for(var Te in K.tokenizer)Pe(Te);z.tokenizer=ge}(),K.walkTokens){var le=fe.defaults.walkTokens;z.walkTokens=function(ge){K.walkTokens.call(this,ge),le&&le.call(this,ge)}}$&&(z.extensions=V),fe.setOptions(z)})},fe.walkTokens=function(W,Z){for(var ie=function(){var K=V.value;switch(Z.call(fe,K),K.type){case"table":{for(var le=C(K.header),ge;!(ge=le()).done;){var Pe=ge.value;fe.walkTokens(Pe.tokens,Z)}for(var Te=C(K.rows),Ne;!(Ne=Te()).done;)for(var Ue=Ne.value,me=C(Ue),be;!(be=me()).done;){var ye=be.value;fe.walkTokens(ye.tokens,Z)}break}case"list":{fe.walkTokens(K.items,Z);break}default:fe.defaults.extensions&&fe.defaults.extensions.childTokens&&fe.defaults.extensions.childTokens[K.type]?fe.defaults.extensions.childTokens[K.type].forEach(function(Oe){fe.walkTokens(K[Oe],Z)}):K.tokens&&fe.walkTokens(K.tokens,Z)}},z=C(W),V;!(V=z()).done;)ie()},fe.parseInline=function(W,Z){if(typeof W=="undefined"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");Z=u({},fe.defaults,Z||{}),q(Z);try{var ie=U.lexInline(W,Z);return Z.walkTokens&&fe.walkTokens(ie,Z.walkTokens),ae.parseInline(ie,Z)}catch(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+h(z.message+"",!0)+"</pre>";throw z}},fe.Parser=ae,fe.parser=ae.parse,fe.Renderer=M,fe.TextRenderer=B,fe.Lexer=U,fe.lexer=U.lex,fe.Tokenizer=G,fe.Slugger=Q,fe.parse=fe;var X=fe.options,re=fe.setOptions,L=fe.use,O=fe.walkTokens,x=fe.parseInline,ne=fe,ue=ae.parse,pe=U.lex;oe.Lexer=U,oe.Parser=ae,oe.Renderer=M,oe.Slugger=Q,oe.TextRenderer=B,oe.Tokenizer=G,oe.getDefaults=k,oe.lexer=pe,oe.marked=fe,oe.options=X,oe.parse=ne,oe.parseInline=x,oe.parser=ue,oe.setOptions=re,oe.use=L,oe.walkTokens=O,Object.defineProperty(oe,"__esModule",{value:!0})}),function(){function oe(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function k(p){C.push(p,Date.now())}function S(){const p=[];for(let E=0;E<C.length;E+=2)p.push({name:C[E],startTime:C[E+1]});return p}return{mark:k,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))C.push({name:k.name,startTime:Math.round(D+k.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function b(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=b(t))}(),define(ve[3],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const b="en";let t=!1,D=!1,C=!1,k=!1,S=!1,p=!1,E=!1,T=!1,R=!1,w,v=b,h,I;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?y=e.globals.vscode.process:typeof process!="undefined"&&(y=process);const d=typeof y?.versions?.electron=="string",g=d&&y?.type==="renderer";if(typeof navigator=="object"&&!g){I=navigator.userAgent,t=I.indexOf("Windows")>=0,D=I.indexOf("Macintosh")>=0,T=(I.indexOf("Macintosh")>=0||I.indexOf("iPad")>=0||I.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=I.indexOf("Linux")>=0,p=!0,w=b,v=w;const a=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),u=a&&a.getAttribute("data-settings");if(u)try{const m=JSON.parse(u);w=m.locale,h=m._translationsConfigFile,v=m.availableLanguages["*"]||b}catch{}}else if(typeof y=="object"){t=y.platform==="win32",D=y.platform==="darwin",C=y.platform==="linux",k=C&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,E=d,R=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=b,v=b;const a=y.env.VSCODE_NLS_CONFIG;if(a)try{const u=JSON.parse(a),m=u.availableLanguages["*"];w=u.locale,v=m||b,h=u._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var c;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function l(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let f=0;D?f=1:t?f=3:C&&(f=2),e.isWindows=t,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=k,e.isNative=S,e.isElectron=E,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isCI=R,e.platform=f,e.userAgent=I,e.language=v;var r;(function(a){function u(){return e.language}a.value=u;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=m;function P(){return e.language==="en"}a.isDefault=P})(r=e.Language||(e.Language={})),e.locale=w,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let P=0,F=a.length;P<F;P++){const q=a[P];if(q.id===m.data.vscodeScheduleAsyncWork){a.splice(P,1),q.callback();return}}});let u=0;return m=>{const P=++u;a.push({id:P,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:P},"*")}}return a=>setTimeout(a)})();var o;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||T?2:t?1:3;let n=!0,i=!1;function s(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,n=new Uint16Array(a.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[27],we([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof b.globals.vscode!="undefined"&&typeof b.globals.vscode.process!="undefined"){const D=b.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[6],we([0,1,27]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,C=90,k=122,S=46,p=47,E=92,T=58,R=63;class w extends Error{constructor(l,f,r){let o;typeof f=="string"&&f.indexOf("not ")===0?(o="must not be",f=f.replace(/^not /,"")):o="must be";const n=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${n} ${o} of type ${f}`;i+=`. Received type ${typeof r}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function v(c,l){if(typeof c!="string")throw new w(l,"string",c)}function h(c){return c===p||c===E}function I(c){return c===p}function y(c){return c>=t&&c<=C||c>=D&&c<=k}function d(c,l,f,r){let o="",n=0,i=-1,s=0,a=0;for(let u=0;u<=c.length;++u){if(u<c.length)a=c.charCodeAt(u);else{if(r(a))break;a=p}if(r(a)){if(!(i===u-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==S||o.charCodeAt(o.length-2)!==S){if(o.length>2){const m=o.lastIndexOf(f);m===-1?(o="",n=0):(o=o.slice(0,m),n=o.length-1-o.lastIndexOf(f)),i=u,s=0;continue}else if(o.length!==0){o="",n=0,i=u,s=0;continue}}l&&(o+=o.length>0?`${f}..`:"..",n=2)}else o.length>0?o+=`${f}${c.slice(i+1,u)}`:o=c.slice(i+1,u),n=u-i-1;i=u,s=0}else a===S&&s!==-1?++s:s=-1}return o}function g(c,l){if(l===null||typeof l!="object")throw new w("pathObject","Object",l);const f=l.dir||l.root,r=l.base||`${l.name||""}${l.ext||""}`;return f?f===l.root?`${f}${r}`:`${f}${c}${r}`:r}e.win32={resolve(...c){let l="",f="",r=!1;for(let o=c.length-1;o>=-1;o--){let n;if(o>=0){if(n=c[o],v(n,"path"),n.length===0)continue}else l.length===0?n=b.cwd():(n=b.env[`=${l}`]||b.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==l.toLowerCase()&&n.charCodeAt(2)===E)&&(n=`${l}\\`));const i=n.length;let s=0,a="",u=!1;const m=n.charCodeAt(0);if(i===1)h(m)&&(s=1,u=!0);else if(h(m))if(u=!0,h(n.charCodeAt(1))){let P=2,F=P;for(;P<i&&!h(n.charCodeAt(P));)P++;if(P<i&&P!==F){const q=n.slice(F,P);for(F=P;P<i&&h(n.charCodeAt(P));)P++;if(P<i&&P!==F){for(F=P;P<i&&!h(n.charCodeAt(P));)P++;(P===i||P!==F)&&(a=`\\\\${q}\\${n.slice(F,P)}`,s=P)}}}else s=1;else y(m)&&n.charCodeAt(1)===T&&(a=n.slice(0,2),s=2,i>2&&h(n.charCodeAt(2))&&(u=!0,s=3));if(a.length>0)if(l.length>0){if(a.toLowerCase()!==l.toLowerCase())continue}else l=a;if(r){if(l.length>0)break}else if(f=`${n.slice(s)}\\${f}`,r=u,u&&l.length>0)break}return f=d(f,!r,"\\",h),r?`${l}\\${f}`:`${l}${f}`||"."},normalize(c){v(c,"path");const l=c.length;if(l===0)return".";let f=0,r,o=!1;const n=c.charCodeAt(0);if(l===1)return I(n)?"\\":c;if(h(n))if(o=!0,h(c.charCodeAt(1))){let s=2,a=s;for(;s<l&&!h(c.charCodeAt(s));)s++;if(s<l&&s!==a){const u=c.slice(a,s);for(a=s;s<l&&h(c.charCodeAt(s));)s++;if(s<l&&s!==a){for(a=s;s<l&&!h(c.charCodeAt(s));)s++;if(s===l)return`\\\\${u}\\${c.slice(a)}\\`;s!==a&&(r=`\\\\${u}\\${c.slice(a,s)}`,f=s)}}}else f=1;else y(n)&&c.charCodeAt(1)===T&&(r=c.slice(0,2),f=2,l>2&&h(c.charCodeAt(2))&&(o=!0,f=3));let i=f<l?d(c.slice(f),!o,"\\",h):"";return i.length===0&&!o&&(i="."),i.length>0&&h(c.charCodeAt(l-1))&&(i+="\\"),r===void 0?o?`\\${i}`:i:o?`${r}\\${i}`:`${r}${i}`},isAbsolute(c){v(c,"path");const l=c.length;if(l===0)return!1;const f=c.charCodeAt(0);return h(f)||l>2&&y(f)&&c.charCodeAt(1)===T&&h(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let l,f;for(let n=0;n<c.length;++n){const i=c[n];v(i,"path"),i.length>0&&(l===void 0?l=f=i:l+=`\\${i}`)}if(l===void 0)return".";let r=!0,o=0;if(typeof f=="string"&&h(f.charCodeAt(0))){++o;const n=f.length;n>1&&h(f.charCodeAt(1))&&(++o,n>2&&(h(f.charCodeAt(2))?++o:r=!1))}if(r){for(;o<l.length&&h(l.charCodeAt(o));)o++;o>=2&&(l=`\\${l.slice(o)}`)}return e.win32.normalize(l)},relative(c,l){if(v(c,"from"),v(l,"to"),c===l)return"";const f=e.win32.resolve(c),r=e.win32.resolve(l);if(f===r||(c=f.toLowerCase(),l=r.toLowerCase(),c===l))return"";let o=0;for(;o<c.length&&c.charCodeAt(o)===E;)o++;let n=c.length;for(;n-1>o&&c.charCodeAt(n-1)===E;)n--;const i=n-o;let s=0;for(;s<l.length&&l.charCodeAt(s)===E;)s++;let a=l.length;for(;a-1>s&&l.charCodeAt(a-1)===E;)a--;const u=a-s,m=i<u?i:u;let P=-1,F=0;for(;F<m;F++){const Y=c.charCodeAt(o+F);if(Y!==l.charCodeAt(s+F))break;Y===E&&(P=F)}if(F!==m){if(P===-1)return r}else{if(u>m){if(l.charCodeAt(s+F)===E)return r.slice(s+F+1);if(F===2)return r.slice(s+F)}i>m&&(c.charCodeAt(o+F)===E?P=F:F===2&&(P=3)),P===-1&&(P=0)}let q="";for(F=o+P+1;F<=n;++F)(F===n||c.charCodeAt(F)===E)&&(q+=q.length===0?"..":"\\..");return s+=P,q.length>0?`${q}${r.slice(s,a)}`:(r.charCodeAt(s)===E&&++s,r.slice(s,a))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const l=e.win32.resolve(c);if(l.length<=2)return c;if(l.charCodeAt(0)===E){if(l.charCodeAt(1)===E){const f=l.charCodeAt(2);if(f!==R&&f!==S)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(y(l.charCodeAt(0))&&l.charCodeAt(1)===T&&l.charCodeAt(2)===E)return`\\\\?\\${l}`;return c},dirname(c){v(c,"path");const l=c.length;if(l===0)return".";let f=-1,r=0;const o=c.charCodeAt(0);if(l===1)return h(o)?c:".";if(h(o)){if(f=r=1,h(c.charCodeAt(1))){let s=2,a=s;for(;s<l&&!h(c.charCodeAt(s));)s++;if(s<l&&s!==a){for(a=s;s<l&&h(c.charCodeAt(s));)s++;if(s<l&&s!==a){for(a=s;s<l&&!h(c.charCodeAt(s));)s++;if(s===l)return c;s!==a&&(f=r=s+1)}}}}else y(o)&&c.charCodeAt(1)===T&&(f=l>2&&h(c.charCodeAt(2))?3:2,r=f);let n=-1,i=!0;for(let s=l-1;s>=r;--s)if(h(c.charCodeAt(s))){if(!i){n=s;break}}else i=!1;if(n===-1){if(f===-1)return".";n=f}return c.slice(0,n)},basename(c,l){l!==void 0&&v(l,"ext"),v(c,"path");let f=0,r=-1,o=!0,n;if(c.length>=2&&y(c.charCodeAt(0))&&c.charCodeAt(1)===T&&(f=2),l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let i=l.length-1,s=-1;for(n=c.length-1;n>=f;--n){const a=c.charCodeAt(n);if(h(a)){if(!o){f=n+1;break}}else s===-1&&(o=!1,s=n+1),i>=0&&(a===l.charCodeAt(i)?--i==-1&&(r=n):(i=-1,r=s))}return f===r?r=s:r===-1&&(r=c.length),c.slice(f,r)}for(n=c.length-1;n>=f;--n)if(h(c.charCodeAt(n))){if(!o){f=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":c.slice(f,r)},extname(c){v(c,"path");let l=0,f=-1,r=0,o=-1,n=!0,i=0;c.length>=2&&c.charCodeAt(1)===T&&y(c.charCodeAt(0))&&(l=r=2);for(let s=c.length-1;s>=l;--s){const a=c.charCodeAt(s);if(h(a)){if(!n){r=s+1;break}continue}o===-1&&(n=!1,o=s+1),a===S?f===-1?f=s:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||o===-1||i===0||i===1&&f===o-1&&f===r+1?"":c.slice(f,o)},format:g.bind(null,"\\"),parse(c){v(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const f=c.length;let r=0,o=c.charCodeAt(0);if(f===1)return h(o)?(l.root=l.dir=c,l):(l.base=l.name=c,l);if(h(o)){if(r=1,h(c.charCodeAt(1))){let P=2,F=P;for(;P<f&&!h(c.charCodeAt(P));)P++;if(P<f&&P!==F){for(F=P;P<f&&h(c.charCodeAt(P));)P++;if(P<f&&P!==F){for(F=P;P<f&&!h(c.charCodeAt(P));)P++;P===f?r=P:P!==F&&(r=P+1)}}}}else if(y(o)&&c.charCodeAt(1)===T){if(f<=2)return l.root=l.dir=c,l;if(r=2,h(c.charCodeAt(2))){if(f===3)return l.root=l.dir=c,l;r=3}}r>0&&(l.root=c.slice(0,r));let n=-1,i=r,s=-1,a=!0,u=c.length-1,m=0;for(;u>=r;--u){if(o=c.charCodeAt(u),h(o)){if(!a){i=u+1;break}continue}s===-1&&(a=!1,s=u+1),o===S?n===-1?n=u:m!==1&&(m=1):n!==-1&&(m=-1)}return s!==-1&&(n===-1||m===0||m===1&&n===s-1&&n===i+1?l.base=l.name=c.slice(i,s):(l.name=c.slice(i,n),l.base=c.slice(i,s),l.ext=c.slice(n,s))),i>0&&i!==r?l.dir=c.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let l="",f=!1;for(let r=c.length-1;r>=-1&&!f;r--){const o=r>=0?c[r]:b.cwd();v(o,"path"),o.length!==0&&(l=`${o}/${l}`,f=o.charCodeAt(0)===p)}return l=d(l,!f,"/",I),f?`/${l}`:l.length>0?l:"."},normalize(c){if(v(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===p,f=c.charCodeAt(c.length-1)===p;return c=d(c,!l,"/",I),c.length===0?l?"/":f?"./":".":(f&&(c+="/"),l?`/${c}`:c)},isAbsolute(c){return v(c,"path"),c.length>0&&c.charCodeAt(0)===p},join(...c){if(c.length===0)return".";let l;for(let f=0;f<c.length;++f){const r=c[f];v(r,"path"),r.length>0&&(l===void 0?l=r:l+=`/${r}`)}return l===void 0?".":e.posix.normalize(l)},relative(c,l){if(v(c,"from"),v(l,"to"),c===l||(c=e.posix.resolve(c),l=e.posix.resolve(l),c===l))return"";const f=1,r=c.length,o=r-f,n=1,i=l.length-n,s=o<i?o:i;let a=-1,u=0;for(;u<s;u++){const P=c.charCodeAt(f+u);if(P!==l.charCodeAt(n+u))break;P===p&&(a=u)}if(u===s)if(i>s){if(l.charCodeAt(n+u)===p)return l.slice(n+u+1);if(u===0)return l.slice(n+u)}else o>s&&(c.charCodeAt(f+u)===p?a=u:u===0&&(a=0));let m="";for(u=f+a+1;u<=r;++u)(u===r||c.charCodeAt(u)===p)&&(m+=m.length===0?"..":"/..");return`${m}${l.slice(n+a)}`},toNamespacedPath(c){return c},dirname(c){if(v(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===p;let f=-1,r=!0;for(let o=c.length-1;o>=1;--o)if(c.charCodeAt(o)===p){if(!r){f=o;break}}else r=!1;return f===-1?l?"/":".":l&&f===1?"//":c.slice(0,f)},basename(c,l){l!==void 0&&v(l,"ext"),v(c,"path");let f=0,r=-1,o=!0,n;if(l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let i=l.length-1,s=-1;for(n=c.length-1;n>=0;--n){const a=c.charCodeAt(n);if(a===p){if(!o){f=n+1;break}}else s===-1&&(o=!1,s=n+1),i>=0&&(a===l.charCodeAt(i)?--i==-1&&(r=n):(i=-1,r=s))}return f===r?r=s:r===-1&&(r=c.length),c.slice(f,r)}for(n=c.length-1;n>=0;--n)if(c.charCodeAt(n)===p){if(!o){f=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":c.slice(f,r)},extname(c){v(c,"path");let l=-1,f=0,r=-1,o=!0,n=0;for(let i=c.length-1;i>=0;--i){const s=c.charCodeAt(i);if(s===p){if(!o){f=i+1;break}continue}r===-1&&(o=!1,r=i+1),s===S?l===-1?l=i:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||r===-1||n===0||n===1&&l===r-1&&l===f+1?"":c.slice(l,r)},format:g.bind(null,"/"),parse(c){v(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const f=c.charCodeAt(0)===p;let r;f?(l.root="/",r=1):r=0;let o=-1,n=0,i=-1,s=!0,a=c.length-1,u=0;for(;a>=r;--a){const m=c.charCodeAt(a);if(m===p){if(!s){n=a+1;break}continue}i===-1&&(s=!1,i=a+1),m===S?o===-1?o=a:u!==1&&(u=1):o!==-1&&(u=-1)}if(i!==-1){const m=n===0&&f?1:n;o===-1||u===0||u===1&&o===i-1&&o===n+1?l.base=l.name=c.slice(m,i):(l.name=c.slice(m,o),l.base=c.slice(m,i),l.ext=c.slice(o,i))}return n>0?l.dir=c.slice(0,n-1):f&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[66],we([0,1,6]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(T){const R=(0,b.extname)(T),w=t[R.toLowerCase()];return w!==void 0?w:k(T)}e.getMediaOrTextMime=C;function k(T){const R=(0,b.extname)(T);return D[R.toLowerCase()]}e.getMediaMime=k;function S(T){for(const R in D)if(D[R]===T)return R}e.getExtensionForMimeType=S;const p=/^(.+)\/(.+?)(;.+)?$/;function E(T,R){const w=p.exec(T);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:R?void 0:T}e.normalizeMimeType=E}),define(ve[56],we([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(S,...p){const E=p.reduce((w,v)=>(w[v]=!0,w),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(S).filter(w=>!E[w]).forEach(w=>{for(let v=0;v<T.length;v++)if(w.search(T[v])!==-1){delete S[w];break}})}e.sanitizeProcessEnvironment=C;function k(S){!S||(delete S.DEBUG,b.isMacintosh&&delete S.DYLD_LIBRARY_PATH,b.isLinux&&delete S.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var b=e();for(var t in b)(typeof exports=="object"?exports:oe)[t]=b[t]}}(typeof self!="undefined"?self:this,function(){return function(oe){var e={};function b(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return oe[t].call(D.exports,D,D.exports,b),D.l=!0,D.exports}return b.m=oe,b.c=e,b.d=function(t,D,C){b.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:C})},b.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},b.t=function(t,D){if(1&D&&(t=b(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var C=Object.create(null);if(b.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var k in t)b.d(C,k,function(S){return t[S]}.bind(null,k));return C},b.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return b.d(D,"a",D),D},b.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},b.p="",b(b.s=0)}([function(oe,e,b){(function(t){var D;e=oe.exports=L,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],p=e.src=[],E=0,T=E++;p[T]="0|[1-9]\\d*";var R=E++;p[R]="[0-9]+";var w=E++;p[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=E++;p[v]="("+p[T]+")\\.("+p[T]+")\\.("+p[T]+")";var h=E++;p[h]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var I=E++;p[I]="(?:"+p[T]+"|"+p[w]+")";var y=E++;p[y]="(?:"+p[R]+"|"+p[w]+")";var d=E++;p[d]="(?:-("+p[I]+"(?:\\."+p[I]+")*))";var g=E++;p[g]="(?:-?("+p[y]+"(?:\\."+p[y]+")*))";var c=E++;p[c]="[0-9A-Za-z-]+";var l=E++;p[l]="(?:\\+("+p[c]+"(?:\\."+p[c]+")*))";var f=E++,r="v?"+p[v]+p[d]+"?"+p[l]+"?";p[f]="^"+r+"$";var o="[v=\\s]*"+p[h]+p[g]+"?"+p[l]+"?",n=E++;p[n]="^"+o+"$";var i=E++;p[i]="((?:<|>)?=?)";var s=E++;p[s]=p[R]+"|x|X|\\*";var a=E++;p[a]=p[T]+"|x|X|\\*";var u=E++;p[u]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[d]+")?"+p[l]+"?)?)?";var m=E++;p[m]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[g]+")?"+p[l]+"?)?)?";var P=E++;p[P]="^"+p[i]+"\\s*"+p[u]+"$";var F=E++;p[F]="^"+p[i]+"\\s*"+p[m]+"$";var q=E++;p[q]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=E++;p[Y]="(?:~>?)";var se=E++;p[se]="(\\s*)"+p[Y]+"\\s+",S[se]=new RegExp(p[se],"g");var _=E++;p[_]="^"+p[Y]+p[u]+"$";var G=E++;p[G]="^"+p[Y]+p[m]+"$";var te=E++;p[te]="(?:\\^)";var j=E++;p[j]="(\\s*)"+p[te]+"\\s+",S[j]=new RegExp(p[j],"g");var he=E++;p[he]="^"+p[te]+p[u]+"$";var J=E++;p[J]="^"+p[te]+p[m]+"$";var U=E++;p[U]="^"+p[i]+"\\s*("+o+")$|^$";var M=E++;p[M]="^"+p[i]+"\\s*("+r+")$|^$";var B=E++;p[B]="(\\s*)"+p[i]+"\\s*("+o+"|"+p[u]+")",S[B]=new RegExp(p[B],"g");var Q=E++;p[Q]="^\\s*("+p[u]+")\\s+-\\s+("+p[u]+")\\s*$";var ae=E++;p[ae]="^\\s*("+p[m]+")\\s+-\\s+("+p[m]+")\\s*$";var fe=E++;p[fe]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)D(X,p[X]),S[X]||(S[X]=new RegExp(p[X]));function re(me,be){if(me instanceof L)return me;if(typeof me!="string"||me.length>C||!(be?S[n]:S[f]).test(me))return null;try{return new L(me,be)}catch{return null}}function L(me,be){if(me instanceof L){if(me.loose===be)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof L))return new L(me,be);D("SemVer",me,be),this.loose=be;var ye=me.trim().match(be?S[n]:S[f]);if(!ye)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Me=+Oe;if(Me>=0&&Me<k)return Me}return Oe}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=re,e.valid=function(me,be){var ye=re(me,be);return ye?ye.version:null},e.clean=function(me,be){var ye=re(me.trim().replace(/^[=v]+/,""),be);return ye?ye.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(me){return D("SemVer.compare",this.version,this.loose,me),me instanceof L||(me=new L(me,this.loose)),this.compareMain(me)||this.comparePre(me)},L.prototype.compareMain=function(me){return me instanceof L||(me=new L(me,this.loose)),x(this.major,me.major)||x(this.minor,me.minor)||x(this.patch,me.patch)},L.prototype.comparePre=function(me){if(me instanceof L||(me=new L(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var be=0;do{var ye=this.prerelease[be],Oe=me.prerelease[be];if(D("prerelease compare",be,ye,Oe),ye===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ye===void 0)return-1;if(ye!==Oe)return x(ye,Oe)}while(++be)},L.prototype.inc=function(me,be){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,be,ye,Oe){typeof ye=="string"&&(Oe=ye,ye=void 0);try{return new L(me,ye).inc(be,Oe).version}catch{return null}},e.diff=function(me,be){if(W(me,be))return null;var ye=re(me),Oe=re(be);if(ye.prerelease.length||Oe.prerelease.length){for(var Me in ye)if((Me==="major"||Me==="minor"||Me==="patch")&&ye[Me]!==Oe[Me])return"pre"+Me;return"prerelease"}for(var Me in ye)if((Me==="major"||Me==="minor"||Me==="patch")&&ye[Me]!==Oe[Me])return Me},e.compareIdentifiers=x;var O=/^[0-9]+$/;function x(me,be){var ye=O.test(me),Oe=O.test(be);return ye&&Oe&&(me=+me,be=+be),ye&&!Oe?-1:Oe&&!ye?1:me<be?-1:me>be?1:0}function ne(me,be,ye){return new L(me,ye).compare(new L(be,ye))}function ue(me,be,ye){return ne(me,be,ye)>0}function pe(me,be,ye){return ne(me,be,ye)<0}function W(me,be,ye){return ne(me,be,ye)===0}function Z(me,be,ye){return ne(me,be,ye)!==0}function ie(me,be,ye){return ne(me,be,ye)>=0}function z(me,be,ye){return ne(me,be,ye)<=0}function V(me,be,ye,Oe){var Me;switch(be){case"===":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),Me=me===ye;break;case"!==":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),Me=me!==ye;break;case"":case"=":case"==":Me=W(me,ye,Oe);break;case"!=":Me=Z(me,ye,Oe);break;case">":Me=ue(me,ye,Oe);break;case">=":Me=ie(me,ye,Oe);break;case"<":Me=pe(me,ye,Oe);break;case"<=":Me=z(me,ye,Oe);break;default:throw new TypeError("Invalid operator: "+be)}return Me}function $(me,be){if(me instanceof $){if(me.loose===be)return me;me=me.value}if(!(this instanceof $))return new $(me,be);D("comparator",me,be),this.loose=be,this.parse(me),this.semver===K?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(me,be){return x(be,me)},e.major=function(me,be){return new L(me,be).major},e.minor=function(me,be){return new L(me,be).minor},e.patch=function(me,be){return new L(me,be).patch},e.compare=ne,e.compareLoose=function(me,be){return ne(me,be,!0)},e.rcompare=function(me,be,ye){return ne(be,me,ye)},e.sort=function(me,be){return me.sort(function(ye,Oe){return e.compare(ye,Oe,be)})},e.rsort=function(me,be){return me.sort(function(ye,Oe){return e.rcompare(ye,Oe,be)})},e.gt=ue,e.lt=pe,e.eq=W,e.neq=Z,e.gte=ie,e.lte=z,e.cmp=V,e.Comparator=$;var K={};function le(me,be){if(me instanceof le)return me.loose===be?me:new le(me.raw,be);if(me instanceof $)return new le(me.value,be);if(!(this instanceof le))return new le(me,be);if(this.loose=be,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function ge(me){return!me||me.toLowerCase()==="x"||me==="*"}function Pe(me,be,ye,Oe,Me,Ke,$e,Ze,Ge,je,We,ce,Ce){return((be=ge(ye)?"":ge(Oe)?">="+ye+".0.0":ge(Me)?">="+ye+"."+Oe+".0":">="+be)+" "+(Ze=ge(Ge)?"":ge(je)?"<"+(+Ge+1)+".0.0":ge(We)?"<"+Ge+"."+(+je+1)+".0":ce?"<="+Ge+"."+je+"."+We+"-"+ce:"<="+Ze)).trim()}function Te(me,be){for(var ye=0;ye<me.length;ye++)if(!me[ye].test(be))return!1;if(be.prerelease.length){for(ye=0;ye<me.length;ye++)if(D(me[ye].semver),me[ye].semver!==K&&me[ye].semver.prerelease.length>0){var Oe=me[ye].semver;if(Oe.major===be.major&&Oe.minor===be.minor&&Oe.patch===be.patch)return!0}return!1}return!0}function Ne(me,be,ye){try{be=new le(be,ye)}catch{return!1}return be.test(me)}function Ue(me,be,ye,Oe){var Me,Ke,$e,Ze,Ge;switch(me=new L(me,Oe),be=new le(be,Oe),ye){case">":Me=ue,Ke=z,$e=pe,Ze=">",Ge=">=";break;case"<":Me=pe,Ke=ie,$e=ue,Ze="<",Ge="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(me,be,Oe))return!1;for(var je=0;je<be.set.length;++je){var We=be.set[je],ce=null,Ce=null;if(We.forEach(function(ke){ke.semver===K&&(ke=new $(">=0.0.0")),ce=ce||ke,Ce=Ce||ke,Me(ke.semver,ce.semver,Oe)?ce=ke:$e(ke.semver,Ce.semver,Oe)&&(Ce=ke)}),ce.operator===Ze||ce.operator===Ge||(!Ce.operator||Ce.operator===Ze)&&Ke(me,Ce.semver)||Ce.operator===Ge&&$e(me,Ce.semver))return!1}return!0}$.prototype.parse=function(me){var be=this.loose?S[U]:S[M],ye=me.match(be);if(!ye)throw new TypeError("Invalid comparator: "+me);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new L(ye[2],this.loose):this.semver=K},$.prototype.toString=function(){return this.value},$.prototype.test=function(me){return D("Comparator.test",me,this.loose),this.semver===K||(typeof me=="string"&&(me=new L(me,this.loose)),V(me,this.operator,this.semver,this.loose))},$.prototype.intersects=function(me,be){if(!(me instanceof $))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new le(me.value,be),Ne(this.value,ye,be);if(me.operator==="")return ye=new le(this.value,be),Ne(me.semver,ye,be);var Oe=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Ke=this.semver.version===me.semver.version,$e=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ze=V(this.semver,"<",me.semver,be)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Ge=V(this.semver,">",me.semver,be)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Oe||Me||Ke&&$e||Ze||Ge},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(me){var be=this.loose;me=me.trim(),D("range",me,be);var ye=be?S[ae]:S[Q];me=me.replace(ye,Pe),D("hyphen replace",me),me=me.replace(S[B],"$1$2$3"),D("comparator trim",me,S[B]),me=(me=(me=me.replace(S[se],"$1~")).replace(S[j],"$1^")).split(/\s+/).join(" ");var Oe=be?S[U]:S[M],Me=me.split(" ").map(function(Ke){return function($e,Ze){return D("comp",$e),$e=function(Ge,je){return Ge.trim().split(/\s+/).map(function(We){return function(ce,Ce){D("caret",ce,Ce);var ke=Ce?S[J]:S[he];return ce.replace(ke,function(Fe,Re,Be,He,Qe){var Xe;return D("caret",ce,Fe,Re,Be,He,Qe),ge(Re)?Xe="":ge(Be)?Xe=">="+Re+".0.0 <"+(+Re+1)+".0.0":ge(He)?Xe=Re==="0"?">="+Re+"."+Be+".0 <"+Re+"."+(+Be+1)+".0":">="+Re+"."+Be+".0 <"+(+Re+1)+".0.0":Qe?(D("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Xe=Re==="0"?Be==="0"?">="+Re+"."+Be+"."+He+Qe+" <"+Re+"."+Be+"."+(+He+1):">="+Re+"."+Be+"."+He+Qe+" <"+Re+"."+(+Be+1)+".0":">="+Re+"."+Be+"."+He+Qe+" <"+(+Re+1)+".0.0"):(D("no pr"),Xe=Re==="0"?Be==="0"?">="+Re+"."+Be+"."+He+" <"+Re+"."+Be+"."+(+He+1):">="+Re+"."+Be+"."+He+" <"+Re+"."+(+Be+1)+".0":">="+Re+"."+Be+"."+He+" <"+(+Re+1)+".0.0"),D("caret return",Xe),Xe})}(We,je)}).join(" ")}($e,Ze),D("caret",$e),$e=function(Ge,je){return Ge.trim().split(/\s+/).map(function(We){return function(ce,Ce){var ke=Ce?S[G]:S[_];return ce.replace(ke,function(Fe,Re,Be,He,Qe){var Xe;return D("tilde",ce,Fe,Re,Be,He,Qe),ge(Re)?Xe="":ge(Be)?Xe=">="+Re+".0.0 <"+(+Re+1)+".0.0":ge(He)?Xe=">="+Re+"."+Be+".0 <"+Re+"."+(+Be+1)+".0":Qe?(D("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Xe=">="+Re+"."+Be+"."+He+Qe+" <"+Re+"."+(+Be+1)+".0"):Xe=">="+Re+"."+Be+"."+He+" <"+Re+"."+(+Be+1)+".0",D("tilde return",Xe),Xe})}(We,je)}).join(" ")}($e,Ze),D("tildes",$e),$e=function(Ge,je){return D("replaceXRanges",Ge,je),Ge.split(/\s+/).map(function(We){return function(ce,Ce){ce=ce.trim();var ke=Ce?S[F]:S[P];return ce.replace(ke,function(Fe,Re,Be,He,Qe,Xe){D("xRange",ce,Fe,Re,Be,He,Qe,Xe);var tt=ge(Be),it=tt||ge(He),rt=it||ge(Qe);return Re==="="&&rt&&(Re=""),tt?Fe=Re===">"||Re==="<"?"<0.0.0":"*":Re&&rt?(it&&(He=0),rt&&(Qe=0),Re===">"?(Re=">=",it?(Be=+Be+1,He=0,Qe=0):rt&&(He=+He+1,Qe=0)):Re==="<="&&(Re="<",it?Be=+Be+1:He=+He+1),Fe=Re+Be+"."+He+"."+Qe):it?Fe=">="+Be+".0.0 <"+(+Be+1)+".0.0":rt&&(Fe=">="+Be+"."+He+".0 <"+Be+"."+(+He+1)+".0"),D("xRange return",Fe),Fe})}(We,je)}).join(" ")}($e,Ze),D("xrange",$e),$e=function(Ge,je){return D("replaceStars",Ge,je),Ge.trim().replace(S[fe],"")}($e,Ze),D("stars",$e),$e}(Ke,be)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Ke){return!!Ke.match(Oe)})),Me=Me.map(function(Ke){return new $(Ke,be)})},le.prototype.intersects=function(me,be){if(!(me instanceof le))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Oe){return me.set.some(function(Me){return Me.every(function(Ke){return Oe.intersects(Ke,be)})})})})},e.toComparators=function(me,be){return new le(me,be).set.map(function(ye){return ye.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},le.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new L(me,this.loose));for(var be=0;be<this.set.length;be++)if(Te(this.set[be],me))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(me,be,ye){var Oe=null,Me=null;try{var Ke=new le(be,ye)}catch{return null}return me.forEach(function($e){Ke.test($e)&&(Oe&&Me.compare($e)!==-1||(Me=new L(Oe=$e,ye)))}),Oe},e.minSatisfying=function(me,be,ye){var Oe=null,Me=null;try{var Ke=new le(be,ye)}catch{return null}return me.forEach(function($e){Ke.test($e)&&(Oe&&Me.compare($e)!==1||(Me=new L(Oe=$e,ye)))}),Oe},e.validRange=function(me,be){try{return new le(me,be).range||"*"}catch{return null}},e.ltr=function(me,be,ye){return Ue(me,be,"<",ye)},e.gtr=function(me,be,ye){return Ue(me,be,">",ye)},e.outside=Ue,e.prerelease=function(me,be){var ye=re(me,be);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(me,be,ye){return me=new le(me,ye),be=new le(be,ye),me.intersects(be)},e.coerce=function(me){if(me instanceof L)return me;if(typeof me!="string")return null;var be=me.match(S[q]);return be==null?null:re((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,b(1))},function(oe,e){var b,t,D=oe.exports={};function C(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function S(y){if(b===setTimeout)return setTimeout(y,0);if((b===C||!b)&&setTimeout)return b=setTimeout,setTimeout(y,0);try{return b(y,0)}catch{try{return b.call(null,y,0)}catch{return b.call(this,y,0)}}}(function(){try{b=typeof setTimeout=="function"?setTimeout:C}catch{b=C}try{t=typeof clearTimeout=="function"?clearTimeout:k}catch{t=k}})();var p,E=[],T=!1,R=-1;function w(){T&&p&&(T=!1,p.length?E=p.concat(E):R=-1,E.length&&v())}function v(){if(!T){var y=S(w);T=!0;for(var d=E.length;d;){for(p=E,E=[];++R<d;)p&&p[R].run();R=-1,d=E.length}p=null,T=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===k||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(y)}}function h(y,d){this.fun=y,this.array=d}function I(){}D.nextTick=function(y){var d=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)d[g-1]=arguments[g];E.push(new h(y,d)),E.length!==1||T||S(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=I,D.addListener=I,D.once=I,D.off=I,D.removeListener=I,D.removeAllListeners=I,D.emit=I,D.prependListener=I,D.prependOnceListener=I,D.listeners=function(y){return[]},D.binding=function(y){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(y){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ve[136],we([0,1]),function(oe,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(S,p,E){this.level=S,this.key=p,this.value=E,this.forward=[]}}const D=void 0;class C{constructor(S,p=2**16){this.comparator=S,this[b]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new t(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,D,D)}has(S){return Boolean(C._search(this,S,this.comparator))}get(S){return C._search(this,S,this.comparator)?.value}set(S,p){return C._insert(this,S,p,this.comparator)&&(this._size+=1),this}delete(S){const p=C._delete(this,S,this.comparator);return p&&(this._size-=1),p}forEach(S,p){let E=this._header.forward[0];for(;E;)S.call(p,E.value,E.key,this),E=E.forward[0]}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",p=this._header.forward[0];for(;p;)S+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return S}static _search(S,p,E){let T=S._header;for(let R=S._level-1;R>=0;R--)for(;T.forward[R]&&E(T.forward[R].key,p)<0;)T=T.forward[R];if(T=T.forward[0],T&&E(T.key,p)===0)return T}static _insert(S,p,E,T){const R=[];let w=S._header;for(let v=S._level-1;v>=0;v--){for(;w.forward[v]&&T(w.forward[v].key,p)<0;)w=w.forward[v];R[v]=w}if(w=w.forward[0],w&&T(w.key,p)===0)return w.value=E,!1;{const v=C._randomLevel(S);if(v>S._level){for(let h=S._level;h<v;h++)R[h]=S._header;S._level=v}w=new t(v,p,E);for(let h=0;h<v;h++)w.forward[h]=R[h].forward[h],R[h].forward[h]=w;return!0}}static _randomLevel(S,p=.5){let E=1;for(;Math.random()<p&&E<S._maxLevel;)E+=1;return E}static _delete(S,p,E){const T=[];let R=S._header;for(let w=S._level-1;w>=0;w--){for(;R.forward[w]&&E(R.forward[w].key,p)<0;)R=R.forward[w];T[w]=R}if(R=R.forward[0],!R||E(R.key,p)!==0)return!1;for(let w=0;w<S._level&&T[w].forward[w]===R;w++)T[w].forward[w]=R.forward[w];for(;S._level>0&&S._header.forward[S._level-1]===D;)S._level-=1;return!0}}e.SkipList=C}),define(ve[137],we([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=b.globals.performance&&typeof b.globals.performance.now=="function";class D{constructor(k){this._highResolution=t&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ve[7],we([0,1,11,64,2,134,137]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const S=!1,p=!1;var E;(function(a){a.None=()=>D.Disposable.None;function u(O){if(p){const{onListenerDidAdd:x}=O,ne=h.create();let ue=0;O.onListenerDidAdd=()=>{++ue==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ne.print()),x?.()}}}function m(O){return(x,ne=null,ue)=>{let pe=!1,W;return W=O(Z=>{if(!pe)return W?W.dispose():pe=!0,x.call(ne,Z)},null,ue),pe&&W.dispose(),W}}a.once=m;function P(O,x,ne){return G((ue,pe=null,W)=>O(Z=>ue.call(pe,x(Z)),null,W),ne)}a.map=P;function F(O,x,ne){return G((ue,pe=null,W)=>O(Z=>{x(Z),ue.call(pe,Z)},null,W),ne)}a.forEach=F;function q(O,x,ne){return G((ue,pe=null,W)=>O(Z=>x(Z)&&ue.call(pe,Z),null,W),ne)}a.filter=q;function Y(O){return O}a.signal=Y;function se(...O){return(x,ne=null,ue)=>(0,D.combinedDisposable)(...O.map(pe=>pe(W=>x.call(ne,W),null,ue)))}a.any=se;function _(O,x,ne,ue){let pe=ne;return P(O,W=>(pe=x(pe,W),pe),ue)}a.reduce=_;function G(O,x){let ne;const ue={onFirstListenerAdd(){ne=O(pe.fire,pe)},onLastListenerRemove(){ne?.dispose()}};x||u(ue);const pe=new y(ue);return x?.add(pe),pe.event}function te(O,x,ne=100,ue=!1,pe,W){let Z,ie,z,V=0;const $={leakWarningThreshold:pe,onFirstListenerAdd(){Z=O(le=>{V++,ie=x(ie,le),ue&&!z&&(K.fire(ie),ie=void 0),clearTimeout(z),z=setTimeout(()=>{const ge=ie;ie=void 0,z=void 0,(!ue||V>1)&&K.fire(ge),V=0},ne)})},onLastListenerRemove(){Z.dispose()}};W||u($);const K=new y($);return W?.add(K),K.event}a.debounce=te;function j(O,x=(ue,pe)=>ue===pe,ne){let ue=!0,pe;return q(O,W=>{const Z=ue||!x(W,pe);return ue=!1,pe=W,Z},ne)}a.latch=j;function he(O,x,ne){return[a.filter(O,x,ne),a.filter(O,ue=>!x(ue),ne)]}a.split=he;function J(O,x=!1,ne=[]){let ue=ne.slice(),pe=O(ie=>{ue?ue.push(ie):Z.fire(ie)});const W=()=>{ue?.forEach(ie=>Z.fire(ie)),ue=null},Z=new y({onFirstListenerAdd(){pe||(pe=O(ie=>Z.fire(ie)))},onFirstListenerDidAdd(){ue&&(x?setTimeout(W):W())},onLastListenerRemove(){pe&&pe.dispose(),pe=null}});return Z.event}a.buffer=J;class U{constructor(x){this.event=x,this.disposables=new D.DisposableStore}map(x){return new U(P(this.event,x,this.disposables))}forEach(x){return new U(F(this.event,x,this.disposables))}filter(x){return new U(q(this.event,x,this.disposables))}reduce(x,ne){return new U(_(this.event,x,ne,this.disposables))}latch(){return new U(j(this.event,void 0,this.disposables))}debounce(x,ne=100,ue=!1,pe){return new U(te(this.event,x,ne,ue,pe,this.disposables))}on(x,ne,ue){return this.event(x,ne,ue)}once(x,ne,ue){return m(this.event)(x,ne,ue)}dispose(){this.disposables.dispose()}}function M(O){return new U(O)}a.chain=M;function B(O,x,ne=ue=>ue){const ue=(...ie)=>Z.fire(ne(...ie)),pe=()=>O.on(x,ue),W=()=>O.removeListener(x,ue),Z=new y({onFirstListenerAdd:pe,onLastListenerRemove:W});return Z.event}a.fromNodeEventEmitter=B;function Q(O,x,ne=ue=>ue){const ue=(...ie)=>Z.fire(ne(...ie)),pe=()=>O.addEventListener(x,ue),W=()=>O.removeEventListener(x,ue),Z=new y({onFirstListenerAdd:pe,onLastListenerRemove:W});return Z.event}a.fromDOMEventEmitter=Q;function ae(O){return new Promise(x=>m(O)(x))}a.toPromise=ae;function fe(O,x){return x(void 0),O(ne=>x(ne))}a.runAndSubscribe=fe;function X(O,x){let ne=null;function ue(W){ne?.dispose(),ne=new D.DisposableStore,x(W,ne)}ue(void 0);const pe=O(W=>ue(W));return(0,D.toDisposable)(()=>{pe.dispose(),ne?.dispose()})}a.runAndSubscribeWithStore=X;class re{constructor(x,ne){this.obs=x,this._counter=0,this._hasChanged=!1;const ue={onFirstListenerAdd:()=>{x.addObserver(this)},onLastListenerRemove:()=>{x.removeObserver(this)}};ne||u(ue),this.emitter=new y(ue),ne&&ne.add(this.emitter)}beginUpdate(x){this._counter++}handleChange(x,ne){this._hasChanged=!0}endUpdate(x){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,x){return new re(O,x).emitter.event}a.fromObservable=L})(E=e.Event||(e.Event={}));class T{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${T._idPool++}`}start(u){this._stopWatch=new k.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}T._idPool=0;let R=-1;function w(a){const u=R;return R=a,{dispose(){R=u}}}e.setGlobalLeakWarningThreshold=w;class v{constructor(u,m=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,m){let P=R;if(typeof this.customThreshold=="number"&&(P=this.customThreshold),P<=0||m<P)return;this._stacks||(this._stacks=new Map);const F=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,F+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let q,Y=0;for(const[se,_]of this._stacks)(!q||Y<_)&&(q=se,Y=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${Y}):`),console.warn(q)}return()=>{const q=this._stacks.get(u.value)||0;this._stacks.set(u.value,q-1)}}}class h{constructor(u){this.value=u}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class I{constructor(u,m,P){this.callback=u,this.callbackThis=m,this.stack=P,this.subscription=new D.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class y{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=R>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new T(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(S){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const m of u)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,m,P)=>{this._listeners||(this._listeners=new C.LinkedList);const F=this._listeners.isEmpty();F&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let q,Y;this._leakageMon&&this._listeners.size>=30&&(Y=h.create(),q=this._leakageMon.check(Y,this._listeners.size+1)),S&&(Y=Y??h.create());const se=new I(u,m,Y),_=this._listeners.push(se);F&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,m);const G=se.subscription.set(()=>{q?.(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return P instanceof D.DisposableStore?P.add(G):Array.isArray(P)&&P.push(G),G}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const m of this._listeners)this._deliveryQueue.push(this,m,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class d{constructor(){this._queue=new C.LinkedList}get size(){return this._queue.size}push(u,m,P){this._queue.push(new c(u,m,P))}clear(u){const m=new C.LinkedList;for(const P of this._queue)P.emitter!==u&&m.push(P);this._queue=m}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(m){(0,b.onUnexpectedError)(m)}}}}e.EventDeliveryQueue=d;class g extends d{clear(u){this._queue.clear()}}class c{constructor(u,m,P){this.emitter=u,this.listener=m,this.event=P}}class l extends y{async fireAsync(u,m,P){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const F of this._listeners)this._asyncDeliveryQueue.push([F,u]);for(;this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[F,q]=this._asyncDeliveryQueue.shift(),Y=[],se={...q,token:m,waitUntil:_=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");P&&(_=P(_,F.callback)),Y.push(_)}};try{F.invoke(se)}catch(_){(0,b.onUnexpectedError)(_);continue}Object.freeze(Y),await Promise.allSettled(Y).then(_=>{for(const G of _)G.status==="rejected"&&(0,b.onUnexpectedError)(G.reason)})}}}}e.AsyncEmitter=l;class f extends y{constructor(u){super(u);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=f;class r extends f{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=r;class o extends y{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(m=>super.fire(m)),this._queuedEvents=[]})}}e.MicrotaskEmitter=o;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const m={event:u,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const P=()=>{this.hasListeners&&this.unhook(m);const F=this.events.indexOf(m);this.events.splice(F,1)};return(0,D.toDisposable)((0,t.once)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(m=>this.emitter.fire(m))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.buffers=[]}wrapEvent(u){return(m,P,F)=>u(q=>{const Y=this.buffers[this.buffers.length-1];Y?Y.push(()=>m.call(P,q)):m.call(P,q)},void 0,F)}bufferEvents(u){const m=[];this.buffers.push(m);const P=u();return this.buffers.pop(),m.forEach(F=>F()),P}}e.EventBufferer=i;class s{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=D.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ve[20],we([0,1,7]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(S,p){const E=setTimeout(S.bind(p),0);return{dispose(){clearTimeout(E)}}});var D;(function(S){function p(E){return E===S.None||E===S.Cancelled||E instanceof C?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}S.isCancellationToken=p,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(ve[138],we([0,1,20]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(S){this.task=S,this.result=null}get(){if(this.result)return this.result;const S=new b.CancellationTokenSource,p=this.task(S.token);return this.result={promise:p,dispose:()=>{this.result=null,S.cancel(),S.dispose()}},this.result}}e.Cache=t;class D{constructor(S){this.fn=S,this.lastCache=void 0,this.lastArgKey=void 0}get(S){const p=JSON.stringify(S);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(S)),this.lastCache}}e.LRUCachedFunction=D;class C{constructor(S){this.fn=S,this._map=new Map}get cachedValues(){return this._map}get(S){if(this._map.has(S))return this._map.get(S);const p=this.fn(S);return this._map.set(S,p),p}}e.CachedFunction=C}),define(ve[85],we([0,1,7,2]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=k=>({onDidChange:b.Event.None,value:k});e.staticObservableValue=D;class C extends t.Disposable{constructor(S){super();this._value=S,this.changeEmitter=this._register(new b.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(S){S!==this._value&&(this._value=S,this.changeEmitter.fire(S))}}e.MutableObservableValue=C}),define(ve[46],we([0,1,11,2]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(l){const f=l;return f?typeof f.read=="function":!1}e.isReadable=D;function C(l){const f=l;return f?[f.on,f.pause,f.resume,f.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=C;function k(l){const f=l;return f?C(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=k;function S(l,f){return new p(l,f)}e.newWriteableStream=S;class p{constructor(f,r){this.reducer=f,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(r=>r(f))}emitError(f){this.listeners.error.length===0?(0,b.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(r=>r(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,r){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(f,r){if(this.state.destroyed)return;let o;switch(f){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(r);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(l,f){const r=[];let o;for(;(o=l.read())!==null;)r.push(o);return f(r)}e.consumeReadable=E;function T(l,f,r){const o=[];let n;for(;(n=l.read())!==null&&o.length<r;)o.push(n);return n===null&&o.length>0?f(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return l.read()}}}e.peekReadable=T;function R(l,f){return new Promise((r,o)=>{const n=[];w(l,{onData:i=>{f&&n.push(i)},onError:i=>{f?o(i):r(void 0)},onEnd:()=>{r(f?f(n):void 0)}})})}e.consumeStream=R;function w(l,f){let r=!1;return l.on("error",o=>{r||f.onError(o)}),l.on("end",()=>{r||f.onEnd()}),l.on("data",o=>{r||f.onData(o)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=w;function v(l,f){return new Promise((r,o)=>{const n=new t.DisposableStore,i=[],s=m=>{if(i.push(m),i.length>f)return n.dispose(),l.pause(),r({stream:l,buffer:i,ended:!1})},a=m=>o(m),u=()=>r({stream:l,buffer:i,ended:!0});n.add((0,t.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),n.add((0,t.toDisposable)(()=>l.removeListener("end",u))),l.on("end",u),n.add((0,t.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=v;function h(l,f){const r=S(f);return r.end(l),r}e.toStream=h;function I(){const l=S(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=I;function y(l){let f=!1;return{read:()=>f?null:(f=!0,l)}}e.toReadable=y;function d(l,f,r){const o=S(r);return w(l,{onData:n=>o.write(f.data(n)),onError:n=>o.error(f.error?f.error(n):n),onEnd:()=>o.end()}),o}e.transform=d;function g(l,f,r){let o=!1;return{read:()=>{const n=f.read();return o?n:(o=!0,n!==null?r([l,n]):l)}}}e.prefixedReadable=g;function c(l,f,r){let o=!1;const n=S(r);return w(f,{onData:i=>o?n.write(i):(o=!0,n.write(r([l,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(l)),n.end()}}),n}e.prefixedStream=c}),define(ve[16],we([0,1,46]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let D,C;class k{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return t?new k(Buffer.allocUnsafe(m)):new k(new Uint8Array(m))}static wrap(m){return t&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new k(m)}static fromString(m,P){return!(P?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(m)):(D||(D=new TextEncoder),new k(D.encode(m)))}static fromByteArray(m){const P=k.alloc(m.length);for(let F=0,q=m.length;F<q;F++)P.buffer[F]=m[F];return P}static concat(m,P){if(typeof P=="undefined"){P=0;for(let Y=0,se=m.length;Y<se;Y++)P+=m[Y].byteLength}const F=k.alloc(P);let q=0;for(let Y=0,se=m.length;Y<se;Y++){const _=m[Y];F.set(_,q),q+=_.byteLength}return F}clone(){const m=k.alloc(this.byteLength);return m.set(this),m}toString(){return t?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(m,P){return new k(this.buffer.subarray(m,P))}set(m,P){if(m instanceof k)this.buffer.set(m.buffer,P);else if(m instanceof Uint8Array)this.buffer.set(m,P);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),P);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return E(this.buffer,m)}writeUInt32BE(m,P){T(this.buffer,m,P)}readUInt32LE(m){return R(this.buffer,m)}writeUInt32LE(m,P){w(this.buffer,m,P)}readUInt8(m){return v(this.buffer,m)}writeUInt8(m,P){h(this.buffer,m,P)}}e.VSBuffer=k;function S(u,m){return u[m+0]<<0>>>0|u[m+1]<<8>>>0}e.readUInt16LE=S;function p(u,m,P){u[P+0]=m&255,m=m>>>8,u[P+1]=m&255}e.writeUInt16LE=p;function E(u,m){return u[m]*2**24+u[m+1]*2**16+u[m+2]*2**8+u[m+3]}e.readUInt32BE=E;function T(u,m,P){u[P+3]=m,m=m>>>8,u[P+2]=m,m=m>>>8,u[P+1]=m,m=m>>>8,u[P]=m}e.writeUInt32BE=T;function R(u,m){return u[m+0]<<0>>>0|u[m+1]<<8>>>0|u[m+2]<<16>>>0|u[m+3]<<24>>>0}e.readUInt32LE=R;function w(u,m,P){u[P+0]=m&255,m=m>>>8,u[P+1]=m&255,m=m>>>8,u[P+2]=m&255,m=m>>>8,u[P+3]=m&255}e.writeUInt32LE=w;function v(u,m){return u[m]}e.readUInt8=v;function h(u,m,P){u[P]=m}e.writeUInt8=h;function I(u){return b.consumeReadable(u,m=>k.concat(m))}e.readableToBuffer=I;function y(u){return b.toReadable(u)}e.bufferToReadable=y;function d(u){return b.consumeStream(u,m=>k.concat(m))}e.streamToBuffer=d;async function g(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await d(u.stream)])}e.bufferedStreamToBuffer=g;function c(u){return b.toStream(u,m=>k.concat(m))}e.bufferToStream=c;function l(u){return b.transform(u,{data:m=>typeof m=="string"?k.fromString(m):k.wrap(m)},m=>k.concat(m))}e.streamToBufferReadableStream=l;function f(u){return b.newWriteableStream(m=>k.concat(m),u)}e.newWriteableBufferStream=f;function r(u,m){return b.prefixedReadable(u,m,P=>k.concat(P))}e.prefixedBufferReadable=r;function o(u,m){return b.prefixedStream(u,m,P=>k.concat(P))}e.prefixedBufferStream=o;function n(u){let m=0,P=0,F=0;const q=new Uint8Array(Math.floor(u.length/4*3)),Y=_=>{switch(P){case 3:q[F++]=m|_,P=0;break;case 2:q[F++]=m|_>>>2,m=_<<6,P=3;break;case 1:q[F++]=m|_>>>4,m=_<<4,P=2;break;default:m=_<<2,P=1}};for(let _=0;_<u.length;_++){const G=u.charCodeAt(_);if(G>=65&&G<=90)Y(G-65);else if(G>=97&&G<=122)Y(G-97+26);else if(G>=48&&G<=57)Y(G-48+52);else if(G===43||G===45)Y(62);else if(G===47||G===95)Y(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${u[_]}`)}}const se=F;for(;P>0;)Y(0);return k.wrap(q).slice(0,se)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:u},m=!0,P=!1){const F=P?s:i;let q="";const Y=u.byteLength%3;let se=0;for(;se<u.byteLength-Y;se+=3){const _=u[se+0],G=u[se+1],te=u[se+2];q+=F[_>>>2],q+=F[(_<<4|G>>>4)&63],q+=F[(G<<2|te>>>6)&63],q+=F[te&63]}if(Y===1){const _=u[se+0];q+=F[_>>>2],q+=F[_<<4&63],m&&(q+="==")}else if(Y===2){const _=u[se+0],G=u[se+1];q+=F[_>>>2],q+=F[(_<<4|G>>>4)&63],q+=F[G<<2&63],m&&(q+="=")}return q}e.encodeBase64=a}),define(ve[15],we([0,1,138,133]),function(oe,e,b,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=C;const k=/{(\d+)}/g;function S(ce,...Ce){return Ce.length===0?ce:ce.replace(k,function(ke,Fe){const Re=parseInt(Fe,10);return isNaN(Re)||Re<0||Re>=Ce.length?ke:Ce[Re]})}e.format=S;const p=/{([^}]+)}/g;function E(ce,Ce){return ce.replace(p,(ke,Fe)=>Ce[Fe]??ke)}e.format2=E;function T(ce){return ce.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=T;function R(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function w(ce,Ce){let ke=0;const Fe=Ce.charCodeAt(0);for(let Re=ce.length-1;Re>=0;Re--)ce.charCodeAt(Re)===Fe&&ke++;return ke}e.count=w;function v(ce,Ce,ke="\u2026"){return ce.length<=Ce?ce:`${ce.substr(0,Ce)}${ke}`}e.truncate=v;function h(ce,Ce=" "){const ke=I(ce,Ce);return y(ke,Ce)}e.trim=h;function I(ce,Ce){if(!ce||!Ce)return ce;const ke=Ce.length;if(ke===0||ce.length===0)return ce;let Fe=0;for(;ce.indexOf(Ce,Fe)===Fe;)Fe=Fe+ke;return ce.substring(Fe)}e.ltrim=I;function y(ce,Ce){if(!ce||!Ce)return ce;const ke=Ce.length,Fe=ce.length;if(ke===0||Fe===0)return ce;let Re=Fe,Be=-1;for(;Be=ce.lastIndexOf(Ce,Re-1),!(Be===-1||Be+ke!==Re);){if(Be===0)return"";Re=Be}return ce.substring(0,Re)}e.rtrim=y;function d(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(ce){return ce.replace(/\*/g,"")}e.stripWildcards=g;function c(ce,Ce,ke={}){if(!ce)throw new Error("Cannot create regex from empty string");Ce||(ce=R(ce)),ke.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Fe="";return ke.global&&(Fe+="g"),ke.matchCase||(Fe+="i"),ke.multiline&&(Fe+="m"),ke.unicode&&(Fe+="u"),new RegExp(ce,Fe)}e.createRegExp=c;function l(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function f(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function r(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=r;function o(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=o;function n(ce){for(let Ce=0,ke=ce.length;Ce<ke;Ce++){const Fe=ce.charCodeAt(Ce);if(Fe!==32&&Fe!==9)return Ce}return-1}e.firstNonWhitespaceIndex=n;function i(ce,Ce=0,ke=ce.length){for(let Fe=Ce;Fe<ke;Fe++){const Re=ce.charCodeAt(Fe);if(Re!==32&&Re!==9)return ce.substring(Ce,Fe)}return ce.substring(Ce,ke)}e.getLeadingWhitespace=i;function s(ce,Ce=ce.length-1){for(let ke=Ce;ke>=0;ke--){const Fe=ce.charCodeAt(ke);if(Fe!==32&&Fe!==9)return ke}return-1}e.lastNonWhitespaceIndex=s;function a(ce,Ce,ke){const Fe=[];let Re=0;for(const Be of ce.matchAll(Ce)){if(Fe.push(ce.slice(Re,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Re=Be.index+Be[0].length,Fe.push(ke(Be[0],...Be.slice(1),Be.index,ce,Be.groups))}return Fe.push(ce.slice(Re)),Promise.all(Fe).then(Be=>Be.join(""))}e.replaceAsync=a;function u(ce,Ce){return ce<Ce?-1:ce>Ce?1:0}e.compare=u;function m(ce,Ce,ke=0,Fe=ce.length,Re=0,Be=Ce.length){for(;ke<Fe&&Re<Be;ke++,Re++){const Xe=ce.charCodeAt(ke),tt=Ce.charCodeAt(Re);if(Xe<tt)return-1;if(Xe>tt)return 1}const He=Fe-ke,Qe=Be-Re;return He<Qe?-1:He>Qe?1:0}e.compareSubstring=m;function P(ce,Ce){return F(ce,Ce,0,ce.length,0,Ce.length)}e.compareIgnoreCase=P;function F(ce,Ce,ke=0,Fe=ce.length,Re=0,Be=Ce.length){for(;ke<Fe&&Re<Be;ke++,Re++){let Xe=ce.charCodeAt(ke),tt=Ce.charCodeAt(Re);if(Xe===tt)continue;if(Xe>=128||tt>=128)return m(ce.toLowerCase(),Ce.toLowerCase(),ke,Fe,Re,Be);Y(Xe)&&(Xe-=32),Y(tt)&&(tt-=32);const it=Xe-tt;if(it!==0)return it}const He=Fe-ke,Qe=Be-Re;return He<Qe?-1:He>Qe?1:0}e.compareSubstringIgnoreCase=F;function q(ce){return ce>=48&&ce<=57}e.isAsciiDigit=q;function Y(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=Y;function se(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=se;function _(ce,Ce){return ce.length===Ce.length&&F(ce,Ce)===0}e.equalsIgnoreCase=_;function G(ce,Ce){const ke=Ce.length;return Ce.length>ce.length?!1:F(ce,Ce,0,ke)===0}e.startsWithIgnoreCase=G;function te(ce,Ce){const ke=Math.min(ce.length,Ce.length);let Fe;for(Fe=0;Fe<ke;Fe++)if(ce.charCodeAt(Fe)!==Ce.charCodeAt(Fe))return Fe;return ke}e.commonPrefixLength=te;function j(ce,Ce){const ke=Math.min(ce.length,Ce.length);let Fe;const Re=ce.length-1,Be=Ce.length-1;for(Fe=0;Fe<ke;Fe++)if(ce.charCodeAt(Re-Fe)!==Ce.charCodeAt(Be-Fe))return Fe;return ke}e.commonSuffixLength=j;function he(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=he;function J(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=J;function U(ce,Ce){return(ce-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=U;function M(ce,Ce,ke){const Fe=ce.charCodeAt(ke);if(he(Fe)&&ke+1<Ce){const Re=ce.charCodeAt(ke+1);if(J(Re))return U(Fe,Re)}return Fe}e.getNextCodePoint=M;function B(ce,Ce){const ke=ce.charCodeAt(Ce-1);if(J(ke)&&Ce>1){const Fe=ce.charCodeAt(Ce-2);if(he(Fe))return U(Fe,ke)}return ke}class Q{constructor(Ce,ke=0){this._str=Ce,this._len=Ce.length,this._offset=ke}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=B(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=M(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class ae{constructor(Ce,ke=0){this._iterator=new Q(Ce,ke)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=Oe.getInstance(),ke=this._iterator,Fe=ke.offset;let Re=Ce.getGraphemeBreakType(ke.nextCodePoint());for(;!ke.eol();){const Be=ke.offset,He=Ce.getGraphemeBreakType(ke.nextCodePoint());if(be(Re,He)){ke.setOffset(Be);break}Re=He}return ke.offset-Fe}prevGraphemeLength(){const Ce=Oe.getInstance(),ke=this._iterator,Fe=ke.offset;let Re=Ce.getGraphemeBreakType(ke.prevCodePoint());for(;ke.offset>0;){const Be=ke.offset,He=Ce.getGraphemeBreakType(ke.prevCodePoint());if(be(He,Re)){ke.setOffset(Be);break}Re=He}return Fe-ke.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ae;function fe(ce,Ce){return new ae(ce,Ce).nextGraphemeLength()}e.nextCharLength=fe;function X(ce,Ce){return new ae(ce,Ce).prevGraphemeLength()}e.prevCharLength=X;function re(ce,Ce){Ce>0&&J(ce.charCodeAt(Ce))&&Ce--;const ke=Ce+fe(ce,Ce);return[ke-X(ce,ke),ke]}e.getCharContainingOffset=re;const L=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(ce){return L.test(ce)}e.containsRTL=O;const x=/^[\t\n\r\x20-\x7E]*$/;function ne(ce){return x.test(ce)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ue(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=ue;function pe(ce){return ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=pe;function W(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129008||ce>=129280&&ce<=129535||ce>=129648&&ce<=129782}e.isEmojiImprecise=W;function Z(ce,Ce){if(ce.length<Ce)return ce;const ke=/\b/g;let Fe=0;for(;ke.test(ce)&&!(ce.length-ke.lastIndex<Ce);)Fe=ke.lastIndex,ke.lastIndex+=1;return ce.substring(Fe).replace(/^\s/,"")}e.lcut=Z;const ie=/\x1B\x5B[12]?K/g,z=/\x1b\[\d+m/g,V=/\x1b\[0?m/g;function $(ce){return ce&&(ce=ce.replace(ie,""),ce=ce.replace(z,""),ce=ce.replace(V,"")),ce}e.removeAnsiEscapeCodes=$,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function K(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=K;function le(ce){return K(ce)?ce.substr(1):ce}e.stripUTF8BOM=le;function ge(ce,Ce){if(!ce||!Ce||ce.length<Ce.length)return!1;const ke=Ce.length,Fe=ce.toLowerCase();let Re=0,Be=-1;for(;Re<ke;){const He=Fe.indexOf(Ce[Re],Be+1);if(He<0)return!1;Be=He,Re++}return!0}e.fuzzyContains=ge;function Pe(ce,Ce=!1){return ce?(Ce&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=Pe;function Te(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Te;function Ne(ce,Ce=1){if(Ce===0)return"";let ke=-1;do ke=ce.indexOf(`
`,ke+1),Ce--;while(Ce>0&&ke>=0);return ke===-1?ce:(ce[ke-1]==="\r"&&ke--,ce.substr(0,ke))}e.getNLines=Ne;function Ue(ce){const Ce=90-65+1;return ce=ce%(2*Ce),ce<Ce?String.fromCharCode(97+ce):String.fromCharCode(65+ce-Ce)}e.singleLetterHash=Ue;function me(ce){return Oe.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=me;function be(ce,Ce){return ce===0?Ce!==5&&Ce!==7:ce===2&&Ce===3?!1:ce===4||ce===2||ce===3||Ce===4||Ce===2||Ce===3?!0:!(ce===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(ce===11||ce===9)&&(Ce===9||Ce===10)||(ce===12||ce===10)&&Ce===10||Ce===5||Ce===13||Ce===7||ce===1||ce===13&&Ce===14||ce===6&&Ce===6)}var ye;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Me()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const ke=this._data,Fe=ke.length/3;let Re=1;for(;Re<=Fe;)if(Ce<ke[3*Re])Re=2*Re;else if(Ce>ke[3*Re+1])Re=2*Re+1;else return ke[3*Re+2];return 0}}Oe._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ke(ce,Ce){if(ce===0)return 0;const ke=$e(ce,Ce);if(ke!==void 0)return ke;const Fe=new Q(Ce,ce);return Fe.prevCodePoint(),Fe.offset}e.getLeftDeleteOffset=Ke;function $e(ce,Ce){const ke=new Q(Ce,ce);let Fe=ke.prevCodePoint();for(;Ze(Fe)||Fe===65039||Fe===8419;){if(ke.offset===0)return;Fe=ke.prevCodePoint()}if(!W(Fe))return;let Re=ke.offset;return Re>0&&ke.prevCodePoint()===8205&&(Re=ke.offset),Re}function Ze(ce){return 127995<=ce&&ce<=127999}var Ge;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.noBreakWhitespace="\xA0";class je{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return je.cache.get(Array.from(Ce))}static getLocales(){return je._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je,D=je,je.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new b.LRUCachedFunction(ce=>{function Ce(tt){const it=new Map;for(let rt=0;rt<tt.length;rt+=2)it.set(tt[rt],tt[rt+1]);return it}function ke(tt,it){const rt=new Map(tt);for(const[ft,ut]of it)rt.set(ft,ut);return rt}function Fe(tt,it){if(!tt)return it;const rt=new Map;for(const[ft,ut]of tt)it.has(ft)&&rt.set(ft,ut);return rt}const Re=D.ambiguousCharacterData.getValue();let Be=ce.filter(tt=>!tt.startsWith("_")&&tt in Re);Be.length===0&&(Be=["_default"]);let He;for(const tt of Be){const it=Ce(Re[tt]);He=Fe(He,it)}const Qe=Ce(Re._common),Xe=ke(Qe,He);return new je(Xe)}),je._locales=new t.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(ce=>!ce.startsWith("_")));class We{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(We.getRawData())),this._data}static isInvisibleCharacter(Ce){return We.getData().has(Ce)}static get codePoints(){return We.getData()}}e.InvisibleCharacters=We,We._data=void 0}),define(ve[86],we([0,1,15]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(d){return D(d,0)}e.hash=t;function D(d,g){switch(typeof d){case"object":return d===null?C(349,g):Array.isArray(d)?p(d,g):E(d,g);case"string":return S(d,g);case"boolean":return k(d,g);case"number":return C(d,g);case"undefined":return C(937,g);default:return C(617,g)}}e.doHash=D;function C(d,g){return(g<<5)-g+d|0}e.numberHash=C;function k(d,g){return C(d?433:863,g)}function S(d,g){g=C(149417,g);for(let c=0,l=d.length;c<l;c++)g=C(d.charCodeAt(c),g);return g}e.stringHash=S;function p(d,g){return g=C(104579,g),d.reduce((c,l)=>D(l,c),g)}function E(d,g){return g=C(181387,g),Object.keys(d).sort().reduce((c,l)=>(c=S(l,c),D(d[l],c)),g)}class T{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=D(g,this._value),this._value}}e.Hasher=T;var R;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function w(d,g,c=32){const l=c-g,f=~((1<<l)-1);return(d<<g|(f&d)>>>l)>>>0}function v(d,g=0,c=d.byteLength,l=0){for(let f=0;f<c;f++)d[g+f]=l}function h(d,g,c="0"){for(;d.length<g;)d=c+d;return d}function I(d,g=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(c=>c.toString(16).padStart(2,"0")).join(""):h((d>>>0).toString(16),g/4)}e.toHexString=I;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const c=g.length;if(c===0)return;const l=this._buff;let f=this._buffLen,r=this._leftoverHighSurrogate,o,n;for(r!==0?(o=r,n=-1,r=0):(o=g.charCodeAt(0),n=0);;){let i=o;if(b.isHighSurrogate(o))if(n+1<c){const s=g.charCodeAt(n+1);b.isLowSurrogate(s)?(n++,i=b.computeCodePoint(o,s)):i=65533}else{r=o;break}else b.isLowSurrogate(o)&&(i=65533);if(f=this._push(l,f,i),n++,n<c)o=g.charCodeAt(n);else break}this._buffLen=f,this._leftoverHighSurrogate=r}_push(g,c,l){return l<128?g[c++]=l:l<2048?(g[c++]=192|(l&1984)>>>6,g[c++]=128|(l&63)>>>0):l<65536?(g[c++]=224|(l&61440)>>>12,g[c++]=128|(l&4032)>>>6,g[c++]=128|(l&63)>>>0):(g[c++]=240|(l&1835008)>>>18,g[c++]=128|(l&258048)>>>12,g[c++]=128|(l&4032)>>>6,g[c++]=128|(l&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),I(this._h0)+I(this._h1)+I(this._h2)+I(this._h3)+I(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=y._bigBlock32,c=this._buffDV;for(let u=0;u<64;u+=4)g.setUint32(u,c.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)g.setUint32(u,w(g.getUint32(u-12,!1)^g.getUint32(u-32,!1)^g.getUint32(u-56,!1)^g.getUint32(u-64,!1),1),!1);let l=this._h0,f=this._h1,r=this._h2,o=this._h3,n=this._h4,i,s,a;for(let u=0;u<80;u++)u<20?(i=f&r|~f&o,s=1518500249):u<40?(i=f^r^o,s=1859775393):u<60?(i=f&r|f&o|r&o,s=2400959708):(i=f^r^o,s=3395469782),a=w(l,5)+i+n+s+g.getUint32(u*4,!1)&4294967295,n=o,o=r,r=w(f,30),f=l,l=a;this._h0=this._h0+l&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[24],we([0,1,18,15]),function(oe,e,b,t){"use strict";var D,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(n,i,s){let a=n.get(i);return a===void 0&&(a=s,n.set(i,a)),a}e.getOrSet=S;function p(n){const i=[];return n.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=p;function E(n){const i=[];return n.forEach(s=>{i.push(s)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=E;class T{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=T;class R{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class w{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var v;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(i,s){this._ignorePathCasing=i,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(y||(y={}));class d{constructor(i){this._iter=i}static forUris(i=()=>!1,s=()=>!1){return new d(new h(i,s))}static forPaths(i=!1){return new d(new w(void 0,!i))}static forStrings(){return new d(new T)}static forConfigKeys(){return new d(new R)}clear(){this._root=void 0}fill(i,s){if(s){const a=s.slice(0);(0,b.shuffle)(a);for(const u of a)this.set(u,i)}else{const a=i.slice(0);(0,b.shuffle)(a);for(const u of a)this.set(u[0],u[1])}}set(i,s){const a=this._iter.reset(i);let u;this._root||(this._root=new I,this._root.segment=a.value());const m=[];for(u=this._root;;){const F=a.cmp(u.segment);if(F>0)u.left||(u.left=new I,u.left.segment=a.value()),m.push([-1,u]),u=u.left;else if(F<0)u.right||(u.right=new I,u.right.segment=a.value()),m.push([1,u]),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new I,u.mid.segment=a.value()),m.push([0,u]),u=u.mid;else break}const P=u.value;u.value=s,u.key=i;for(let F=m.length-1;F>=0;F--){const q=m[F][1];q.updateHeight();const Y=q.balanceFactor();if(Y<-1||Y>1){const se=m[F][0],_=m[F+1][0];if(se===1&&_===1)m[F][1]=q.rotateLeft();else if(se===-1&&_===-1)m[F][1]=q.rotateRight();else if(se===1&&_===-1)q.right=m[F+1][1]=m[F+1][1].rotateRight(),m[F][1]=q.rotateLeft();else if(se===-1&&_===1)q.left=m[F+1][1]=m[F+1][1].rotateLeft(),m[F][1]=q.rotateRight();else throw new Error;if(F>0)switch(m[F-1][0]){case-1:m[F-1][1].left=m[F][1];break;case 1:m[F-1][1].right=m[F][1];break;case 0:m[F-1][1].mid=m[F][1];break}else this._root=m[0][1]}}return P}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const a=this._iter.reset(i),u=[];let m=this._root;for(;m;){const P=a.cmp(m.segment);if(P>0)u.push([-1,m]),m=m.left;else if(P<0)u.push([1,m]),m=m.right;else if(a.hasNext())a.next(),u.push([0,m]),m=m.mid;else break}if(!!m){if(s?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const P=this._min(m.right),{key:F,value:q,segment:Y}=P;this._delete(P.key,!1),m.key=F,m.value=q,m.segment=Y}else{const P=m.left??m.right;if(u.length>0){const[F,q]=u[u.length-1];switch(F){case-1:q.left=P;break;case 0:q.mid=P;break;case 1:q.right=P;break}}else this._root=P}for(let P=u.length-1;P>=0;P--){const F=u[P][1];F.updateHeight();const q=F.balanceFactor();if(q>1?(F.right.balanceFactor()>=0||(F.right=F.right.rotateRight()),u[P][1]=F.rotateLeft()):q<-1&&(F.left.balanceFactor()<=0||(F.left=F.left.rotateLeft()),u[P][1]=F.rotateRight()),P>0)switch(u[P-1][0]){case-1:u[P-1][1].left=u[P][1];break;case 1:u[P-1][1].right=u[P][1];break;case 0:u[P-1][1].mid=u[P][1];break}else this._root=u[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let a=this._root,u;for(;a;){const m=s.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(s.hasNext())s.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[s,a]of this)i(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const s=[];return this._dfsEntries(i,s),s[Symbol.iterator]()}_dfsEntries(i,s){!i||(i.left&&this._dfsEntries(i.left,s),i.value&&s.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,s),i.right&&this._dfsEntries(i.right,s))}_isBalanced(){const i=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=d;class g{constructor(i,s){this.uri=i,this.value=s}}class c{constructor(i,s){this[D]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new g(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(const[a,u]of this.map)i(u.value,u.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=n=>n.toString();class l{constructor(i,s){this[C]="ResourceSet",!i||typeof i=="function"?this._map=new c(i):(this._map=new c(s),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,s){this._map.forEach((a,u)=>i.call(s,u,u,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var f;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class r{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const a=this._map.get(i);if(!!a)return s!==0&&this.touch(a,s),a.value}set(i,s,a=0){let u=this._map.get(i);if(u)u.value=s,a!==0&&this.touch(u,a);else{switch(u={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const a=this._state;let u=this._head;for(;u;){if(s?i.bind(s)(u.value,u.key,this):i(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:a.key,done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return u}values(){const i=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:a.value,done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return u}entries(){const i=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:[a.key,a.value],done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>i;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const a=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const a=i.next,u=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.LinkedMap=r;class o extends r{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(ve[139],we([0,1,24,15]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...$){return function(K,le){for(let ge=0,Pe=$.length;ge<Pe;ge++){const Te=$[ge](K,le);if(Te)return Te}return null}}e.or=D,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C($,K,le){if(!le||le.length<K.length)return null;let ge;return $?ge=t.startsWithIgnoreCase(le,K):ge=le.indexOf(K)===0,ge?K.length>0?[{start:0,end:K.length}]:[]:null}function k($,K){const le=K.toLowerCase().indexOf($.toLowerCase());return le===-1?null:[{start:le,end:le+$.length}]}e.matchesContiguousSubString=k;function S($,K){return p($.toLowerCase(),K.toLowerCase(),0,0)}e.matchesSubString=S;function p($,K,le,ge){if(le===$.length)return[];if(ge===K.length)return null;if($[le]===K[ge]){let Pe=null;return(Pe=p($,K,le+1,ge+1))?d({start:ge,end:ge+1},Pe):null}return p($,K,le,ge+1)}function E($){return 97<=$&&$<=122}function T($){return 65<=$&&$<=90}e.isUpper=T;function R($){return 48<=$&&$<=57}function w($){return $===32||$===9||$===10||$===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach($=>v.add($.charCodeAt(0)));function h($){return w($)||v.has($)}function I($,K){return $===K||h($)&&h(K)}function y($){return E($)||T($)||R($)}function d($,K){return K.length===0?K=[$]:$.end===K[0].start?K[0].start=$.start:K.unshift($),K}function g($,K){for(let le=K;le<$.length;le++){const ge=$.charCodeAt(le);if(T(ge)||R(ge)||le>0&&!y($.charCodeAt(le-1)))return le}return $.length}function c($,K,le,ge){if(le===$.length)return[];if(ge===K.length)return null;if($[le]!==K[ge].toLowerCase())return null;{let Pe=null,Te=ge+1;for(Pe=c($,K,le+1,ge+1);!Pe&&(Te=g(K,Te))<K.length;)Pe=c($,K,le+1,Te),Te++;return Pe===null?null:d({start:ge,end:ge+1},Pe)}}function l($){let K=0,le=0,ge=0,Pe=0,Te=0;for(let ye=0;ye<$.length;ye++)Te=$.charCodeAt(ye),T(Te)&&K++,E(Te)&&le++,y(Te)&&ge++,R(Te)&&Pe++;const Ne=K/$.length,Ue=le/$.length,me=ge/$.length,be=Pe/$.length;return{upperPercent:Ne,lowerPercent:Ue,alphaPercent:me,numericPercent:be}}function f($){const{upperPercent:K,lowerPercent:le}=$;return le===0&&K>.6}function r($){const{upperPercent:K,lowerPercent:le,alphaPercent:ge,numericPercent:Pe}=$;return le>.2&&K<.8&&ge>.6&&Pe<.2}function o($){let K=0,le=0,ge=0,Pe=0;for(let Te=0;Te<$.length;Te++)ge=$.charCodeAt(Te),T(ge)&&K++,E(ge)&&le++,w(ge)&&Pe++;return(K===0||le===0)&&Pe===0?$.length<=30:K<=5}function n($,K){if(!K||(K=K.trim(),K.length===0)||!o($)||K.length>60)return null;const le=l(K);if(!r(le)){if(!f(le))return null;K=K.toLowerCase()}let ge=null,Pe=0;for($=$.toLowerCase();Pe<K.length&&(ge=c($,K,0,Pe))===null;)Pe=g(K,Pe+1);return ge}e.matchesCamelCase=n;function i($,K,le=!1){if(!K||K.length===0)return null;let ge=null,Pe=0;for($=$.toLowerCase(),K=K.toLowerCase();Pe<K.length&&(ge=s($,K,0,Pe,le))===null;)Pe=a(K,Pe+1);return ge}e.matchesWords=i;function s($,K,le,ge,Pe){if(le===$.length)return[];if(ge===K.length)return null;if(I($.charCodeAt(le),K.charCodeAt(ge))){let Te=null,Ne=ge+1;if(Te=s($,K,le+1,ge+1,Pe),!Pe)for(;!Te&&(Ne=a(K,Ne))<K.length;)Te=s($,K,le+1,Ne,Pe),Ne++;return Te?$.charCodeAt(le)!==K.charCodeAt(ge)?Te:d({start:ge,end:ge+1},Te):null}else return null}function a($,K){for(let le=K;le<$.length;le++)if(h($.charCodeAt(le))||le>0&&h($.charCodeAt(le-1)))return le;return $.length}const u=D(e.matchesPrefix,n,k),m=D(e.matchesPrefix,n,S),P=new b.LRUCache(1e4);function F($,K,le=!1){if(typeof $!="string"||typeof K!="string")return null;let ge=P.get($);ge||(ge=new RegExp(t.convertSimple2RegExpPattern($),"i"),P.set($,ge));const Pe=ge.exec(K);return Pe?[{start:Pe.index,end:Pe.index+Pe[0].length}]:le?m($,K):u($,K)}e.matchesFuzzy=F;function q($,K){const le=ue($,$.toLowerCase(),0,K,K.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return le?se(le):null}e.matchesFuzzy2=q;function Y($,K,le,ge,Pe,Te){const Ne=Math.min(13,$.length);for(;le<Ne;le++){const Ue=ue($,K,le,ge,Pe,Te,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ue)return Ue}return[0,Te]}e.anyScore=Y;function se($){if(typeof $=="undefined")return[];const K=[],le=$[1];for(let ge=$.length-1;ge>1;ge--){const Pe=$[ge]+le,Te=K[K.length-1];Te&&Te.end===Pe?Te.end=Pe+1:K.push({start:Pe,end:Pe+1})}return K}e.createMatches=se;const _=128;function G(){const $=[],K=[];for(let le=0;le<=_;le++)K[le]=0;for(let le=0;le<=_;le++)$.push(K.slice(0));return $}function te($){const K=[];for(let le=0;le<=$;le++)K[le]=0;return K}const j=te(2*_),he=te(2*_),J=G(),U=G(),M=G(),B=!1;function Q($,K,le,ge,Pe){function Te(Ue,me,be=" "){for(;Ue.length<me;)Ue=be+Ue;return Ue}let Ne=` |   |${ge.split("").map(Ue=>Te(Ue,3)).join("|")}
`;for(let Ue=0;Ue<=le;Ue++)Ue===0?Ne+=" |":Ne+=`${K[Ue-1]}|`,Ne+=$[Ue].slice(0,Pe+1).map(me=>Te(me.toString(),3)).join("|")+`
`;return Ne}function ae($,K,le,ge){$=$.substr(K),le=le.substr(ge),console.log(Q(U,$,$.length,le,le.length)),console.log(Q(M,$,$.length,le,le.length)),console.log(Q(J,$,$.length,le,le.length))}function fe($,K){if(K<0||K>=$.length)return!1;const le=$.codePointAt(K);switch(le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(le)}}function X($,K){if(K<0||K>=$.length)return!1;switch($.charCodeAt(K)){case 32:case 9:return!0;default:return!1}}function re($,K,le){return K[$]!==le[$]}function L($,K,le,ge,Pe,Te,Ne=!1){for(;K<le&&Pe<Te;)$[K]===ge[Pe]&&(Ne&&(j[K]=Pe),K+=1),Pe+=1;return K===le}e.isPatternInWord=L;var O;(function($){$[$.Diag=1]="Diag",$[$.Left=2]="Left",$[$.LeftLeft=3]="LeftLeft"})(O||(O={}));var x;(function($){$.Default=[-100,0];function K(le){return!le||le.length===2&&le[0]===-100&&le[1]===0}$.isDefault=K})(x=e.FuzzyScore||(e.FuzzyScore={}));class ne{constructor(K,le){this.firstMatchCanBeWeak=K,this.boostFullMatch=le}}e.FuzzyScoreOptions=ne,ne.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ue($,K,le,ge,Pe,Te,Ne=ne.default){const Ue=$.length>_?_:$.length,me=ge.length>_?_:ge.length;if(le>=Ue||Te>=me||Ue-le>me-Te||!L(K,le,Ue,Pe,Te,me,!0))return;pe(Ue,me,le,Te,K,Pe);let be=1,ye=1,Oe=le,Me=Te;const Ke=[!1];for(be=1,Oe=le;Oe<Ue;be++,Oe++){const We=j[Oe],ce=he[Oe],Ce=Oe+1<Ue?he[Oe+1]:me;for(ye=We-Te+1,Me=We;Me<Ce;ye++,Me++){let ke=Number.MIN_SAFE_INTEGER,Fe=!1;Me<=ce&&(ke=W($,K,Oe,le,ge,Pe,Me,me,Te,J[be-1][ye-1]===0,Ke));let Re=0;ke!==Number.MAX_SAFE_INTEGER&&(Fe=!0,Re=ke+U[be-1][ye-1]);const Be=Me>We,He=Be?U[be][ye-1]+(J[be][ye-1]>0?-5:0):0,Qe=Me>We+1&&J[be][ye-1]>0,Xe=Qe?U[be][ye-2]+(J[be][ye-2]>0?-5:0):0;if(Qe&&(!Be||Xe>=He)&&(!Fe||Xe>=Re))U[be][ye]=Xe,M[be][ye]=3,J[be][ye]=0;else if(Be&&(!Fe||He>=Re))U[be][ye]=He,M[be][ye]=2,J[be][ye]=0;else if(Fe)U[be][ye]=Re,M[be][ye]=1,J[be][ye]=J[be-1][ye-1]+1;else throw new Error("not possible")}}if(B&&ae($,le,ge,Te),!Ke[0]&&!Ne.firstMatchCanBeWeak)return;be--,ye--;const $e=[U[be][ye],Te];let Ze=0,Ge=0;for(;be>=1;){let We=ye;do{const ce=M[be][We];if(ce===3)We=We-2;else if(ce===2)We=We-1;else break}while(We>=1);Ze>1&&K[le+be-1]===Pe[Te+ye-1]&&!re(We+Te-1,ge,Pe)&&Ze+1>J[be][We]&&(We=ye),We===ye?Ze++:Ze=1,Ge||(Ge=We),be--,ye=We-1,$e.push(ye)}me===Ue&&Ne.boostFullMatch&&($e[0]+=2);const je=Ge-Ue;return $e[0]-=je,$e}e.fuzzyScore=ue;function pe($,K,le,ge,Pe,Te){let Ne=$-1,Ue=K-1;for(;Ne>=le&&Ue>=ge;)Pe[Ne]===Te[Ue]&&(he[Ne]=Ue,Ne--),Ue--}function W($,K,le,ge,Pe,Te,Ne,Ue,me,be,ye){if(K[le]!==Te[Ne])return Number.MIN_SAFE_INTEGER;let Oe=1,Me=!1;return Ne===le-ge?Oe=$[le]===Pe[Ne]?7:5:re(Ne,Pe,Te)&&(Ne===0||!re(Ne-1,Pe,Te))?(Oe=$[le]===Pe[Ne]?7:5,Me=!0):fe(Te,Ne)&&(Ne===0||!fe(Te,Ne-1))?Oe=5:(fe(Te,Ne-1)||X(Te,Ne-1))&&(Oe=5,Me=!0),Oe>1&&le===ge&&(ye[0]=!0),Me||(Me=re(Ne,Pe,Te)||fe(Te,Ne-1)||X(Te,Ne-1)),le===ge?Ne>me&&(Oe-=Me?3:5):be?Oe+=Me?2:0:Oe+=Me?0:1,Ne+1===Ue&&(Oe-=Me?3:5),Oe}function Z($,K,le,ge,Pe,Te,Ne){return z($,K,le,ge,Pe,Te,!0,Ne)}e.fuzzyScoreGracefulAggressive=Z;function ie($,K,le,ge,Pe,Te,Ne){return z($,K,le,ge,Pe,Te,!1,Ne)}e.fuzzyScoreGraceful=ie;function z($,K,le,ge,Pe,Te,Ne,Ue){let me=ue($,K,le,ge,Pe,Te,Ue);if(me&&!Ne)return me;if($.length>=3){const be=Math.min(7,$.length-1);for(let ye=le+1;ye<be;ye++){const Oe=V($,ye);if(Oe){const Me=ue(Oe,Oe.toLowerCase(),le,ge,Pe,Te,Ue);Me&&(Me[0]-=3,(!me||Me[0]>me[0])&&(me=Me))}}}return me}function V($,K){if(K+1>=$.length)return;const le=$[K],ge=$[K+1];if(le!==ge)return $.slice(0,K)+ge+le+$.slice(K+2)}}),define(ve[140],we([0,1,41,139,15]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(b.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${C.source}`,"g");function p(y){return y.replace(S,(d,g)=>g?d:`\\${d}`)}e.escapeIcons=p;const E=new RegExp(`\\\\${C.source}`,"g");function T(y){return y.replace(E,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=T;const R=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function w(y){return y.indexOf(e.iconStartMarker)===-1?y:y.replace(R,(d,g,c,l)=>c?d:g||l||"")}e.stripIcons=w;function v(y){const d=y.indexOf(e.iconStartMarker);return d===-1?{text:y}:h(y,d)}e.parseLabelWithIcons=v;function h(y,d){const g=[];let c="";function l(u){if(u){c+=u;for(const m of u)g.push(o)}}let f=-1,r="",o=0,n,i,s=d;const a=y.length;for(l(y.substr(0,d));s<a;)n=y[s],i=y[s+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(f=s,l(r),r=e.iconStartMarker,s++):n===")"&&f!==-1?(o+=s-f+1,f=-1,r=""):f!==-1?k.test(n)?r+=n:(l(r),f=-1,r=""):l(n),s++;return l(r),{text:c,iconOffsets:g}}function I(y,d,g=!1){const{text:c,iconOffsets:l}=d;if(!l||l.length===0)return(0,t.matchesFuzzy)(y,c,g);const f=(0,D.ltrim)(c," "),r=c.length-f.length,o=(0,t.matchesFuzzy)(y,f,g);if(o)for(const n of o){const i=l[n.start+r]+r;n.start+=i,n.end+=i}return o}e.matchesFuzzyIconAware=I}),define(ve[87],we([0,1,24]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new b.LRUCache(1e4);function D(E){return p(E,"NFC",t)}e.normalizeNFC=D;const C=new b.LRUCache(1e4);function k(E){return p(E,"NFD",C)}e.normalizeNFD=k;const S=/[^\u0000-\u0080]/;function p(E,T,R){if(!E)return E;const w=R.get(E);if(w)return w;let v;return S.test(E)?v=E.normalize(T):v=E,R.set(E,v),v}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(T){return k(T).replace(E,"")}}()}),define(ve[67],we([0,1,15]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const C="error",k="warning",S="warn",p="info",E="ignore";function T(w){return w?b.equalsIgnoreCase(C,w)?D.Error:b.equalsIgnoreCase(k,w)||b.equalsIgnoreCase(S,w)?D.Warning:b.equalsIgnoreCase(p,w)?D.Info:D.Ignore:D.Ignore}D.fromValue=T;function R(w){switch(w){case D.Error:return C;case D.Warning:return k;case D.Info:return p;default:return E}}D.toString=R}(t||(t={})),e.default=t}),define(ve[12],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function b(o){return typeof o=="string"}e.isString=b;function t(o){return Array.isArray(o)&&o.every(n=>b(n))}e.isStringArray=t;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=D;function C(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=C;function k(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=k;function S(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=S;function p(o){return o===!0||o===!1}e.isBoolean=p;function E(o){return typeof o=="undefined"}e.isUndefined=E;function T(o){return!R(o)}e.isDefined=T;function R(o){return E(o)||o===null}e.isUndefinedOrNull=R;function w(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=w;function v(o){if(R(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=v;function h(...o){const n=[];for(let i=0;i<o.length;i++){const s=o[i];if(R(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(s)}return n}e.assertAllDefined=h;const I=Object.prototype.hasOwnProperty;function y(o){if(!D(o))return!1;for(const n in o)if(I.call(o,n))return!1;return!0}e.isEmptyObject=y;function d(o){return typeof o=="function"}e.isFunction=d;function g(...o){return o.length>0&&o.every(d)}e.areFunctions=g;function c(o,n){const i=Math.min(o.length,n.length);for(let s=0;s<i;s++)l(o[s],n[s])}e.validateConstraints=c;function l(o,n){if(b(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(d(n)){try{if(o instanceof n)return}catch{}if(!R(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function f(o){return o===null?void 0:o}e.withNullAsUndefined=f;function r(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=r}),define(ve[35],we([0,1,6,3,15,12]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function S(s){return s.replace(/[\\/]/g,b.posix.sep)}e.toSlashes=S;function p(s){return s.indexOf("/")===-1&&(s=S(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=p;function E(s,a=b.posix.sep){if(!s)return"";const u=s.length,m=s.charCodeAt(0);if(k(m)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let F=3;const q=F;for(;F<u&&!k(s.charCodeAt(F));F++);if(q!==F&&!k(s.charCodeAt(F+1))){for(F+=1;F<u;F++)if(k(s.charCodeAt(F)))return s.slice(0,F+1).replace(/[\\/]/g,a)}}return a}else if(d(m)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let P=s.indexOf("://");if(P!==-1){for(P+=3;P<u;P++)if(k(s.charCodeAt(P)))return s.slice(0,P+1)}return""}e.getRoot=E;function T(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let u=2;const m=u;for(;u<s.length&&(a=s.charCodeAt(u),a!==92);u++);return!(m===u||(a=s.charCodeAt(u+1),isNaN(a)||a===92))}e.isUNC=T;const R=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,a=t.isWindows){const u=a?R:w;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||a&&v.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function I(s,a,u){const m=s===a;return!u||m?m:!s||!a?!1:(0,D.equalsIgnoreCase)(s,a)}e.isEqual=I;function y(s,a,u,m=b.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(u){if(!(0,D.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let F=a.length;return a.charAt(a.length-1)===m&&F--,s.charAt(F)===m}return a.charAt(a.length-1)!==m&&(a+=m),s.indexOf(a)===0}e.isEqualOrParent=y;function d(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=d;function g(s,a){return t.isWindows&&s.endsWith(":")&&(s+=b.sep),(0,b.isAbsolute)(s)||(s=(0,b.join)(a,s)),s=(0,b.normalize)(s),t.isWindows?(s=(0,D.rtrim)(s,b.sep),s.endsWith(":")&&(s+=b.sep)):(s=(0,D.rtrim)(s,b.sep),s||(s=b.sep)),s}e.sanitizeFilePath=g;function c(s){const a=(0,b.normalize)(s);return t.isWindows?s.length>3?!1:l(a)&&(s.length===2||a.charCodeAt(2)===92):a===b.posix.sep}e.isRootOrDriveLetter=c;function l(s,a=t.isWindows){return a?d(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function f(s){return l(s)?s[0]:void 0}e.getDriveLetter=f;function r(s,a,u){return a.length>s.length?-1:s===a?0:(u&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=r;function o(s){const a=s.split(":");let u,m,P;for(const F of a){const q=Number(F);(0,C.isNumber)(q)?m===void 0?m=q:P===void 0&&(P=q):u=u?[u,F].join(":"):F}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:m!==void 0?m:void 0,column:P!==void 0?P:m!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,a,u=8){let m="";for(let F=0;F<u;F++)m+=n.charAt(Math.floor(Math.random()*n.length));let P;return a?P=`${a}-${m}`:P=m,s?(0,b.join)(s,P):P}e.randomPath=i}),define(ve[22],we([0,1,12]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const g=Array.isArray(d)?[]:{};return Object.keys(d).forEach(c=>{d[c]&&typeof d[c]=="object"?g[c]=t(d[c]):g[c]=d[c]}),g}e.deepClone=t;function D(d){if(!d||typeof d!="object")return d;const g=[d];for(;g.length>0;){const c=g.shift();Object.freeze(c);for(const l in c)if(C.call(c,l)){const f=c[l];typeof f=="object"&&!Object.isFrozen(f)&&!(0,b.isTypedArray)(f)&&g.push(f)}}return d}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function k(d,g){return S(d,g,new Set)}e.cloneAndChange=k;function S(d,g,c){if((0,b.isUndefinedOrNull)(d))return d;const l=g(d);if(typeof l!="undefined")return l;if(Array.isArray(d)){const f=[];for(const r of d)f.push(S(r,g,c));return f}if((0,b.isObject)(d)){if(c.has(d))throw new Error("Cannot clone recursive data-structure");c.add(d);const f={};for(const r in d)C.call(d,r)&&(f[r]=S(d[r],g,c));return c.delete(d),f}return d}function p(d,g,c=!0){return(0,b.isObject)(d)?((0,b.isObject)(g)&&Object.keys(g).forEach(l=>{l in d?c&&((0,b.isObject)(d[l])&&(0,b.isObject)(g[l])?p(d[l],g[l],c):d[l]=g[l]):d[l]=g[l]}),d):g}e.mixin=p;function E(d,g){if(d===g)return!0;if(d==null||g===null||g===void 0||typeof d!=typeof g||typeof d!="object"||Array.isArray(d)!==Array.isArray(g))return!1;let c,l;if(Array.isArray(d)){if(d.length!==g.length)return!1;for(c=0;c<d.length;c++)if(!E(d[c],g[c]))return!1}else{const f=[];for(l in d)f.push(l);f.sort();const r=[];for(l in g)r.push(l);if(r.sort(),!E(f,r))return!1;for(c=0;c<f.length;c++)if(!E(d[f[c]],g[f[c]]))return!1}return!0}e.equals=E;function T(d){const g=new Set;return JSON.stringify(d,(c,l)=>{if((0,b.isObject)(l)||Array.isArray(l)){if(g.has(l))return"[Circular]";g.add(l)}return l})}e.safeStringify=T;function R(d,g){const c=Object.create(null);return!d||!g||Object.keys(g).forEach(f=>{const r=d[f],o=g[f];E(r,o)||(c[f]=o)}),c}e.distinct=R;function w(d,g){const c=g.toLowerCase(),l=Object.keys(d).find(f=>f.toLowerCase()===c);return l?d[l]:d[g]}e.getCaseInsensitive=w;function v(d,g){const c=Object.create(null);for(const[l,f]of Object.entries(d))g(l,f)&&(c[l]=f);return c}e.filter=v;function h(d){let g=[],c=Object.getPrototypeOf(d);for(;Object.prototype!==c;)g=g.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return g}e.getAllPropertyNames=h;function I(d){const g=[];for(const c of h(d))typeof d[c]=="function"&&g.push(c);return g}e.getAllMethodNames=I;function y(d,g){const c=f=>function(){const r=Array.prototype.slice.call(arguments,0);return g(f,r)},l={};for(const f of d)l[f]=c(f);return l}e.createProxyObject=y}),define(ve[4],we([0,1,6,3]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,k=/^\/\//;function S(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(n,i){return!n&&!i?"file":n}function E(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==R&&(i=R+i):i=R;break}return i}const T="",R="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(i,s,a,u,m,P=!1){typeof i=="object"?(this.scheme=i.scheme||T,this.authority=i.authority||T,this.path=i.path||T,this.query=i.query||T,this.fragment=i.fragment||T):(this.scheme=p(i,P),this.authority=s||T,this.path=E(this.scheme,a||T),this.query=u||T,this.fragment=m||T,S(this,P))}static isUri(i){return i instanceof v?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:a,path:u,query:m,fragment:P}=i;return s===void 0?s=this.scheme:s===null&&(s=T),a===void 0?a=this.authority:a===null&&(a=T),u===void 0?u=this.path:u===null&&(u=T),m===void 0?m=this.query:m===null&&(m=T),P===void 0?P=this.fragment:P===null&&(P=T),s===this.scheme&&a===this.authority&&u===this.path&&m===this.query&&P===this.fragment?this:new I(s,a,u,m,P)}static parse(i,s=!1){const a=w.exec(i);return a?new I(a[2]||T,o(a[4]||T),o(a[5]||T),o(a[7]||T),o(a[9]||T),s):new I(T,T,T,T,T)}static file(i){let s=T;if(t.isWindows&&(i=i.replace(/\\/g,R)),i[0]===R&&i[1]===R){const a=i.indexOf(R,2);a===-1?(s=i.substring(2),i=R):(s=i.substring(2,a),i=i.substring(a)||R)}return new I("file",s,i,T,T)}static from(i){const s=new I(i.scheme,i.authority,i.path,i.query,i.fragment);return S(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&i.scheme==="file"?a=v.file(b.win32.join(c(i,!0),...s)).path:a=b.posix.join(i.path,...s),i.with({path:a})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof v)return i;{const s=new I(i);return s._formatted=i.external,s._fsPath=i._sep===h?i.fsPath:null,s}}else return i}}e.URI=v;const h=t.isWindows?1:void 0;class I extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=h),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(n,i){let s,a=-1;for(let u=0;u<n.length;u++){const m=n.charCodeAt(u);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||i&&m===47)a!==-1&&(s+=encodeURIComponent(n.substring(a,u)),a=-1),s!==void 0&&(s+=n.charAt(u));else{s===void 0&&(s=n.substr(0,u));const P=y[m];P!==void 0?(a!==-1&&(s+=encodeURIComponent(n.substring(a,u)),a=-1),s+=P):a===-1&&(a=u)}}return a!==-1&&(s+=encodeURIComponent(n.substring(a))),s!==void 0?s:n}function g(n){let i;for(let s=0;s<n.length;s++){const a=n.charCodeAt(s);a===35||a===63?(i===void 0&&(i=n.substr(0,s)),i+=y[a]):i!==void 0&&(i+=n[s])}return i!==void 0?i:n}function c(n,i){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function l(n,i){const s=i?g:d;let a="",{scheme:u,authority:m,path:P,query:F,fragment:q}=n;if(u&&(a+=u,a+=":"),(m||u==="file")&&(a+=R,a+=R),m){let Y=m.indexOf("@");if(Y!==-1){const se=m.substr(0,Y);m=m.substr(Y+1),Y=se.indexOf(":"),Y===-1?a+=s(se,!1):(a+=s(se.substr(0,Y),!1),a+=":",a+=s(se.substr(Y+1),!1)),a+="@"}m=m.toLowerCase(),Y=m.indexOf(":"),Y===-1?a+=s(m,!1):(a+=s(m.substr(0,Y),!1),a+=m.substr(Y))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const Y=P.charCodeAt(1);Y>=65&&Y<=90&&(P=`/${String.fromCharCode(Y+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const Y=P.charCodeAt(0);Y>=65&&Y<=90&&(P=`${String.fromCharCode(Y+32)}:${P.substr(2)}`)}a+=s(P,!0)}return F&&(a+="?",a+=s(F,!1)),q&&(a+="#",a+=i?q:d(q,!1)),a}function f(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+f(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(r)?n.replace(r,i=>f(i)):n}}),define(ve[141],we([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(E){const T=E;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=t;function D(E){const T=[];let R;try{const w=JSON.parse(E.arguments),v=w[w.length-1];v&&v.__$stack&&(w.pop(),R=v.__$stack),T.push(...w)}catch{T.push("Unable to log remote console arguments",E.arguments)}return{args:T,stack:R}}e.parse=D;function C(E){if(typeof E!="string")return C(D(E).stack);const T=E;if(T){const R=k(T),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(w&&w.length===4)return{uri:b.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=C;function k(E){if(!E)return E;const T=E.indexOf(`
`);return T===-1?E:E.substring(0,T)}function S(E,T){const{args:R,stack:w}=D(E),v=typeof R[0]=="string"&&R.length===1;let h=k(w);h&&(h=`(${h.trim()})`);let I=[];if(typeof R[0]=="string"?h&&v?I=[`%c[${T}] %c${R[0]} %c${h}`,p("blue"),p(""),p("grey")]:I=[`%c[${T}] %c${R[0]}`,p("blue"),p(""),...R.slice(1)]:I=[`%c[${T}]%`,p("blue"),...R],h&&!v&&I.push(h),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,I)}e.log=S;function p(E){return`color: ${E}`}}),define(ve[42],we([0,1,16,15,4]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(E){return JSON.stringify(E,S)}e.stringify=C;function k(E){let T=JSON.parse(E);return T=p(T),T}e.parse=k;function S(E,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,t.regExpFlags)(T)}:T}function p(E,T=0){if(!E||T>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return D.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 14:return new Date(E.source)}if(E instanceof b.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let R=0;R<E.length;++R)E[R]=p(E[R],T+1);else for(const R in E)Object.hasOwnProperty.call(E,R)&&(E[R]=p(E[R],T+1))}return E}e.revive=p}),define(ve[8],we([0,1,3,4]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p){this._remoteResourcesPath=`${p}/${D.vscodeRemoteResource}`}set(p,E,T){this._hosts[p]=E,this._ports[p]=T}setConnectionToken(p,E){this._connectionTokens[p]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)return this._delegate(p);const E=p.authority;let T=this._hosts[E];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const R=this._ports[E],w=this._connectionTokens[E];let v=`path=${encodeURIComponent(p.path)}`;return typeof w=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),t.URI.from({scheme:b.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${T}:${R}`,path:b.isWeb?(window.location.pathname+"/"+this._remoteResourcesPath).replace(/\/\/+/g,"/"):this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new C;class k{asBrowserUri(p,E){const T=this.toUri(p,E);return T.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===D.file&&(b.isNative||b.isWebWorker&&b.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?T.with({scheme:D.vscodeFileResource,authority:T.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(p,E){const T=this.toUri(p,E);return T.scheme===D.vscodeFileResource?T.with({scheme:D.file,authority:T.authority!==k.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(p,E){return t.URI.isUri(p)?p:t.URI.parse(E.toUrl(p))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ve[19],we([0,1,35,8,6,3,15,4]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(v){return(0,S.uriToFsPath)(v,!0)}e.originalFSPath=p;class E{constructor(h){this._ignorePathCasing=h}compare(h,I,y=!1){return h===I?0:(0,k.compare)(this.getComparisonKey(h,y),this.getComparisonKey(I,y))}isEqual(h,I,y=!1){return h===I?!0:!h||!I?!1:this.getComparisonKey(h,y)===this.getComparisonKey(I,y)}getComparisonKey(h,I=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:I?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,I,y=!1){if(h.scheme===I.scheme){if(h.scheme===t.Schemas.file)return b.isEqualOrParent(p(h),p(I),this._ignorePathCasing(h))&&h.query===I.query&&(y||h.fragment===I.fragment);if((0,e.isEqualAuthority)(h.authority,I.authority))return b.isEqualOrParent(h.path,I.path,this._ignorePathCasing(h),"/")&&h.query===I.query&&(y||h.fragment===I.fragment)}return!1}joinPath(h,...I){return S.URI.joinPath(h,...I)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let I;return h.scheme===t.Schemas.file?I=S.URI.file(D.dirname(p(h))).path:(I=D.posix.dirname(h.path),h.authority&&I.length&&I.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),I="/")),h.with({path:I})}normalizePath(h){if(!h.path.length)return h;let I;return h.scheme===t.Schemas.file?I=S.URI.file(D.normalize(p(h))).path:I=D.posix.normalize(h.path),h.with({path:I})}relativePath(h,I){if(h.scheme!==I.scheme||!(0,e.isEqualAuthority)(h.authority,I.authority))return;if(h.scheme===t.Schemas.file){const g=D.relative(p(h),p(I));return C.isWindows?b.toSlashes(g):g}let y=h.path||"/";const d=I.path||"/";if(this._ignorePathCasing(h)){let g=0;for(const c=Math.min(y.length,d.length);g<c&&!(y.charCodeAt(g)!==d.charCodeAt(g)&&y.charAt(g).toLowerCase()!==d.charAt(g).toLowerCase());g++);y=d.substr(0,g)+y.substr(g)}return D.posix.relative(y,d)}resolvePath(h,I){if(h.scheme===t.Schemas.file){const y=S.URI.file(D.resolve(p(h),I));return h.with({authority:y.authority,path:y.path})}return I=b.toPosixPath(I),h.with({path:D.posix.resolve(h.path,I)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,I){return h===I||h!==void 0&&I!==void 0&&(0,k.equalsIgnoreCase)(h,I)}hasTrailingPathSeparator(h,I=D.sep){if(h.scheme===t.Schemas.file){const y=p(h);return y.length>b.getRoot(y).length&&y[y.length-1]===I}else{const y=h.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,I=D.sep){return(0,e.hasTrailingPathSeparator)(h,I)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,I=D.sep){let y=!1;if(h.scheme===t.Schemas.file){const d=p(h);y=d!==void 0&&d.length===b.getRoot(d).length&&d[d.length-1]===I}else{I="/";const d=h.path;y=d.length===1&&d.charCodeAt(d.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(h,I)?h.with({path:h.path+"/"}):h}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(v=>v.scheme===t.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new E(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(v,h){const I=[];for(let y=0;y<v.length;y++){const d=h(v[y]);v.some((g,c)=>c===y?!1:(0,e.isEqualOrParent)(d,h(g)))||I.push(v[y])}return I}e.distinctParents=T;var R;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(I){const y=new Map;I.path.substring(I.path.indexOf(";")+1,I.path.lastIndexOf(";")).split(";").forEach(c=>{const[l,f]=c.split(":");l&&f&&y.set(l,f)});const g=I.path.substring(0,I.path.indexOf(";"));return g&&y.set(v.META_DATA_MIME,g),y}v.parseMetaData=h})(R=e.DataUri||(e.DataUri={}));function w(v,h,I){if(h){let y=v.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),v.with({scheme:I,authority:h,path:y})}return v.with({scheme:I})}e.toLocalResource=w}),define(ve[14],we([0,1,20,11,7,2,19,3]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(re){return!!re&&typeof re.then=="function"}e.isThenable=p;function E(re){const L=new b.CancellationTokenSource,O=re(L.token),x=new Promise((ne,ue)=>{const pe=L.token.onCancellationRequested(()=>{pe.dispose(),L.dispose(),ue(new t.CancellationError)});Promise.resolve(O).then(W=>{pe.dispose(),L.dispose(),ne(W)},W=>{pe.dispose(),L.dispose(),ue(W)})});return new class{cancel(){L.cancel()}then(ne,ue){return x.then(ne,ue)}catch(ne){return this.then(void 0,ne)}finally(ne){return x.finally(ne)}}}e.createCancelablePromise=E;function T(re,L,O){return new Promise((x,ne)=>{const ue=L.onCancellationRequested(()=>{ue.dispose(),x(O)});re.then(x,ne).finally(()=>ue.dispose())})}e.raceCancellation=T;function R(re,L){return new Promise((O,x)=>{const ne=L.onCancellationRequested(()=>{ne.dispose(),x(new t.CancellationError)});re.then(O,x).finally(()=>ne.dispose())})}e.raceCancellationError=R;async function w(re){let L=-1;const O=re.map((ne,ue)=>ne.then(pe=>(L=ue,pe))),x=await Promise.race(O);return re.forEach((ne,ue)=>{ue!==L&&ne.cancel()}),x}e.raceCancellablePromises=w;function v(re,L,O){let x;const ne=setTimeout(()=>{x?.(void 0),O?.()},L);return Promise.race([re.finally(()=>clearTimeout(ne)),new Promise(ue=>x=ue)])}e.raceTimeout=v;function h(re){return new Promise((L,O)=>{const x=re();p(x)?x.then(L,O):L(x)})}e.asPromise=h;class I{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(O,O).then(x)})}return new Promise((O,x)=>{this.queuedPromise.then(O,x)})}return this.activePromise=L(),new Promise((O,x)=>{this.activePromise.then(ne=>{this.activePromise=null,O(ne)},ne=>{this.activePromise=null,x(ne)})})}}e.Throttler=I;class y{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=y;class d{constructor(){this.promiseMap=new Map}queue(L,O){const ne=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===ne&&this.promiseMap.delete(L)});return this.promiseMap.set(L,ne),ne}}e.SequencerByKey=d;const g=(re,L)=>{let O=!0;const x=setTimeout(()=>{O=!1,L()},re);return{isTriggered:()=>O,dispose:()=>{clearTimeout(x),O=!1}}},c=re=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,re())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ne,ue)=>{this.doResolve=ne,this.doReject=ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ne=this.task;return this.task=null,ne()}}));const x=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?c(x):g(O,x),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class f{constructor(L){this.delayer=new l(L),this.throttler=new I}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class r{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class o extends r{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function n(re,L){return L?new Promise((O,x)=>{const ne=setTimeout(()=>{ue.dispose(),O()},re),ue=L.onCancellationRequested(()=>{clearTimeout(ne),ue.dispose(),x(new t.CancellationError)})}):E(O=>n(re,O))}e.timeout=n;function i(re,L=0){const O=setTimeout(re,L);return(0,C.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=i;function s(re){const L=[];let O=0;const x=re.length;function ne(){return O<x?re[O++]():null}function ue(pe){pe!=null&&L.push(pe);const W=ne();return W?W.then(ue):Promise.resolve(L)}return Promise.resolve(null).then(ue)}e.sequence=s;function a(re,L=x=>!!x,O=null){let x=0;const ne=re.length,ue=()=>{if(x>=ne)return Promise.resolve(O);const pe=re[x++];return Promise.resolve(pe()).then(Z=>L(Z)?Promise.resolve(Z):ue())};return ue()}e.first=a;function u(re,L=x=>!!x,O=null){if(re.length===0)return Promise.resolve(O);let x=re.length;const ne=()=>{x=-1;for(const ue of re)ue.cancel?.()};return new Promise((ue,pe)=>{for(const W of re)W.then(Z=>{--x>=0&&L(Z)?(ne(),ue(Z)):x===0&&ue(O)}).catch(Z=>{--x>=0&&(ne(),pe(Z))})})}e.firstParallel=u;class m{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,x)=>{this.outstandingPromises.push({factory:L,c:O,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class P extends m{constructor(){super(1)}}e.Queue=P;class F{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new M;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=k.extUri){const x=O.getComparisonKey(L);let ne=this.queues.get(x);return ne||(ne=new P,D.Event.once(ne.onDrained)(()=>{ne?.dispose(),this.queues.delete(x),this.onDidQueueDrain()}),this.queues.set(x,ne)),ne}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=F;class q{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=q;class Y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=Y;class se{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=se;class _{constructor(L,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=_;class G extends se{constructor(L,O){super(L,O);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=G;class te extends C.Disposable{constructor(L,O){super();this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new se(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=te,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=re=>{(0,S.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(re,L)=>{const O=requestIdleCallback(re,typeof L=="number"?{timeout:L}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(O))}}}}();class j{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function he(re,L,O){let x;for(let ne=0;ne<O;ne++)try{return await re()}catch(ue){x=ue,await n(L)}throw x}e.retry=he;class J{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,O,x){return this._pending={taskId:L,cancel:()=>x?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,x;const ne=new Promise((ue,pe)=>{O=ue,x=pe});this._next={run:L,promise:ne,promiseResolve:O,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=J;class U{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=M;var B;(function(re){async function L(x){let ne;const ue=await Promise.all(x.map(pe=>pe.then(W=>W,W=>{ne||(ne=W)})));if(typeof ne!="undefined")throw ne;return ue}re.settled=L;function O(x){return new Promise(async(ne,ue)=>{try{await x(ne,ue)}catch(pe){ue(pe)}})}re.withAsyncBody=O})(B=e.Promises||(e.Promises={}));var Q;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(Q||(Q={}));class ae{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const O={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(L(O)),this.resolve()}catch(x){this.reject(x)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new ae(O=>{O.emitMany(L)})}static fromPromise(L){return new ae(async O=>{O.emitMany(await L)})}static fromPromises(L){return new ae(async O=>{await Promise.all(L.map(async x=>O.emitOne(await x)))})}static merge(L){return new ae(async O=>{await Promise.all(L.map(async x=>{for await(const ne of x)O.emitOne(ne)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new ae(async x=>{for await(const ne of L)x.emitOne(O(ne))})}map(L){return ae.map(this,L)}static filter(L,O){return new ae(async x=>{for await(const ne of L)O(ne)&&x.emitOne(ne)})}filter(L){return ae.filter(this,L)}static coalesce(L){return ae.filter(L,O=>!!O)}coalesce(){return ae.coalesce(this)}static async toPromise(L){const O=[];for await(const x of L)O.push(x);return O}toPromise(){return ae.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=ae,ae.EMPTY=ae.fromArray([]);class fe extends ae{constructor(L,O){super(O);this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=fe;function X(re){const L=new b.CancellationTokenSource,O=re(L.token);return new fe(L,async x=>{const ne=L.token.onCancellationRequested(()=>{ne.dispose(),L.dispose(),x.reject(new t.CancellationError)});try{for await(const ue of O){if(L.token.isCancellationRequested)return;x.emitOne(ue)}ne.dispose(),L.dispose()}catch(ue){ne.dispose(),L.dispose(),x.reject(ue)}})}e.createCancelableAsyncIterable=X}),define(ve[68],we([0,1,18,14,35,24,6,3,15]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",R="[^/\\\\]",w=/\//g;function v(M,B){switch(M){case 0:return"";case 1:return`${R}*?`;default:return`(?:${T}|${R}+${T}${B?`|${T}${R}+`:""})*?`}}function h(M,B){if(!M)return[];const Q=[];let ae=!1,fe=!1,X="";for(const re of M){switch(re){case B:if(!ae&&!fe){Q.push(X),X="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}X+=re}return X&&Q.push(X),Q}e.splitGlobAware=h;function I(M){if(!M)return"";let B="";const Q=h(M,e.GLOB_SPLIT);if(Q.every(ae=>ae===e.GLOBSTAR))B=".*";else{let ae=!1;Q.forEach((fe,X)=>{if(fe===e.GLOBSTAR){if(ae)return;B+=v(2,X===Q.length-1)}else{let re=!1,L="",O=!1,x="";for(const ne of fe){if(ne!=="}"&&re){L+=ne;continue}if(O&&(ne!=="]"||!x)){let ue;ne==="-"?ue=ne:(ne==="^"||ne==="!")&&!x?ue="^":ne===e.GLOB_SPLIT?ue="":ue=(0,p.escapeRegExpCharacters)(ne),x+=ue;continue}switch(ne){case"{":re=!0;continue;case"[":O=!0;continue;case"}":{B+=`(?:${h(L,",").map(W=>I(W)).join("|")})`,re=!1,L="";break}case"]":{B+="["+x+"]",O=!1,x="";break}case"?":B+=R;continue;case"*":B+=v(1);continue;default:B+=(0,p.escapeRegExpCharacters)(ne)}}X<Q.length-1&&(Q[X+1]!==e.GLOBSTAR||X+2<Q.length)&&(B+=T)}ae=fe===e.GLOBSTAR})}return B}const y=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new C.LRUCache(1e4),o=function(){return!1},n=function(){return null};function i(M,B){if(!M)return n;let Q;typeof M!="string"?Q=M.pattern:Q=M,Q=Q.trim();const ae=`${Q}_${!!B.trimForExclusions}`;let fe=r.get(ae);if(fe)return s(fe,M);let X;return y.test(Q)?fe=u(Q.substr(4),Q):(X=d.exec(a(Q,B)))?fe=m(X[1],Q):(B.trimForExclusions?c:g).test(Q)?fe=P(Q,B):(X=l.exec(a(Q,B)))?fe=F(X[1].substr(1),Q,!0):(X=f.exec(a(Q,B)))?fe=F(X[1],Q,!1):fe=q(Q),r.set(ae,fe),s(fe,M)}function s(M,B){if(typeof B=="string")return M;const Q=function(ae,fe){return(0,D.isEqualOrParent)(ae,B.base,!S.isLinux)?M(ae.substr(B.base.length+1),fe):null};return Q.allBasenames=M.allBasenames,Q.allPaths=M.allPaths,Q.basenames=M.basenames,Q.patterns=M.patterns,Q}function a(M,B){return B.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function u(M,B){return function(Q,ae){return typeof Q=="string"&&Q.endsWith(M)?B:null}}function m(M,B){const Q=`/${M}`,ae=`\\${M}`,fe=function(re,L){return typeof re!="string"?null:L?L===M?B:null:re===M||re.endsWith(Q)||re.endsWith(ae)?B:null},X=[M];return fe.basenames=X,fe.patterns=[B],fe.allBasenames=X,fe}function P(M,B){const Q=J(M.slice(1,-1).split(",").map(L=>i(L,B)).filter(L=>L!==n),M),ae=Q.length;if(!ae)return n;if(ae===1)return Q[0];const fe=function(L,O){for(let x=0,ne=Q.length;x<ne;x++)if(Q[x](L,O))return M;return null},X=Q.find(L=>!!L.allBasenames);X&&(fe.allBasenames=X.allBasenames);const re=Q.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return re.length&&(fe.allPaths=re),fe}function F(M,B,Q){const ae=k.sep===k.posix.sep,fe=ae?M:M.replace(w,k.sep),X=k.sep+fe,re=k.posix.sep+M;let L;return Q?L=function(O,x){return typeof O=="string"&&(O===fe||O.endsWith(X)||!ae&&(O===M||O.endsWith(re)))?B:null}:L=function(O,x){return typeof O=="string"&&(O===fe||!ae&&O===M)?B:null},L.allPaths=[(Q?"*/":"./")+M],L}function q(M){try{const B=new RegExp(`^${I(M)}$`);return function(Q){return B.lastIndex=0,typeof Q=="string"&&B.test(Q)?M:null}}catch{return n}}function Y(M,B,Q){return!M||typeof B!="string"?!1:se(M)(B,void 0,Q)}e.match=Y;function se(M,B={}){if(!M)return o;if(typeof M=="string"||_(M)){const Q=i(M,B);if(Q===n)return o;const ae=function(fe,X){return!!Q(fe,X)};return Q.allBasenames&&(ae.allBasenames=Q.allBasenames),Q.allPaths&&(ae.allPaths=Q.allPaths),ae}return j(M,B)}e.parse=se;function _(M){const B=M;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=_;function G(M){return M.allBasenames||[]}e.getBasenameTerms=G;function te(M){return M.allPaths||[]}e.getPathTerms=te;function j(M,B){const Q=J(Object.getOwnPropertyNames(M).map(L=>he(L,M[L],B)).filter(L=>L!==n)),ae=Q.length;if(!ae)return n;if(!Q.some(L=>!!L.requiresSiblings)){if(ae===1)return Q[0];const L=function(ne,ue){let pe;for(let W=0,Z=Q.length;W<Z;W++){const ie=Q[W](ne,ue);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(pe||(pe=[]),pe.push(ie))}return pe?(async()=>{for(const W of pe){const Z=await W;if(typeof Z=="string")return Z}return null})():null},O=Q.find(ne=>!!ne.allBasenames);O&&(L.allBasenames=O.allBasenames);const x=Q.reduce((ne,ue)=>ue.allPaths?ne.concat(ue.allPaths):ne,[]);return x.length&&(L.allPaths=x),L}const fe=function(L,O,x){let ne,ue;for(let pe=0,W=Q.length;pe<W;pe++){const Z=Q[pe];Z.requiresSiblings&&x&&(O||(O=(0,k.basename)(L)),ne||(ne=O.substr(0,O.length-(0,k.extname)(L).length)));const ie=Z(L,O,ne,x);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(ue||(ue=[]),ue.push(ie))}return ue?(async()=>{for(const pe of ue){const W=await pe;if(typeof W=="string")return W}return null})():null},X=Q.find(L=>!!L.allBasenames);X&&(fe.allBasenames=X.allBasenames);const re=Q.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return re.length&&(fe.allPaths=re),fe}function he(M,B,Q){if(B===!1)return n;const ae=i(M,Q);if(ae===n)return n;if(typeof B=="boolean")return ae;if(B){const fe=B.when;if(typeof fe=="string"){const X=(re,L,O,x)=>{if(!x||!ae(re,L))return null;const ne=fe.replace("$(basename)",O),ue=x(ne);return(0,t.isThenable)(ue)?ue.then(pe=>pe?M:null):ue?M:null};return X.requiresSiblings=!0,X}}return ae}function J(M,B){const Q=M.filter(L=>!!L.basenames);if(Q.length<2)return M;const ae=Q.reduce((L,O)=>{const x=O.basenames;return x?L.concat(x):L},[]);let fe;if(B){fe=[];for(let L=0,O=ae.length;L<O;L++)fe.push(B)}else fe=Q.reduce((L,O)=>{const x=O.patterns;return x?L.concat(x):L},[]);const X=function(L,O){if(typeof L!="string")return null;if(!O){let ne;for(ne=L.length;ne>0;ne--){const ue=L.charCodeAt(ne-1);if(ue===47||ue===92)break}O=L.substr(ne)}const x=ae.indexOf(O);return x!==-1?fe[x]:null};X.basenames=ae,X.patterns=fe,X.allBasenames=ae;const re=M.filter(L=>!L.basenames);return re.push(X),re}function U(M,B){return(0,b.equals)(M,B,(Q,ae)=>typeof Q=="string"&&typeof ae=="string"?Q===ae:typeof Q!="string"&&typeof ae!="string"?Q.base===ae.base&&Q.pattern===ae.pattern:!1)}e.patternsEquals=U}),define(ve[88],we([0,1,11,140,19,15,4]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(y){y[y.Paragraph=0]="Paragraph",y[y.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class p{constructor(d="",g=!1){if(this.value=d,typeof this.value!="string")throw(0,b.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(d,g=0){return this.value+=w(this.supportThemeIcons?(0,t.escapeIcons)(d):d).replace(/([ \t]+)/g,(c,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,g){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(d,g,c){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(d),")"),c&&(this.value+=` "${this._escape(this._escape(c,'"'),")")}"`),this.value+=")",this}_escape(d,g){const c=new RegExp((0,C.escapeRegExpCharacters)(g),"g");return d.replace(c,(l,f)=>d.charAt(f-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=p;function E(y){return T(y)?!y.value:Array.isArray(y)?y.every(E):!0}e.isEmptyMarkdownString=E;function T(y){return y instanceof p?!0:y&&typeof y=="object"?typeof y.value=="string"&&(typeof y.isTrusted=="boolean"||y.isTrusted===void 0)&&(typeof y.supportThemeIcons=="boolean"||y.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function R(y,d){return y===d?!0:!y||!d?!1:y.value===d.value&&y.isTrusted===d.isTrusted&&y.supportThemeIcons===d.supportThemeIcons&&y.supportHtml===d.supportHtml&&(y.baseUri===d.baseUri||!!y.baseUri&&!!d.baseUri&&(0,D.isEqual)(k.URI.from(y.baseUri),k.URI.from(d.baseUri)))}e.markdownStringEqual=R;function w(y){return y.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=w;function v(y){return y.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function h(y){return y&&y.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function I(y){const d=[],g=y.split("|").map(l=>l.trim());y=g[0];const c=g[1];if(c){const l=/height=(\d+)/.exec(c),f=/width=(\d+)/.exec(c),r=l?l[1]:"",o=f?f[1]:"",n=isFinite(parseInt(o)),i=isFinite(parseInt(r));n&&d.push(`width="${o}"`),i&&d.push(`height="${r}"`)}return{href:y,dimensions:d}}e.parseHrefAndDimensions=I}),define(ve[142],we([0,1,18,35,6,3,19,15]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(n,i){const{os:s,tildify:a,relative:u}=i;if(u){const F=E(n,u,s);if(typeof F=="string")return F}let m=n.fsPath;if(s===1&&!C.isWindows?m=m.replace(/\//g,"\\"):s!==1&&C.isWindows&&(m=m.replace(/\\/g,"/")),s!==1&&a?.userHome){const F=a.userHome.fsPath;let q;n.scheme!==a.userHome.scheme&&n.path.startsWith(D.posix.sep)?q=a.userHome.with({path:n.path}).fsPath:q=n.fsPath,m=w(q,F,s)}return(s===1?D.win32:D.posix).normalize(T(m,s===1))}e.getPathLabel=p;function E(n,i,s){const a=s===1?D.win32:D.posix,u=s===3?k.extUri:k.extUriIgnorePathCase,m=i.getWorkspace(),P=(0,b.firstOrDefault)(m.folders);if(!P)return;n.scheme!==P.uri.scheme&&n.path.startsWith(D.posix.sep)&&(n=P.uri.with({path:n.path}));const F=i.getWorkspaceFolder(n);if(!F)return;let q;if(u.isEqual(F.uri,n)?q="":q=u.relativePath(F.uri,n)??"",q&&(q=a.normalize(q)),m.folders.length>1&&!i.noPrefix){const Y=F.name?F.name:u.basenameOrAuthority(F.uri);q=q?`${Y} \u2022 ${q}`:Y}return q}function T(n,i=C.isWindows){return(0,t.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=T;let R=Object.create(null);function w(n,i,s=C.OS){if(s===1||!n||!i)return n;let a=R.original===i?R.normalized:void 0;a||(a=i,C.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,S.rtrim)(a,D.posix.sep)}${D.posix.sep}`,R={original:i,normalized:a});let u=n;return C.isWindows&&(u=(0,t.toSlashes)(u)),(s===3?u.startsWith(a):(0,S.startsWithIgnoreCase)(u,a))?`~/${u.substr(a.length)}`:n}e.tildify=w;function v(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=v;const h="\u2026",I="\\\\",y="~";function d(n,i=D.sep){const s=new Array(n.length);let a=!1;for(let u=0;u<n.length;u++){const m=n[u];if(m===""){s[u]=`.${i}`;continue}if(!m){s[u]=m;continue}a=!0;let P="",F=m;F.indexOf(I)===0?(P=F.substr(0,F.indexOf(I)+I.length),F=F.substr(F.indexOf(I)+I.length)):F.indexOf(i)===0?(P=F.substr(0,F.indexOf(i)+i.length),F=F.substr(F.indexOf(i)+i.length)):F.indexOf(y)===0&&(P=F.substr(0,F.indexOf(y)+y.length),F=F.substr(F.indexOf(y)+y.length));const q=F.split(i);for(let Y=1;a&&Y<=q.length;Y++)for(let se=q.length-Y;a&&se>=0;se--){a=!1;let _=q.slice(se,se+Y).join(i);for(let G=0;!a&&G<n.length;G++)if(G!==u&&n[G]&&n[G].indexOf(_)>-1){const te=se+Y===q.length,j=se>0&&n[G].indexOf(i)>-1?i+_:_,he=n[G].endsWith(j);a=!te||he}if(!a){let G="";(q[0].endsWith(":")||P!=="")&&(se===1&&(se=0,Y++,_=q[0]+i+_),se>0&&(G=q[0]+i),G=P+G),se>0&&(G=G+h+i),G=G+_,se+Y<q.length&&(G=G+i+h),s[u]=G}}a&&(s[u]=m)}return s}e.shorten=d;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function c(n,i=Object.create(null)){const s=[];let a=!1,u="";for(const m of n)if(m==="$"||a&&m==="{")u&&s.push({value:u,type:g.TEXT}),u="",a=!0;else if(m==="}"&&a){const P=i[u];if(typeof P=="string")P.length&&s.push({value:P,type:g.VARIABLE});else if(P){const F=s[s.length-1];(!F||F.type!==g.SEPARATOR)&&s.push({value:P.label,type:g.SEPARATOR})}u="",a=!1}else u+=m;return u&&!a&&s.push({value:u,type:g.TEXT}),s.filter((m,P)=>{if(m.type===g.SEPARATOR){const F=s[P-1],q=s[P+1];return[F,q].every(Y=>Y&&(Y.type===g.VARIABLE||Y.type===g.TEXT)&&Y.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=c;function l(n,i){return C.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function f(n,i){return C.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=f;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(n){const i=n.indexOf("/")!==-1?D.posix:D.win32,s=i.basename(n),a=i.dirname(n);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(ve[69],we([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(T){return T.toJSON()}class D{constructor(R){this._uriTransformer=R}transformIncoming(R){const w=this._uriTransformer.transformIncoming(R);return w===R?R:t(b.URI.from(w))}transformOutgoing(R){const w=this._uriTransformer.transformOutgoing(R);return w===R?R:t(b.URI.from(w))}transformOutgoingURI(R){const w=this._uriTransformer.transformOutgoing(R);return w===R?R:b.URI.from(w)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function C(T,R,w){if(!T||w>200)return null;if(typeof T=="object"){if(T instanceof b.URI)return R.transformOutgoing(T);for(const v in T)if(Object.hasOwnProperty.call(T,v)){const h=C(T[v],R,w+1);h!==null&&(T[v]=h)}}return null}function k(T,R){const w=C(T,R,0);return w===null?T:w}e.transformOutgoingURIs=k;function S(T,R,w,v){if(!T||v>200)return null;if(typeof T=="object"){if(T.$mid===1)return w?b.URI.revive(R.transformIncoming(T)):R.transformIncoming(T);for(const h in T)if(Object.hasOwnProperty.call(T,h)){const I=S(T[h],R,w,v+1);I!==null&&(T[h]=I)}}return null}function p(T,R){const w=S(T,R,!1,0);return w===null?T:w}e.transformIncomingURIs=p;function E(T,R){const w=S(T,R,!0,0);return w===null?T:w}e.transformAndReviveIncomingURIs=E}),define(ve[23],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return b.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(S){for(let p=0;p<S.length;p++)S[p]=Math.floor(Math.random()*256);return S};const C=new Uint8Array(16),k=[];for(let S=0;S<256;S++)k.push(S.toString(16).padStart(2,"0"));return function(){D(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let p=0,E="";return E+=k[C[p++]],E+=k[C[p++]],E+=k[C[p++]],E+=k[C[p++]],E+="-",E+=k[C[p++]],E+=k[C[p++]],E+="-",E+=k[C[p++]],E+=k[C[p++]],E+="-",E+=k[C[p++]],E+=k[C[p++]],E+="-",E+=k[C[p++]],E+=k[C[p++]],E+=k[C[p++]],E+=k[C[p++]],E+=k[C[p++]],E+=k[C[p++]],E}}()}),function(){"use strict";function oe(e,b,t,D){function C(h){return new Promise(I=>t.exists(h,I))}function k(h){return new Promise((I,y)=>{const d=new Date;t.utimes(h,d,d,g=>g?y(g):I())})}function S(h){return new Promise((I,y)=>t.mkdir(h,{recursive:!0},d=>d&&d.code!=="EEXIST"?y(d):I(h)))}function p(h){return new Promise((I,y)=>t.rm(h,{recursive:!0,force:!0,maxRetries:3},d=>d?y(d):I()))}function E(h){return new Promise((I,y)=>t.readFile(h,"utf8",(d,g)=>d?y(d):I(g)))}function T(h,I){return new Promise((y,d)=>t.writeFile(h,I,"utf8",g=>g?d(g):y()))}function R(h){const I=b.join(h,"languagepacks.json");try{return JSON.parse(t.readFileSync(I,"utf8"))}catch{}}function w(h,I){try{for(;I;){if(h[I])return I;{const y=I.lastIndexOf("-");if(y>0)I=I.substring(0,y);else return}}}catch(y){console.error("Resolving language pack configuration failed.",y)}}function v(h,I,y,d){if(d==="pseudo")return Promise.resolve({locale:d,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:d,availableLanguages:{}});if(d&&(d==="en"||d==="en-us"))return Promise.resolve({locale:d,availableLanguages:{}});const g=d;D.mark("code/willGenerateNls");const c=function(l){return D.mark("code/didGenerateNls"),Promise.resolve({locale:l,availableLanguages:{}})};try{if(!h)return c(g);const l=R(I);if(!l||(d=w(l,d),!d))return c(g);const f=l[d];let r;return!f||typeof f.hash!="string"||!f.translations||typeof(r=f.translations.vscode)!="string"?c(g):C(r).then(o=>{if(!o)return c(g);const n=f.hash+"."+d,i=b.join(I,"clp",n),s=b.join(i,h),a=b.join(i,"tcf.json"),u=b.join(i,"corrupted.info"),m={locale:g,availableLanguages:{"*":d},_languagePackId:n,_translationsConfigFile:a,_cacheRoot:i,_resolvedLanguagePackCoreLocation:s,_corruptedFile:u};return C(u).then(P=>{let F;return P?F=p(i):F=Promise.resolve(void 0),F.then(()=>C(s).then(q=>q?(k(s).catch(()=>{}),D.mark("code/didGenerateNls"),m):S(s).then(()=>Promise.all([E(y),E(r)])).then(Y=>{const se=JSON.parse(Y[0]),_=JSON.parse(Y[1]).contents,G=Object.keys(se.bundles),te=[];for(const j of G){const he=se.bundles[j],J=Object.create(null);for(const U of he){const M=se.keys[U],B=se.messages[U],Q=_[U];let ae;if(Q){ae=[];for(let fe=0;fe<M.length;fe++){const X=M[fe],re=typeof X=="string"?X:X.key;let L=Q[re];L===void 0&&(L=B[fe]),ae.push(L)}}else ae=B;J[U]=ae}te.push(T(b.join(s,j.replace(/\//g,"!")+".nls.json"),JSON.stringify(J)))}return te.push(T(a,JSON.stringify(f.translations))),Promise.all(te)}).then(()=>(D.mark("code/didGenerateNls"),m)).catch(Y=>(console.error("Generating translation files failed.",Y),c(d)))))})})}catch(l){return console.error("Generating translation files failed.",l),c(d)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(ve[143],we([0,89,30,47]),function(e,b,t,D){return oe(e.__$__nodeRequire,b,t,D)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),b=require("fs"),t=require("../common/performance");module.exports=oe(require,e,b,t)}else throw new Error("Unknown context")}(),define(ve[144],we([0,1,28]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(k){const S=k.replace(/\-/g,":").toLowerCase();return!t.has(S)}function C(){const k=(0,b.networkInterfaces)();for(const S in k){const p=k[S];if(p){for(const{mac:E}of p)if(D(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ve[90],we([0,1,28,11,24,23,144]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(T){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(T)}value(){if(this._value===void 0){let T=0,R=0;const w=(0,b.networkInterfaces)();for(const v in w){const h=w[v];if(h)for(const{mac:I,internal:y}of h)y||(R+=1,this._isVirtualMachineMacAddress(I.toUpperCase())&&(T+=1))}this._value=R>0?T/R:0}return this._value}};let S;async function p(){return S||(S=(async()=>await E()||C.generateUuid())()),S}e.getMachineId=p;async function E(){try{const T=await new Promise((w,v)=>{oe(["crypto"],w,v)}),R=(0,k.getMac)();return T.createHash("sha256").update(R,"utf8").digest("hex")}catch(T){t.onUnexpectedError(T);return}}}),define(ve[21],we([0,1,30,28,266,14,35,87,6,3,19,4]),function(oe,e,b,t,D,C,k,S,p,E,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function v(j,he=w.UNLINK){if((0,k.isRootOrDriveLetter)(j))throw new Error("rimraf - will refuse to recursively delete root");return he===w.UNLINK?I(j):h(j)}async function h(j){try{const he=(0,k.randomPath)((0,t.tmpdir)());try{await b.promises.rename(j,he)}catch{return I(j)}I(he).catch(J=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function I(j){return(0,D.promisify)(b.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function y(j){if((0,k.isRootOrDriveLetter)(j))throw new Error("rimraf - will refuse to recursively delete root");b.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function d(j,he){return l(await(he?g(j):(0,D.promisify)(b.readdir)(j)))}async function g(j){try{return await(0,D.promisify)(b.readdir)(j,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const he=[],J=await d(j);for(const U of J){let M=!1,B=!1,Q=!1;try{const ae=await e.Promises.lstat((0,p.join)(j,U));M=ae.isFile(),B=ae.isDirectory(),Q=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}he.push({name:U,isFile:()=>M,isDirectory:()=>B,isSymbolicLink:()=>Q})}return he}function c(j){return l(b.readdirSync(j))}e.readdirSync=c;function l(j){return j.map(he=>typeof he=="string"?E.isMacintosh?(0,S.normalizeNFC)(he):he:(he.name=E.isMacintosh?(0,S.normalizeNFC)(he.name):he.name,he))}async function f(j){const he=await d(j),J=[];for(const U of he)await o.existsDirectory((0,p.join)(j,U))&&J.push(U);return J}function r(j,he=1e3){return new Promise(J=>{let U=!1;const M=setInterval(()=>{U||(U=!0,b.access(j,B=>{U=!1,B&&(clearInterval(M),J(void 0))}))},he)})}e.whenDeleted=r;var o;(function(j){async function he(M){let B;try{if(B=await e.Promises.lstat(M),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(M),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(E.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ae}throw Q}}j.stat=he;async function J(M){try{const{stat:B,symbolicLink:Q}=await j.stat(M);return B.isFile()&&Q?.dangling!==!0}catch{}return!1}j.existsFile=J;async function U(M){try{const{stat:B,symbolicLink:Q}=await j.stat(M);return B.isDirectory()&&Q?.dangling!==!0}catch{}return!1}j.existsDirectory=U})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new C.ResourceQueue;function i(j,he,J){return n.queueFor(R.URI.file(j),T.extUriBiasedIgnorePathCase).queue(()=>{const U=P(J);return new Promise((M,B)=>u(j,he,U,Q=>Q?B(Q):M()))})}let s=!0;function a(j){s=j}e.configureFlushOnWrite=a;function u(j,he,J,U){if(!s)return b.writeFile(j,he,{mode:J.mode,flag:J.flag},U);b.open(j,J.flag,J.mode,(M,B)=>{if(M)return U(M);b.writeFile(B,he,Q=>{if(Q)return b.close(B,()=>U(Q));b.fdatasync(B,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),a(!1)),b.close(B,fe=>U(fe))))})})}function m(j,he,J){const U=P(J);if(!s)return b.writeFileSync(j,he,{mode:U.mode,flag:U.flag});const M=b.openSync(j,U.flag,U.mode);try{b.writeFileSync(M,he);try{b.fdatasyncSync(M)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),a(!1)}}finally{b.closeSync(M)}}e.writeFileSync=m;function P(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function F(j,he){if(j!==he)try{await e.Promises.rename(j,he)}catch(J){if(j.toLowerCase()!==he.toLowerCase()&&J.code==="EXDEV"||j.endsWith("."))await q(j,he,{preserveSymlinks:!1}),await v(j,w.MOVE);else throw J}}async function q(j,he,J){return se(j,he,{root:{source:j,target:he},options:J,handledSourcePaths:new Set})}const Y=511;async function se(j,he,J){if(J.handledSourcePaths.has(j))return;J.handledSourcePaths.add(j);const{stat:U,symbolicLink:M}=await o.stat(j);if(M){if(J.options.preserveSymlinks)try{return await te(j,he,J)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(M.dangling)return}return U.isDirectory()?_(j,he,U.mode&Y,J):G(j,he,U.mode&Y)}async function _(j,he,J,U){await e.Promises.mkdir(he,{recursive:!0,mode:J});const M=await d(j);for(const B of M)await se((0,p.join)(j,B),(0,p.join)(he,B),U)}async function G(j,he,J){await e.Promises.copyFile(j,he),await e.Promises.chmod(he,J)}async function te(j,he,J){let U=await e.Promises.readlink(j);(0,k.isEqualOrParent)(U,J.root.source,!E.isLinux)&&(U=(0,p.join)(J.root.target,U.substr(J.root.source.length+1))),await e.Promises.symlink(U,he)}e.Promises=new class{get access(){return(0,D.promisify)(b.access)}get stat(){return(0,D.promisify)(b.stat)}get lstat(){return(0,D.promisify)(b.lstat)}get utimes(){return(0,D.promisify)(b.utimes)}get read(){return(j,he,J,U,M)=>new Promise((B,Q)=>{b.read(j,he,J,U,M,(ae,fe,X)=>ae?Q(ae):B({bytesRead:fe,buffer:X}))})}get readFile(){return(0,D.promisify)(b.readFile)}get write(){return(j,he,J,U,M)=>new Promise((B,Q)=>{b.write(j,he,J,U,M,(ae,fe,X)=>ae?Q(ae):B({bytesWritten:fe,buffer:X}))})}get appendFile(){return(0,D.promisify)(b.appendFile)}get fdatasync(){return(0,D.promisify)(b.fdatasync)}get truncate(){return(0,D.promisify)(b.truncate)}get rename(){return(0,D.promisify)(b.rename)}get copyFile(){return(0,D.promisify)(b.copyFile)}get open(){return(0,D.promisify)(b.open)}get close(){return(0,D.promisify)(b.close)}get symlink(){return(0,D.promisify)(b.symlink)}get readlink(){return(0,D.promisify)(b.readlink)}get chmod(){return(0,D.promisify)(b.chmod)}get mkdir(){return(0,D.promisify)(b.mkdir)}get unlink(){return(0,D.promisify)(b.unlink)}get rmdir(){return(0,D.promisify)(b.rmdir)}get realpath(){return(0,D.promisify)(b.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return f}get writeFile(){return i}get rm(){return v}get move(){return F}get copy(){return q}}}),define(ve[145],we([0,1,30,6,3,15,21]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function S(w){if(D.isLinux)return w;const v=(0,t.dirname)(w);if(w===v)return w;const h=((0,t.basename)(w)||w).toLowerCase();try{const y=(0,k.readdirSync)(v).filter(d=>d.toLowerCase()===h);if(y.length===1){const d=S(v);if(d)return(0,t.join)(d,y[0])}else if(y.length>1){const d=y.indexOf(h);if(d>=0){const g=S(v);if(g)return(0,t.join)(g,y[d])}}}catch{}return null}e.realcaseSync=S;async function p(w){if(D.isLinux)return w;const v=(0,t.dirname)(w);if(w===v)return w;const h=((0,t.basename)(w)||w).toLowerCase();try{const y=(await k.Promises.readdir(v)).filter(d=>d.toLowerCase()===h);if(y.length===1){const d=await p(v);if(d)return(0,t.join)(d,y[0])}else if(y.length>1){const d=y.indexOf(h);if(d>=0){const g=await p(v);if(g)return(0,t.join)(g,y[d])}}}catch{}return null}e.realcase=p;async function E(w){try{return await k.Promises.realpath(w)}catch{const h=R(w);return await k.Promises.access(h,b.constants.R_OK),h}}e.realpath=E;function T(w){try{return b.realpathSync(w)}catch{const h=R(w);return b.accessSync(h,b.constants.R_OK),h}}e.realpathSync=T;function R(w){return(0,C.rtrim)((0,t.normalize)(w),t.sep)}}),define(ve[146],we([0,1,91]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(S,p,E,T=1){let R=!1;return new Promise(w=>{const v=setTimeout(()=>{if(!R)return R=!0,w(0)},E);D(S,p,T,h=>{if(!R)return R=!0,clearTimeout(v),w(h)})})}e.findFreePort=t;function D(S,p,E,T){if(p===0)return T(0);const R=new b.Socket;R.once("connect",()=>(k(R),D(S+E,p-1,E,T))),R.once("data",()=>{}),R.once("error",w=>(k(R),w.code!=="ECONNREFUSED"?D(S+E,p-1,E,T):T(S))),R.connect(S,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(S,p,E){let T=!1,R,w=1;const v=b.createServer({pauseOnConnect:!0});function h(I,y){T||(T=!0,v.removeAllListeners(),v.close(),R&&clearTimeout(R),y(I))}return new Promise(I=>{R=setTimeout(()=>{h(0,I)},E),v.on("listening",()=>{h(S,I)}),v.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&w<p?(S++,w++,v.listen(S,"127.0.0.1")):h(0,I)}),v.on("close",()=>{h(0,I)}),v.listen(S,"127.0.0.1")})}e.findFreePortFaster=C;function k(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(p){console.error(p)}}}),define(ve[92],we([0,1,28,6,21]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,k=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var p;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(p||(p={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class R{constructor(f,r,o){this.exePath=f,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:l=!1}={}){return l?E===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:l=!1,findPreview:f=!1}={}){const r=w({useAlternateBitness:l});if(!r)return null;const o=t.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let n=-1,i=null;for(const u of await D.Promises.readdir(o)){let m=-1;if(f){const F=u.indexOf("-");if(F<0)continue;const q=u.substring(0,F);if(!C.test(q)||u.substring(F+1)!=="preview")continue;m=parseInt(q,10)}else{if(!C.test(u))continue;m=parseInt(u,10)}if(m<=n)continue;const P=t.join(o,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(P)||(i=P,n=m)}if(!i)return null;const s=r.includes("x86")?" (x86)":"",a=f?" Preview":"";return new R(i,`PowerShell${a}${s}`,!0)}async function h({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const f=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=l?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(f))if(r.test(n)){const i=t.join(f,n,"pwsh.exe");return new R(i,o)}return null}function I(){const l=t.join(b.homedir(),".dotnet","tools","pwsh.exe");return new R(l,".NET Core PowerShell Global Tool")}function y(){const l=t.join(process.env.windir,E===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(l,"Windows PowerShell",!0)}async function*d(){let l=await v();l&&(yield l),l=await v({useAlternateBitness:!0}),l&&(yield l),l=await h(),l&&(yield l),l=I(),l&&(yield l),l=await v({findPreview:!0}),l&&(yield l),l=await h({findPreview:!0}),l&&(yield l),l=await v({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=y(),l&&(yield l)}async function*g(){for await(const l of d())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=g;async function c(){for await(const l of g())return l;return null}e.getFirstAvailablePowerShellInstallation=c}),define(ve[93],we([0,1,6,3,27,56,12,21]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function p(R=D.env){return R.comspec||"cmd.exe"}e.getWindowsShell=p;function E(R){let w=[],v=!1;const h=function(I){if(v){w.push(I);return}(!R.send(I,d=>{if(d&&console.error(d),v=!1,w.length>0){const g=w.slice(0);w=[],g.forEach(c=>h(c))}})||t.isWindows)&&(v=!0)};return{send:h}}e.createQueuedSender=E;var T;(function(R){async function w(v,h,I){if(b.isAbsolute(v))return v;if(h===void 0&&(h=D.cwd()),b.dirname(v)!=="."||(I===void 0&&k.isString(D.env.PATH)&&(I=D.env.PATH.split(b.delimiter)),I===void 0||I.length===0))return b.join(h,v);async function d(g){if(await S.Promises.exists(g)){let c;try{c=await S.Promises.stat(g)}catch(l){l.message.startsWith("EACCES")&&(c=await S.Promises.lstat(g))}return c?!c.isDirectory():!1}return!1}for(const g of I){let c;if(b.isAbsolute(g)?c=b.join(g,v):c=b.join(h,g,v),await d(c))return c;let l=c+".com";if(await d(l)||(l=c+".exe",await d(l)))return l}return b.join(h,v)}R.findExecutable=w})(T=e.win32||(e.win32={}))}),define(ve[94],we([0,1,48,8]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((S,p)=>{let E;const T=new Map;function R(v,h,I,y,d){const g=T.get(h);if(v===k||g){const c={name:w(I),cmd:I,pid:v,ppid:h,load:y,mem:d};T.set(v,c),v===k&&(E=c),g&&(g.children||(g.children=[]),g.children.push(c),g.children.length>1&&(g.children=g.children.sort((l,f)=>l.pid-f.pid)))}}function w(v){const h=/--vscode-window-kind=shared-process/,I=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,l=/\\pipe\\winpty-control/,f=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(c.exec(v))return"electron-crash-reporter";if(l.exec(v))return"winpty-process";if(f.exec(v))return"console-window-host (Windows internal process)";let o=r.exec(v);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(v)?"shared-process":I.exec(v)?"issue-reporter":y.exec(v)?"process-explorer":"window";if(o[1]==="utility"){if(d.exec(v))return"utility-network-service";if(g.exec(v))return"extension-host"}return o[1]}const n=/[a-zA-Z-]+\.js/g;let i="";do o=n.exec(v),o&&(i+=o+" ");while(o);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,I)=>{oe(["windows-process-tree"],h,I)}).then(h=>{h.getProcessList(k,I=>{if(!I){p(new Error(`Root process ${k} not found`));return}h.getProcessCpuUsage(I,y=>{const d=new Map;y.forEach(g=>{const c=v(g.commandLine||"");d.set(g.pid,{name:w(c),cmd:c,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),E=d.get(k),E?(d.forEach(g=>{const c=d.get(g.ppid);c&&(c.children||(c.children=[]),c.children.push(g))}),d.forEach(g=>{g.children&&(g.children=g.children.sort((c,l)=>c.pid-l.pid))}),S(E)):p(new Error(`Root process ${k} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[E];const I=[];for(;h.length;){const d=h.shift();d&&(I.push(d.pid),d.children&&(h=h.concat(d.children)))}let y=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",oe).fsPath);y+=" "+I.join(" "),(0,b.exec)(y,{},(d,g,c)=>{if(d||c)p(d||new Error(c.toString()));else{const l=g.toString().split(`
`);for(let f=0;f<I.length;f++){const r=T.get(I[f]);r.load=parseFloat(l[f])}if(!E){p(new Error(`Root process ${k} not found`));return}S(E)}})};(0,b.exec)("which ps",{},(h,I,y)=>{if(h||y)if(process.platform!=="linux")p(h||new Error(y.toString()));else{const d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",oe).fsPath);(0,b.exec)(d,{},(g,c,l)=>{g||l?p(g||new Error(l.toString())):(C(c,R),v())})}else{const d=I.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,b.exec)(`${d} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,l,f)=>{c||f&&!f.includes("screen size is bogus")?p(c||new Error(f.toString())):(C(l,R),process.platform==="linux"?v():E?S(E):p(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function C(k,S){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=k.toString().split(`
`);for(const T of E){const R=p.exec(T.trim());R&&R.length===6&&S(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}}),define(ve[147],we([0,1,28,3,92,93]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(v,h){return v===1?t.isWindows?R():C.getWindowsShell(h):E(v,h)}e.getSystemShell=k;function S(v,h){return v===1?t.isWindows?w(h):C.getWindowsShell(h):E(v,h)}e.getSystemShellSync=S;let p=null;function E(v,h){if(t.isLinux&&v===2||t.isMacintosh&&v===3)return"/bin/bash";if(!p){let I;if(t.isWindows)I="/bin/bash";else{if(I=h.SHELL,!I)try{I=(0,b.userInfo)().shell}catch{}I||(I="sh"),I==="/bin/false"&&(I="/bin/bash")}p=I}return p}let T=null;async function R(){return T||(T=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),T}function w(v){if(T)return T;const h=t.isWindows&&parseFloat((0,b.release)())>=10,I=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${I?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?y:C.getWindowsShell(v)}});var Ae=this&&this.__decorate||function(oe,e,b,t){var D=arguments.length,C=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,b):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(oe,e,b,t);else for(var S=oe.length-1;S>=0;S--)(k=oe[S])&&(C=(D<3?k(C):D>3?k(e,b,C):k(e,b))||C);return D>3&&C&&Object.defineProperty(e,b,C),C};define(ve[43],we([0,1,18,14,16,20,84,11,7,2,42,15,12]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var I;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(I=e.ResponseType||(e.ResponseType={}));function y(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(d||(d={}));class g{constructor(B){this.buffer=B,this.pos=0}read(B){const Q=this.buffer.slice(this.pos,this.pos+B);return this.pos+=Q.byteLength,Q}}class c{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var l;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(l||(l={}));function f(M){const B=D.VSBuffer.alloc(4);return B.writeUInt32BE(M,0),B}function r(M){return M.read(4).readUInt32BE(0)}function o(M){const B=D.VSBuffer.alloc(1);return B.writeUInt8(M,0),B}const n={Undefined:o(l.Undefined),String:o(l.String),Buffer:o(l.Buffer),VSBuffer:o(l.VSBuffer),Array:o(l.Array),Object:o(l.Object)},i=typeof Buffer!="undefined";function s(M,B){if(typeof B=="undefined")M.write(n.Undefined);else if(typeof B=="string"){const Q=D.VSBuffer.fromString(B);M.write(n.String),M.write(f(Q.byteLength)),M.write(Q)}else if(i&&Buffer.isBuffer(B)){const Q=D.VSBuffer.wrap(B);M.write(n.Buffer),M.write(f(Q.byteLength)),M.write(Q)}else if(B instanceof D.VSBuffer)M.write(n.VSBuffer),M.write(f(B.byteLength)),M.write(B);else if(Array.isArray(B)){M.write(n.Array),M.write(f(B.length));for(const Q of B)s(M,Q)}else{const Q=D.VSBuffer.fromString(JSON.stringify(B));M.write(n.Object),M.write(f(Q.byteLength)),M.write(Q)}}function a(M){switch(M.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return M.read(r(M)).toString();case l.Buffer:return M.read(r(M)).buffer;case l.VSBuffer:return M.read(r(M));case l.Array:{const Q=r(M),ae=[];for(let fe=0;fe<Q;fe++)ae.push(a(M));return ae}case l.Object:return JSON.parse(M.read(r(M)).toString())}}class u{constructor(B,Q,ae=null,fe=1e3){this.protocol=B,this.ctx=Q,this.logger=ae,this.timeoutDelay=fe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(B,Q){this.channels.set(B,Q),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const Q=this.send([B.type]);this.logger?.logOutgoing(Q,0,1,y(B.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(Q,B.id,1,y(B.type),B.data);return}}}send(B,Q=void 0){const ae=new c;return s(ae,B),s(ae,Q),this.sendBuffer(ae.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const Q=new g(B),ae=a(Q),fe=a(Q),X=ae[0];switch(X){case 100:return this.logger?.logIncoming(B.byteLength,ae[1],1,`${h(X)}: ${ae[2]}.${ae[3]}`,fe),this.onPromise({type:X,id:ae[1],channelName:ae[2],name:ae[3],arg:fe});case 102:return this.logger?.logIncoming(B.byteLength,ae[1],1,`${h(X)}: ${ae[2]}.${ae[3]}`,fe),this.onEventListen({type:X,id:ae[1],channelName:ae[2],name:ae[3],arg:fe});case 101:return this.logger?.logIncoming(B.byteLength,ae[1],1,`${h(X)}`),this.disposeActiveRequest({type:X,id:ae[1]});case 103:return this.logger?.logIncoming(B.byteLength,ae[1],1,`${h(X)}`),this.disposeActiveRequest({type:X,id:ae[1]})}}onPromise(B){const Q=this.channels.get(B.channelName);if(!Q){this.collectPendingRequest(B);return}const ae=new C.CancellationTokenSource;let fe;try{fe=Q.call(this.ctx,B.name,B.arg,ae.token)}catch(L){fe=Promise.reject(L)}const X=B.id;fe.then(L=>{this.sendResponse({id:X,data:L,type:201}),this.activeRequests.delete(B.id)},L=>{L instanceof Error?this.sendResponse({id:X,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:X,data:L,type:203}),this.activeRequests.delete(B.id)});const re=(0,E.toDisposable)(()=>ae.cancel());this.activeRequests.set(B.id,re)}onEventListen(B){const Q=this.channels.get(B.channelName);if(!Q){this.collectPendingRequest(B);return}const ae=B.id,X=Q.listen(this.ctx,B.name,B.arg)(re=>this.sendResponse({id:ae,data:re,type:204}));this.activeRequests.set(B.id,X)}disposeActiveRequest(B){const Q=this.activeRequests.get(B.id);Q&&(Q.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let Q=this.pendingRequests.get(B.channelName);Q||(Q=[],this.pendingRequests.set(B.channelName,Q));const ae=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:B,timeoutTimer:ae})}flushPendingRequests(B){const Q=this.pendingRequests.get(B);if(Q){for(const ae of Q)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.onPromise(ae.request);break;case 102:this.onEventListen(ae.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var m;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(B,Q=null){this.protocol=B,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=Q}getChannel(B){const Q=this;return{call(ae,fe,X){return Q.isDisposed?Promise.reject(new S.CancellationError):Q.requestPromise(B,ae,fe,X)},listen(ae,fe){return Q.isDisposed?p.Event.None:Q.requestEvent(B,ae,fe)}}}requestPromise(B,Q,ae,fe=C.CancellationToken.None){const X=this.lastRequestId++,L={id:X,type:100,channelName:B,name:Q,arg:ae};if(fe.isCancellationRequested)return Promise.reject(new S.CancellationError);let O;return new Promise((ne,ue)=>{if(fe.isCancellationRequested)return ue(new S.CancellationError);const pe=()=>{const z=V=>{switch(V.type){case 201:this.handlers.delete(X),ne(V.data);break;case 202:{this.handlers.delete(X);const $=new Error(V.data.message);$.stack=V.data.stack,$.name=V.data.name,ue($);break}case 203:this.handlers.delete(X),ue(V.data);break}};this.handlers.set(X,z),this.sendRequest(L)};let W=null;this.state===d.Idle?pe():(W=(0,t.createCancelablePromise)(z=>this.whenInitialized()),W.then(()=>{W=null,pe()}));const Z=()=>{W?(W.cancel(),W=null):this.sendRequest({id:X,type:101}),ue(new S.CancellationError)},ie=fe.onCancellationRequested(Z);O=(0,E.combinedDisposable)((0,E.toDisposable)(Z),ie),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(B,Q,ae){const fe=this.lastRequestId++,re={id:fe,type:102,channelName:B,name:Q,arg:ae};let L=null;const O=new p.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(ne=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(re)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:fe,type:103}))}}),x=ne=>O.fire(ne.data);return this.handlers.set(fe,x),O.event}sendRequest(B){switch(B.type){case 100:case 102:{const Q=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(Q,B.id,0,`${h(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const Q=this.send([B.type,B.id]);this.logger?.logOutgoing(Q,B.id,0,h(B.type));return}}}send(B,Q=void 0){const ae=new c;return s(ae,B),s(ae,Q),this.sendBuffer(ae.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const Q=new g(B),ae=a(Q),fe=a(Q),X=ae[0];switch(X){case 200:return this.logger?.logIncoming(B.byteLength,0,0,y(X)),this.onResponse({type:ae[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(B.byteLength,ae[1],0,y(X),fe),this.onResponse({type:ae[0],id:ae[1],data:fe})}}onResponse(B){if(B.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ae([k.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class F{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:Q,onDidClientDisconnect:ae})=>{p.Event.once(Q.onMessage)(X=>{const re=new g(X),L=a(re),O=new u(Q,L),x=new P(Q);this.channels.forEach((ue,pe)=>O.registerChannel(pe,ue));const ne={channelServer:O,channelClient:x,ctx:L};this._connections.add(ne),this._onDidAddConnection.fire(ne),ae(()=>{O.dispose(),x.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const B=[];return this._connections.forEach(Q=>B.push(Q)),B}getChannel(B,Q){const ae=this;return{call(fe,X,re){let L;if((0,w.isFunction)(Q)){const x=(0,b.getRandomElement)(ae.connections.filter(Q));L=x?Promise.resolve(x):p.Event.toPromise(p.Event.filter(ae.onDidAddConnection,Q))}else L=Q.routeCall(ae,fe,X);const O=L.then(x=>x.channelClient.getChannel(B));return Y(O).call(fe,X,re)},listen(fe,X){if((0,w.isFunction)(Q))return ae.getMulticastEvent(B,Q,fe,X);const re=Q.routeEvent(ae,fe,X).then(L=>L.channelClient.getChannel(B));return Y(re).listen(fe,X)}}}getMulticastEvent(B,Q,ae,fe){const X=this;let re=new E.DisposableStore;const L=new p.Emitter({onFirstListenerAdd:()=>{re=new E.DisposableStore;const O=new p.EventMultiplexer,x=new Map,ne=pe=>{const Z=pe.channelClient.getChannel(B).listen(ae,fe),ie=O.add(Z);x.set(pe,ie)},ue=pe=>{const W=x.get(pe);!W||(W.dispose(),x.delete(pe))};X.connections.filter(Q).forEach(ne),p.Event.filter(X.onDidAddConnection,Q)(ne,void 0,re),X.onDidRemoveConnection(ue,void 0,re),O.event(L.fire,L,re),re.add(O)},onLastListenerRemove:()=>{re.dispose()}});return L.event}registerChannel(B,Q){this.channels.set(B,Q),this._connections.forEach(ae=>{ae.channelServer.registerChannel(B,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class q{constructor(B,Q,ae=null){const fe=new c;s(fe,Q),B.send(fe.buffer),this.channelClient=new P(B,ae),this.channelServer=new u(B,Q,ae)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,Q){this.channelServer.registerChannel(B,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=q;function Y(M){return{call(B,Q,ae){return M.then(fe=>fe.call(B,Q,ae))},listen(B,Q){const ae=new p.Relay;return M.then(fe=>ae.input=fe.listen(B,Q)),ae.event}}}e.getDelayedChannel=Y;function se(M){let B=!1;return{call(Q,ae,fe){return B?M.call(Q,ae,fe):(0,t.timeout)(0).then(()=>B=!0).then(()=>M.call(Q,ae,fe))},listen(Q,ae){if(B)return M.listen(Q,ae);const fe=new p.Relay;return(0,t.timeout)(0).then(()=>B=!0).then(()=>fe.input=M.listen(Q,ae)),fe.event}}}e.getNextTickChannel=se;class _{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const Q of B.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await p.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=_;var G;(function(M){function B(X,re){const L=X,O=re&&re.disableMarshalling,x=new Map;for(const ne in L)ae(ne)&&x.set(ne,p.Event.buffer(L[ne],!0));return new class{listen(ne,ue,pe){const W=x.get(ue);if(W)return W;if(fe(ue)){const Z=L[ue];if(typeof Z=="function")return Z.call(L,pe)}throw new Error(`Event not found: ${ue}`)}call(ne,ue,pe){const W=L[ue];if(typeof W=="function"){if(!O&&Array.isArray(pe))for(let Z=0;Z<pe.length;Z++)pe[Z]=(0,T.revive)(pe[Z]);return W.apply(L,pe)}throw new Error(`Method not found: ${ue}`)}}}M.fromService=B;function Q(X,re){const L=re&&re.disableMarshalling;return new Proxy({},{get(O,x){if(typeof x=="string")return re?.properties?.has(x)?re.properties.get(x):fe(x)?function(ne){return X.listen(x,ne)}:ae(x)?X.listen(x):async function(...ne){let ue;re&&!(0,w.isUndefinedOrNull)(re.context)?ue=[re.context,...ne]:ue=ne;const pe=await X.call(x,ue);return L?pe:(0,T.revive)(pe)};throw new Error(`Property not found: ${String(x)}`)}})}M.toService=Q;function ae(X){return X[0]==="o"&&X[1]==="n"&&R.isUpperAsciiLetter(X.charCodeAt(2))}function fe(X){return/^onDynamic/.test(X)&&R.isUpperAsciiLetter(X.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const B=M.toString();if(B!=="[object Object]")return B}return M}function he(M){return Array.isArray(M)?M.map(j):j(M)}function J(M,B,Q,ae,fe,X,re){re=he(re);const L=te[fe],O=L[ae%L.length];let x=[`%c[${M}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(X)?(x=x.concat(re),x.push(")")):x.push(re),console.log.apply(console,x)}e.logWithColors=J;class U{constructor(B,Q){this._outgoingPrefix=B,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,Q,ae,fe,X){this._totalOutgoing+=B,J(this._outgoingPrefix,this._totalOutgoing,B,Q,ae,fe,X)}logIncoming(B,Q,ae,fe,X){this._totalIncoming+=B,J(this._incomingPrefix,this._totalIncoming,B,Q,ae,fe,X)}}e.IPCLogger=U}),define(ve[95],we([0,1,16,7,2,43]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let a=0;function u(P,F){if(!s.has(P)){const q=String(++a);s.set(P,q)}return s.get(P)}function m(P,F,q,Y){if(!i.enableDiagnostics)return;const se=u(P,F);if(Y instanceof b.VSBuffer||Y instanceof Uint8Array||Y instanceof ArrayBuffer||ArrayBuffer.isView(Y)){const _=b.VSBuffer.alloc(Y.byteLength);_.set(Y),i.records.push({timestamp:Date.now(),id:se,label:F,type:q,buff:_})}else i.records.push({timestamp:Date.now(),id:se,label:F,type:q,data:Y})}i.traceSocketEvent=m})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function T(){return E||(E=b.VSBuffer.alloc(0)),E}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return T();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const F=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),F}if(this._chunks[0].byteLength>s){const F=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),F}const u=b.VSBuffer.alloc(s);let m=0,P=0;for(;s>0;){const F=this._chunks[P];if(F.byteLength>s){const q=F.slice(0,s);u.set(q,m),m+=s,a&&(this._chunks[P]=F.slice(s),this._totalLength-=s),s-=s}else u.set(F,m),m+=F.byteLength,a?(this._chunks.shift(),this._totalLength-=F.byteLength):P++,s-=F.byteLength}return u}}e.ChunkStream=R;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(w||(w={}));function v(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class I{constructor(s,a,u,m){this.type=s,this.id=a,this.ack=u,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends D.Disposable{constructor(s){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,m=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new I(u,m,P,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=b.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const u=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,u}_bufferTake(){const s=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class g extends D.Disposable{constructor(s){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new I(1,0,0,s))}}e.Protocol=g;class c extends C.IPCClient{constructor(s,a,u=null){super(s,a,u);this.protocol=s}static fromSocket(s,a){return new c(new g(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class f{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}length(){let s=0,a=this._first;for(;a;)a=a.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let a=0,u=this._first;for(;u;)s[a++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new f(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class o{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<o._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=o._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const s=Date.now(),a=(1+o._HISTORY_LENGTH)*1e3;let u=0;for(let m=0;m<o._HISTORY_LENGTH;m++)s-this.lastRuns[m]<=a&&u++;return 1-u/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class n{constructor(s,a=null,u=o.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),a&&this._socketReader.acceptChunk(a),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new I(5,0,0,T());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new I(7,0,0,T());this._socketWriter.write(s)}sendResume(){const s=new I(8,0,0,T());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new I(3,0,this._incomingAckId,T());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let u=0,m=a.length;u<m;u++)this._socketWriter.write(a[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new I(6,0,0,T())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let u=0,m=a.length;u<m;u++)this._socketWriter.write(a[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new I(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const a=new I(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,u=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&u>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:u});return}const P=Math.max(2e4-a,2e4-u,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new I(3,0,this._incomingAckId,T());this._socketWriter.write(s)}_sendKeepAlive(){const s=new I(9,0,0,T());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(ve[96],we([0,1,48,14,16,20,141,11,7,2,22,93,56,43]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(d){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",g=>D.VSBuffer.wrap(Buffer.from(g,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=h;class I{constructor(d,g){this.modulePath=d,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new t.Delayer(c),this.child=null,this._client=null}getChannel(d){const g=this;return{call(c,l,f){return g.requestPromise(d,c,l,f)},listen(c,l){return g.requestEvent(d,c,l)}}}requestPromise(d,g,c,l=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const f=this.getCachedChannel(d),r=(0,t.createCancelablePromise)(i=>f.call(g,c,i)),o=l.onCancellationRequested(()=>r.cancel()),n=(0,E.toDisposable)(()=>r.cancel());return this.activeRequests.add(n),r.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(d,g,c){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let l;const f=new p.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(d).listen(g,c)(f.fire,f),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return f.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,w.removeDangerousEnvVariables)(g.env),this.child=(0,b.fork)(this.modulePath,d,g);const c=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,k.isRemoteConsoleLog)(s)){(0,k.log)(s,`IPC Library: ${this.options.serverName}`);return}c.fire(D.VSBuffer.wrap(Buffer.from(s,"base64")))});const f=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,r=s=>this.child&&this.child.connected&&f.send(s.buffer.toString("base64")),o=c.event,n={send:r,onMessage:o};this._client=new v.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(u=>(0,E.dispose)(u)),this.activeRequests.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:a})})}return this._client}getCachedChannel(d){let g=this.channels.get(d);return g||(g=this.client.getChannel(d),this.channels.set(d,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=I}),define(ve[57],we([0,1,16,11,7,2,6,3,23,43,95]),function(oe,e,b,t,D,C,k,S,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function R(){return{crypto:oe.__$__nodeRequire("crypto"),zlib:oe.__$__nodeRequire("zlib"),net:oe.__$__nodeRequire("net"),os:oe.__$__nodeRequire("os")}}class w{constructor(u,m=""){this.debugLabel=m,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,m){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,m)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const m=P=>{this.traceSocketEvent("read",P),u(b.VSBuffer.wrap(P))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(u){const m=P=>{this.traceSocketEvent("close",{hadError:P}),u({type:0,hadError:P,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(u){const m=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,t.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,t.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=w;var v;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var h;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(h||(h={}));class I extends C.Disposable{constructor(u,m,P,F){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:P?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new y(this,m,P,F,this._onData,(q,Y)=>this._write(q,Y))),this._register(this._flowManager.onError(q=>{console.error(q),(0,t.onUnexpectedError)(q),this._onClose.fire({type:0,hadError:!0,error:q})})),this._incomingData=new T.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(q=>this._onClose.fire(q)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,m){this.socket.traceSocketEvent(u,m)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,m){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let P=2;u.byteLength<126?P+=0:u.byteLength<2**16?P+=2:P+=8;const F=b.VSBuffer.alloc(P);if(m?F.writeUInt8(194,0):F.writeUInt8(130,0),u.byteLength<126)F.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){F.writeUInt8(126,1);let q=1;F.writeUInt8(u.byteLength>>>8&255,++q),F.writeUInt8(u.byteLength>>>0&255,++q)}else{F.writeUInt8(127,1);let q=1;F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(0,++q),F.writeUInt8(u.byteLength>>>24&255,++q),F.writeUInt8(u.byteLength>>>16&255,++q),F.writeUInt8(u.byteLength>>>8&255,++q),F.writeUInt8(u.byteLength>>>0&255,++q)}this.socket.write(b.VSBuffer.concat([F,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),P=m.readUInt8(0),F=(P&128)>>>7,q=(P&64)>>>6,Y=m.readUInt8(1),se=(Y&128)>>>7,_=Y&127;this._state.state=2,this._state.readLen=2+(se?4:0)+(_===126?2:0)+(_===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(q)),this._state.firstFrameOfMessage=Boolean(F),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),P=m.readUInt8(1),F=(P&128)>>>7;let q=P&127,Y=1;q===126?q=m.readUInt8(++Y)*2**8+m.readUInt8(++Y):q===127&&(q=m.readUInt8(++Y)*0+m.readUInt8(++Y)*0+m.readUInt8(++Y)*0+m.readUInt8(++Y)*0+m.readUInt8(++Y)*2**24+m.readUInt8(++Y)*2**16+m.readUInt8(++Y)*2**8+m.readUInt8(++Y));let se=0;F&&(se=m.readUInt8(++Y)*2**24+m.readUInt8(++Y)*2**16+m.readUInt8(++Y)*2**8+m.readUInt8(++Y)),this._state.state=3,this._state.readLen=q,this._state.mask=se,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),c(m,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(m,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=I;class y extends C.Disposable{constructor(u,m,P,F,q,Y){super();this._tracer=u,this._onData=q,this._writeFn=Y,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,m?(this._zlibInflateStream=this._register(new d(this._tracer,F,P,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(se=>this._onError.fire(se))),this._register(this._zlibDeflateStream.onError(se=>this._onError.fire(se)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:b.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const m=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(m,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,m){return new Promise((P,F)=>{u.write(m),u.flush(q=>P(q))})}acceptFrame(u,m,P){this._readQueue.push({data:u,isCompressed:m,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const m=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(m)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,m,P){return new Promise((F,q)=>{u.write(m),P&&u.write(b.VSBuffer.fromByteArray([0,0,255,255])),u.flush(Y=>F(Y))})}}class d extends C.Disposable{constructor(u,m,P,F){super();this._tracer=u,this._recordInflateBytes=m,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=R().zlib.createInflateRaw(F),this._zlibInflate.on("error",q=>{this._tracer.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this._onError.fire(q)}),this._zlibInflate.on("data",q=>{this._tracer.traceSocketEvent("zlibInflateData",q),this._pendingInflateData.push(b.VSBuffer.wrap(q))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?b.VSBuffer.concat(this._recordedInflateBytes):b.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const m=b.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(m)})}}class g extends C.Disposable{constructor(u,m){super();this._tracer=u,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=R().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(b.VSBuffer.wrap(P))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let m=b.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.byteLength-4),u(m)})}}function c(a,u){if(u===0)return;const m=a.byteLength>>>2;for(let _=0;_<m;_++){const G=a.readUInt32BE(_*4);a.writeUInt32BE(G^u,_*4)}const P=m*4,F=a.byteLength-P,q=u>>>24&255,Y=u>>>16&255,se=u>>>8&255;F>=1&&a.writeUInt8(a.readUInt8(P)^q,P),F>=2&&a.writeUInt8(a.readUInt8(P+1)^Y,P+1),F>=3&&a.writeUInt8(a.readUInt8(P+2)^se,P+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const l={[2]:107,[1]:103};function f(){const a=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):u=(0,k.join)(R().os.tmpdir(),`vscode-ipc-${a}.sock`),o(u),u}e.createRandomIPCHandle=f;function r(a,u,m){const P=R().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${m}-${u}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${P.substr(0,8)}-${m}-${u}.sock`):F=(0,k.join)(a,`${m}-${u}.sock`),o(F),F}e.createStaticIPCHandle=r;function o(a){const u=l[S.platform];typeof u=="number"&&a.length>=u&&console.warn(`WARNING: IPC handle "${a}" is longer than ${u} chars, try a shorter --user-data-dir`)}class n extends E.IPCServer{constructor(u){super(n.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const m=D.Event.fromNodeEventEmitter(u,"connection");return D.Event.map(m,P=>({protocol:new T.Protocol(new w(P,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(P,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function i(a){return new Promise((u,m)=>{const P=R().net.createServer();P.on("error",m),P.listen(a,()=>{P.removeListener("error",m),u(new n(P))})})}e.serve=i;function s(a,u){return new Promise((m,P)=>{const F=R().net.createConnection(a,()=>{F.removeListener("error",P),m(T.Client.fromSocket(new w(F,`ipc-client${u}`),u))});F.once("error",P)})}e.connect=s}),define(ve[148],we([0,1,14,7,2,12]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function S(R){const w=R;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var p;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(p=e.StorageState||(e.StorageState={}));class E extends D.Disposable{constructor(w,v=Object.create(null)){super();this.database=w,this.options=v,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=p.None,this.cache=new Map,this.flushDelayer=new b.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){w.changed?.forEach((v,h)=>this.accept(h,v)),w.deleted?.forEach(v=>this.accept(v,void 0))}accept(w,v){if(this.state===p.Closed)return;let h=!1;(0,C.isUndefinedOrNull)(v)?h=this.cache.delete(w):this.cache.get(w)!==v&&(this.cache.set(w,v),h=!0),h&&this._onDidChangeStorage.fire(w)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===p.None&&(this.state=p.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,v){const h=this.cache.get(w);return(0,C.isUndefinedOrNull)(h)?v:h}getBoolean(w,v){const h=this.get(w);return(0,C.isUndefinedOrNull)(h)?v:h==="true"}getNumber(w,v){const h=this.get(w);return(0,C.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(w,v){if(this.state===p.Closed)return;if((0,C.isUndefinedOrNull)(v))return this.delete(w);const h=String(v);if(this.cache.get(w)!==h)return this.cache.set(w,h),this.pendingInserts.set(w,h),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async delete(w){if(!(this.state===p.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=p.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(w){if(!!this.hasPending)return this.doFlush(w)}async doFlush(w){return this.flushDelayer.trigger(()=>this.flushPending(),w)}async whenFlushed(){if(!!this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class T{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert?.forEach((v,h)=>this.items.set(h,v)),w.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=T}),define(ve[97],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(D,C){this.lineNumber=D,this.column=C}with(D=this.lineNumber,C=this.column){return D===this.lineNumber&&C===this.column?this:new b(D,C)}delta(D=0,C=0){return this.with(this.lineNumber+D,this.column+C)}equals(D){return b.equals(this,D)}static equals(D,C){return!D&&!C?!0:!!D&&!!C&&D.lineNumber===C.lineNumber&&D.column===C.column}isBefore(D){return b.isBefore(this,D)}static isBefore(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<C.column}isBeforeOrEqual(D){return b.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<=C.column}static compare(D,C){const k=D.lineNumber|0,S=C.lineNumber|0;if(k===S){const p=D.column|0,E=C.column|0;return p-E}return k-S}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new b(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=b}),define(ve[49],we([0,1,97]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(C,k,S,p){C>S||C===S&&k>p?(this.startLineNumber=S,this.startColumn=p,this.endLineNumber=C,this.endColumn=k):(this.startLineNumber=C,this.startColumn=k,this.endLineNumber=S,this.endColumn=p)}isEmpty(){return t.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return t.containsPosition(this,C)}static containsPosition(C,k){return!(k.lineNumber<C.startLineNumber||k.lineNumber>C.endLineNumber||k.lineNumber===C.startLineNumber&&k.column<C.startColumn||k.lineNumber===C.endLineNumber&&k.column>C.endColumn)}static strictContainsPosition(C,k){return!(k.lineNumber<C.startLineNumber||k.lineNumber>C.endLineNumber||k.lineNumber===C.startLineNumber&&k.column<=C.startColumn||k.lineNumber===C.endLineNumber&&k.column>=C.endColumn)}containsRange(C){return t.containsRange(this,C)}static containsRange(C,k){return!(k.startLineNumber<C.startLineNumber||k.endLineNumber<C.startLineNumber||k.startLineNumber>C.endLineNumber||k.endLineNumber>C.endLineNumber||k.startLineNumber===C.startLineNumber&&k.startColumn<C.startColumn||k.endLineNumber===C.endLineNumber&&k.endColumn>C.endColumn)}strictContainsRange(C){return t.strictContainsRange(this,C)}static strictContainsRange(C,k){return!(k.startLineNumber<C.startLineNumber||k.endLineNumber<C.startLineNumber||k.startLineNumber>C.endLineNumber||k.endLineNumber>C.endLineNumber||k.startLineNumber===C.startLineNumber&&k.startColumn<=C.startColumn||k.endLineNumber===C.endLineNumber&&k.endColumn>=C.endColumn)}plusRange(C){return t.plusRange(this,C)}static plusRange(C,k){let S,p,E,T;return k.startLineNumber<C.startLineNumber?(S=k.startLineNumber,p=k.startColumn):k.startLineNumber===C.startLineNumber?(S=k.startLineNumber,p=Math.min(k.startColumn,C.startColumn)):(S=C.startLineNumber,p=C.startColumn),k.endLineNumber>C.endLineNumber?(E=k.endLineNumber,T=k.endColumn):k.endLineNumber===C.endLineNumber?(E=k.endLineNumber,T=Math.max(k.endColumn,C.endColumn)):(E=C.endLineNumber,T=C.endColumn),new t(S,p,E,T)}intersectRanges(C){return t.intersectRanges(this,C)}static intersectRanges(C,k){let S=C.startLineNumber,p=C.startColumn,E=C.endLineNumber,T=C.endColumn;const R=k.startLineNumber,w=k.startColumn,v=k.endLineNumber,h=k.endColumn;return S<R?(S=R,p=w):S===R&&(p=Math.max(p,w)),E>v?(E=v,T=h):E===v&&(T=Math.min(T,h)),S>E||S===E&&p>T?null:new t(S,p,E,T)}equalsRange(C){return t.equalsRange(this,C)}static equalsRange(C,k){return!!C&&!!k&&C.startLineNumber===k.startLineNumber&&C.startColumn===k.startColumn&&C.endLineNumber===k.endLineNumber&&C.endColumn===k.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(C){return new b.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(C){return new b.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,k){return new t(this.startLineNumber,this.startColumn,C,k)}setStartPosition(C,k){return new t(C,k,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(C){return new t(this.startLineNumber+C,this.startColumn,this.endLineNumber+C,this.endColumn)}static collapseToStart(C){return new t(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,k=C){return new t(C.lineNumber,C.column,k.lineNumber,k.column)}static lift(C){return C?new t(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,k){return!(C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<k.startColumn||k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<C.startColumn)}static areIntersecting(C,k){return!(C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<=k.startColumn||k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,k){if(C&&k){const E=C.startLineNumber|0,T=k.startLineNumber|0;if(E===T){const R=C.startColumn|0,w=k.startColumn|0;if(R===w){const v=C.endLineNumber|0,h=k.endLineNumber|0;if(v===h){const I=C.endColumn|0,y=k.endColumn|0;return I-y}return v-h}return R-w}return E-T}return(C?1:0)-(k?1:0)}static compareRangesUsingEnds(C,k){return C.endLineNumber===k.endLineNumber?C.endColumn===k.endColumn?C.startLineNumber===k.startLineNumber?C.startColumn-k.startColumn:C.startLineNumber-k.startLineNumber:C.endColumn-k.endColumn:C.endLineNumber-k.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.Range=t}),define(ve[149],we([0,1,7,2]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,p){return this._map.set(S,p),this.fire([S]),(0,t.toDisposable)(()=>{this._map.get(S)===p&&(this._map.delete(S),this.fire([S]))})}registerFactory(S,p){this._factories.get(S)?.dispose();const E=new C(this,S,p);return this._factories.set(S,E),(0,t.toDisposable)(()=>{const T=this._factories.get(S);!T||T!==E||(this._factories.delete(S),T.dispose())})}async getOrCreate(S){const p=this.get(S);if(p)return p;const E=this._factories.get(S);return!E||E.isResolved?null:(await E.resolve(),this.get(S))}get(S){return this._map.get(S)||null}isResolved(S){if(this.get(S))return!0;const E=this._factories.get(S);return!!(!E||E.isResolved)}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class C extends t.Disposable{constructor(S,p,E){super();this._registry=S,this._languageId=p,this._factory=E,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const S=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,S&&!this._isDisposed&&this._register(this._registry.register(this._languageId,S))}}}),define(ve[150],we([0,1,41,4,49,149]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(P,F,q){this._tokenBrand=void 0,this.offset=P,this.type=F,this.language=q}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class S{constructor(P,F){this._tokenizationResultBrand=void 0,this.tokens=P,this.endState=F}}e.TokenizationResult=S;class p{constructor(P,F){this._encodedTokenizationResultBrand=void 0,this.tokens=P,this.endState=F}}e.EncodedTokenizationResult=p;var E;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(E=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(m){const P=new Map;P.set(0,b.Codicon.symbolMethod),P.set(1,b.Codicon.symbolFunction),P.set(2,b.Codicon.symbolConstructor),P.set(3,b.Codicon.symbolField),P.set(4,b.Codicon.symbolVariable),P.set(5,b.Codicon.symbolClass),P.set(6,b.Codicon.symbolStruct),P.set(7,b.Codicon.symbolInterface),P.set(8,b.Codicon.symbolModule),P.set(9,b.Codicon.symbolProperty),P.set(10,b.Codicon.symbolEvent),P.set(11,b.Codicon.symbolOperator),P.set(12,b.Codicon.symbolUnit),P.set(13,b.Codicon.symbolValue),P.set(15,b.Codicon.symbolEnum),P.set(14,b.Codicon.symbolConstant),P.set(15,b.Codicon.symbolEnum),P.set(16,b.Codicon.symbolEnumMember),P.set(17,b.Codicon.symbolKeyword),P.set(27,b.Codicon.symbolSnippet),P.set(18,b.Codicon.symbolText),P.set(19,b.Codicon.symbolColor),P.set(20,b.Codicon.symbolFile),P.set(21,b.Codicon.symbolReference),P.set(22,b.Codicon.symbolCustomColor),P.set(23,b.Codicon.symbolFolder),P.set(24,b.Codicon.symbolTypeParameter),P.set(25,b.Codicon.account),P.set(26,b.Codicon.issues);function F(se){let _=P.get(se);return _||(console.info("No codicon found for CompletionItemKind "+se),_=b.Codicon.symbolProperty),_}m.toIcon=F;const q=new Map;q.set("method",0),q.set("function",1),q.set("constructor",2),q.set("field",3),q.set("variable",4),q.set("class",5),q.set("struct",6),q.set("interface",7),q.set("module",8),q.set("property",9),q.set("event",10),q.set("operator",11),q.set("unit",12),q.set("value",13),q.set("constant",14),q.set("enum",15),q.set("enum-member",16),q.set("enumMember",16),q.set("keyword",17),q.set("snippet",27),q.set("text",18),q.set("color",19),q.set("file",20),q.set("reference",21),q.set("customcolor",22),q.set("folder",23),q.set("type-parameter",24),q.set("typeParameter",24),q.set("account",25),q.set("issue",26);function Y(se,_){let G=q.get(se);return typeof G=="undefined"&&!_&&(G=9),G}m.fromString=Y})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var R;(function(m){m[m.Deprecated=1]="Deprecated"})(R=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var h;(function(m){m[m.Automatic=0]="Automatic",m[m.Explicit=1]="Explicit"})(h=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var I;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(I=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var y;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(m){return m&&t.URI.isUri(m.uri)&&D.Range.isIRange(m.range)&&(D.Range.isIRange(m.originSelectionRange)||D.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=g;var c;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(c=e.SymbolKind||(e.SymbolKind={}));var l;(function(m){m[m.Deprecated=1]="Deprecated"})(l=e.SymbolTag||(e.SymbolTag={}));var f;(function(m){const P=new Map;P.set(0,b.Codicon.symbolFile),P.set(1,b.Codicon.symbolModule),P.set(2,b.Codicon.symbolNamespace),P.set(3,b.Codicon.symbolPackage),P.set(4,b.Codicon.symbolClass),P.set(5,b.Codicon.symbolMethod),P.set(6,b.Codicon.symbolProperty),P.set(7,b.Codicon.symbolField),P.set(8,b.Codicon.symbolConstructor),P.set(9,b.Codicon.symbolEnum),P.set(10,b.Codicon.symbolInterface),P.set(11,b.Codicon.symbolFunction),P.set(12,b.Codicon.symbolVariable),P.set(13,b.Codicon.symbolConstant),P.set(14,b.Codicon.symbolString),P.set(15,b.Codicon.symbolNumber),P.set(16,b.Codicon.symbolBoolean),P.set(17,b.Codicon.symbolArray),P.set(18,b.Codicon.symbolObject),P.set(19,b.Codicon.symbolKey),P.set(20,b.Codicon.symbolNull),P.set(21,b.Codicon.symbolEnumMember),P.set(22,b.Codicon.symbolStruct),P.set(23,b.Codicon.symbolEvent),P.set(24,b.Codicon.symbolOperator),P.set(25,b.Codicon.symbolTypeParameter);function F(q){let Y=P.get(q);return Y||(console.info("No codicon found for SymbolKind "+q),Y=b.Codicon.symbolProperty),Y}m.toIcon=F})(f=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(P){this.value=P}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var o;(function(m){function P(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}m.is=P})(o=e.Command||(e.Command={}));var n;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(m){m[m.Unresolved=0]="Unresolved",m[m.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var a;(function(m){m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(a=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new C.TokenizationRegistry;var u;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(u=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[151],we([9,10]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(ve[152],we([0,1,151]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,C=D*24,k=C*7,S=C*30,p=C*365;function E(R,w,v){typeof R!="number"&&(R=R.getTime());const h=Math.round((new Date().getTime()-R)/1e3);if(h<-30)return(0,b.localize)(0,null,E(new Date().getTime()+h*1e3,!1));if(h<30)return(0,b.localize)(1,null);let I;return h<t?(I=h,w?I===1?v?(0,b.localize)(2,null,I):(0,b.localize)(3,null,I):v?(0,b.localize)(4,null,I):(0,b.localize)(5,null,I):I===1?v?(0,b.localize)(6,null,I):(0,b.localize)(7,null,I):v?(0,b.localize)(8,null,I):(0,b.localize)(9,null,I)):h<D?(I=Math.floor(h/t),w?I===1?v?(0,b.localize)(10,null,I):(0,b.localize)(11,null,I):v?(0,b.localize)(12,null,I):(0,b.localize)(13,null,I):I===1?v?(0,b.localize)(14,null,I):(0,b.localize)(15,null,I):v?(0,b.localize)(16,null,I):(0,b.localize)(17,null,I)):h<C?(I=Math.floor(h/D),w?I===1?v?(0,b.localize)(18,null,I):(0,b.localize)(19,null,I):v?(0,b.localize)(20,null,I):(0,b.localize)(21,null,I):I===1?v?(0,b.localize)(22,null,I):(0,b.localize)(23,null,I):v?(0,b.localize)(24,null,I):(0,b.localize)(25,null,I)):h<k?(I=Math.floor(h/C),w?I===1?(0,b.localize)(26,null,I):(0,b.localize)(27,null,I):I===1?(0,b.localize)(28,null,I):(0,b.localize)(29,null,I)):h<S?(I=Math.floor(h/k),w?I===1?v?(0,b.localize)(30,null,I):(0,b.localize)(31,null,I):v?(0,b.localize)(32,null,I):(0,b.localize)(33,null,I):I===1?v?(0,b.localize)(34,null,I):(0,b.localize)(35,null,I):v?(0,b.localize)(36,null,I):(0,b.localize)(37,null,I)):h<p?(I=Math.floor(h/S),w?I===1?v?(0,b.localize)(38,null,I):(0,b.localize)(39,null,I):v?(0,b.localize)(40,null,I):(0,b.localize)(41,null,I):I===1?v?(0,b.localize)(42,null,I):(0,b.localize)(43,null,I):v?(0,b.localize)(44,null,I):(0,b.localize)(45,null,I)):(I=Math.floor(h/p),w?I===1?v?(0,b.localize)(46,null,I):(0,b.localize)(47,null,I):v?(0,b.localize)(48,null,I):(0,b.localize)(49,null,I):I===1?v?(0,b.localize)(50,null,I):(0,b.localize)(51,null,I):v?(0,b.localize)(52,null,I):(0,b.localize)(53,null,I))}e.fromNow=E;function T(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ve[153],we([9,10]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(ve[38],we([0,1,18,12,153]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(R,w){return w&&(R.stack||R.stacktrace)?D.localize(0,null,S(R),k(R.stack)||k(R.stacktrace)):S(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function S(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?D.localize(1,null,R.message):R.message||D.localize(2,null)}function p(R=null,w=!1){if(!R)return D.localize(3,null);if(Array.isArray(R)){const v=b.coalesce(R),h=p(v[0],w);return v.length>1?D.localize(4,null,h,v.length):h}if(t.isString(R))return R;if(R.detail){const v=R.detail;if(v.error)return C(v.error,w);if(v.exception)return C(v.exception,w)}return R.stack?C(R,w):R.message?R.message:D.localize(5,null)}e.toErrorMessage=p;function E(R){const w=R;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=E;function T(R,w){let v;return typeof R=="string"?v=new Error(R):v=R,v.actions=w,v}e.createErrorWithActions=T}),define(ve[154],we([9,10]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(ve[155],we([0,1,154]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(D){switch(D){case 1:return(0,b.localize)(0,null);case 2:return(0,b.localize)(1,null);case 3:return(0,b.localize)(2,null);case 4:return(0,b.localize)(3,null);case 5:return(0,b.localize)(4,null);case 6:return(0,b.localize)(5,null);case 7:return(0,b.localize)(6,null);case 8:return(0,b.localize)(7,null);case 9:return(0,b.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ve[156],we([9,10]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(ve[157],we([9,10]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[158],we([9,10]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(ve[159],we([9,10]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(ve[160],we([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[161],we([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[162],we([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(ve[163],we([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ve[164],we([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ve[165],we([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[166],we([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[167],we([9,10]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[168],we([9,10]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(ve[169],we([9,10]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(ve[170],we([9,10]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(ve[171],we([9,10]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[172],we([9,10]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ve[173],we([9,10]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(ve[174],we([9,10]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(ve[175],we([9,10]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(ve[176],we([9,10]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[177],we([9,10]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[178],we([9,10]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ve[179],we([9,10]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ve[180],we([9,10]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(ve[181],we([9,10]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(ve[182],we([9,10]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(ve[183],we([9,10]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[184],we([9,10]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ve[185],we([0,1,7,2]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new b.Emitter,this._onReloadEmitter=new b.Emitter,this._onTerminateEmitter=new b.Emitter,this._onAttachEmitter=new b.Emitter}call(S,p,E){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:E[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:E[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:E[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:E[0],port:E[1],subId:E[2]}))}throw new Error("Method not implemented.")}listen(S,p,E){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends t.Disposable{constructor(S){super();this.channel=S}reload(S){this.channel.call("reload",[S])}get onReload(){return this.channel.listen("reload")}close(S){this.channel.call("close",[S])}get onClose(){return this.channel.listen("close")}attachSession(S,p,E){this.channel.call("attach",[S,p,E])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(S,p){this.channel.call("terminate",[S,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(S,p){return this.channel.call("openExtensionDevelopmentHostWindow",[S,p])}}e.ExtensionHostDebugChannelClient=C}),define(ve[186],we([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(k){this.service=k}listen(k,S,p){throw new Error("Invalid listen")}call(k,S,p){switch(S){case"download":return this.service.download(b.URI.revive(p[0]),b.URI.revive(p[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class D{constructor(k,S){this.channel=k,this.getUriTransformer=S}async download(k,S){const p=this.getUriTransformer();p&&(k=p.transformOutgoingURI(k),S=p.transformOutgoingURI(S)),await this.channel.call("download",[k,S])}}e.DownloadServiceChannelClient=D}),define(ve[187],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class b{constructor(D){this.machineId=D}encryption(){return new Promise((D,C)=>oe(["vscode-encrypt"],D,C))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=b}),define(ve[98],we([0,1,152,84,8,6,27,19,4]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(I,y,d){this._args=I,this.paths=y,this.productService=d,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",oe).fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const I=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",I)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return p.URI.file((0,C.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(p.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const I=k.env.VSCODE_PORTABLE;return I?p.URI.file((0,C.join)(I,"argv.json")):(0,S.joinPath)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const I=this.args["builtin-extensions-dir"];return I?(0,C.resolve)(I):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",oe).fsPath,"..","extensions"))}get extensionsDownloadPath(){const I=this.args["extensions-download-dir"];return I?(0,C.resolve)(I):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const I=this.args["extensions-dir"];if(I)return(0,C.resolve)(I);const y=k.env.VSCODE_EXTENSIONS;if(y)return y;const d=k.env.VSCODE_PORTABLE;return d?(0,C.join)(d,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const I=this.args.extensionDevelopmentPath;if(Array.isArray(I))return I.map(y=>/^[^:/?#]+?:\/\//.test(y)?p.URI.parse(y):p.URI.file((0,C.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(I=>I==="ui"||I==="workspace"||I==="web"?I:"workspace")}get extensionTestsLocationURI(){const I=this.args.extensionTestsPath;if(I)return/^[^:/?#]+?:\/\//.test(I)?p.URI.parse(I):p.URI.file((0,C.normalize)(I))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const I=this.args["disable-extension"];if(I){if(typeof I=="string")return[I];if(Array.isArray(I)&&I.length>0)return I}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return p.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return p.URI.file((0,C.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const I=k.env.VSCODE_PORTABLE;return I?p.URI.file((0,C.join)(I,"policy.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}Ae([t.memoize],E.prototype,"appRoot",null),Ae([t.memoize],E.prototype,"userHome",null),Ae([t.memoize],E.prototype,"userDataPath",null),Ae([t.memoize],E.prototype,"appSettingsHome",null),Ae([t.memoize],E.prototype,"tmpDir",null),Ae([t.memoize],E.prototype,"cacheHome",null),Ae([t.memoize],E.prototype,"stateResource",null),Ae([t.memoize],E.prototype,"userRoamingDataHome",null),Ae([t.memoize],E.prototype,"userDataSyncHome",null),Ae([t.memoize],E.prototype,"userDataSyncLogResource",null),Ae([t.memoize],E.prototype,"editSessionsLogResource",null),Ae([t.memoize],E.prototype,"sync",null),Ae([t.memoize],E.prototype,"machineSettingsResource",null),Ae([t.memoize],E.prototype,"workspaceStorageHome",null),Ae([t.memoize],E.prototype,"localHistoryHome",null),Ae([t.memoize],E.prototype,"keyboardLayoutResource",null),Ae([t.memoize],E.prototype,"argvResource",null),Ae([t.memoize],E.prototype,"isExtensionDevelopment",null),Ae([t.memoize],E.prototype,"untitledWorkspacesHome",null),Ae([t.memoize],E.prototype,"installSourcePath",null),Ae([t.memoize],E.prototype,"builtinExtensionsPath",null),Ae([t.memoize],E.prototype,"extensionsPath",null),Ae([t.memoize],E.prototype,"extensionDevelopmentLocationURI",null),Ae([t.memoize],E.prototype,"extensionDevelopmentKind",null),Ae([t.memoize],E.prototype,"extensionTestsLocationURI",null),Ae([t.memoize],E.prototype,"debugExtensionHost",null),Ae([t.memoize],E.prototype,"serviceMachineIdResource",null),Ae([t.memoize],E.prototype,"telemetryLogResource",null),Ae([t.memoize],E.prototype,"disableWorkspaceTrust",null),Ae([t.memoize],E.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=E;function T(h,I){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,I,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=T;function R(h,I){return v(h["inspect-search"],h["inspect-brk-search"],5876,I,h.extensionEnvironment)}e.parseSearchPort=R;function w(h,I){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,I,h.extensionEnvironment)}e.parsePtyHostPort=w;function v(h,I,y,d,g,c){const f=Number(I||h)||(d?null:y),r=f?Boolean(!!I):!1;let o;if(c)try{o=JSON.parse(c)}catch{}return{port:f,break:r,debugId:g,env:o}}}),define(ve[58],we([0,1,267,3,158]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,D.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},category:{type:"string",cat:"e",description:(0,D.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(h,I,y=k){const d={},g=["_"],c=[];for(const o in I){const n=I[o];n.alias&&(d[o]=n.alias),n.type==="string"||n.type==="string[]"?(g.push(o),n.deprecates&&g.push(...n.deprecates)):n.type==="boolean"&&(c.push(o),n.deprecates&&c.push(...n.deprecates))}const l=b(h,{string:g,boolean:c,alias:d}),f={},r=l;f._=l._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in I){const n=I[o];n.alias&&delete r[n.alias];let i=r[o];if(n.deprecates)for(const s of n.deprecates)r.hasOwnProperty(s)&&(i||(i=r[s],i&&y.onDeprecatedOption(s,n.deprecationMessage||(0,D.localize)(35,null,o))),delete r[s]);if(typeof i!="undefined"){if(n.type==="string[]"){if(Array.isArray(i)||(i=[i]),!n.allowEmptyValue){const s=i.filter(a=>a.length>0);s.length!==i.length&&(y.onEmptyValue(o),i=s.length>0?s:void 0)}}else n.type==="string"&&(Array.isArray(i)?(i=i.pop(),y.onMultipleValues(o,i)):!i&&!n.allowEmptyValue&&(y.onEmptyValue(o),i=void 0));f[o]=i,n.deprecationMessage&&y.onDeprecatedOption(o,n.deprecationMessage)}delete r[o]}for(const o in r)y.onUnknownOption(o);return f}e.parseArgs=S;function p(h,I){let y="";return I.args&&(Array.isArray(I.args)?y=` <${I.args.join("> <")}>`:y=` <${I.args}>`),I.alias?`-${I.alias} --${h}${y}`:`--${h}${y}`}function E(h,I){let y=0;const d=[];for(const f in h){const r=h[f],o=p(f,r);y=Math.max(y,o.length),d.push([o,r.description])}const g=y+2+1;if(I-g<25)return d.reduce((f,r)=>f.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const c=I-g-1,l=[];for(const f of d){const r=f[0],o=R(f[1],c),n=T(g-r.length-2);l.push("  "+r+n+o[0]);for(let i=1;i<o.length;i++)l.push(T(g)+o[i])}return l}e.formatOptions=E;function T(h){return" ".repeat(h)}function R(h,I){const y=[];for(;h.length;){const d=h.length<I?h.length:h.lastIndexOf(" ",I),g=h.slice(0,d).trim();h=h.slice(d),y.push(g)}return y}function w(h,I,y,d,g){const c=process.stdout.isTTY&&process.stdout.columns||80,l=g?.noInputFiles!==!0?`[${(0,D.localize)(36,null)}...]`:"",f=[`${h} ${y}`];f.push(""),f.push(`${(0,D.localize)(37,null)}: ${I} [${(0,D.localize)(38,null)}]${l}`),f.push(""),g?.noPipe!==!0&&(t.isWindows?f.push((0,D.localize)(39,null,I)):f.push((0,D.localize)(40,null,I)),f.push(""));const r={};for(const o in d){const n=d[o];if(n.description&&n.cat){let i=r[n.cat];i||(r[n.cat]=i={}),i[o]=n}}for(const o in r){const n=o,i=r[n];i&&(f.push(C[n]),f.push(...E(i,c)),f.push(""))}return f.join(`
`)}e.buildHelpMessage=w;function v(h,I){return`${h||(0,D.localize)(41,null)}
${I||(0,D.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=v}),define(ve[188],we([0,1,268,159,58]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function k(w,v){const h={onUnknownOption:y=>{console.warn((0,t.localize)(0,null,y))},onMultipleValues:(y,d)=>{console.warn((0,t.localize)(1,null,y,d))},onEmptyValue:y=>{console.warn((0,t.localize)(2,null,y))},onDeprecatedOption:(y,d)=>{console.warn((0,t.localize)(3,null,y,d))}},I=(0,D.parseArgs)(w,D.OPTIONS,v?h:void 0);return I.goto&&I._.forEach(y=>b(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,t.localize)(4,null))),I["max-memory"]&&b(parseInt(I["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),I}function S(w){const v=w.findIndex(h=>!/^-/.test(h));if(v>-1)return[...w.slice(0,v),...w.slice(v+1)]}function p(w){let[,...v]=w;process.env.VSCODE_DEV&&(v=S(v)||[]);const h=!R(process.env);return k(v,h)}e.parseMainProcessArgv=p;function E(w){const[,,...v]=w;return k(v,!0)}e.parseCLIProcessArgv=E;function T(w,...v){const h=w.indexOf("--");return h===-1?w.push(...v):w.splice(h,0,...v),w}e.addArg=T;function R(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function oe(e,b,t,D){function C(S){const p=k(S),E=[p];return e.isAbsolute(p)||E.unshift(D),e.resolve(...E)}function k(S){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,t);const T=S["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(R,"AppData","Roaming")}break;case"darwin":E=e.join(b.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(b.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,t)}return{getUserDataPath:C}}if(typeof define=="function")define(ve[189],we([0,89,28,8,19,27]),function(e,b,t,D,C,k){const S=C.dirname(D.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(C.joinPath(S,"package.json").fsPath);return oe(b,t,p.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),b=require("path"),t=require("os");module.exports=oe(b,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[190],we([0,1,28,98,189]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends t.AbstractNativeEnvironmentService{constructor(S,p){super(S,{homeDir:(0,b.homedir)(),tmpDir:(0,b.tmpdir)(),userDataDir:(0,D.getUserDataPath)(S)},p)}}e.NativeEnvironmentService=C}),define(ve[191],we([0,1,12,163]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(k,S,p){try{C(k,S,p)}catch{}return k}e.localizeManifest=D;function C(k,S,p){const E=(T,R,w)=>{const v=T[R];if((0,b.isString)(v)){const h=v,I=h.length;if(I>1&&h[0]==="%"&&h[I-1]==="%"){const y=h.substr(1,I-2);let d=S[y];d===void 0&&p&&(d=p[y]);const g=typeof d=="string"?d:d.message;if(g!==void 0){const c=p?.[y],l=typeof c=="string"?c:c?.message;if(w&&(R==="title"||R==="category")&&l&&l!==g){const f={value:g,original:l};T[R]=f}else T[R]=g}else console.warn(`[${k.name}]: ${(0,t.localize)(0,null,y)}`)}}else if((0,b.isObject)(v))for(const h in v)v.hasOwnProperty(h)&&(h==="commands"?E(v,h,!0):E(v,h,w));else if(Array.isArray(v))for(let h=0;h<v.length;h++)E(v,h,w)};for(const T in k)k.hasOwnProperty(T)&&E(k,T)}}),define(ve[70],we([0,1,19,67,167,50]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function p(d){return d=d.trim(),d==="*"||k.test(d)}e.isValidVersionStr=p;function E(d){if(!p(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=d.match(k);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=E;function T(d){if(!d)return null;const g=d.majorBase,c=d.majorMustEqual,l=d.minorBase;let f=d.minorMustEqual;const r=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(g===0||(f=!1),o=!1);let n=0;if(d.preRelease){const i=S.exec(d.preRelease);if(i){const[,s,a,u]=i;n=Date.UTC(Number(s),Number(a)-1,Number(u))}}return{majorBase:g,majorMustEqual:c,minorBase:l,minorMustEqual:f,patchBase:r,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:n}}e.normalizeVersion=T;function R(d,g,c){let l;typeof d=="string"?l=T(E(d)):l=d;let f;g instanceof Date?f=g.getTime():typeof g=="string"&&(f=new Date(g).getTime());let r;if(typeof c=="string"?r=T(E(c)):r=c,!l||!r)return!1;const o=l.majorBase,n=l.minorBase,i=l.patchBase;let s=r.majorBase,a=r.minorBase,u=r.patchBase;const m=r.notBefore;let P=r.majorMustEqual,F=r.minorMustEqual,q=r.patchMustEqual;return r.isMinimum?o>s?!0:o<s?!1:n>a?!0:n<a||f&&f<m?!1:i>=u:(o===1&&s===0&&(!P||!F||!q)&&(s=1,a=0,u=0,P=!0,F=!1,q=!1),o<s?!1:o>s?!P:n<a?!1:n>a?!F:i<u?!1:i>u?!q:!(f&&f<m))}e.isValidVersion=R;function w(d,g,c,l,f){const r=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return r.push([t.default.Error,D.localize(0,null)]),r;if(typeof l.name!="string")return r.push([t.default.Error,D.localize(1,null,"name")]),r;if(typeof l.version!="string")return r.push([t.default.Error,D.localize(2,null,"version")]),r;if(!l.engines)return r.push([t.default.Error,D.localize(3,null,"engines")]),r;if(typeof l.engines.vscode!="string")return r.push([t.default.Error,D.localize(4,null,"engines.vscode")]),r;if(typeof l.extensionDependencies!="undefined"&&!y(l.extensionDependencies))return r.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),r;if(typeof l.activationEvents!="undefined"){if(!y(l.activationEvents))return r.push([t.default.Error,D.localize(6,null,"activationEvents")]),r;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return r.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),r}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&r.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return r.push([t.default.Error,D.localize(9,null,"main")]),r;{const i=(0,b.joinPath)(c,l.main);(0,b.isEqualOrParent)(i,c)||r.push([t.default.Warning,D.localize(10,null,i.path,c.path)])}if(typeof l.activationEvents=="undefined")return r.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),r}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return r.push([t.default.Error,D.localize(12,null,"browser")]),r;{const i=(0,b.joinPath)(c,l.browser);(0,b.isEqualOrParent)(i,c)||r.push([t.default.Warning,D.localize(13,null,i.path,c.path)])}if(typeof l.activationEvents=="undefined")return r.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),r}if(!C.valid(l.version))return r.push([t.default.Error,D.localize(15,null)]),r;const o=[];if(!v(d,g,l,f,o))for(const i of o)r.push([t.default.Error,i]);return r}e.validateExtensionManifest=w;function v(d,g,c,l,f){return l||typeof c.main=="undefined"&&typeof c.browser=="undefined"?!0:I(d,g,c.engines.vscode,f)}e.isValidExtensionVersion=v;function h(d,g,c){return d==="*"||I(g,c,d)}e.isEngineValid=h;function I(d,g,c,l=[]){const f=T(E(c));if(!f)return l.push(D.localize(16,null,c)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return l.push(D.localize(17,null,c)),!1}else if(!f.majorMustEqual)return l.push(D.localize(18,null,c)),!1;return R(d,g,f)?!0:(l.push(D.localize(19,null,d,c)),!1)}function y(d){if(!Array.isArray(d))return!1;for(let g=0,c=d.length;g<c;g++)if(typeof d[g]!="string")return!1;return!0}}),define(ve[192],we([0,1,16,23]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,k,S){let p=S&&S.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const T=(await k.readFile(C.serviceMachineIdResource)).value.toString();p=(0,t.isUUID)(T)?T:null}catch{p=null}if(!p){p=(0,t.generateUuid)();try{await k.writeFile(C.serviceMachineIdResource,b.VSBuffer.fromString(p))}catch{}}return S?.store("storage.serviceMachineId",p,-1,1),p}e.getServiceMachineId=D}),define(ve[59],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class b{constructor(D,C=[],k=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=b}),define(ve[193],we([0,1,59]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function D(k,S,p){S instanceof b.SyncDescriptor||(S=new b.SyncDescriptor(S,[],p)),t.push([k,S])}e.registerSingleton=D;function C(){return t}e.getSingletonServiceDescriptors=C}),define(ve[194],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=b;class t{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(const k of this._nodes.values())k.outgoing.size===0&&C.push(k);return C}insertEdge(C,k){const S=this.lookupOrInsertNode(C),p=this.lookupOrInsertNode(k);S.outgoing.set(this._hashFn(k),p),p.incoming.set(this._hashFn(C),S)}removeNode(C){const k=this._hashFn(C);this._nodes.delete(k);for(const S of this._nodes.values())S.outgoing.delete(k),S.incoming.delete(k)}lookupOrInsertNode(C){const k=this._hashFn(C);let S=this._nodes.get(k);return S||(S=new b(C),this._nodes.set(k,S)),S}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){const C=[];for(const[k,S]of this._nodes)C.push(`${k}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(const[C,k]of this._nodes){const S=new Set([C]),p=this._findCycle(k,S);if(p)return p}}_findCycle(C,k){for(const[S,p]of C.outgoing){if(k.has(S))return[...k,S].join(" -> ");k.add(S);const E=this._findCycle(p,k);if(E)return E;k.delete(S)}}}e.Graph=t}),define(ve[5],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function S(p){return p[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=S})(b=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(k,S,p){S[b.DI_TARGET]===S?S[b.DI_DEPENDENCIES].push({id:k,index:p}):(S[b.DI_DEPENDENCIES]=[{id:k,index:p}],S[b.DI_TARGET]=S)}function D(k){if(b.serviceIds.has(k))return b.serviceIds.get(k);const S=function(p,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(S,p,T)};return S.toString=()=>k,b.serviceIds.set(k,S),S}e.createDecorator=D;function C(k){return k}e.refineServiceDecorator=C}),define(ve[25],we([0,1,12,4,5]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=C;function k(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var S;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function p(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function E(d,g){const c=Object.create(null);for(const l in d)T(c,l,d[l],g);return c}e.toValuesTree=E;function T(d,g,c,l){const f=g.split("."),r=f.pop();let o=d;for(let n=0;n<f.length;n++){const i=f[n];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:l(`Ignoring ${g} as ${f.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[r]=c}catch{l(`Ignoring ${g} as ${f.join(".")} is ${JSON.stringify(o)}`)}else l(`Ignoring ${g} as ${f.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=T;function R(d,g){const c=g.split(".");w(d,c)}e.removeFromValueTree=R;function w(d,g){const c=g.shift();if(g.length===0){delete d[c];return}if(Object.keys(d).indexOf(c)!==-1){const l=d[c];typeof l=="object"&&!Array.isArray(l)&&(w(l,g),Object.keys(l).length===0&&delete d[c])}}function v(d,g,c){function l(o,n){let i=o;for(const s of n){if(typeof i!="object"||i===null)return;i=i[s]}return i}const f=g.split("."),r=l(d,f);return typeof r=="undefined"?c:r}e.getConfigurationValue=v;function h(d,g,c){Object.keys(g).forEach(l=>{l!=="__proto__"&&(l in d?b.isObject(d[l])&&b.isObject(g[l])?h(d[l],g[l],c):c&&(d[l]=g[l]):d[l]=g[l])})}e.merge=h;function I(d,g,c){const l=d.inspect(g),f=d.inspect(c);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=I;function y(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(ve[99],we([0,1,3,15,5]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",b.isMacintosh),C.set("isLinux",b.isLinux),C.set("isWindows",b.isWindows),C.set("isWeb",b.isWeb),C.set("isMacNative",b.isMacintosh&&!b.isWeb),C.set("isEdge",b.isEdge),C.set("isFirefox",b.isFirefox),C.set("isChrome",b.isChrome),C.set("isSafari",b.isSafari);const k=Object.prototype.hasOwnProperty;var S;(function(se){se[se.False=0]="False",se[se.True=1]="True",se[se.Defined=2]="Defined",se[se.Not=3]="Not",se[se.Equals=4]="Equals",se[se.NotEquals=5]="NotEquals",se[se.And=6]="And",se[se.Regex=7]="Regex",se[se.NotRegex=8]="NotRegex",se[se.Or=9]="Or",se[se.In=10]="In",se[se.NotIn=11]="NotIn",se[se.Greater=12]="Greater",se[se.GreaterEquals=13]="GreaterEquals",se[se.Smaller=14]="Smaller",se[se.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class p{static false(){return R.INSTANCE}static true(){return w.INSTANCE}static has(_){return v.create(_)}static equals(_,G){return h.create(_,G)}static notEquals(_,G){return d.create(_,G)}static regex(_,G){return n.create(_,G)}static in(_,G){return I.create(_,G)}static notIn(_,G){return y.create(_,G)}static not(_){return g.create(_)}static and(..._){return a.create(_,null)}static or(..._){return u.create(_,null,!0)}static greater(_,G){return l.create(_,G)}static greaterEquals(_,G){return f.create(_,G)}static smaller(_,G){return r.create(_,G)}static smallerEquals(_,G){return o.create(_,G)}static deserialize(_,G=!1){if(!!_)return this._deserializeOrExpression(_,G)}static _deserializeOrExpression(_,G){const te=_.split("||");return u.create(te.map(j=>this._deserializeAndExpression(j,G)),null,!0)}static _deserializeAndExpression(_,G){const te=_.split("&&");return a.create(te.map(j=>this._deserializeOne(j,G)),null)}static _deserializeOne(_,G){if(_=_.trim(),_.indexOf("!=")>=0){const te=_.split("!=");return d.create(te[0].trim(),this._deserializeValue(te[1],G))}if(_.indexOf("==")>=0){const te=_.split("==");return h.create(te[0].trim(),this._deserializeValue(te[1],G))}if(_.indexOf("=~")>=0){const te=_.split("=~");return n.create(te[0].trim(),this._deserializeRegexValue(te[1],G))}if(_.indexOf(" not in ")>=0){const te=_.split(" not in ");return y.create(te[0].trim(),te[1].trim())}if(_.indexOf(" in ")>=0){const te=_.split(" in ");return I.create(te[0].trim(),te[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const te=_.split(">=");return f.create(te[0].trim(),te[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const te=_.split(">");return l.create(te[0].trim(),te[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const te=_.split("<=");return o.create(te[0].trim(),te[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const te=_.split("<");return r.create(te[0].trim(),te[1].trim())}return/^\!\s*/.test(_)?g.create(_.substr(1).trim()):v.create(_)}static _deserializeValue(_,G){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;const te=/^'([^']*)'$/.exec(_);return te?te[1].trim():_}static _deserializeRegexValue(_,G){if((0,t.isFalsyOrWhitespace)(_)){if(G)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const te=_.indexOf("/"),j=_.lastIndexOf("/");if(te===j||te<0){if(G)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}const he=_.slice(te+1,j),J=_[j+1]==="i"?"i":"";try{return new RegExp(he,J)}catch(U){if(G)throw new Error(`bad regexp-value '${_}', parse error: ${U}`);return console.warn(`bad regexp-value '${_}', parse error: ${U}`),null}}}e.ContextKeyExpr=p;function E(se,_){const G=se?se.substituteConstants():void 0,te=_?_.substituteConstants():void 0;return!G&&!te?!0:!G||!te?!1:G.equals(te)}e.expressionsAreEqualWithConstantSubstitution=E;function T(se,_){return se.cmp(_)}class R{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class w{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class v{constructor(_,G){this.key=_,this.negated=G,this.type=2}static create(_,G=null){const te=C.get(_);return typeof te=="boolean"?te?w.INSTANCE:R.INSTANCE:new v(_,G)}cmp(_){return _.type!==this.type?this.type-_.type:P(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=C.get(this.key);return typeof _=="boolean"?_?w.INSTANCE:R.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class h{constructor(_,G,te){this.key=_,this.value=G,this.negated=te,this.type=4}static create(_,G,te=null){if(typeof G=="boolean")return G?v.create(_,te):g.create(_,te);const j=C.get(_);return typeof j=="boolean"?G===(j?"true":"false")?w.INSTANCE:R.INSTANCE:new h(_,G,te)}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=C.get(this.key);if(typeof _=="boolean"){const G=_?"true":"false";return this.value===G?w.INSTANCE:R.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class I{constructor(_,G){this.key=_,this.valueKey=G,this.type=10,this.negated=null}static create(_,G){return new I(_,G)}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const G=_.getValue(this.valueKey),te=_.getValue(this.key);return Array.isArray(G)?G.includes(te):typeof te=="string"&&typeof G=="object"&&G!==null?k.call(G,te):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=I;class y{constructor(_,G){this.key=_,this.valueKey=G,this.type=11,this._negated=I.create(_,G)}static create(_,G){return new y(_,G)}cmp(_){return _.type!==this.type?this.type-_.type:this._negated.cmp(_._negated)}equals(_){return _.type===this.type?this._negated.equals(_._negated):!1}substituteConstants(){return this}evaluate(_){return!this._negated.evaluate(_)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(_){return _.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=y;class d{constructor(_,G,te){this.key=_,this.value=G,this.negated=te,this.type=5}static create(_,G,te=null){if(typeof G=="boolean")return G?g.create(_,te):v.create(_,te);const j=C.get(_);return typeof j=="boolean"?G===(j?"true":"false")?R.INSTANCE:w.INSTANCE:new d(_,G,te)}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=C.get(this.key);if(typeof _=="boolean"){const G=_?"true":"false";return this.value===G?R.INSTANCE:w.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class g{constructor(_,G){this.key=_,this.negated=G,this.type=3}static create(_,G=null){const te=C.get(_);return typeof te=="boolean"?te?R.INSTANCE:w.INSTANCE:new g(_,G)}cmp(_){return _.type!==this.type?this.type-_.type:P(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=C.get(this.key);return typeof _=="boolean"?_?R.INSTANCE:w.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function c(se,_){if(typeof se=="string"){const G=parseFloat(se);isNaN(G)||(se=G)}return typeof se=="string"||typeof se=="number"?_(se):R.INSTANCE}class l{constructor(_,G,te){this.key=_,this.value=G,this.negated=te,this.type=12}static create(_,G,te=null){return c(G,j=>new l(_,j,te))}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class f{constructor(_,G,te){this.key=_,this.value=G,this.negated=te,this.type=13}static create(_,G,te=null){return c(G,j=>new f(_,j,te))}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=f;class r{constructor(_,G,te){this.key=_,this.value=G,this.negated=te,this.type=14}static create(_,G,te=null){return c(G,j=>new r(_,j,te))}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class o{constructor(_,G,te){this.key=_,this.value=G,this.negated=te,this.type=15}static create(_,G,te=null){return c(G,j=>new o(_,j,te))}cmp(_){return _.type!==this.type?this.type-_.type:F(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class n{constructor(_,G){this.key=_,this.regexp=G,this.type=7,this.negated=null}static create(_,G){return new n(_,G)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const G=this.regexp?this.regexp.source:"",te=_.regexp?_.regexp.source:"";return G<te?-1:G>te?1:0}equals(_){if(_.type===this.type){const G=this.regexp?this.regexp.source:"",te=_.regexp?_.regexp.source:"";return this.key===_.key&&G===te}return!1}substituteConstants(){return this}evaluate(_){const G=_.getValue(this.key);return this.regexp?this.regexp.test(G):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{constructor(_){this._actual=_,this.type=8}static create(_){return new i(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new i(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(se){let _=null;for(let G=0,te=se.length;G<te;G++){const j=se[G].substituteConstants();if(se[G]!==j&&_===null){_=[];for(let he=0;he<G;he++)_[he]=se[he]}_!==null&&(_[G]=j)}return _===null?se:_}class a{constructor(_,G){this.expr=_,this.negated=G,this.type=6}static create(_,G){return a._normalizeArr(_,G)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let G=0,te=this.expr.length;G<te;G++){const j=T(this.expr[G],_.expr[G]);if(j!==0)return j}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let G=0,te=this.expr.length;G<te;G++)if(!this.expr[G].equals(_.expr[G]))return!1;return!0}return!1}substituteConstants(){const _=s(this.expr);return _===this.expr?this:a.create(_,this.negated)}evaluate(_){for(let G=0,te=this.expr.length;G<te;G++)if(!this.expr[G].evaluate(_))return!1;return!0}static _normalizeArr(_,G){const te=[];let j=!1;for(const he of _)if(!!he){if(he.type===1){j=!0;continue}if(he.type===0)return R.INSTANCE;if(he.type===6){te.push(...he.expr);continue}te.push(he)}if(te.length===0&&j)return w.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(T);for(let he=1;he<te.length;he++)te[he-1].equals(te[he])&&(te.splice(he,1),he--);if(te.length===1)return te[0];for(;te.length>1;){const he=te[te.length-1];if(he.type!==9)break;te.pop();const J=te.pop(),U=te.length===0,M=u.create(he.expr.map(B=>a.create([B,J],null)),null,U);M&&(te.push(M),te.sort(T))}return te.length===1?te[0]:new a(te,G)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(const G of this.expr)_.push(...G.keys());return _}map(_){return new a(this.expr.map(G=>G.map(_)),null)}negate(){if(!this.negated){const _=[];for(const G of this.expr)_.push(G.negate());this.negated=u.create(_,this,!0)}return this.negated}}class u{constructor(_,G){this.expr=_,this.negated=G,this.type=9}static create(_,G,te){return u._normalizeArr(_,G,te)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let G=0,te=this.expr.length;G<te;G++){const j=T(this.expr[G],_.expr[G]);if(j!==0)return j}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let G=0,te=this.expr.length;G<te;G++)if(!this.expr[G].equals(_.expr[G]))return!1;return!0}return!1}substituteConstants(){const _=s(this.expr);return _===this.expr?this:u.create(_,this.negated,!1)}evaluate(_){for(let G=0,te=this.expr.length;G<te;G++)if(this.expr[G].evaluate(_))return!0;return!1}static _normalizeArr(_,G,te){let j=[],he=!1;if(_){for(let J=0,U=_.length;J<U;J++){const M=_[J];if(!!M){if(M.type===0){he=!0;continue}if(M.type===1)return w.INSTANCE;if(M.type===9){j=j.concat(M.expr);continue}j.push(M)}}if(j.length===0&&he)return R.INSTANCE;j.sort(T)}if(j.length!==0){if(j.length===1)return j[0];for(let J=1;J<j.length;J++)j[J-1].equals(j[J])&&(j.splice(J,1),J--);if(j.length===1)return j[0];if(te){for(let J=0;J<j.length;J++)for(let U=J+1;U<j.length;U++)q(j[J],j[U])&&(j.splice(U,1),U--);if(j.length===1)return j[0]}return new u(j,G)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(const G of this.expr)_.push(...G.keys());return _}map(_){return new u(this.expr.map(G=>G.map(_)),null)}negate(){if(!this.negated){const _=[];for(const G of this.expr)_.push(G.negate());for(;_.length>1;){const G=_.shift(),te=_.shift(),j=[];for(const J of Y(G))for(const U of Y(te))j.push(a.create([J,U],null));const he=_.length===0;_.unshift(u.create(j,null,he))}this.negated=_[0]}return this.negated}}class m extends v{constructor(_,G,te){super(_,null);this._defaultValue=G,typeof te=="object"?m._info.push({...te,key:_}):te!==!0&&m._info.push({key:_,description:te,type:G!=null?typeof G:void 0})}static all(){return m._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return h.create(this.key,_)}notEqualsTo(_){return d.create(this.key,_)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P(se,_){return se<_?-1:se>_?1:0}function F(se,_,G,te){return se<G?-1:se>G?1:_<te?-1:_>te?1:0}function q(se,_){if(_.type===6&&se.type!==9&&se.type!==6){for(const j of _.expr)if(se.equals(j))return!0}const G=se.negate(),te=Y(G).concat(Y(_));te.sort(T);for(let j=0;j<te.length;j++){const J=te[j].negate();for(let U=j+1;U<te.length;U++){const M=te[U];if(J.equals(M))return!0}}return!1}e.implies=q;function Y(se){return se.type===9?se.expr:[se]}}),define(ve[71],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,b.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,b.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(C,k){return this.secretVault[C]?.[k]??null}async setPassword(C,k,S){this.secretVault[C]=this.secretVault[C]??{},this.secretVault[C][k]=S}async deletePassword(C,k){return this.secretVault[C]?.[k]?(delete this.secretVault[C][k],Object.keys(this.secretVault[C]).length===0&&delete this.secretVault[C],!0):!1}async findPassword(C){return JSON.stringify(this.secretVault[C])??null}async findCredentials(C){const k=[];for(const S of Object.keys(this.secretVault[C]||{}))k.push({account:S,password:this.secretVault[C][S]});return k}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(ve[195],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,b.createDecorator)(e.ID);function t(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=t;class D{async getPerformanceInfo(k,S){return{}}async getSystemInfo(k,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,S){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=D}),define(ve[72],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,b.createDecorator)("downloadService")}),define(ve[196],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,b.createDecorator)("encryptionMainService")}),define(ve[29],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[31],we([0,1,161,5]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function C(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function k(d,g){switch(d){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function S(d,g){return g==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=S;function p(d,g,c){return S(g,c)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===c?!0:E(c).includes(d)}e.isTargetPlatformCompatible=p;function E(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function T(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=T;var R;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(R=e.SortBy||(e.SortBy={}));var w;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var v;(function(d){d.Install="install",d.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var I;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(I=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(g,c){super(g);this.code=c,this.name=c}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(ve[197],we([0,1,7,2,42,22,4,69,31]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(y,d){return k.URI.revive(d?d.transformIncoming(y):y)}function T(y,d){return d?d.transformOutgoingURI(y):y}function R(y,d){d=d||S.DefaultURITransformer;const g=y.manifest;return{...(0,S.transformAndReviveIncomingURIs)({...y,manifest:void 0},d),manifest:g}}function w(y,d){return d?(0,C.cloneAndChange)(y,g=>g instanceof k.URI?d.transformOutgoingURI(g):void 0):y}class v{constructor(d,g){this.service=d,this.getUriTransformer=g,this.onInstallExtension=b.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=b.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=b.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=b.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,g){const c=this.getUriTransformer(d);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return b.Event.map(this.onDidInstallExtensions,l=>l.map(f=>({...f,local:f.local?w(f.local,c):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,g,c){const l=this.getUriTransformer(d);switch(g){case"zip":return this.service.zip(R(c[0],l)).then(f=>T(f,l));case"unzip":return this.service.unzip(E(c[0],l));case"install":return this.service.install(E(c[0],l),(0,D.revive)(c[1]));case"getManifest":return this.service.getManifest(E(c[0],l));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(c[0]);case"installFromGallery":return this.service.installFromGallery(c[0],(0,D.revive)(c[1]));case"uninstall":return this.service.uninstall(R(c[0],l),(0,D.revive)(c[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(R(c[0],l));case"getInstalled":return this.service.getInstalled(c[0],k.URI.revive(c[1])).then(f=>f.map(r=>w(r,l)));case"getMetadata":return this.service.getMetadata(R(c[0],l));case"updateMetadata":return this.service.updateMetadata(R(c[0],l),c[1]).then(f=>w(f,l));case"updateExtensionScope":return this.service.updateExtensionScope(R(c[0],l),c[1]).then(f=>w(f,l));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends t.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new b.Emitter),this._onDidInstallExtensions=this._register(new b.Emitter),this._onUninstallExtension=this._register(new b.Emitter),this._onDidUninstallExtension=this._register(new b.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?k.URI.revive(g.source):g.source,profileLocation:k.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(c=>({...c,local:c.local?R(c.local,null):c.local,source:this.isUriComponents(c.source)?k.URI.revive(c.source):c.source,profileLocation:k.URI.revive(c.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:k.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:k.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const g=await this.getTargetPlatform();return d.allTargetPlatforms.some(c=>(0,p.isTargetPlatformCompatible)(c,d.allTargetPlatforms,g))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(g=>k.URI.revive(g)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,g){return Promise.resolve(this.channel.call("install",[d,g])).then(c=>R(c,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,g){return Promise.resolve(this.channel.call("installFromGallery",[d,g])).then(c=>R(c,null))}uninstall(d,g){return Promise.resolve(this.channel.call("uninstall",[d,g]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null,g){return Promise.resolve(this.channel.call("getInstalled",[d,g])).then(c=>c.map(l=>R(l,null)))}getMetadata(d){return Promise.resolve(this.channel.call("getMetadata",[d]))}updateMetadata(d,g){return Promise.resolve(this.channel.call("updateMetadata",[d,g])).then(c=>R(c,null))}updateExtensionScope(d,g){return Promise.resolve(this.channel.call("updateExtensionScope",[d,g])).then(c=>R(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class I{constructor(d){this.service=d}listen(d,g){throw new Error("Invalid listen")}call(d,g,c){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=I}),define(ve[17],we([0,1,24,6,15,12,4,169,5]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function E(J){return J.create===!0}e.isFileOpenForWriteOptions=E;var T;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var R;(function(J){J[J.Readonly=1]="Readonly"})(R=e.FilePermission||(e.FilePermission={}));var w;(function(J){J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(J){return!!(J.capabilities&2)}e.hasReadWriteCapability=v;function h(J){return!!(J.capabilities&8)}e.hasFileFolderCopyCapability=h;function I(J){return!!(J.capabilities&32768)}e.hasFileCloneCapability=I;function y(J){return!!(J.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function d(J){return!!(J.capabilities&16)}e.hasFileReadStreamCapability=d;function g(J){return v(J)?!!(J.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var c;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(U,M){super(U);this.code=M}}e.FileSystemProviderError=l;function f(J,U){const M=new l(J.toString(),U);return o(M,U),M}e.createFileSystemProviderError=f;function r(J){return J||f((0,S.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=r;function o(J,U){return J.name=U?`${U} (FileSystemError)`:"FileSystemError",J}e.markAsFileSystemProviderError=o;function n(J){if(!J)return c.Unknown;if(J instanceof l)return J.code;const U=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!U)return c.Unknown;switch(U[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=n;function i(J){if(J instanceof F)return J.fileOperationResult;switch(n(J)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(U,M,B){this.resource=U,this.operation=M,this.target=B}isOperation(U){return this.operation===U}}e.FileOperationEvent=a;var u;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class m{constructor(U,M){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const B=new Map;for(const Q of U){const ae=B.get(Q.type);switch(ae?ae.push([Q.resource,Q]):B.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,ae]of B)switch(Q){case 1:this.added=b.TernarySearchTree.forUris(()=>M),this.added.fill(ae);break;case 0:this.updated=b.TernarySearchTree.forUris(()=>M),this.updated.fill(ae);break;case 2:this.deleted=b.TernarySearchTree.forUris(()=>M),this.deleted.fill(ae);break}}contains(U,...M){return this.doContains(U,{includeChildren:!1},...M)}affects(U,...M){return this.doContains(U,{includeChildren:!0},...M)}doContains(U,M,...B){if(!U)return!1;const Q=B.length>0;return!!((!Q||B.includes(1))&&(this.added?.get(U)||M.includeChildren&&this.added?.findSuperstr(U))||(!Q||B.includes(0))&&(this.updated?.get(U)||M.includeChildren&&this.updated?.findSuperstr(U))||(!Q||B.includes(2))&&(this.deleted?.findSubstr(U)||M.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function P(J,U,M){return!J||!U||J===U||U.length>J.length?!1:(U.charAt(U.length-1)!==t.sep&&(U+=t.sep),M?(0,D.startsWithIgnoreCase)(J,U):J.indexOf(U)===0)}e.isParent=P;class F extends Error{constructor(U,M,B){super(U);this.fileOperationResult=M,this.options=B}}e.FileOperationError=F;class q extends F{constructor(U,M,B){super(U,2,B);this.stat=M}}e.NotModifiedSinceFileOperationError=q;var Y;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",J[J.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var se;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(se=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}e.etag=_;async function G(J,U){if(!U.hasProvider(k.URI.from({scheme:J.scheme})))return new Promise(M=>{const B=U.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===J.scheme&&Q.added&&(B.dispose(),M())})})}e.whenProviderRegistered=G,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class te{static formatSize(U){return(0,C.isNumber)(U)||(U=0),U<te.KB?(0,S.localize)(1,null,U.toFixed(0)):U<te.MB?(0,S.localize)(2,null,(U/te.KB).toFixed(2)):U<te.GB?(0,S.localize)(3,null,(U/te.MB).toFixed(2)):U<te.TB?(0,S.localize)(4,null,(U/te.GB).toFixed(2)):(0,S.localize)(5,null,(U/te.TB).toFixed(2))}}e.ByteSize=te,te.KB=1024,te.MB=te.KB*te.KB,te.GB=te.MB*te.KB,te.TB=te.GB*te.KB;var j;(function(J){J[J.IA32=0]="IA32",J[J.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function he(J){return{maxFileSize:J===0?300*te.MB:16*te.GB,maxHeapSize:J===0?700*te.MB:2*700*te.MB}}e.getPlatformLimits=he}),define(ve[198],we([0,1,16,38,11,7,2,46,4,23,17]),function(oe,e,b,t,D,C,k,S,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends k.Disposable{constructor(v,h){super();this.channel=v,this.extraCapabilities=h,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,h){const{buffer:I}=await this.channel.call("readFile",[v,h]);return I}readFileStream(v,h,I){const y=(0,S.newWriteableStream)(g=>b.VSBuffer.concat(g.map(c=>b.VSBuffer.wrap(c))).buffer),d=this.channel.listen("readFileStream",[v,h])(g=>{if(g instanceof b.VSBuffer)y.write(g.buffer);else{if(g==="end")y.end();else{let c=g;c instanceof Error||(c=(0,T.createFileSystemProviderError)((0,t.toErrorMessage)(c),T.FileSystemProviderErrorCode.Unknown)),y.error(c),y.end()}d.dispose()}});return I.onCancellationRequested(()=>{y.error((0,D.canceled)()),y.end(),d.dispose()}),y}writeFile(v,h,I){return this.channel.call("writeFile",[v,b.VSBuffer.wrap(h),I])}open(v,h){return this.channel.call("open",[v,h])}close(v){return this.channel.call("close",[v])}async read(v,h,I,y,d){const[g,c]=await this.channel.call("read",[v,h,d]);return I.set(g.buffer.slice(0,c),y),c}write(v,h,I,y,d){return this.channel.call("write",[v,h,b.VSBuffer.wrap(I),y,d])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,h){return this.channel.call("delete",[v,h])}rename(v,h,I){return this.channel.call("rename",[v,h,I])}copy(v,h,I){return this.channel.call("copy",[v,h,I])}cloneFile(v,h){return this.channel.call("cloneFile",[v,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const h=v;this._onDidChange.fire(h.map(I=>({resource:p.URI.revive(I.resource),type:I.type})))}else{const h=v;this._onDidWatchError.fire(h)}}))}watch(v,h){const I=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,I,v,h]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,I]))}}e.DiskFileSystemProviderClient=R}),define(ve[100],we([0,1,16,11,170,17]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(T,R,w,v,h,I){let y;try{await S(T,R,w,v,h,I)}catch(d){y=d}finally{y&&h.errorTransformer&&(y=h.errorTransformer(y)),typeof y!="undefined"&&w.error(y),w.end()}}e.readFileIntoStream=k;async function S(T,R,w,v,h,I){p(I);const y=await T.open(R,{create:!1});try{p(I);let d=0,g=0,c=h&&typeof h.length=="number"?h.length:void 0,l=b.VSBuffer.alloc(Math.min(h.bufferSize,typeof c=="number"?c:h.bufferSize)),f=h&&typeof h.position=="number"?h.position:0,r=0;do g=await T.read(y,f,l.buffer,r,l.byteLength-r),f+=g,r+=g,d+=g,typeof c=="number"&&(c-=g),r===l.byteLength&&(await w.write(v(l)),l=b.VSBuffer.alloc(Math.min(h.bufferSize,typeof c=="number"?c:h.bufferSize)),r=0);while(g>0&&(typeof c!="number"||c>0)&&p(I)&&E(d,h));if(r>0){let o=r;typeof c=="number"&&(o=Math.min(r,c)),w.write(v(l.slice(0,o)))}}catch(d){throw(0,C.ensureFileSystemProviderError)(d)}finally{await T.close(y)}}function p(T){if(T.isCancellationRequested)throw(0,t.canceled)();return!0}function E(T,R){if(R?.limits){if(typeof R.limits.memory=="number"&&T>R.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&T>R.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ve[60],we([0,1,68,2,6,3,4,17]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(d){return d.recursive===!0}e.isRecursiveWatchRequest=p;class E extends t.Disposable{constructor(g,c,l,f){super();this.onFileChanges=g,this.onLogMessage=c,this.verboseLogging=l,this.options=f,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new t.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),g.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),g.add(this.watcher.onDidError(c=>this.onError(c)))}onError(g){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.MAX_RESTARTS=5;class T extends E{constructor(g,c,l){super(g,c,l,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class R extends E{constructor(g,c,l){super(g,c,l,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=R;function w(d){return d.map(g=>({type:g.type,resource:k.URI.file(g.path)}))}e.toFileChanges=w;function v(d){const g=new y;for(const c of d)g.processEvent(c);return g.coalesce()}e.coalesceEvents=v;function h(d,g){return typeof g=="string"&&!g.startsWith(b.GLOBSTAR)&&!(0,D.isAbsolute)(g)?{base:d,pattern:g}:g}e.normalizeWatcherPattern=h;function I(d,g){const c=[];for(const l of g)c.push((0,b.parse)(h(d,l)));return c}e.parseWatcherPatterns=I;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return C.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const c=this.mapPathToChange.get(this.toKey(g));let l=!1;if(c){const f=c.type,r=g.type;c.path!==g.path&&(g.type===2||g.type===1)?l=!0:f===1&&r===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(c)):f===2&&r===1?c.type=0:f===1&&r===0||(c.type=r)}else l=!0;l&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],c=[];return Array.from(this.coalesced).filter(l=>l.type!==2?(g.push(l),!1):!0).sort((l,f)=>l.path.length-f.path.length).filter(l=>c.some(f=>(0,S.isParent)(l.path,f,!C.isLinux))?!1:(c.push(l.path),!0)).concat(g)}}}),define(ve[199],we([0,1,30,14,20,35,2,87,6,3,145,21,60]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends k.Disposable{constructor(y,d,g,c){super();this.request=y,this.onDidFilesChange=d,this.onLogMessage=g,this.verboseLogging=c,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,w.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,w.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await R.Promises.stat(y);this._register(await this.doWatch(y,d.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let d=y.path;try{d=await R.Promises.realpath(y.path),y.path===d&&(d=await(0,T.realcase)(y.path)??y.path),y.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${d})`)}catch{}return d}async doWatch(y,d){if(E.isMacintosh&&(0,C.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=new D.CancellationTokenSource(this.cts.token),c=new k.DisposableStore;try{const l=(0,p.basename)(y),f=(0,b.watch)(y);c.add((0,k.toDisposable)(()=>{f.removeAllListeners(),f.close()})),this.trace(`Started watching: '${y}'`);const r=new Set;if(d)try{for(const n of await R.Promises.readdir(y))r.add(n)}catch(n){this.error(n)}const o=new Map;c.add((0,k.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),f.on("error",(n,i)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),f.on("change",(n,i)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${i}`);let s="";if(i&&(s=i.toString(),E.isMacintosh&&(s=(0,S.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(d)if(n==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===l&&!await R.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,p.join)(y,s));if(g.token.isCancellationRequested)return;let m;u?r.has(s)?m=0:(m=1,r.add(s)):(r.delete(s),m=2),this.onFileChange({path:(0,p.join)(this.request.path,s),type:m})},v.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,k.toDisposable)(()=>clearTimeout(a)))}else{let a;r.has(s)?a=0:(a=1,r.add(s)),this.onFileChange({path:(0,p.join)(this.request.path,s),type:a})}else if(n==="rename"||s!==l){const a=setTimeout(async()=>{const u=await R.Promises.exists(y);g.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,k.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await R.Promises.exists(y)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${l.toString()})`)}return(0,k.toDisposable)(()=>{g.dispose(!0),c.dispose()})}async onFileChange(y,d=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!d&&this.excludes.some(g=>g(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const c=(0,w.coalesceEvents)(g);if(c.length>0){if(this.verboseLogging)for(const f of c)this.trace(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.throttledFileChangesWorker.work(c)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(E.isLinux)return R.Promises.exists(y);try{const d=(0,p.basename)(y);return(await R.Promises.readdir((0,p.dirname)(y))).some(c=>c===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function h(I,y,d,g,c=512){const l=await R.Promises.open(I,"r"),f=Buffer.allocUnsafe(c),r=new D.CancellationTokenSource(g);let o,n=!1;const i={path:I,excludes:[],recursive:!1},s=new v(i,a=>{(async()=>{for(const{type:u}of a)if(u===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:m}=await R.Promises.read(l,f,0,c,null);if(!m||r.token.isCancellationRequested)break;y(f.slice(0,m))}}catch(m){o=new Error(m),r.dispose(!0)}finally{n=!1}}})()});return await s.ready,d(),new Promise((a,u)=>{r.token.onCancellationRequested(async()=>{s.dispose();try{await R.Promises.close(l)}catch(m){o=new Error(m)}o?u(o):a()})})}e.watchFileContents=h}),define(ve[200],we([0,1,7,68,2,3,199]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new b.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new b.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=b.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const T=this.normalizeRequests(E),R=T.filter(v=>{const h=this.watchers.get(v.path);return h?!(0,t.patternsEquals)(h.request.excludes,v.excludes)||!(0,t.patternsEquals)(h.request.includes,v.includes):!0}),w=Array.from(this.watchers.values()).filter(({request:v})=>!T.find(h=>h.path===v.path&&(0,t.patternsEquals)(h.excludes,v.excludes)&&(0,t.patternsEquals)(h.includes,v.includes))).map(({request:v})=>v.path);R.length&&this.trace(`Request to start watching: ${R.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),w.length&&this.trace(`Request to stop watching: ${w.join(",")}`);for(const v of w)this.stopWatching(v);for(const v of R)this.startWatching(v)}startWatching(E){const T=new k.NodeJSFileWatcherLibrary(E,w=>this._onDidChangeFile.fire(w),w=>this._onDidLogMessage.fire(w),this.verboseLogging),R={request:E,instance:T};this.watchers.set(E.path,R)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const T=this.watchers.get(E);T&&(this.watchers.delete(E),T.instance.dispose())}normalizeRequests(E){const T=new Map;for(const R of E){const w=C.isLinux?R.path:R.path.toLowerCase();T.set(w,R)}return Array.from(T.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,T]of this.watchers)T.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,T){return T?`[File Watcher (node.js)] ${E} (path: ${T.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=S}),define(ve[201],we([0,1,60,200]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends b.AbstractNonRecursiveWatcherClient{constructor(k,S,p){super(k,S,p);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ve[202],we([0,1,8,43,96,60]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends C.AbstractUniversalWatcherClient{constructor(p,E,T){super(p,E,T);this.init()}createWatcher(p){const E=p.add(new D.Client(b.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(E.onDidProcessExit(({code:T,signal:R})=>this.onError(`terminated by itself with code ${T}, signal: ${R}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(ve[73],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...D){this._entries=new Map;for(const[C,k]of D)this.set(C,k)}set(D,C){const k=this._entries.get(D);return this._entries.set(D,C),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=b}),define(ve[101],we([0,1,14,11,59,194,5,73]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class E extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class T{constructor(h=new S.ServiceCollection,I=!1,y){this._activeInstantiations=new Set,this._services=h,this._strict=I,this._parent=y,this._services.set(k.IInstantiationService,this)}createChild(h){return new T(h,this._strict,this)}invokeFunction(h,...I){const y=w.traceInvocation(h);let d=!1;try{return h({get:c=>{if(d)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(c,y);if(!l)throw new Error(`[invokeFunction] unknown service '${c}'`);return l}},...I)}finally{d=!0,y.stop()}}createInstance(h,...I){let y,d;return h instanceof D.SyncDescriptor?(y=w.traceCreation(h.ctor),d=this._createInstance(h.ctor,h.staticArguments.concat(I),y)):(y=w.traceCreation(h),d=this._createInstance(h,I,y)),y.stop(),d}_createInstance(h,I=[],y){const d=k._util.getServiceDependencies(h).sort((l,f)=>l.index-f.index),g=[];for(const l of d){const f=this._getOrCreateServiceInstance(l.id,y);f||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${l.id}.`,!1),g.push(f)}const c=d.length>0?d[0].index:I.length;if(I.length!==c){console.trace(`[createInstance] First service dependency of ${h.name} at position ${c+1} conflicts with ${I.length} static arguments`);const l=c-I.length;l>0?I=I.concat(new Array(l)):I=I.slice(0,c)}return new h(...[...I,...g])}_setServiceInstance(h,I){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,I);else if(this._parent)this._parent._setServiceInstance(h,I);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const I=this._services.get(h);return!I&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):I}_getOrCreateServiceInstance(h,I){const y=this._getServiceInstanceOrDescriptor(h);return y instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,y,I.branch(h,!0)):(I.branch(h,!1),y)}_safeCreateAndCacheServiceInstance(h,I,y){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,I,y)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,I,y){const d=new C.Graph(l=>l.id.toString());let g=0;const c=[{id:h,desc:I,_trace:y}];for(;c.length;){const l=c.pop();if(d.lookupOrInsertNode(l),g++>1e3)throw new E(d);for(const f of k._util.getServiceDependencies(l.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(f.id);if(r||this._throwIfStrict(`[createInstance] ${h} depends on ${f.id} which is NOT registered.`,!0),r instanceof D.SyncDescriptor){const o={id:f.id,desc:r,_trace:l._trace.branch(f.id,!0)};d.insertEdge(l,o),c.push(o)}}}for(;;){const l=d.roots();if(l.length===0){if(!d.isEmpty())throw new E(d);break}for(const{data:f}of l){if(this._getServiceInstanceOrDescriptor(f.id)instanceof D.SyncDescriptor){const o=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,o)}d.removeNode(f)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,I,y=[],d,g){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(I,y,d,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,I,y,d,g);throw new Error(`illegalState - creating UNKNOWN service instance ${I.name}`)}_createServiceInstance(h,I=[],y,d){if(y){const g=new b.IdleValue(()=>this._createInstance(h,I,d));return new Proxy(Object.create(null),{get(c,l){if(l in c)return c[l];const f=g.value;let r=f[l];return typeof r!="function"||(r=r.bind(f),c[l]=r),r},set(c,l,f){return g.value[l]=f,!0}})}else return this._createInstance(h,I,d)}_throwIfStrict(h,I){if(I&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=T;var R;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(R||(R={}));class w{constructor(h,I){this.type=h,this.name=I,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return p?new w(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(h){return p?new w(0,h.name):w._None}branch(h,I){const y=new w(2,h.toString());return this._dep.push([h,I,y]),y}stop(){const h=Date.now()-this._start;w._totals+=h;let I=!1;function y(g,c){const l=[],f=new Array(g+1).join("	");for(const[r,o,n]of c._dep)if(o&&n){I=!0,l.push(`${f}CREATES -> ${r}`);const i=y(g+1,n);i&&l.push(i)}else l.push(`${f}uses -> ${r}`);return l.join(`
`)}const d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(h>2||I)&&console.log(d.join(`
`))}}e.Trace=w,w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(ve[203],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,b.createDecorator)("labelService")});var _e=this&&this.__param||function(oe,e){return function(b,t){e(b,t,oe)}};define(ve[74],we([0,1,20,2,3,172,31,5]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,S.createDecorator)("languagePackService");let p=class extends t.Disposable{constructor(T){super();this.extensionGalleryService=T}async getAvailableLanguages(){const T=new b.CancellationTokenSource;setTimeout(()=>T.cancel(),1e3);let R;try{R=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},T.token)}catch{return[]}const v=R.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(I=>I.startsWith("lp-"))).map(h=>{const I=h.properties.localizedLanguages?.[0],y=this.getLocale(h);return{...this.createQuickPickItem(y,I,h),extensionId:h.identifier.id,galleryExtension:h}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(T){return T.tags.find(R=>R.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(T,R,w){const v=R??T;let h;if(v!==T&&(h=`(${T})`),T.toLowerCase()===D.language.toLowerCase()&&(h??(h=""),h+=(0,C.localize)(0,null)),w?.installCount){h??(h="");const I=w.installCount;let y;I>1e6?y=`${Math.floor(I/1e5)/10}M`:I>1e3?y=`${Math.floor(I/1e3)}K`:y=String(I),h+=` $(cloud-download) ${y}`}return{id:T,label:v,description:h}}};p=Ae([_e(0,k.IExtensionGalleryService)],p),e.LanguagePackBaseService=p}),define(ve[13],we([0,1,38,7,2,3,5]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function S(){return new Date().toISOString()}var p;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function E(o,n,i){switch(n){case p.Trace:o.trace(i);break;case p.Debug:o.debug(i);break;case p.Info:o.info(i);break;case p.Warning:o.warn(i);break;case p.Error:o.error(i);break;case p.Critical:o.critical(i);break;default:throw new Error("Invalid log level")}}e.log=E;function T(o){let n="";for(let i=0;i<o.length;i++){let s=o[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(i>0?" ":"")+s}return n}e.format=T;class R extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=R;class w extends R{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(p.Trace)&&this.log(p.Trace,T([n,...i]))}debug(n,...i){this.checkLogLevel(p.Debug)&&this.log(p.Debug,T([n,...i]))}info(n,...i){this.checkLogLevel(p.Info)&&this.log(p.Info,T([n,...i]))}warn(n,...i){this.checkLogLevel(p.Warning)&&this.log(p.Warning,T([n,...i]))}error(n,...i){if(this.checkLogLevel(p.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(p.Error,T(s))}else this.log(p.Error,T([n,...i]))}critical(n,...i){this.checkLogLevel(p.Critical)&&this.log(p.Critical,T([n,...i]))}flush(){}}e.AbstractMessageLogger=w;class v extends R{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...i){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,n,...i):console.log(`[main ${S()}]`,n,...i))}debug(n,...i){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,n,...i):console.log(`[main ${S()}]`,n,...i))}info(n,...i){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,n,...i):console.log(`[main ${S()}]`,n,...i))}warn(n,...i){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,n,...i):console.warn(`[main ${S()}]`,n,...i))}error(n,...i){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,n,...i):console.error(`[main ${S()}]`,n,...i))}critical(n,...i){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,n,...i):console.error(`[main ${S()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends R{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=h;class I extends R{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,b.toErrorMessage)(n,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=I;class y extends R{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const s of this.logServices)s.trace(n,...i)}debug(n,...i){for(const s of this.logServices)s.debug(n,...i)}info(n,...i){for(const s of this.logServices)s.info(n,...i)}warn(n,...i){for(const s of this.logServices)s.warn(n,...i)}error(n,...i){for(const s of this.logServices)s.error(n,...i)}critical(n,...i){for(const s of this.logServices)s.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=y;class d extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=d;class g extends D.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,i?.always?p.Trace:this.logLevel,i),this.loggers.set(n.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class c{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return p.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=c;function l(o){if(o.verbose)return p.Trace;if(typeof o.logLevel=="string"){const n=f(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function f(o){switch(o){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=f;function r(o){switch(o){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=r}),define(ve[204],we([0,1,71,7,2,13,3]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let S=class zt extends D.Disposable{constructor(E){super();this.logService=E,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(E,T){let R;try{R=await this.withKeytar()}catch{return null}const w=await R.getPassword(E,T);if(w)try{let{content:v,hasNextChunk:h}=JSON.parse(w);if(!v||!h)return w;let I=1;for(;h;){const y=await R.getPassword(E,`${T}-${I}`),d=JSON.parse(y);v+=d.content,h=d.hasNextChunk,I++}return v}catch{return w}return w}async setPassword(E,T,R){let w;try{w=await this.withKeytar()}catch(I){throw this.surfaceKeytarLoadError?.(I),I}const v=3,h=async(I,y,d)=>{let g=0,c;for(;g<v;)try{await w.setPassword(I,y,d);return}catch(l){c=l,this.logService.warn("Error attempting to set a password: ",l?.message??l),g++,await new Promise(f=>setTimeout(f,200))}throw c};if(k.isWindows&&R.length>zt.MAX_PASSWORD_LENGTH){let I=0,y=0,d=!0;for(;d;){const g=R.substring(I,I+zt.PASSWORD_CHUNK_SIZE);I+=zt.PASSWORD_CHUNK_SIZE,d=R.length-I>0;const c={content:g,hasNextChunk:d};await h(E,y?`${T}-${y}`:T,JSON.stringify(c)),y++}}else await h(E,T,R);this._onDidChangePassword.fire({service:E,account:T})}async deletePassword(E,T){let R;try{R=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}const w=await R.getPassword(E,T);if(!w)return!1;const v=await R.deletePassword(E,T);try{let{content:h,hasNextChunk:I}=JSON.parse(w);if(h&&I){let y=1;for(;I;){const d=`${T}-${y}`,g=await R.getPassword(E,d);await R.deletePassword(E,d),I=JSON.parse(g).hasNextChunk,y++}}}catch{}return v&&this._onDidChangePassword.fire({service:E,account:T}),v}async findPassword(E){let T;try{T=await this.withKeytar()}catch{return null}return T.findPassword(E)}async findCredentials(E){let T;try{T=await this.withKeytar()}catch{return[]}return T.findCredentials(E)}clear(){return this._keytarCache instanceof b.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};S.MAX_PASSWORD_LENGTH=2500,S.PASSWORD_CHUNK_SIZE=S.MAX_PASSWORD_LENGTH-100,S=Ae([_e(0,C.ILogService)],S),e.BaseCredentialsMainService=S}),define(ve[205],we([0,1,18,14,11,7,2,6,60,13]),function(oe,e,b,t,D,C,k,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends k.Disposable{constructor(w,v){super();this.logService=w,this.options=v,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(w,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(w,v):this.watchNonRecursive(w,v)}watchUniversal(w,v){const h={path:this.toFilePath(w),excludes:v.excludes,includes:v.includes,recursive:v.recursive},I=(0,b.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{I(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(w=>(0,D.onUnexpectedError)(w))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,p.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const w=this.options?.watcher?.recursive?.usePolling;if(w===!0)for(const v of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const v of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(v)&&w.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(w,v){const h={path:this.toFilePath(w),excludes:v.excludes,includes:v.includes,recursive:!1},I=(0,b.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{I(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(w=>(0,D.onUnexpectedError)(w))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(w=>this._onDidChangeFile.fire((0,p.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logService[w.type](w.message)}toFilePath(w){return(0,S.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(ve[102],we([0,1,18,14,16,20,7,86,45,2,24,8,47,19,46,168,17,100,13]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends E.Disposable{constructor(f){super();this.logService=f,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(f,r){if(this.provider.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${f}`);const o=new E.DisposableStore;return this.provider.set(f,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:f,provider:r}),o.add(r.onDidChangeFile(n=>this._onDidFilesChange.fire(new y.FileChangesEvent(n,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&o.add(r.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),o.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:f}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:f,provider:r}),this.provider.delete(f),(0,E.dispose)(o)})}getProvider(f){return this.provider.get(f)}async activateProvider(f){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:f,join(o){r.push(o)}}),!this.provider.has(f)&&await t.Promises.settled(r)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.provider.has(f.scheme)}hasCapability(f,r){const o=this.provider.get(f.scheme);return!!(o&&o.capabilities&r)}listCapabilities(){return p.Iterable.map(this.provider,([f,r])=>({scheme:f,capabilities:r.capabilities}))}async withProvider(f){if(!(0,v.isAbsolutePath)(f))throw new y.FileOperationError((0,I.localize)(0,null,this.resourceForError(f)),8);await this.activateProvider(f.scheme);const r=this.provider.get(f.scheme);if(!r){const o=new Error;throw o.name="ENOPRO",o.message=(0,I.localize)(1,null,f.toString()),o}return r}async withReadProvider(f){const r=await this.withProvider(f);if((0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r)||(0,y.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(f){const r=await this.withProvider(f);if((0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,r){try{return await this.doResolveFile(f,r)}catch(o){throw(0,y.toFileSystemProviderErrorCode)(o)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,I.localize)(2,null,this.resourceForError(f)),1):(0,y.ensureFileSystemProviderError)(o)}}async doResolveFile(f,r){const o=await this.withProvider(f),n=this.isPathCaseSensitive(o),i=r?.resolveTo,s=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,u=await o.stat(f);let m;return this.toFileStat(o,f,u,void 0,!!a,(P,F)=>(m||(m=T.TernarySearchTree.forUris(()=>!n),m.set(f,!0),i&&m.fill(!0,i)),m.get(P.resource)||m.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&s?F===1:!1))}async toFileStat(f,r,o,n,i,s){const{providerExtUri:a}=this.getExtUri(f),u={resource:r,name:a.basename(r),isFile:(o.type&y.FileType.File)!=0,isDirectory:(o.type&y.FileType.Directory)!=0,isSymbolicLink:(o.type&y.FileType.SymbolicLink)!=0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&y.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,y.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(u.isDirectory&&s(u,n)){try{const m=await f.readdir(r),P=await t.Promises.settled(m.map(async([F,q])=>{try{const Y=a.joinPath(r,F),se=i?await f.stat(Y):{type:q};return await this.toFileStat(f,Y,se,m.length,i,s)}catch(Y){return this.logService.trace(Y),null}}));u.children=(0,b.coalesce)(P)}catch(m){this.logService.trace(m),u.children=[]}return u}return u}async resolveAll(f){return t.Promises.settled(f.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(f){const r=await this.withProvider(f),o=await r.stat(f);return this.toFileStat(r,f,o,void 0,!0,()=>!1)}async exists(f){const r=await this.withProvider(f);try{return!!await r.stat(f)}catch{return!1}}async canCreateFile(f,r){try{await this.doValidateCreateFile(f,r)}catch(o){return o}return!0}async doValidateCreateFile(f,r){if(!r?.overwrite&&await this.exists(f))throw new y.FileOperationError((0,I.localize)(3,null,this.resourceForError(f)),3,r)}async createFile(f,r=D.VSBuffer.fromString(""),o){await this.doValidateCreateFile(f,o);const n=await this.writeFile(f,r);return this._onDidRunOperation.fire(new y.FileOperationEvent(f,0,n)),n}async writeFile(f,r,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,f,o)||await this.mkdirp(n,i.dirname(f));let a;if((0,y.hasReadWriteCapability)(n)&&!(r instanceof D.VSBuffer))if((0,h.isReadableStream)(r)){const u=await(0,h.peekStream)(r,3);u.ended?a=D.VSBuffer.concat(u.buffer):a=u}else a=(0,h.peekReadable)(r,u=>D.VSBuffer.concat(u),3);else a=r;!(0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(n,f,o,a):await this.doWriteBuffered(n,f,o,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this._onDidRunOperation.fire(new y.FileOperationEvent(f,4))}catch(s){throw new y.FileOperationError((0,I.localize)(4,null,this.resourceForError(f),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),o)}return this.resolve(f,{resolveMetadata:!0})}async validateWriteFile(f,r,o){if(!!o?.unlock&&!(f.capabilities&8192))throw new Error((0,I.localize)(5,null,this.resourceForError(r)));let i;try{i=await f.stat(r)}catch{return}if((i.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,I.localize)(6,null,this.resourceForError(r)),0,o);if(this.throwIfFileIsReadonly(r,i),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==y.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&o.mtime<i.mtime&&o.etag!==(0,y.etag)({mtime:o.mtime,size:i.size}))throw new y.FileOperationError((0,I.localize)(7,null),3,o);return i}async readFile(f,r,o){const n=await this.withReadProvider(f);return r?.atomic?this.doReadFileAtomic(n,f,r,o):this.doReadFile(n,f,r,o)}async doReadFileAtomic(f,r,o,n){return new Promise((i,s)=>{this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(f,r,o,n);i(a)}catch(a){s(a)}})})}async doReadFile(f,r,o,n){const i=await this.doReadFileStream(f,r,{...o,preferUnbuffered:!0},n);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(f,r,o){const n=await this.withReadProvider(f);return this.doReadFileStream(n,f,r,o)}async doReadFileStream(f,r,o,n){const i=new C.CancellationTokenSource(n),s=this.validateReadFile(r,o).then(u=>u,u=>{throw i.cancel(),u});let a;try{return typeof o?.etag=="string"&&o.etag!==y.ETAG_DISABLED&&await s,o?.atomic&&(0,y.hasFileAtomicReadCapability)(f)||!((0,y.hasOpenReadWriteCloseCapability)(f)||(0,y.hasFileReadStreamCapability)(f))||(0,y.hasReadWriteCapability)(f)&&o?.preferUnbuffered?a=this.readFileUnbuffered(f,r,o):(0,y.hasFileReadStreamCapability)(f)?a=this.readFileStreamed(f,r,i.token,o):a=this.readFileBuffered(f,r,i.token,o),{...await s,value:a}}catch(u){a&&await(0,h.consumeStream)(a);const m=(0,I.localize)(8,null,this.resourceForError(r),(0,y.ensureFileSystemProviderError)(u).toString());throw u instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(m,u.stat,o):new y.FileOperationError(m,(0,y.toFileOperationResult)(u),o)}}readFileStreamed(f,r,o,n=Object.create(null)){const i=f.readFileStream(r,n,o);return(0,h.transform)(i,{data:s=>s instanceof D.VSBuffer?s:D.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,I.localize)(9,null,this.resourceForError(r),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),n)},s=>D.VSBuffer.concat(s))}readFileBuffered(f,r,o,n=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,d.readFileIntoStream)(f,r,i,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,I.localize)(10,null,this.resourceForError(r),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),n)},o),i}readFileUnbuffered(f,r,o){const n=(0,h.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;o?.atomic&&(0,y.hasFileAtomicReadCapability)(f)?i=await f.readFile(r,{atomic:!0}):i=await f.readFile(r),typeof o?.position=="number"&&(i=i.slice(o.position)),typeof o?.length=="number"&&(i=i.slice(0,o.length)),this.validateReadFileLimits(r,i.byteLength,o),n.end(D.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(f,r){const o=await this.resolve(f,{resolveMetadata:!0});if(o.isDirectory)throw new y.FileOperationError((0,I.localize)(11,null,this.resourceForError(f)),0,r);if(typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&r.etag===o.etag)throw new y.NotModifiedSinceFileOperationError((0,I.localize)(12,null),o,r);return this.validateReadFileLimits(f,o.size,r),o}validateReadFileLimits(f,r,o){if(o?.limits){let n;if(typeof o.limits.memory=="number"&&r>o.limits.memory&&(n=9),typeof o.limits.size=="number"&&r>o.limits.size&&(n=7),typeof n=="number")throw new y.FileOperationError((0,I.localize)(13,null,this.resourceForError(f)),n)}}async canMove(f,r,o){return this.doCanMoveCopy(f,r,"move",o)}async canCopy(f,r,o){return this.doCanMoveCopy(f,r,"copy",o)}async doCanMoveCopy(f,r,o,n){if(f.toString()!==r.toString())try{const i=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f):await this.withReadProvider(f),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(i,f,s,r,o,n)}catch(i){return i}return!0}async move(f,r,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,f,i,r,"move",!!o),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(f,s==="move"?2:3,a)),a}async copy(f,r,o){const n=await this.withReadProvider(f),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,f,i,r,"copy",!!o),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(f,s==="copy"?3:2,a)),a}async doMoveCopy(f,r,o,n,i,s){if(r.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(f,r,o,n,i,s);if(a&&!u&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(n)),i==="copy"){if(f===o&&(0,y.hasFileFolderCopyCapability)(f))await f.copy(r,n,{overwrite:s});else{const m=await this.resolve(r);m.isDirectory?await this.doCopyFolder(f,m,o,n):await this.doCopyFile(f,r,o,n)}return i}else return f===o?(await f.rename(r,n,{overwrite:s}),i):(await this.doMoveCopy(f,r,o,n,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(f,r,o,n){if((0,y.hasOpenReadWriteCloseCapability)(f)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(f,r,o,n);if((0,y.hasOpenReadWriteCloseCapability)(f)&&(0,y.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(f,r,o,n);if((0,y.hasReadWriteCapability)(f)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(f,r,o,n);if((0,y.hasReadWriteCapability)(f)&&(0,y.hasReadWriteCapability)(o))return this.doPipeUnbuffered(f,r,o,n)}async doCopyFolder(f,r,o,n){await o.mkdir(n),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async i=>{const s=this.getExtUri(o).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(f,await this.resolve(i.resource),o,s):this.doCopyFile(f,i.resource,o,s)}))}async doValidateMoveCopy(f,r,o,n,i,s){let a=!1;if(f===o){const{providerExtUri:m,isPathCaseSensitive:P}=this.getExtUri(f);if(P||(a=m.isEqual(r,n)),a&&i==="copy")throw new Error((0,I.localize)(14,null,this.resourceForError(r),this.resourceForError(n)));if(!a&&m.isEqualOrParent(n,r))throw new Error((0,I.localize)(15,null,this.resourceForError(r),this.resourceForError(n)))}const u=await this.exists(n);if(u&&!a){if(!s)throw new y.FileOperationError((0,I.localize)(16,null,this.resourceForError(r),this.resourceForError(n)),4);if(f===o){const{providerExtUri:m}=this.getExtUri(f);if(m.isEqualOrParent(r,n))throw new Error((0,I.localize)(17,null,this.resourceForError(r),this.resourceForError(n)))}}return{exists:u,isSameResourceWithDifferentPathCase:a}}getExtUri(f){const r=this.isPathCaseSensitive(f);return{providerExtUri:r?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(f){return!!(f.capabilities&1024)}async createFolder(f){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);await this.mkdirp(r,f);const o=await this.resolve(f,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(f,0,o)),o}async mkdirp(f,r){const o=[],{providerExtUri:n}=this.getExtUri(f);for(;!n.isEqual(r,n.dirname(r));)try{if(((await f.stat(r)).type&y.FileType.Directory)==0)throw new Error((0,I.localize)(18,null,this.resourceForError(r)));break}catch(i){if((0,y.toFileSystemProviderErrorCode)(i)!==y.FileSystemProviderErrorCode.FileNotFound)throw i;o.push(n.basename(r)),r=n.dirname(r)}for(let i=o.length-1;i>=0;i--){r=n.joinPath(r,o[i]);try{await f.mkdir(r)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(f,r){try{await this.doValidateDelete(f,r)}catch(o){return o}return!0}async doValidateDelete(f,r){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);if(!!r?.useTrash&&!(o.capabilities&4096))throw new Error((0,I.localize)(19,null,this.resourceForError(f)));let i;try{i=await o.stat(f)}catch{}if(i)this.throwIfFileIsReadonly(f,i);else throw new y.FileOperationError((0,I.localize)(20,null,this.resourceForError(f)),1);if(!!!r?.recursive){const a=await this.resolve(f);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,I.localize)(21,null,this.resourceForError(f)))}return o}async del(f,r){const o=await this.doValidateDelete(f,r),n=!!r?.useTrash,i=!!r?.recursive;await o.delete(f,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new y.FileOperationEvent(f,1))}async cloneFile(f,r){const o=await this.withProvider(f),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(o===n&&this.getExtUri(o).providerExtUri.isEqual(f,r))return;if(o===n&&(0,y.hasFileCloneCapability)(o))return o.cloneFile(f,r);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r));const i=this.writeQueue.queueFor(f,this.getExtUri(o).providerExtUri);return o===n&&(0,y.hasFileFolderCopyCapability)(o)?i.queue(()=>o.copy(f,r,{overwrite:!0})):i.queue(()=>this.doCopyFile(o,f,n,r))}watch(f,r={recursive:!1,excludes:[]}){const o=new E.DisposableStore;let n=!1,i=()=>{n=!0};return o.add((0,E.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(f,r);n?(0,E.dispose)(s):i=()=>(0,E.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(f,r){const o=await this.withProvider(f),n=(0,S.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(f),r]);let i=this.activeWatchers.get(n);return i||(i={count:0,disposable:o.watch(f,r)},this.activeWatchers.set(n,i)),i.count+=1,(0,E.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,E.dispose)(i.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,f]of this.activeWatchers)(0,E.dispose)(f.disposable);this.activeWatchers.clear()}async doWriteBuffered(f,r,o,n){return this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(async()=>{const i=await f.open(r,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(n)||(0,h.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(f,i,n):await this.doWriteReadableBufferedQueued(f,i,n)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await f.close(i)}})}async doWriteStreamBufferedQueued(f,r,o){let n=0,i;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=D.VSBuffer.concat(o.buffer);await this.doWriteBuffer(f,r,s,s.byteLength,n,0),n+=s.byteLength}if(o.ended)return;i=o.stream}else i=o;return new Promise((s,a)=>{(0,h.listenStream)(i,{onData:async u=>{i.pause();try{await this.doWriteBuffer(f,r,u,u.byteLength,n,0)}catch(m){return a(m)}n+=u.byteLength,setTimeout(()=>i.resume())},onError:u=>a(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(f,r,o){let n=0,i;for(;(i=o.read())!==null;)await this.doWriteBuffer(f,r,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(f,r,o,n,i,s){let a=0;for(;a<n;)a+=await f.write(r,i+a,o.buffer,s+a,n-a)}async doWriteUnbuffered(f,r,o,n){return this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(f,r,o,n))}async doWriteUnbufferedQueued(f,r,o,n){let i;n instanceof D.VSBuffer?i=n:(0,h.isReadableStream)(n)?i=await(0,D.streamToBuffer)(n):(0,h.isReadableBufferedStream)(n)?i=await(0,D.bufferedStreamToBuffer)(n):i=(0,D.readableToBuffer)(n),await f.writeFile(r,i.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(f,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(f,r,o,n))}async doPipeBufferedQueued(f,r,o,n){let i,s;try{i=await f.open(r,{create:!1}),s=await o.open(n,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,m=0,P=0;do P=await f.read(i,u,a.buffer,m,a.byteLength-m),await this.doWriteBuffer(o,s,a,P,u,m),u+=P,m+=P,m===a.byteLength&&(m=0);while(P>0)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof i=="number"?f.close(i):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(f,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(f,r,o,n))}async doPipeUnbufferedQueued(f,r,o,n){return o.writeFile(n,await f.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(f,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(f,r,o,n))}async doPipeUnbufferedToBufferedQueued(f,r,o,n){const i=await o.open(n,{create:!0,unlock:!1});try{const s=await f.readFile(r);await this.doWriteBuffer(o,i,D.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await o.close(i)}}async doPipeBufferedToUnbuffered(f,r,o,n){const i=await(0,D.streamToBuffer)(this.readFileBuffered(f,r,C.CancellationToken.None));await this.doWriteUnbuffered(o,n,void 0,i)}throwIfFileSystemIsReadonly(f,r){if(f.capabilities&2048)throw new y.FileOperationError((0,I.localize)(22,null,this.resourceForError(r)),6);return f}throwIfFileIsReadonly(f,r){if((r.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,I.localize)(23,null,this.resourceForError(f)),6)}resourceForError(f){return f.scheme===R.Schemas.file?f.fsPath:f.toString(!0)}};c=Ae([_e(0,g.ILogService)],c),e.FileService=c}),define(ve[61],we([0,1,30,269,14,24,16,7,35,2,6,3,19,46,21,171,17,100,205,38,202,201]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(b)}catch(o){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(o)}`)}})();class r extends g.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i);this.onDidChangeCapabilities=S.Event.None,this.resourceLocks=new C.ResourceMap(s=>w.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(n){try{const i=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async a=>{try{let u;a.isSymbolicLink()?u=(await this.stat((0,w.joinPath)(n,a.name))).type:u=this.toType(a),s.push([a.name,u])}catch(u){this.logService.trace(u)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let s;return i?.dangling?s=y.FileType.Unknown:n.isFile()?s=y.FileType.File:n.isDirectory()?s=y.FileType.Directory:s=y.FileType.Unknown,i&&(s|=y.FileType.SymbolicLink),s}async createResourceLock(n){const i=this.toFilePath(n);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const a=new D.Barrier;return this.resourceLocks.set(n,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(n,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const a=this.toFilePath(n);return await h.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}readFileStream(n,i,s){const a=(0,v.newWriteableStream)(u=>k.VSBuffer.concat(u.map(m=>k.VSBuffer.wrap(m))).buffer);return(0,d.readFileIntoStream)(this,n,a,u=>u.buffer,{...i,bufferSize:256*1024},s),a}async writeFile(n,i,s){let a;try{const u=this.toFilePath(n);if(!s.create||!s.overwrite){if(await h.Promises.exists(u)){if(!s.overwrite)throw(0,y.createFileSystemProviderError)((0,I.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,y.createFileSystemProviderError)((0,I.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(n,u)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){r.canFlush=n}async open(n,i){const s=this.toFilePath(n);let a;(0,y.isFileOpenForWriteOptions)(i)&&(a=await this.createResourceLock(n));let u;try{if((0,y.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:P}=await h.SymlinkSupport.stat(s);P.mode&128||await h.Promises.chmod(s,P.mode|128)}catch(P){this.logService.trace(P)}let m;if((0,y.isFileOpenForWriteOptions)(i)){if(R.isWindows)try{await h.Promises.truncate(s,0),m="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}m||(m="w")}else m="r";u=await h.Promises.open(s,m)}catch(m){throw a?.dispose(),(0,y.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,m):this.toFileSystemProviderError(m)}if(this.mapHandleToPos.set(u,0),(0,y.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(u,n),a){const m=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${s})`),this.mapHandleToLock.set(u,a),m&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${s})`),m.dispose())}return u}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&r.canFlush)try{await h.Promises.fdatasync(n)}catch(s){r.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,s,a,u){const m=this.normalizePos(n,i);let P=null;try{P=(await h.Promises.read(n,s,a,u,m)).bytesRead}catch(F){throw this.toFileSystemProviderError(F)}finally{this.updatePos(n,m,P)}return P}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,s){const a=this.mapHandleToPos.get(n);typeof a=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,a+s):this.mapHandleToPos.delete(n)))}async write(n,i,s,a,u){return(0,D.retry)(()=>this.doWrite(n,i,s,a,u),100,3)}async doWrite(n,i,s,a,u){const m=this.normalizePos(n,i);let P=null;try{P=(await h.Promises.write(n,s,a,u,m)).bytesWritten}catch(F){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),F)}finally{this.updatePos(n,m,P)}return P}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const s=this.toFilePath(n);i.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,i,s){const a=this.toFilePath(n),u=this.toFilePath(i);if(a!==u)try{await this.validateTargetDeleted(n,i,"move",s.overwrite),await h.Promises.move(a,u)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,I.localize)(2,null,(0,T.basename)(a),(0,T.basename)((0,T.dirname)(u)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(n,i,s){const a=this.toFilePath(n),u=this.toFilePath(i);if(a!==u)try{await this.validateTargetDeleted(n,i,"copy",s.overwrite),await h.Promises.copy(a,u,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,I.localize)(3,null,(0,T.basename)(a),(0,T.basename)((0,T.dirname)(u)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(n,i,s,a){const u=this.toFilePath(n),m=this.toFilePath(i);let P=!1;if(!!(this.capabilities&1024)||(P=(0,p.isEqual)(u,m,!0)),P&&s==="copy")throw(0,y.createFileSystemProviderError)((0,I.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!P&&await h.Promises.exists(m)){if(!a)throw(0,y.createFileSystemProviderError)((0,I.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,s){const a=this.toFilePath(n),u=this.toFilePath(i),m=!!(this.capabilities&1024);if((0,p.isEqual)(a,u,!m))return;const P=new E.DisposableStore;try{const[F,q]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);P.add(F),P.add(q),s&&await h.Promises.mkdir((0,T.dirname)(u),{recursive:!0}),await h.Promises.copyFile(a,u)}catch(F){if(F.code==="ENOENT"&&!s)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(F)}finally{P.dispose()}}createUniversalWatcher(n,i,s){return new l.UniversalWatcherClient(a=>n(a),a=>i(a),s)}createNonRecursiveWatcher(n,i,s){return new f.NodeJSWatcherClient(a=>n(a),a=>i(a),s)}toFileSystemProviderError(n){if(n instanceof y.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=y.FileSystemProviderErrorCode.NoPermissions;break;default:i=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(n,i){let s=this.toFileSystemProviderError(i);if(n&&s.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await h.SymlinkSupport.stat(this.toFilePath(n));a.mode&128||(s=(0,y.createFileSystemProviderError)(i,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=r,r.canFlush=!0}),define(ve[206],we([0,1,7,61,2,16,46,20]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class p extends D.Disposable{constructor(R,w){super();this.provider=R,this.logService=w,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,w,v){const h=this.getUriTransformer(R);switch(w){case"stat":return this.stat(h,v[0]);case"readdir":return this.readdir(h,v[0]);case"open":return this.open(h,v[0],v[1]);case"close":return this.close(v[0]);case"read":return this.read(v[0],v[1],v[2]);case"readFile":return this.readFile(h,v[0],v[1]);case"write":return this.write(v[0],v[1],v[2],v[3],v[4]);case"writeFile":return this.writeFile(h,v[0],v[1],v[2]);case"rename":return this.rename(h,v[0],v[1],v[2]);case"copy":return this.copy(h,v[0],v[1],v[2]);case"cloneFile":return this.cloneFile(h,v[0],v[1]);case"mkdir":return this.mkdir(h,v[0]);case"delete":return this.delete(h,v[0],v[1]);case"watch":return this.watch(h,v[0],v[1],v[2],v[3]);case"unwatch":return this.unwatch(v[0],v[1])}throw new Error(`IPC Command ${w} not found`)}listen(R,w,v){const h=this.getUriTransformer(R);switch(w){case"fileChange":return this.onFileChange(h,v[0]);case"readFileStream":return this.onReadFileStream(h,v[0],v[1])}throw new Error(`Unknown event ${w}`)}stat(R,w){const v=this.transformIncoming(R,w,!0);return this.provider.stat(v)}readdir(R,w){const v=this.transformIncoming(R,w);return this.provider.readdir(v)}async readFile(R,w,v){const h=this.transformIncoming(R,w,!0),I=await this.provider.readFile(h,v);return C.VSBuffer.wrap(I)}onReadFileStream(R,w,v){const h=this.transformIncoming(R,w,!0),I=new S.CancellationTokenSource,y=new b.Emitter({onLastListenerRemove:()=>{I.cancel()}}),d=this.provider.readFileStream(h,v,I.token);return(0,k.listenStream)(d,{onData:g=>y.fire(C.VSBuffer.wrap(g)),onError:g=>y.fire(g),onEnd:()=>{y.fire("end"),y.dispose(),I.dispose()}}),y.event}writeFile(R,w,v,h){const I=this.transformIncoming(R,w);return this.provider.writeFile(I,v.buffer,h)}open(R,w,v){const h=this.transformIncoming(R,w,!0);return this.provider.open(h,v)}close(R){return this.provider.close(R)}async read(R,w,v){const h=C.VSBuffer.alloc(v),I=0,y=await this.provider.read(R,w,h.buffer,I,v);return[h,y]}write(R,w,v,h,I){return this.provider.write(R,w,v.buffer,h,I)}mkdir(R,w){const v=this.transformIncoming(R,w);return this.provider.mkdir(v)}delete(R,w,v){const h=this.transformIncoming(R,w);return this.provider.delete(h,v)}rename(R,w,v,h){const I=this.transformIncoming(R,w),y=this.transformIncoming(R,v);return this.provider.rename(I,y,h)}copy(R,w,v,h){const I=this.transformIncoming(R,w),y=this.transformIncoming(R,v);return this.provider.copy(I,y,h)}cloneFile(R,w,v){const h=this.transformIncoming(R,w),I=this.transformIncoming(R,v);return this.provider.cloneFile(h,I)}onFileChange(R,w){const v=new b.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(w,this.createSessionFileWatcher(R,v))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(w)),this.sessionToWatcher.delete(w)}});return v.event}async watch(R,w,v,h,I){const y=this.sessionToWatcher.get(w);if(y){const d=this.transformIncoming(R,h),g=y.watch(v,d,I);this.watchRequests.set(w+v,g)}}async unwatch(R,w){const v=R+w,h=this.watchRequests.get(v);h&&((0,D.dispose)(h),this.watchRequests.delete(v))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=p;class E extends D.Disposable{constructor(R,w,v,h){super();this.uriTransformer=R,this.logService=v,this.environmentService=h,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(w)}registerListeners(R){const w=this._register(new b.Emitter);this._register(w.event(v=>{R.fire(v.map(h=>({resource:this.uriTransformer.transformOutgoingURI(h.resource),type:h.type})))})),this._register(this.fileWatcher.onDidChangeFile(v=>w.fire(v))),this._register(this.fileWatcher.onDidWatchError(v=>R.fire(v)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,w,v){const h=this.getExtraExcludes(this.environmentService);return Array.isArray(h)&&(v.excludes=[...v.excludes,...h]),this.watcherRequests.set(R,this.fileWatcher.watch(w,v)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=E}),define(ve[103],we([0,1,7,4,13]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(w){this.service=w,this.onDidChangeLogLevel=b.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(w,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=C;class k{constructor(w){this.channel=w}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(w){k.setLevel(this.channel,w)}static setLevel(w,v){return w.call("setLevel",v)}}e.LogLevelChannelClient=k;class S{constructor(w){this.loggerService=w,this.loggers=new Map}listen(w,v){throw new Error(`Event not found: ${v}`)}async call(w,v,h){switch(v){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(w,v){this.loggers.set(w.toString(),this.loggerService.createLogger(w,v))}consoleLog(w,v){let h=console.log;switch(w){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(w,v){const h=this.loggers.get(w.toString());if(!h)throw new Error("Create the logger before logging");for(const[I,y]of v)(0,D.log)(h,I,y)}}e.LoggerChannel=S;class p extends D.AbstractLoggerService{constructor(w,v,h){super(w,v);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(w,v)=>{this.channel.call("consoleLog",[w,v])}})}doCreateLogger(w,v,h){return new E(this.channel,w,v,h)}}e.LoggerChannelClient=p;class E extends D.AbstractMessageLogger{constructor(w,v,h,I){super(I?.always);this.channel=w,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,I]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,v){const h=[[w,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(w){this.channel.call("log",[this.file,w])}}class T extends D.LogService{constructor(w,v){super(v);this.parent=w,this._register(w.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(w){super.setLevel(w),this.parent.setLevel(w)}}e.FollowerLogService=T}),define(ve[104],we([0,1,17,13]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(S,p,E,T,R){try{const w=await new Promise((h,I)=>{oe(["spdlog"],h,I)});w.setFlushOn(t.LogLevel.Trace);const v=await w.createAsyncRotatingLogger(S,p,E,T);return R&&v.clearFormatters(),v}catch(w){console.error(w)}return null}function C(S,p,E){switch(p){case t.LogLevel.Trace:S.trace(E);break;case t.LogLevel.Debug:S.debug(E);break;case t.LogLevel.Info:S.info(E);break;case t.LogLevel.Warning:S.warn(E);break;case t.LogLevel.Error:S.error(E);break;case t.LogLevel.Critical:S.critical(E);break;default:throw new Error("Invalid log level")}}class k extends t.AbstractMessageLogger{constructor(p,E,T,R,w){super();this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(p,E,T,R),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}async _createSpdLogLogger(p,E,T,R){const w=T?6:1,v=30/w*b.ByteSize.MB,h=await D(p,E,v,w,R);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:I,message:y}of this.buffer)C(this._logger,I,y);this.buffer=[]}}log(p,E){this._logger?C(this._logger,p,E):this.getLevel()<=p&&this.buffer.push({level:p,message:E})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ve[207],we([0,1,67,173,5]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var k;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(p){function E(h,I){return I-h}p.compare=E;const T=Object.create(null);T[p.Error]=(0,t.localize)(0,null),T[p.Warning]=(0,t.localize)(1,null),T[p.Info]=(0,t.localize)(2,null);function R(h){return T[h]||""}p.toString=R;function w(h){switch(h){case b.default.Error:return p.Error;case b.default.Warning:return p.Warning;case b.default.Info:return p.Info;case b.default.Ignore:return p.Hint}}p.fromSeverity=w;function v(h){switch(h){case p.Error:return b.default.Error;case p.Warning:return b.default.Warning;case p.Info:return b.default.Info;case p.Hint:return b.default.Ignore}}p.toSeverity=v}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var S;(function(p){const E="";function T(w){return R(w,!0)}p.makeKey=T;function R(w,v){const h=[E];return w.source?h.push(w.source.replace("\xA6","\\\xA6")):h.push(E),w.code?typeof w.code=="string"?h.push(w.code.replace("\xA6","\\\xA6")):h.push(w.code.value.replace("\xA6","\\\xA6")):h.push(E),w.severity!==void 0&&w.severity!==null?h.push(k.toString(w.severity)):h.push(E),w.message&&v?h.push(w.message.replace("\xA6","\\\xA6")):h.push(E),w.startLineNumber!==void 0&&w.startLineNumber!==null?h.push(w.startLineNumber.toString()):h.push(E),w.startColumn!==void 0&&w.startColumn!==null?h.push(w.startColumn.toString()):h.push(E),w.endLineNumber!==void 0&&w.endLineNumber!==null?h.push(w.endLineNumber.toString()):h.push(E),w.endColumn!==void 0&&w.endColumn!==null?h.push(w.endColumn.toString()):h.push(E),h.push(E),h.join("\xA6")}p.makeKeyOptionalMessage=R})(S=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(ve[62],we([0,1,7,45,2,5]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class k extends D.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(E){const T=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...E,...this.policyDefinitions},T!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(E),t.Iterable.reduce(this.policies.entries(),(R,[w,v])=>({...R,[w]:v}),{})}getPolicyValue(E){return this.policies.get(E)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(E,[T,R])=>({...E,[T]:{definition:R,value:this.policies.get(T)}}),{})}}e.AbstractPolicyService=k;class S{constructor(){this.onDidChange=b.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=S}),define(ve[51],we([0,1,8,3,27,19]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const S=t.globals.vscode.context.configuration();if(S)k=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof oe?.__$__nodeRequire=="function"){const S=(0,C.dirname)(b.FileAccess.asFileUri("",oe));k=oe.__$__nodeRequire((0,C.joinPath)(S,"product.json").fsPath);const p=oe.__$__nodeRequire((0,C.joinPath)(S,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),Object.assign(k,{version:p.version,extensionsGallery:D.env.EXTENSIONS_GALLERY?JSON.parse(D.env.EXTENSIONS_GALLERY):k.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else k={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.71.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"4.7.1",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.71.2",commit:"74b1f979648cc44d385a2286793c226e611f59e7",date:"2022-09-30T17:08:31.326Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(ve[26],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,b.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ve[33],we([0,1,83,12]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,S){b.ok(t.isString(k)),b.ok(t.isObject(S)),b.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,S)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(ve[208],we([0,1,7,33]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class C{constructor(){this._onDidChangeSchema=new b.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,E){this.schemasById[D(p)]=E,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new C;t.Registry.add(e.Extensions.JSONContribution,k)}),define(ve[52],we([0,1,18,7,12,157,25,208,33]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=p.Registry.as(S.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,o=!0){this.registerConfigurations([r],o)}registerConfigurations(r,o=!0){const n=this.doRegisterConfigurations(r,o);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(r){const o=this.doDeregisterConfigurations(r);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:r,remove:o}){const n=[];n.push(...this.doDeregisterConfigurations(o)),n.push(...this.doRegisterConfigurations(r,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,b.distinct)(n)})}registerDefaultConfigurations(r){const o=[],n=[];for(const{overrides:i,source:s}of r)for(const a in i)if(o.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const u=this.configurationDefaultsOverrides.get(a),m=u?.valuesSources??new Map;if(s)for(const Y of Object.keys(i[a]))m.set(Y,s);const P={...u?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:P,valuesSources:m});const F=(0,k.getLanguageTagSettingPlainKey)(a),q={type:"object",default:P,description:C.localize(1,null,F),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:D.isString(s)?void 0:s,defaultValueSource:s};n.push(...I(a)),this.configurationProperties[a]=q,this.defaultLanguageConfigurationOverridesNode.properties[a]=q}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:s});const u=this.configurationProperties[a];u&&(this.updatePropertyDefaultValue(a,u),this.updateSchema(a,u))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const o=[];for(const{overrides:n,source:i}of r)for(const s in n){const a=this.configurationDefaultsOverrides.get(s),u=D.isString(i)?i:i?.id,m=D.isString(a?.source)?a?.source:a?.source?.id;if(u===m)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const P=this.configurationProperties[s];P&&(this.updatePropertyDefaultValue(s,P),this.updateSchema(s,P))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const o of r)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,o){const n=[];return r.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(r){const o=[],n=i=>{if(i.properties)for(const s in i.properties){o.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s])}i.allOf?.forEach(s=>n(s))};for(const i of r){n(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(r,o=!0,n,i,s=3){s=D.isUndefinedOrNull(r.scope)?s:r.scope;const a=[],u=r.properties;if(u)for(const P in u){const F=u[P];if(o&&c(P,F)){delete u[P];continue}if(F.source=n,F.defaultDefaultValue=u[P].default,this.updatePropertyDefaultValue(P,F),e.OVERRIDE_PROPERTY_REGEX.test(P)?F.scope=void 0:(F.scope=D.isUndefinedOrNull(F.scope)?s:F.scope,F.restricted=D.isUndefinedOrNull(F.restricted)?!!i?.includes(P):F.restricted),u[P].hasOwnProperty("included")&&!u[P].included){this.excludedConfigurationProperties[P]=u[P],delete u[P];continue}else this.configurationProperties[P]=u[P],u[P].policy?.name&&this.policyConfigurations.set(u[P].policy.name,P);!u[P].deprecationMessage&&u[P].markdownDeprecationMessage&&(u[P].deprecationMessage=u[P].markdownDeprecationMessage),a.push(P)}const m=r.allOf;if(m)for(const P of m)a.push(...this.validateAndRegisterProperties(P,o,n,i,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const o=n=>{const i=n.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);n.allOf?.forEach(o)};o(r)}updateSchema(r,o){switch(e.allSettings.properties[r]=o,o.scope){case 1:e.applicationSettings.properties[r]=o;break;case 2:e.machineSettings.properties[r]=o;break;case 6:e.machineOverridableSettings.properties[r]=o;break;case 3:e.windowSettings.properties[r]=o;break;case 4:e.resourceSettings.properties[r]=o;break;case 5:e.resourceSettings.properties[r]=o,this.resourceLanguageSettingsSchema.properties[r]=o;break}}removeFromSchema(r,o){switch(delete e.allSettings.properties[r],o.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const o=`[${r}]`,n={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,o){const n=this.configurationDefaultsOverrides.get(r);let i=n?.value,s=n?.source;D.isUndefined(i)&&(i=o.defaultDefaultValue,s=void 0),D.isUndefined(i)&&(i=d(o.type)),o.default=i,o.defaultValueSource=s}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function I(f){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let o=h.exec(f);for(;o?.length;){const n=o[1].trim();n&&r.push(n),o=h.exec(f)}}return(0,b.distinct)(r)}e.overrideIdentifiersFromKey=I;function y(f){return f.reduce((r,o)=>`${r}[${o}]`,"")}e.keyFromOverrideIdentifiers=y;function d(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new w;p.Registry.add(e.Extensions.Configuration,g);function c(f,r){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?C.localize(7,null,f):g.getConfigurationProperties()[f]!==void 0?C.localize(8,null,f):r.policy?.name&&g.getPolicyConfigurations().get(r.policy?.name)!==void 0?C.localize(9,null,f,r.policy?.name,g.getPolicyConfigurations().get(r.policy?.name)):null:C.localize(6,null)}e.validateProperty=c;function l(){const f=[],r=g.getConfigurationProperties();for(const o of Object.keys(r))f.push([o,r[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=l}),define(ve[105],we([0,1,18,7,65,2,24,22,12,4,25,52,33]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(o={},n=[],i=[]){this._contents=o,this._keys=n,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(o){return o?(0,T.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,n){const i=this.getContentsForOverrideIdentifer(n);return i?o?(0,T.getConfigurationValue)(i,o):i:void 0}getKeysForOverrideIdentifier(o){const n=[];for(const i of this.overrides)i.identifiers.includes(o)&&n.push(...i.keys);return b.distinct(n)}getAllOverrideIdentifiers(){const o=[];for(const n of this.overrides)o.push(...n.identifiers);return b.distinct(o)}override(o){let n=this.overrideConfigurations.get(o);return n||(n=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,n)),n}merge(...o){const n=S.deepClone(this.contents),i=S.deepClone(this.overrides),s=[...this.keys];for(const a of o)if(!a.isEmpty()){this.mergeContents(n,a.contents);for(const u of a.overrides){const[m]=i.filter(P=>b.equals(P.identifiers,u.identifiers));m?(this.mergeContents(m.contents,u.contents),m.keys.push(...u.keys),m.keys=b.distinct(m.keys)):i.push(S.deepClone(u))}for(const u of a.keys)s.indexOf(u)===-1&&s.push(u)}return new v(n,s,i)}freeze(){return this.frozen=!0,this}clone(){return new v(S.deepClone(this.contents),[...this.keys],S.deepClone(this.overrides))}createOverrideConfigurationModel(o){const n=this.getContentsForOverrideIdentifer(o);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const s of b.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[s];const u=n[s];u&&(typeof a=="object"&&typeof u=="object"?(a=S.deepClone(a),this.mergeContents(a,u)):a=u),i[s]=a}return new v(i,this.keys,this.overrides)}mergeContents(o,n){for(const i of Object.keys(n)){if(i in o&&p.isObject(o[i])&&p.isObject(n[i])){this.mergeContents(o[i],n[i]);continue}o[i]=S.deepClone(n[i])}}checkAndFreeze(o){return this.frozen&&!Object.isFrozen(o)?S.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let n=null,i=null;const s=a=>{a&&(i?this.mergeContents(i,a):i=S.deepClone(a))};for(const a of this.overrides)b.equals(a.identifiers,[o])?n=a.contents:a.identifiers.includes(o)&&s(a.contents);return s(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,n){this.addKey(o),(0,T.addToValueTree)(this.contents,o,n,i=>{throw new Error(i)})}removeValue(o){this.removeKey(o)&&(0,T.removeFromValueTree)(this.contents,o)}addKey(o){let n=this.keys.length;for(let i=0;i<n;i++)o.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,o)}removeKey(o){const n=this.keys.indexOf(o);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,n){if(!p.isUndefinedOrNull(o)){const i=this.doParseContent(o);this.parseRaw(i,n)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,n){this._raw=o;const{contents:i,keys:s,overrides:a,restricted:u}=this.doParseRaw(o,n);this._configurationModel=new v(i,s,a),this._restrictedConfigurations=u||[]}doParseContent(o){let n={},i=null,s=[];const a=[],u=[];function m(F){Array.isArray(s)?s.push(F):i!==null&&(s[i]=F)}const P={onObjectBegin:()=>{const F={};m(F),a.push(s),s=F,i=null},onObjectProperty:F=>{i=F},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const F=[];m(F),a.push(s),s=F,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:m,onError:(F,q,Y)=>{u.push({error:F,offset:q,length:Y})}};if(o)try{D.visit(o,P),n=s[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return n}doParseRaw(o,n){const i=w.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),s=this.filter(o,i,!0,n);o=s.raw;const a=(0,T.toValuesTree)(o,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),u=Object.keys(o),m=this.toOverrides(o,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:a,keys:u,overrides:m,restricted:s.restricted}}filter(o,n,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:o,restricted:[]};const a={},u=[];for(const m in o)if(R.OVERRIDE_PROPERTY_REGEX.test(m)&&i){const P=this.filter(o[m],n,!1,s);a[m]=P.raw,u.push(...P.restricted)}else{const P=n[m],F=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&u.push(m),(F===void 0||s.scopes===void 0||s.scopes.includes(F))&&(s.skipRestricted&&P?.restricted||(a[m]=o[m]))}return{raw:a,restricted:u}}toOverrides(o,n){const i=[];for(const s of Object.keys(o))if(R.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const u in o[s])a[u]=o[s][u];i.push({identifiers:(0,R.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,T.toValuesTree)(a,n)})}return i}}e.ConfigurationModelParser=h;class I extends C.Disposable{constructor(o,n,i,s){super();this.userSettingsResource=o,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class y{constructor(o,n,i,s,a=new v,u=new v,m=new k.ResourceMap,P=new v,F=new k.ResourceMap,q=!0){this._defaultConfiguration=o,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=a,this._workspaceConfiguration=u,this._folderConfigurations=m,this._memoryConfiguration=P,this._memoryConfigurationByResource=F,this._freeze=q,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(o,n,i){return this.getConsolidatedConfigurationModel(o,n,i).getValue(o)}updateValue(o,n,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new v,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(o):s.setValue(o,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,n,i){const s=this.getConsolidatedConfigurationModel(o,n,i),a=this.getFolderConfigurationModelForResource(n.resource,i),u=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,m=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(o),F=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(o),q=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),Y=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),se=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),_=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,G=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(o):a.freeze().getValue(o):void 0,te=n.overrideIdentifier?u.override(n.overrideIdentifier).getValue(o):u.getValue(o),j=s.getValue(o),he=b.distinct(s.overrides.map(J=>J.identifiers).flat()).filter(J=>s.getOverrideValue(o,J)!==void 0);return{defaultValue:m,policyValue:P,applicationValue:F,userValue:q,userLocalValue:Y,userRemoteValue:se,workspaceValue:_,workspaceFolderValue:G,memoryValue:te,value:j,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,policy:P!==void 0?{value:P}:void 0,application:F!==void 0?{value:F,override:n.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,user:q!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userLocal:Y!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userRemote:se!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:a?.freeze().getValue(o),override:n.overrideIdentifier?a?.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:u.getValue(o),override:n.overrideIdentifier?u.getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(o){const n=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(o){this._policyConfiguration=o}updateApplicationConfiguration(o){this._applicationConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,n){this._folderConfigurations.set(o,n),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,n){const i=[];if(!n){const{added:s,updated:a,removed:u}=l(this._defaultConfiguration,o);n=[...s,...a,...u]}for(const s of n)for(const a of(0,R.overrideIdentifiersFromKey)(s)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(a),m=o.getKeysForOverrideIdentifier(a),P=[...m.filter(F=>u.indexOf(F)===-1),...u.filter(F=>m.indexOf(F)===-1),...u.filter(F=>!S.equals(this._defaultConfiguration.override(a).getValue(F),o.override(a).getValue(F)))];i.push([a,P])}return this.updateDefaultConfiguration(o),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(o){const{added:n,updated:i,removed:s}=l(this._policyConfiguration,o),a=[...n,...i,...s];return a.length&&this.updatePolicyConfiguration(o),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:n,updated:i,removed:s,overrides:a}=l(this.applicationConfiguration,o),u=[...n,...i,...s];return u.length&&this.updateApplicationConfiguration(o),{keys:u,overrides:a}}compareAndUpdateLocalUserConfiguration(o){const{added:n,updated:i,removed:s,overrides:a}=l(this.localUserConfiguration,o),u=[...n,...i,...s];return u.length&&this.updateLocalUserConfiguration(o),{keys:u,overrides:a}}compareAndUpdateRemoteUserConfiguration(o){const{added:n,updated:i,removed:s,overrides:a}=l(this.remoteUserConfiguration,o),u=[...n,...i,...s];return u.length&&this.updateRemoteUserConfiguration(o),{keys:u,overrides:a}}compareAndUpdateWorkspaceConfiguration(o){const{added:n,updated:i,removed:s,overrides:a}=l(this.workspaceConfiguration,o),u=[...n,...i,...s];return u.length&&this.updateWorkspaceConfiguration(o),{keys:u,overrides:a}}compareAndUpdateFolderConfiguration(o,n){const i=this.folderConfigurations.get(o),{added:s,updated:a,removed:u,overrides:m}=l(i,n),P=[...s,...a,...u];return(P.length||!i)&&this.updateFolderConfiguration(o,n),{keys:P,overrides:m}}compareAndDeleteFolderConfiguration(o){const n=this.folderConfigurations.get(o);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:i,updated:s,removed:a,overrides:u}=l(n,void 0);return{keys:[...i,...s,...a],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(o,n,i){let s=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(s=s.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(o)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:o},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&o){const s=n.getFolder(o);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const a=this._memoryConfigurationByResource.get(o);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let n=this._foldersConsolidatedConfigurations.get(o);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(o);s?(n=i.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(o,n)):n=i}return n}getFolderConfigurationModelForResource(o,n){if(n&&o){const i=n.getFolder(o);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,n)=>{const{contents:i,overrides:s,keys:a}=this._folderConfigurations.get(n);return o.push([n,{contents:i,overrides:s,keys:a}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>o.add(n)),this.userConfiguration.freeze().keys.forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>o.add(i))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(o).forEach(s=>n.add(s))),[...n.values()]}static parse(o){const n=this.parseConfigurationModel(o.defaults),i=this.parseConfigurationModel(o.policy),s=this.parseConfigurationModel(o.application),a=this.parseConfigurationModel(o.user),u=this.parseConfigurationModel(o.workspace),m=o.folders.reduce((P,F)=>(P.set(E.URI.revive(F[0]),this.parseConfigurationModel(F[1])),P),new k.ResourceMap);return new y(n,i,s,a,new v,u,m,new v,new k.ResourceMap,!1)}static parseConfigurationModel(o){return new v(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=y;function d(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const o=new Set,n=new Map;for(const s of r)s.keys.forEach(a=>o.add(a)),s.overrides.forEach(([a,u])=>{const m=(0,k.getOrSet)(n,a,new Set);u.forEach(P=>m.add(P))});const i=[];return n.forEach((s,a)=>i.push([a,[...s.values()]])),{keys:[...o.values()],overrides:i}}e.mergeChanges=d;class g{constructor(o,n,i,s){this.change=o,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;o.keys.forEach(m=>a.add(m)),o.overrides.forEach(([,m])=>m.forEach(P=>a.add(P))),this.affectedKeys=[...a.values()];const u=new v;this.affectedKeys.forEach(m=>u.setValue(m,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(o,n,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(o,n,this.currentWorkspace);return!S.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(o,n){let i=(0,T.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(o=o[s],!o)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=g;class c extends g{constructor(o,n,i,s){super({keys:o.allKeys(),overrides:[]},void 0,o,n);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=c;function l(r,o){const{added:n,removed:i,updated:s}=f(o,r),a=[],u=r?.getAllOverrideIdentifiers()||[],m=o?.getAllOverrideIdentifiers()||[];if(o){const P=m.filter(F=>!u.includes(F));for(const F of P)a.push([F,o.getKeysForOverrideIdentifier(F)])}if(r){const P=u.filter(F=>!m.includes(F));for(const F of P)a.push([F,r.getKeysForOverrideIdentifier(F)])}if(o&&r){for(const P of u)if(m.includes(P)){const F=f({contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)},{contents:o.getOverrideValue(void 0,P)||{},keys:o.getKeysForOverrideIdentifier(P)});a.push([P,[...F.added,...F.removed,...F.updated]])}}return{added:n,removed:i,updated:s,overrides:a}}function f(r,o){const n=r?o?r.keys.filter(a=>o.keys.indexOf(a)===-1):[...r.keys]:[],i=o?r?o.keys.filter(a=>r.keys.indexOf(a)===-1):[...o.keys]:[],s=[];if(r&&o){for(const a of o.keys)if(r.keys.indexOf(a)!==-1){const u=(0,T.getConfigurationValue)(o.contents,a),m=(0,T.getConfigurationValue)(r.contents,a);S.equals(u,m)||s.push(a)}}return{added:n,removed:i,updated:s}}}),define(ve[209],we([0,1,18,7,2,22,12,25,105,52,13,62,33]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends D.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(w.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:c})=>this.onDidUpdateConfiguration(g,c))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,c){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class h extends p.ConfigurationModel{constructor(g={}){const c=w.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c),f=Object.create(null),r=[];for(const o in c){const n=g[o],i=n!==void 0?n:c[o].default;(0,S.addToValueTree)(f,o,i,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(f))E.OVERRIDE_PROPERTY_REGEX.test(o)&&r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(f[o]),contents:(0,S.toValuesTree)(f[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(f,l,r)}}e.DefaultConfigurationModel=h;class I{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new p.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=I;let y=class extends D.Disposable{constructor(g,c,l){super();this.defaultConfiguration=g,this.policyService=c,this.logService=l,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new p.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const c={},l=[],f=w.Registry.as(E.Extensions.Configuration).getConfigurationProperties();for(const r of g){const o=f[r];if(!o){l.push(r);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}l.push(r),c[o.policy.name]={type:o.type}}}return(0,k.isEmptyObject)(c)||await this.policyService.registerPolicyDefinitions(c),l}onDidChangePolicies(g){const c=w.Registry.as(E.Extensions.Configuration).getPolicyConfigurations(),l=(0,b.coalesce)(g.map(f=>c.get(f)));this.update(l,!0)}update(g,c){const l=w.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),f=[],r=this._configurationModel.isEmpty();for(const o of g){const n=l[o]?.policy?.name;if(n){const i=this.policyService.getPolicyValue(n);(r?i!==void 0:!(0,C.equals)(this._configurationModel.getValue(o),i))&&f.push([o,i])}else this._configurationModel.getValue(o)!==void 0&&f.push([o,void 0])}if(f.length){const o=this._configurationModel;this._configurationModel=new p.ConfigurationModel;for(const n of o.keys)this._configurationModel.setValue(n,o.getValue(n));for(const[n,i]of f)i===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,i);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=Ae([_e(1,R.IPolicyService),_e(2,T.ILogService)],y),e.PolicyConfiguration=y}),define(ve[106],we([0,1,14,7,2,19,25,105,209,62]),function(oe,e,b,t,D,C,k,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends D.Disposable{constructor(w,v,h,I){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new p.DefaultConfiguration),this.policyConfiguration=h instanceof E.NullPolicyService?new p.NullPolicyConfiguration:this._register(new p.PolicyConfiguration(this.defaultConfiguration,h,I)),this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,v)),this.configuration=new S.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new S.ConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new b.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:d})=>this.onDidDefaultConfigurationChange(y,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[w,v,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new S.Configuration(w,v,new S.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(w,v){const h=typeof w=="string"?w:void 0,I=(0,k.isConfigurationOverrides)(w)?w:(0,k.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,I,void 0)}updateValue(w,v,h,I){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(h,v,2)}onDidDefaultConfigurationChange(w,v){const h=this.configuration.toData(),I=this.configuration.compareAndUpdateDefaultConfiguration(w,v);this.trigger(I,h,7)}onDidPolicyConfigurationChange(w){const v=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(w);this.trigger(h,v,7)}trigger(w,v,h){const I=new S.ConfigurationChangeEvent(w,{data:v},this.configuration);I.source=h,I.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(I)}getTargetConfiguration(w){switch(w){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(ve[107],we([0,1,11,5]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends b.ErrorNoTelemetry{constructor(S,p=D.Unknown,E){super(S);this._message=S,this._code=p,this._detail=E,this.isHandled=p===D.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(S){return S instanceof C&&S._code===D.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof C&&S._code===D.NoResolverFound}static isHandled(S){return S instanceof C&&S.isHandled}}e.RemoteAuthorityResolverError=C}),define(ve[75],we([0,1,8]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(E){return E.scheme===b.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=t;function D(E){if(!E)return;const T=E.indexOf("+");return T<0?E:E.substr(0,T)}e.getRemoteName=D;function C(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.getRemoteServerRootPath=C;function k(E){const{host:T,port:R}=p(E);if(typeof R=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:R}}e.parseAuthorityWithPort=k;function S(E,T){let{host:R,port:w}=p(E);return typeof w=="undefined"&&(w=T),{host:R,port:w}}e.parseAuthorityWithOptionalPort=S;function p(E){const T=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const R=E.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const w=E.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:E,port:void 0}}}),define(ve[36],we([0,1,15,5,75]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=C;function k(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));var p;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(p=e.TargetPlatform||(e.TargetPlatform={}));class E{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,y){if(typeof I=="undefined"||I===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof I=="string"||typeof y=="string"){const d=typeof I=="string"?I:I.value,g=typeof y=="string"?y:y.value;return b.equalsIgnoreCase(d,g)}return I._lower===y._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=E;function T(h){return R(h)}e.isApplicationScopedExtension=T;function R(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function w(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function v(h,I){if(I){const y=`onResolveRemoteAuthority:${(0,D.getRemoteName)(I)}`;return h.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[34],we([0,1,15,31,36,3,4,11,27]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function E(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,b.compareIgnoreCase)(o.id,n.id)===0}e.areSameExtensions=E;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class R{constructor(n,i,s="undefined"){this.version=i,this.targetPlatform=s,this.id=n.id}static create(n){const i=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new R(n.identifier,i,s)}static parse(n){const i=T.exec(n);return i&&i[1]&&i[2]?new R({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof R?E(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=R;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const n=w.exec(o);return n&&n[1]?[I(n[1]),n[2]]:[I(o),void 0]}e.getIdAndVersion=v;function h(o,n){return`${o}.${n}`}e.getExtensionId=h;function I(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function y(o,n){return I(h(o,n))}e.getGalleryExtensionId=y;function d(o,n){const i=[],s=a=>{for(const u of i)if(u.some(m=>E(n(m),n(a))))return u;return null};for(const a of o){const u=s(a);u?u.push(a):i.push([a])}return i}e.groupByExtension=d;function g(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function c(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function l(o,n){const i=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&i.every(u=>!E(u.identifier,{id:a}))){const u=o.filter(m=>E(m.identifier,{id:a}));u.length===1&&(i.push(u[0]),s.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=l;async function f(o,n){if(!C.isLinux)return!1;let i;try{i=(await o.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await o.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=f;async function r(o,n){const i=await f(o,n),s=(0,t.getTargetPlatform)(i?"alpine":C.platform,p.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=r}),define(ve[108],we([0,1,20,11,8,19,50,4,162,31,34,36]),function(oe,e,b,t,D,C,k,S,p,E,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const w=y=>(0,p.localize)(0,null,y),v=(0,p.localize)(1,null,"ms-dotnettools.csharp");function h(y,d){return d?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let I=class{constructor(d,g){this.extensionManagementService=d,this.extensionGalleryService=g}get location(){}async listExtensions(d,g,c=console){let l=await this.extensionManagementService.getInstalled(1);const f=R.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(g&&g!==""){if(f.indexOf(g.toLowerCase())<0){c.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}l=l.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){c.log("Possible Categories: "),f.forEach(o=>{c.log(o)});return}this.location&&c.log((0,p.localize)(2,null,this.location)),l=l.sort((o,n)=>o.identifier.id.localeCompare(n.identifier.id));let r;for(const o of l)r!==o.identifier.id&&(r=o.identifier.id,c.log(h(o.manifest,d)))}async installExtensions(d,g,c,l,f=console){const r=[],o=[];d.length&&f.log(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const n=await this.extensionManagementService.getInstalled(1),i=(m,P)=>{const F=n.find(q=>(0,T.areSameExtensions)(q.identifier,{id:m}));if(F){if(!l&&(!P||P==="prerelease"&&F.preRelease))return f.log((0,p.localize)(5,null,m,F.manifest.version,m)),!1;if(P&&F.manifest.version===P)return f.log((0,p.localize)(6,null,`${m}@${P}`)),!1}return!0},s=(m,P,F)=>{u.push({id:m,version:P!=="prerelease"?P:void 0,installOptions:{...c,isBuiltin:F,installPreReleaseVersion:P==="prerelease"||c.installPreReleaseVersion}})},a=[],u=[];for(const m of d)if(m instanceof S.URI)a.push(m);else{const[P,F]=(0,T.getIdAndVersion)(m);i(P,F)&&s(P,F,!1)}for(const m of g){const[P,F]=(0,T.getIdAndVersion)(m);i(P,F)&&s(P,F,!0)}if(a.length&&await Promise.all(a.map(async m=>{try{const P=await this.installVSIX(m,{...c,isBuiltin:!1},l,f);P&&o.push(P)}catch(P){f.error(P.message||P.stack||P),r.push(m.toString())}})),u.length){const m=await this.getGalleryExtensions(u);await Promise.all(u.map(async P=>{const F=m.get(P.id.toLowerCase());if(F)try{const q=await this.installFromGallery(P,F,n,l,f);q&&o.push(q)}catch(q){f.error(q.message||q.stack||q),r.push(P.id)}else f.error(`${w(P.version?`${P.id}@${P.version}`:P.id)}
${v}`),r.push(P.id)}))}if(r.length)throw new Error((0,p.localize)(7,null,r.join(", ")))}async installVSIX(d,g,c,l){const f=await this.extensionManagementService.getManifest(d);if(!f)throw new Error("Invalid vsix");if(await this.validateVSIX(f,c,l))try{return await this.extensionManagementService.install(d,g),l.log((0,p.localize)(8,null,(0,C.basename)(d))),f}catch(o){if((0,t.isCancellationError)(o))return l.log((0,p.localize)(9,null,(0,C.basename)(d))),null;throw o}return null}async getGalleryExtensions(d){const g=new Map,c=d.some(f=>f.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(d.map(f=>({...f,preRelease:c})),b.CancellationToken.None);for(const f of l)g.set(f.identifier.id.toLowerCase(),f);return g}async installFromGallery({id:d,version:g,installOptions:c},l,f,r,o){const n=await this.extensionGalleryService.getManifest(l,b.CancellationToken.None);if(n&&!this.validateExtensionKind(n,o))return null;const i=f.find(s=>(0,T.areSameExtensions)(s.identifier,l.identifier));if(i){if(l.version===i.manifest.version)return o.log((0,p.localize)(10,null,g?`${d}@${g}`:d)),null;o.log((0,p.localize)(11,null,d,l.version))}try{c.isBuiltin?o.log(g?(0,p.localize)(12,null,d,g):(0,p.localize)(13,null,d)):o.log(g?(0,p.localize)(14,null,d,g):(0,p.localize)(15,null,d));const s=await this.extensionManagementService.installFromGallery(l,{...c,installGivenVersion:!!g});return o.log((0,p.localize)(16,null,d,s.manifest.version)),n}catch(s){if((0,t.isCancellationError)(s))return o.log((0,p.localize)(17,null,d)),null;throw s}}validateExtensionKind(d,g){return!0}async validateVSIX(d,g,c){const l={id:(0,T.getGalleryExtensionId)(d.publisher,d.name)},r=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,T.areSameExtensions)(l,o.identifier)&&(0,k.gt)(o.manifest.version,d.version));return r&&!g?(c.log((0,p.localize)(18,null,r.identifier.id,r.manifest.version,d.version)),!1):this.validateExtensionKind(d,c)}async uninstallExtensions(d,g,c=console){const l=async r=>{if(r instanceof S.URI){const o=await this.extensionManagementService.getManifest(r);return h(o)}return r},f=[];for(const r of d){const o=await l(r),i=(await this.extensionManagementService.getInstalled()).filter(s=>(0,T.areSameExtensions)(s.identifier,{id:o}));if(!i.length)throw new Error(`${this.notInstalled(o)}
${v}`);if(i.some(s=>s.type===0)){c.log((0,p.localize)(19,null,o));return}if(!g&&i.some(s=>s.isBuiltin)){c.log((0,p.localize)(20,null,o));return}c.log((0,p.localize)(21,null,o));for(const s of i)await this.extensionManagementService.uninstall(s),f.push(s);this.location?c.log((0,p.localize)(22,null,o,this.location)):c.log((0,p.localize)(23,null,o))}}async locateExtension(d,g=console){const c=await this.extensionManagementService.getInstalled();d.forEach(l=>{c.forEach(f=>{if(f.identifier.id===l&&f.location.scheme===D.Schemas.file){g.log(f.location.fsPath);return}})})}notInstalled(d){return this.location?(0,p.localize)(24,null,d,this.location):(0,p.localize)(25,null,d)}};I=Ae([_e(0,E.IExtensionManagementService),_e(1,E.IExtensionGalleryService)],I),e.ExtensionManagementCLIService=I}),define(ve[53],we([0,1,14,16,2,24,4,34,17,5,13]),function(oe,e,b,t,D,C,k,S,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let R=class extends D.Disposable{constructor(v,h){super();this.fileService=v,this.logService=h,this.resourcesAccessQueueMap=new C.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,h){return this.withProfileExtensions(h,I=>(I=I.filter(y=>v.some(([d])=>!(0,S.areSameExtensions)(y.identifier,d.identifier))),I.push(...v.map(([y,d])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:d}))),I))}removeExtensionFromProfile(v,h){return this.withProfileExtensions(h,I=>I.filter(y=>!(0,S.areSameExtensions)(y.identifier,v)))}async withProfileExtensions(v,h){return this.getResourceAccessQueue(v).queue(async()=>{let I=[];try{const y=await this.fileService.readFile(v),d=JSON.parse(y.value.toString());for(const g of d){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}I.push({identifier:g.identifier,location:k.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(h){I=h(I);const y=I.map(d=>({identifier:d.identifier,version:d.version,location:d.location.toJSON(),metadata:d.metadata}));await this.fileService.writeFile(v,t.VSBuffer.fromString(JSON.stringify(y)))}return I})}getResourceAccessQueue(v){let h=this.resourcesAccessQueueMap.get(v);return h||(h=new b.Queue,this.resourcesAccessQueueMap.set(v,h)),h}};R=Ae([_e(0,p.IFileService),_e(1,T.ILogService)],R),e.ExtensionsProfileScannerService=R}),define(ve[210],we([0,1,14,11,2,3,19,50,4,23,21,29,31,34,17,13]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let y=class extends D.Disposable{constructor(g,c,l,f){super();this.fileService=c,this.extensionGalleryService=l,this.logService=f,this.extensionsDownloadDir=p.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,c){await this.cleanUpPromise;const l=this.getName(g),f=(0,k.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(f)){const r=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(g,r,c);try{await this.rename(r,f,Date.now()+2*60*1e3)}catch(o){try{await this.fileService.del(r)}catch{}if(o.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(o)}. Deleted the vsix from downloaded location`,r.path),o}}return f}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,c,l){try{await T.Promises.rename(g.fsPath,c.fsPath)}catch(f){if(C.isWindows&&f&&f.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${c} with 'EPERM' error. Trying again...`),this.rename(g,c,l);throw f}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const c=[],l=[];for(const o of g.children){const n=v.ExtensionKey.parse(o.name);n&&l.push([n,o])}const f=(0,v.groupByExtension)(l,([o])=>o),r=[];for(const o of f)o.sort((n,i)=>S.rcompare(n[0].version,i[0].version)),c.push(...o.slice(1).map(n=>n[1].resource)),r.push(o[0][1]);r.sort((o,n)=>o.mtime-n.mtime),c.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(o=>o.resource)),await b.Promises.settled(c.map(o=>(this.logService.trace("Deleting vsix from cache",o.path),this.fileService.del(o))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?v.ExtensionKey.create(g).toString().toLowerCase():(0,E.generateUuid)()}};y=Ae([_e(0,R.INativeEnvironmentService),_e(1,h.IFileService),_e(2,w.IExtensionGalleryService),_e(3,I.ILogService)],y),e.ExtensionsDownloader=y}),define(ve[211],we([0,1,2,6,21,36]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends b.Disposable{constructor(p,E){super();this.environmentService=p,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(T=>this.onDidInstallExtensions(T))),this._register(E.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtensions(p){p.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(ve[109],we([0,1,110,18,14,2,8,6,21,29,31,34,13,74]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends v.LanguagePackBaseService{constructor(g,c,l,f){super(l);this.extensionManagementService=g,this.logService=f,this.cache=this._register(new I(c,f)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),c=Object.keys(g).map(l=>{const f=g[l];return{...this.createQuickPickItem(l,f.label),extensionId:f.extensions[0].extensionIdentifier.id}});return c.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),c.sort((l,f)=>l.label.localeCompare(f.label)),c}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const c=await this.cache.getLanguagePacks();Object.keys(c).some(l=>c[l]&&c[l].extensions.some(f=>(0,R.areSameExtensions)(f.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(c);return!(0,t.equals)(Object.keys(g),Object.keys(l))}};h=Ae([_e(0,T.IExtensionManagementService),_e(1,E.INativeEnvironmentService),_e(2,T.IExtensionGalleryService),_e(3,w.ILogService)],h),e.NativeLanguagePackService=h;let I=class extends C.Disposable{constructor(g,c){super();this.logService=c,this.languagePacks={},this.languagePacksFilePath=(0,S.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(c=>{Object.keys(c).forEach(l=>delete c[l]),this.createLanguagePacksFromExtensions(c,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...c){for(const l of c)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,l);Object.keys(g).forEach(l=>this.updateHash(g[l]))}createLanguagePacksFromExtension(g,c){const l=c.identifier,f=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const r of f)if(c.location.scheme===k.Schemas.file&&y(r)){let o=g[r.languageId];o||(o={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},g[r.languageId]=o);const n=o.extensions.filter(i=>(0,R.areSameExtensions)(i.extensionIdentifier,l))[0];n?n.version=c.manifest.version:o.extensions.push({extensionIdentifier:l,version:c.manifest.version});for(const i of r.translations)o.translations[i.id]=(0,S.join)(c.location.fsPath,i.path)}}updateHash(g){if(g){const c=(0,b.createHash)("md5");for(const l of g.extensions)c.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);g.hash=c.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(c=g(l),l)).then(l=>{for(const r of Object.keys(l))l[r]||delete l[r];this.languagePacks=l,this.initializedCache=!0;const f=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",f),p.Promises.writeFile(this.languagePacksFilePath,f)}).then(()=>c,l=>this.logService.error(l))})}};I=Ae([_e(0,E.INativeEnvironmentService),_e(1,w.ILogService)],I);function y(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const g of d.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(ve[54],we([0,1,16,174,52,5,33]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function S(I){return I.res.statusCode&&I.res.statusCode>=200&&I.res.statusCode<300||I.res.statusCode===1223}e.isSuccess=S;function p(I){return I.res.statusCode===204}async function E(I){return p(I)?null:(await(0,b.streamToBuffer)(I.stream)).toString()}e.asText=E;async function T(I){if(!S(I))throw new Error("Server returned "+I.res.statusCode);return E(I)}e.asTextOrError=T;async function R(I){if(!S(I))throw new Error("Server returned "+I.res.statusCode);if(p(I))return null;const d=(await(0,b.streamToBuffer)(I.stream)).toString();try{return JSON.parse(d)}catch(g){throw g.message+=`:
`+d,g}}e.asJson=R;function w(I){h(I)}e.updateProxyConfigurationsScope=w;let v;function h(I){const y=k.Registry.as(D.Extensions.Configuration),d=v;v={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:I,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[v],remove:d?[d]:[]})}h(2)}),define(ve[212],we([0,1,20,8,17,54]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(p,E){this.requestService=p,this.fileService=E}async download(p,E,T=b.CancellationToken.None){if(p.scheme===t.Schemas.file||p.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(p,E);return}const R={type:"GET",url:p.toString(!0)},w=await this.requestService.request(R,T);if(w.res.statusCode===200)await this.fileService.writeFile(E,w.stream);else{const v=await(0,C.asTextOrError)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${v}`)}}};k=Ae([_e(0,C.IRequestService),_e(1,D.IFileService)],k),e.DownloadService=k}),define(ve[213],we([0,1,16,20]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(S){this.service=S}listen(S,p){throw new Error("Invalid listen")}call(S,p,E,T=t.CancellationToken.None){switch(p){case"request":return this.service.request(E[0],T).then(async({res:R,stream:w})=>{const v=await(0,b.streamToBuffer)(w);return[{statusCode:R.statusCode,headers:R.headers},v]});case"resolveProxy":return this.service.resolveProxy(E[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class C{constructor(S){this.channel=S}async request(S,p){const[E,T]=await this.channel.call("request",[S],p);return{res:E,stream:(0,b.bufferToStream)(T)}}async resolveProxy(S){return this.channel.call("resolveProxy",[S])}}e.RequestChannelClient=C}),define(ve[214],we([0,1,76,12]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,S){return k.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:k.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function C(k,S,p={}){const E=(0,b.parse)(k),T=p.proxyUrl||D(E,S);if(!T)return null;const R=(0,b.parse)(T);if(!/^https?:$/.test(R.protocol||""))return null;const w={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,t.isBoolean)(p.strictSSL)?p.strictSSL:!0};return E.protocol==="http:"?new(await new Promise((v,h)=>{oe(["http-proxy-agent"],v,h)}))(w):new(await new Promise((v,h)=>{oe(["https-proxy-agent"],v,h)}))(w)}e.getProxyAgent=C}),define(ve[77],we([0,1,48,6,175,20,38,11,3,23,147,188,14]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let h;async function I(d,g,c){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(c)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(c)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=w.Promises.withAsyncBody(async(l,f)=>{const r=new C.CancellationTokenSource,o=setTimeout(()=>{r.dispose(!0),f(new Error((0,D.localize)(0,null)))},v);try{l(await y(d,r.token))}catch(n){!(0,S.isCancellationError)(n)&&!r.token.isCancellationRequested?f(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(n)))):l({})}finally{clearTimeout(o),r.dispose()}})),h)}e.getResolvedShellEnv=I;async function y(d,g){const c=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",c);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",l);const f=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(f+"(.*)"+f),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",o);const n=await(0,T.getSystemShell)(p.OS,o);return d.trace("getUnixShellEnvironment#shell",n),new Promise((i,s)=>{if(g.isCancellationRequested)return s((0,S.canceled)());const a=(0,t.basename)(n);let u,m;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(u=`& '${process.execPath}' ${P} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,m=["-Login","-Command"]):(u=`'${process.execPath}' ${P} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,a==="tcsh"?m=["-ic"]:m=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),u);const F=(0,b.spawn)(n,[...m,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});g.onCancellationRequested(()=>(F.kill(),s((0,S.canceled)()))),F.on("error",se=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(se)),s(se)});const q=[];F.stdout.on("data",se=>q.push(se));const Y=[];F.stderr.on("data",se=>Y.push(se)),F.on("close",(se,_)=>{const G=Buffer.concat(q).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const te=Buffer.concat(Y).toString("utf8");if(te.trim()&&d.trace("getUnixShellEnvironment#stderr",te),se||_)return s(new Error((0,D.localize)(2,null,se,_)));const j=r.exec(G),he=j?j[1]:"{}";try{const J=JSON.parse(he);c?J.ELECTRON_RUN_AS_NODE=c:delete J.ELECTRON_RUN_AS_NODE,l?J.ELECTRON_NO_ATTACH_CONSOLE=l:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",J),i(J)}catch(J){d.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(J)),s(J)}})})}}),define(ve[111],we([0,1,3,27,4,23]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(E){if(b.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function S(E,T,R,w,v,h,I,y,d,g){const c=Object.create(null);c["common.machineId"]=I,c.sessionID=(0,C.generateUuid)()+Date.now(),c.commitHash=v,c.version=h,c["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,b.PlatformToString)(b.platform),c["common.nodePlatform"]=t.platform,c["common.nodeArch"]=w,c["common.product"]=g||"desktop",y&&(c["common.msftInternal"]=y);let l=0;const f=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),b.isLinuxSnap&&(c["common.snap"]="true");const r=k(R);r&&(c["common.platformDetail"]=r);try{const o=await E.readFile(D.URI.file(d));c["common.source"]=o.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=S;function p(E){const T=t.env.USERDNSDOMAIN;if(!T)return!1;const R=T.toLowerCase();return E.some(w=>R===w)}e.verifyMicrosoftInternalDomain=p}),define(ve[215],we([0,1,18,11,2,22,17]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var S;(function(E){function T(R,w){return R.callstack<w.callstack?-1:R.callstack>w.callstack?1:0}E.compare=T})(S=e.ErrorEvent||(e.ErrorEvent={}));class p{constructor(T,R=p.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new D.DisposableStore,this._telemetryService=T,this._flushDelay=R;const w=t.errorHandler.addListener(v=>this._onErrorEvent(v));this._disposables.add((0,D.toDisposable)(w)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(T){if(!T||(T.detail&&T.detail.stack&&(T=T.detail),t.ErrorNoTelemetry.isErrorNoTelemetry(T)||T instanceof k.FileOperationError))return;const R=Array.isArray(T.stack)?T.stack.join(`
`):T.stack,w=T.message?T.message:(0,C.safeStringify)(T);!R||this._enqueue({msg:w,callstack:R})}_enqueue(T){const R=(0,b.binarySearch)(this._buffer,T,S.compare);R<0?(T.count=1,this._buffer.splice(~R,0,T)):(this._buffer[R].count||(this._buffer[R].count=0),this._buffer[R].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(const T of this._buffer)this._telemetryService.publicLogError2("UnhandledError",T);this._buffer.length=0}}e.default=p,p.ERROR_FLUSH_TIMEOUT=5*1e3}),define(ve[216],we([0,1,2]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends b.Disposable{constructor(C,k){super();this.telemetryService=C,this.telemetryAppender=k}async call(C,k,S){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:p}=S;return this.telemetryService.updateInjectedTelemetryLevel(p)}case"logTelemetry":{const{eventName:p,data:E}=S;return this.telemetryAppender?this.telemetryAppender.log(p,E):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(C,k,S){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(ve[32],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,b.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,b.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ve[217],we([0,1,28,45,14,65,8,6,3,4,90,21,94,195,17,26,32]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const d=new Map;async function g(o,n){const i=`${o}::${n.join(":")}`,s=d.get(i);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,m=new Map,P=2e4;function F(Y,se,_,G){const te=se.substring(Y.length+1);return D.Promises.withAsyncBody(async j=>{let he;try{he=await R.Promises.readdir(se,{withFileTypes:!0})}catch{j();return}if(G.count>=P){G.count+=he.length,G.maxReached=!0,j();return}let J=he.length;if(J===0){j();return}let U=he;G.count+he.length>P&&(G.maxReached=!0,J=P-G.count,U=he.slice(0,J)),G.count+=he.length;for(const M of U)if(M.isDirectory()){if(_.includes(M.name)||await F(Y,(0,S.join)(se,M.name),_,G),--J==0){j();return}}else{const B=M.name.lastIndexOf(".");if(B>=0){const Q=M.name.substring(B+1);Q&&u.set(Q,(u.get(Q)??0)+1)}for(const Q of a)Q.relativePathPattern?.test(te)!==!1&&Q.filePattern.test(M.name)&&m.set(Q.tag,(m.get(Q.tag)??0)+1);if(--J==0){j();return}}})}const q=D.Promises.withAsyncBody(async Y=>{const se={count:0,maxReached:!1};await F(o,o,n,se);const _=await f(o);Y({configFiles:c(m),fileTypes:c(u),fileCount:se.count,maxFilesReached:se.maxReached,launchConfigFiles:_})});return d.set(i,q),q}e.collectWorkspaceStats=g;function c(o){return[...t.Iterable.map(o.entries(),([n,i])=>({name:n,count:i}))].sort((n,i)=>i.count-n.count)}function l(){const o={os:`${b.type()} ${b.arch()} ${b.release()}`,memory:`${(b.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(b.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(T.virtualMachineHint.value()*100)}%`},n=b.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}e.getMachineInfo=l;async function f(o){try{const n=new Map,i=(0,S.join)(o,".vscode","launch.json"),s=await R.Promises.readFile(i),a=[],u=(0,C.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${i}`),[];if((0,C.getNodeType)(u)==="object"&&u.configurations)for(const m of u.configurations){const P=m.type;P&&(n.has(P)?n.set(P,n.get(P)+1):n.set(P,1))}return c(n)}catch{return[]}}e.collectLaunchConfigs=f;let r=class{constructor(n,i){this.telemetryService=n,this.productService=i}formatMachineInfo(n){const i=[];return i.push(`OS Version:       ${n.os}`),i.push(`CPUs:             ${n.cpus}`),i.push(`Memory (System):  ${n.memory}`),i.push(`VM:               ${n.vmHint}`),i.join(`
`)}formatEnvironment(n){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${b.type()} ${b.arch()} ${b.release()}`);const s=b.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(b.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(b.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),p.isWindows||i.push(`Load (avg):       ${b.loadavg().map(a=>Math.round(a)).join(", ")}`),i.push(`VM:               ${Math.round(T.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${n.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(n,i){return Promise.all([(0,w.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async s=>{let[a,u]=s,m=this.formatProcessList(n,a);return i.forEach(P=>{if((0,v.isRemoteDiagnosticError)(P))m+=`
${P.errorMessage}`,u+=`
${P.errorMessage}`;else if(m+=`

Remote: ${P.hostName}`,P.processes&&(m+=`
${this.formatProcessList(n,P.processes)}`),P.workspaceMetadata){u+=`
|  Remote: ${P.hostName}`;for(const F of Object.keys(P.workspaceMetadata)){const q=P.workspaceMetadata[F];let Y=`${q.fileCount} files`;q.maxFilesReached&&(Y=`more than ${Y}`),u+=`|    Folder (${F}): ${Y}`,u+=this.formatWorkspaceStats(q)}}}),{processInfo:m,workspaceInfo:u}})}async getSystemInfo(n,i){const{memory:s,vmHint:a,os:u,cpus:m}=l(),P={os:u,memory:s,cpus:m,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:i};return p.isWindows||(P.load=`${b.loadavg().map(F=>Math.round(F)).join(", ")}`),p.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(n,i){const s=[];return(0,w.listProcesses)(n.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(n)),s.push(""),s.push(this.formatProcessList(n,a)),n.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(n))),i.forEach(u=>{if((0,v.isRemoteDiagnosticError)(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.formatMachineInfo(u.machineInfo)),u.processes&&s.push(this.formatProcessList(n,u.processes)),u.workspaceMetadata)for(const m of Object.keys(u.workspaceMetadata)){const P=u.workspaceMetadata[m];let F=`${P.fileCount} files`;P.maxFilesReached&&(F=`more than ${F}`),s.push(`Folder (${m}): ${F}`),s.push(this.formatWorkspaceStats(P))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(n){const i=[],s=60;let a=0;const u=(q,Y)=>{const se=` ${q}(${Y})`;a+se.length>s?(i.push(m),m="|                 ",a=m.length):a+=se.length,m+=se};let m="|      File types:";const P=10,F=n.fileTypes.length>P?P:n.fileTypes.length;for(let q=0;q<F;q++){const Y=n.fileTypes[q];u(Y.name,Y.count)}if(i.push(m),n.configFiles.length>=0&&(m="|      Conf files:",a=0,n.configFiles.forEach(q=>{u(q.name,q.count)}),i.push(m)),n.launchConfigFiles.length>0){let q="|      Launch Configs:";n.launchConfigFiles.forEach(Y=>{q+=Y.count>1?` ${Y.name}(${Y.count})`:` ${Y.name}`}),i.push(q)}return i.join(`
`)}expandGPUFeatures(n){const i=Math.max(...Object.keys(n).map(s=>s.length));return Object.keys(n).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${n[s]}`).join(`
                  `)}formatWorkspaceMetadata(n){const i=[],s=[];return n.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(i.push(`|  Window (${a.title})`),a.folderURIs.forEach(u=>{const m=E.URI.revive(u);if(m.scheme===k.Schemas.file){const P=m.fsPath;s.push(g(P,["node_modules",".git"]).then(F=>{let q=`${F.fileCount} files`;F.maxFilesReached&&(q=`more than ${q}`),i.push(`|    Folder (${(0,S.basename)(P)}): ${q}`),i.push(this.formatWorkspaceStats(F))}).catch(F=>{i.push(`|      Error: Unable to collect workspace stats for folder ${P} (${F.toString()})`)}))}else i.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>i.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(n,i){const s=new Map;n.windows.forEach(u=>s.set(u.pid,u.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(n.mainPID,s,a,i,0),a.join(`
`)}formatProcessItem(n,i,s,a,u){const m=u===0;let P;m?P=a.pid===n?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(u)} ${a.name}`,a.name==="window"&&(P=`${P} (${i.get(a.pid)})`));const F=process.platform==="win32"?a.mem:b.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(F/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(a.children)&&a.children.forEach(q=>this.formatProcessItem(n,i,s,q,u+1))}async getWorkspaceFileExtensions(n){const i=new Set;for(const{uri:s}of n.folders){const a=E.URI.revive(s);if(a.scheme!==k.Schemas.file)continue;const u=a.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(P=>i.add(P.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(n){for(const{uri:i}of n.folders){const s=E.URI.revive(i);if(s.scheme!==k.Schemas.file)continue;const a=s.fsPath;try{const u=await g(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),u.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:m.name,count:m.count})}),u.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:m.name,count:m.count})}),u.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};r=Ae([_e(0,y.ITelemetryService),_e(1,I.IProductService)],r),e.DiagnosticsService=r}),define(ve[44],we([0,1,22,85,12,25,111,32]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class E{async publicLog(r,o,n){}async publicLogError(r,o,n){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(f,r){return r.onDidChangeConfiguration(o=>{o.source!==7&&f.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(o.source),configurationKeys:d(o.sourceConfig)})})}e.configurationTelemetry=T;function R(f,r){return!(r.disableTelemetry||!f.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=R;function w(f){const r=f.getValue(S.TELEMETRY_SETTING_ID),o=f.getValue("telemetry.enableCrashReporter");if(f.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function v(f){const r={},o={},n={};y(f,n);for(let i in n){i=i.length>150?i.substr(i.length-149):i;const s=n[i];typeof s=="number"?o[i]=s:typeof s=="boolean"?o[i]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${s.length}`),r[i]=s.substring(0,8191)):typeof s!="undefined"&&s!==null&&(r[i]=s)}return{properties:r,measurements:o}}e.validateTelemetryData=v;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function I(f){if(!f)return"none";for(const r of h)if(f.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=I;function y(f,r,o=0,n){if(!!f)for(const i of Object.getOwnPropertyNames(f)){const s=f[i],a=n?n+i:i;Array.isArray(s)?r[a]=(0,b.safeStringify)(s):s instanceof Date?r[a]=s.toISOString():(0,D.isObject)(s)?o<2?y(s,r,o+1,a+"."):r[a]=(0,b.safeStringify)(s):r[a]=s}}function d(f){if(!f)return[];const r=[];return g(r,"",f),r}function g(f,r,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(n=>g(f,r?`${r}.${n}`:n,o[n])):f.push(r)}function c(f,r){const o=f.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(o)||n}e.isInternalTelemetry=c;function l(f){return[f.appRoot,f.extensionsPath,f.userHome.fsPath,f.tmpDir.fsPath,f.userDataPath]}e.getPiiPathsFromEnvironment=l}),define(ve[218],we([0,1,192,44]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(C,k,S,p,E,T,R){const w={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${k.nameShort})`},v=await(0,b.getServiceMachineId)(S,E,T),{sessionId:h}=await R.getTelemetryInfo();return(0,t.supportsTelemetry)(k,S)&&(0,t.getTelemetryLevel)(p)===3&&(w["X-Market-User-Id"]=v,w["VSCode-SessionId"]=h),w}e.resolveMarketplaceHeaders=D}),define(ve[219],we([0,1,11,22,44]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function k(p,E,T){const R=await new Promise((y,d)=>{oe(["@microsoft/1ds-core-js"],y,d)}),w=await new Promise((y,d)=>{oe(["@microsoft/1ds-post-js"],y,d)}),v=new R.AppInsightsCore,h=new w.PostChannel,I={instrumentationKey:p,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(T){I.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:T};I.extensionConfig[h.identifier]=y}return v.initialize(I,[]),v.addTelemetryInitializer(y=>{E&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),v}class S{constructor(E,T,R,w,v){this._isInternalTelemetry=E,this._eventPrefix=T,this._defaultData=R,this._xhrOverride=v,this.endPointUrl=C,this._defaultData||(this._defaultData={}),typeof w=="function"?this._aiCoreOrKey=w():this._aiCoreOrKey=w,this._asyncAiCore=null}_withAIClient(E){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){E(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=k(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(T=>{E(T)},T=>{(0,b.onUnexpectedError)(T),console.error(T)})}}log(E,T){if(!this._aiCoreOrKey)return;T=(0,t.mixin)(T,this._defaultData),T=(0,D.validateTelemetryData)(T);const R=this._eventPrefix+"/"+E;try{this._withAIClient(w=>{w.pluginVersionString=T?.properties.version??"Unknown",w.track({name:R,baseData:{name:R,properties:T?.properties,measurements:T?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(E=>{this._withAIClient(T=>{T.unload(!0,()=>{this._aiCoreOrKey=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=S}),define(ve[220],we([0,1,2,22,85,3,15,176,25,52,51,26,33,32,44]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(g,c,l){this._configurationService=c,this._productService=l,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new b.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(f),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,c){this._experimentProperties[g]=c}_updateTelemetryLevel(){let g=(0,h.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const l=c.usage?3:c.error?2:0;g=Math.min(g,l)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,c=g.sessionID,l=g["common.machineId"],f=g["common.firstSessionDate"],r=g["common.msftInternal"];return{sessionId:c,machineId:l,firstSessionDate:f,msftInternal:r}}dispose(){this._disposables.dispose()}_log(g,c,l,f){return this.telemetryLevel.value<c?Promise.resolve(void 0):this._commonProperties.then(r=>{l=(0,t.mixin)(l,r),l=(0,t.mixin)(l,this._experimentProperties),l=(0,t.cloneAndChange)(l,o=>{if(typeof o=="string")return this._cleanupInfo(o,f)}),this._appenders.forEach(o=>o.log(g,l))},r=>{console.error(r)})}publicLog(g,c,l){return this._log(g,3,c,l)}publicLog2(g,c,l){return this.publicLog(g,c,l)}publicLogError(g,c){return this._sendErrorTelemetry?this._log(g,2,c,!0):Promise.resolve(void 0)}publicLogError2(g,c){return this.publicLogError(g,c)}_anonymizeFilePaths(g){let c=g;const l=[];for(const n of this._cleanupPatterns)for(;;){const i=n.exec(g);if(!i)break;l.push([i.index,n.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(c="";;){const n=r.exec(g);if(!n)break;!f.test(n[0])&&l.every(([i,s])=>n.index<i||n.index>=s)&&(c+=g.substring(o,n.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<g.length&&(c+=g.substr(o)),c}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const c=g.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const f of l)if(f.regex.test(c))return`<REDACTED: ${f.label}>`;return g}_cleanupInfo(g,c){let l=g;c&&(l=this._anonymizeFilePaths(l));for(const f of this._cleanupPatterns)l=l.replace(f,"");return l=this._removePropertiesWithPossibleUserInfo(l),l}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=Ae([_e(1,p.IConfigurationService),_e(2,R.IProductService)],I),e.TelemetryService=I;function y(){const d=(0,S.localize)(0,null,T.default.nameLong),g=T.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",T.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=C.isWeb?"":(0,S.localize)(3,null),l=(0,S.localize)(4,null),f=(0,S.localize)(5,null),r=(0,S.localize)(6,null),o=(0,S.localize)(7,null),n=`
|       | ${l} | ${f} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,S.localize)(8,null);return`
${d} ${g} ${c}

&nbsp;

${o}
${n}

&nbsp;

${i}
`}w.Registry.as(E.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(E.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:T.default.privacyStatementUrl?(0,S.localize)(16,null,T.default.nameLong,T.default.privacyStatementUrl):(0,S.localize)(15,null,T.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[221],we([0,1,25,5,26,32,220,44]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let p=class extends k.TelemetryService{constructor(T,R,w,v){super(T,w,v);this._injectedTelemetryLevel=R}publicLog(T,R,w){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(T,R,w)}publicLog2(T,R,w){return this.publicLog(T,R,w)}publicLogError(T,R){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(T,R)}publicLogError2(T,R){return this.publicLogError(T,R)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,T):T,this._injectedTelemetryLevel===0&&this.dispose()}};p=Ae([_e(2,b.IConfigurationService),_e(3,D.IProductService)],p),e.ServerTelemetryService=p,e.ServerNullTelemetryService=new class extends S.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(C.ITelemetryService)}),define(ve[222],we([0,1,223,219]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends t.AbstractOneDataSystemAppender{constructor(k,S,p,E){const T={sendPOST:(R,w)=>{const v={method:"POST",headers:{...R.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(R.data)}};try{const h=b.request(R.urlString,v,I=>{I.on("data",function(y){w(I.statusCode??200,I.headers,y.toString())}),I.on("error",function(y){w(0,{})})});h.write(R.data),h.end()}catch{w(0,{})}}};super(k,S,p,E,T)}}e.OneDataSystemAppender=D}),define(ve[224],we([0,1,11,215]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class D extends t.default{installErrorListeners(){(0,b.setUnexpectedErrorHandler)(S=>console.error(S));const k=[];process.on("unhandledRejection",(S,p)=>{k.push(p),setTimeout(()=>{const E=k.indexOf(p);E>=0&&p.catch(T=>{k.splice(E,1),(0,b.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),S&&(0,b.onUnexpectedError)(S))})},1e3)}),process.on("rejectionHandled",S=>{const p=k.indexOf(S);p>=0&&k.splice(p,1)}),process.on("uncaughtException",S=>{(0,b.onUnexpectedError)(S)})}}e.default=D}),define(ve[225],we([0,1,14,20,7,2,13]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let S=class extends C.Disposable{constructor(E,T){super();this._logService=T,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((T,R)=>{const w=++this._lastRequestId;this._pendingRequests.set(w,T),this._onCreateRequest.fire({requestId:w,...E});const v=new t.CancellationTokenSource;(0,b.timeout)(this._timeout,v.token).then(()=>R(`Request ${w} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(w,[(0,C.toDisposable)(()=>v.cancel())])})}acceptReply(E,T){const R=this._pendingRequests.get(E);R?(this._pendingRequests.delete(E),(0,C.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),R(T)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};S=Ae([_e(1,k.ILogService)],S),e.RequestStore=S}),define(ve[112],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(c){c.FileName="ptyhost"})(C=e.TerminalLogConstants||(e.TerminalLogConstants={}));var k;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(k=e.PosixShellType||(e.PosixShellType={}));var S;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(S=e.WindowsShellType||(e.WindowsShellType={}));var p;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(p=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,b.createDecorator)("ptyService");var T;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T=e.ProcessPropertyType||(e.ProcessPropertyType={}));var R;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(c){c.TerminalView="view",c.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var I;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(I=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}));var d;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(d=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ve[226],we([0,1,28,8,22,6,3,27,15,12,21]),function(oe,e,b,t,D,C,k,S,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function R(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let f=0;return l&&l.length===4&&(f=parseInt(l[3])),f}e.getWindowsBuildNumber=R;async function w(l,f,r,o=S.env,n=T.Promises.exists){if(C.isAbsolute(l))return await n(l)?l:void 0;if(f===void 0&&(f=S.cwd()),C.dirname(l)!=="."){const u=C.join(f,l);return await n(u)?u:void 0}const s=(0,D.getCaseInsensitive)(o,"PATH");if(r===void 0&&(0,E.isString)(s)&&(r=s.split(C.delimiter)),r===void 0||r.length===0){const u=C.join(f,l);return await n(u)?u:void 0}for(const u of r){let m;if(C.isAbsolute(u)?m=C.join(u,l):m=C.join(f,u,l),await n(m))return m;if(k.isWindows){let P=m+".com";if(await n(P)||(P=m+".exe",await n(P)))return P}}const a=C.join(f,l);return await n(a)?a:void 0}e.findExecutable=w;function v(l,f,r){if(!f.enabled||!l.executable||l.isFeatureTerminal||l.hideFromUser||l.ignoreShellIntegration)return;const o=l.args,n=S.platform==="win32"?C.basename(l.executable).toLowerCase():C.basename(l.executable),i=C.dirname(t.FileAccess.asFileUri("",oe).fsPath);let s;const a={VSCODE_INJECTION:"1"};if(k.isWindows){if(n==="pwsh.exe")return!o||g(o)?s=e.shellIntegrationArgs.get(h.WindowsPwsh):d(o)&&(s=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),s?(s&&(s=[...s],s[s.length-1]=(0,p.format)(s[s.length-1],i,"")),{newArgs:s,envMixin:a}):void 0;r.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(n){case"bash":return!o||o.length===0?s=e.shellIntegrationArgs.get(h.Bash):c(o)&&(a.VSCODE_SHELL_LOGIN="1",s=e.shellIntegrationArgs.get(h.Bash)),s?(s=[...s],s[s.length-1]=(0,p.format)(s[s.length-1],i),{newArgs:s,envMixin:a}):void 0;case"pwsh":return!o||g(o)?s=e.shellIntegrationArgs.get(h.Pwsh):d(o)&&(s=e.shellIntegrationArgs.get(h.PwshLogin)),s?(s=[...s],s[s.length-1]=(0,p.format)(s[s.length-1],i,""),{newArgs:s,envMixin:a}):void 0;case"zsh":{if(!o||o.length===0?s=e.shellIntegrationArgs.get(h.Zsh):c(o)?s=e.shellIntegrationArgs.get(h.ZshLogin):(o===e.shellIntegrationArgs.get(h.Zsh)||o===e.shellIntegrationArgs.get(h.ZshLogin))&&(s=o),!s)return;s=[...s],s[s.length-1]=(0,p.format)(s[s.length-1],i);const u=C.join(b.tmpdir(),"vscode-zsh");a.ZDOTDIR=u;const m=[];return m.push({source:C.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:C.join(u,".zshrc")}),m.push({source:C.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:C.join(u,".zprofile")}),m.push({source:C.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:C.join(u,".zshenv")}),m.push({source:C.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:C.join(u,".zlogin")}),{newArgs:s,envMixin:a,filesToCopy:m}}}r.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}e.getShellIntegrationInjection=v;var h;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const I=["-login","-l"],y=["-nol","-nologo"];function d(l){return typeof l=="string"?I.includes(l.toLowerCase()):l.length===1&&I.includes(l[0].toLowerCase())||l.length===2&&(I.includes(l[0].toLowerCase())||I.includes(l[1].toLowerCase()))&&(y.includes(l[0].toLowerCase())||y.includes(l[1].toLowerCase()))}function g(l){return typeof l=="string"?y.includes(l.toLowerCase()):l.length===0||l?.length===1&&y.includes(l[0].toLowerCase())}function c(l){return l==="string"&&I.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&I.includes(l[0].toLowerCase())}}),define(ve[227],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var b;(function(C){C.DARK="dark",C.LIGHT="light",C.HIGH_CONTRAST_DARK="hcDark",C.HIGH_CONTRAST_LIGHT="hcLight"})(b=e.ColorScheme||(e.ColorScheme={}));function t(C){return C===b.HIGH_CONTRAST_DARK||C===b.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(C){return C===b.DARK||C===b.HIGH_CONTRAST_DARK}e.isDark=D}),define(ve[113],we([0,1,41,7,2,5,33,227]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var p;(function(y){function d(g){return g&&typeof g=="object"&&typeof g.id=="string"}y.isThemeColor=d})(p=e.ThemeColor||(e.ThemeColor={}));function E(y){return{id:y}}e.themeColorFromId=E;var T;(function(y){function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||p.isThemeColor(i.color))}y.isThemeIcon=d;const g=new RegExp(`^\\$\\((${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?)\\)$`);function c(i){const s=g.exec(i);if(!s)return;const[,a]=s;return{id:a}}y.fromString=c;function l(i){return{id:i}}y.fromId=l;function f(i,s){let a=i.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),s&&(a=`${a}~${s}`),{id:a}}y.modify=f;function r(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}y.getModifier=r;function o(i,s){return i.id===s.id&&i.color?.id===s.color?.id}y.isEqual=o;function n(i,s){return{id:i.id,color:s?E(s):void 0}}y.asThemeIcon=n,y.asClassNameArray=b.CSSIcon.asClassNameArray,y.asClassName=b.CSSIcon.asClassName,y.asCSSSelector=b.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=b.Codicon.file,e.FolderThemeIcon=b.Codicon.folder;function R(y){switch(y){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case S.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,D.toDisposable)(()=>{const g=this.themingParticipants.indexOf(d);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new w;k.Registry.add(e.Extensions.ThemingContribution,v);function h(y){return v.onColorThemeChange(y)}e.registerThemingParticipant=h;class I extends D.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,g){let c=this.theme.getColor(d);return c&&g&&(c=g(c,this.theme)),c?c.toString():null}}e.Themable=I}),define(ve[228],we([0,1,41,4,178,113]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(w,v){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...w.map(I=>({name:I.profileName,description:S(I)}))),v&&h.push(...v.map(I=>({name:I.title,description:p(I)}))),{values:h.map(I=>I.name),markdownDescriptions:h.map(I=>I.description)}}e.createProfileSchemaEnums=k;function S(w){let v=`$(${C.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:b.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?v+=`
- args: "${w.args}"`:v+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(v+=`
- overrideName: ${w.overrideName}`),w.color&&(v+=`
- color: ${w.color}`),w.env&&(v+=`
- env: ${JSON.stringify(w.env)}`),v}function p(w){return`$(${C.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:b.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function E(w,v){if(!w&&!v)return!0;if(typeof w=="string"&&typeof v=="string")return w===v;if(Array.isArray(w)&&Array.isArray(v)){if(w.length!==v.length)return!1;for(let h=0;h<w.length;h++)if(w[h]!==v[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function T(w,v){if(!w&&!v)return!0;if(!w||!v)return!1;if(C.ThemeIcon.isThemeIcon(w)&&C.ThemeIcon.isThemeIcon(v))return w.id===v.id&&w.color===v.color;if(typeof w=="object"&&w&&"light"in w&&"dark"in w&&typeof v=="object"&&v&&"light"in v&&"dark"in v){const h=w,I=v;if((t.URI.isUri(h.light)||R(h.light))&&(t.URI.isUri(h.dark)||R(h.dark))&&(t.URI.isUri(I.light)||R(I.light))&&(t.URI.isUri(I.dark)||R(I.dark)))return h.light.path===I.light.path&&h.dark.path===I.dark.path}if(t.URI.isUri(w)&&t.URI.isUri(v)||R(w)||R(v)){const h=w,I=v;return h.path===I.path&&h.scheme===I.scheme}return!1}e.terminalIconsEqual=T;function R(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=R}),define(ve[229],we([0,1,41,177,52,33,228]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(b.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(b.Codicon.getAll(),l=>`$(${l.id})`)};const S={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...S}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...S}},T=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),I=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...S}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...S}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...S}},{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...S}},{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){C.Registry.as(D.Extensions.Configuration).registerConfiguration(y),c()}e.registerTerminalPlatformConfiguration=d;let g;function c(l,f){const r=C.Registry.as(D.Extensions.Configuration);let o;l&&(o=(0,k.createProfileSchemaEnums)(l?.profiles,f));const n=g;g={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?o?.values:void 0,markdownEnumDescriptions:l?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?o?.values:void 0,markdownEnumDescriptions:l?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?o?.values:void 0,markdownEnumDescriptions:l?.os===1?o?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[g],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(ve[230],we([0,1,48,41,6,3,21,92,226,113]),function(oe,e,b,t,D,C,k,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,R=!0;function w(o,n,i,s,a=process.env,u,m,P,F){return u=u||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},C.isWindows?v(i,u,a,m,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),F,P):l(u,m,i,o&&typeof o=="object"?{...o}:s.getValue(C.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(C.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,P,a)}e.detectAvailableProfiles=w;async function v(o,n,i,s,a,u,m,P,F){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let se=!1;(0,p.getWindowsBuildNumber)()>=16299&&(se=!0),await y(P);const _=new Map;o&&(_.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${Y}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Command Prompt",{path:`${Y}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),f(u,_);const G=await h(_.entries(),m,n,i,s,F);if(o||!o&&a)try{const te=await g(`${Y}\\${se?"wsl":"bash"}.exe`,m);for(const j of te)(!u||!(j.profileName in u))&&G.push(j)}catch{R&&(s?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return G}async function h(o,n,i,s=process.env,a,u){const m=[];for(const[P,F]of o){if(F===null)continue;let q,Y,se;if("source"in F){const te=T?.get(F.source);if(!te)continue;q=te.paths,Y=F.args||te.args,F.icon?se=I(F.icon):te.icon&&(se=te.icon)}else q=Array.isArray(F.path)?F.path:[F.path],Y=C.isWindows||Array.isArray(F.args)?F.args:void 0,se=I(F.icon);const _=await u?.(q)||q.slice(),G=await r(P,n,_,i,s,Y,F.env,F.overrideName,F.isAutoDetected,a);G?(G.isAutoDetected=F.isAutoDetected,G.icon=se,G.color=F.color,m.push(G)):a?.debug("Terminal profile not validated",P,q)}return a?.debug("Validated terminal profiles",m),m}function I(o){return typeof o=="string"?{id:o}:o}async function y(o){T&&!o||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),T.set("PowerShell",{profileName:"PowerShell",paths:o||await d(),icon:E.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function d(){const o=[];for await(const n of(0,S.enumeratePowerShellInstallations)())o.push(n.exePath);return o}async function g(o,n){const i=[],s=await new Promise((m,P)=>{b.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,q)=>{if(F)return P("Problem occurred when getting wsl distros");m(q)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),u=s.split(a).filter(m=>m.trim().length>0&&m!=="");for(const m of u){if(m===""||m.startsWith("docker-desktop"))continue;const P=`${m} (WSL)`,F={profileName:P,path:o,args:["-d",`${m}`],isDefault:P===n,icon:c(m),isAutoDetected:!1};i.push(F)}return i}function c(o){return o.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):o.includes("Debian")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function l(o,n,i,s,a,u,m,P){const F=new Map;if(i){const q=(await o.readFile("/etc/shells")).toString(),Y=u||q.split(`
`).filter(_=>_.trim().indexOf("#")!==0&&_.trim().length>0),se=new Map;for(const _ of Y){let G=(0,D.basename)(_),te=se.get(G)||0;te++,te>1&&(G=`${G} (${te})`),se.set(G,te),F.set(G,{path:_,isAutoDetected:!0})}}return f(s,F),await h(F.entries(),a,o,P,n,m)}function f(o,n){if(!!o)for(const[i,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?n.delete(i):(s.icon=s.icon||n.get(i)?.icon,n.set(i,s))}async function r(o,n,i,s,a,u,m,P,F,q){if(i.length===0)return Promise.resolve(void 0);const Y=i.shift();if(Y==="")return r(o,n,i,s,a,u,m,P,F);const se={profileName:o,path:Y,args:u,env:m,overrideName:P,isAutoDetected:F,isDefault:o===n};if((0,D.basename)(Y)===Y){const G=a.PATH?a.PATH.split(D.delimiter):void 0,te=await(0,p.findExecutable)(Y,void 0,G,void 0,s.existsFile);return te?(se.path=te,se.isFromPath=!0,se):r(o,n,i,s,a,u)}return await s.existsFile((0,D.normalize)(Y))?se:r(o,n,i,s,a,u,m,P,F)}}),define(ve[231],we([0,1,7,2,8,3,43,96,25,29,98,77,13,103,225,112,229,230]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let c=0,l=class extends t.Disposable{constructor(r,o,n,i){super();this._reconnectConstants=r,this._configurationService=o,this._environmentService=n,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new b.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new b.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new b.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new b.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new b.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new b.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new b.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new b.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new b.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new b.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new b.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new b.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(C.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,T.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?r.debugBrk=o.port:!o.break&&o.port&&(r.debug=o.port));const n=new S.Client(D.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,r);this._onPtyHostStart.fire(),k.ProxyChannel.toService(n.getChannel(I.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(u=>{this._onPtyHostExit.fire(u.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const s=n.getChannel(I.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const a=k.ProxyChannel.toService(n.getChannel(I.TerminalIpcChannels.PtyHost));return this._register(a.onProcessData(u=>this._onProcessData.fire(u))),this._register(a.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(a.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(a.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(a.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(a.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(a.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),[n,a]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,o,n,i,s,a,u,m,P,F,q){const Y=setTimeout(()=>this._handleUnresponsiveCreateProcess(),I.HeartbeatConstants.CreateProcessTimeout),se=await this._proxy.createProcess(r,o,n,i,s,a,u,m,P,F,q);return clearTimeout(Y),c=Math.max(c,se),se}updateTitle(r,o,n){return this._proxy.updateTitle(r,o,n)}updateIcon(r,o,n){return this._proxy.updateIcon(r,o,n)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r,o){return this._proxy.detachFromProcess(r,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,o){return this._proxy.shutdown(r,o)}input(r,o){return this._proxy.input(r,o)}processBinary(r,o){return this._proxy.processBinary(r,o)}resize(r,o,n){return this._proxy.resize(r,o,n)}acknowledgeDataEvent(r,o){return this._proxy.acknowledgeDataEvent(r,o)}setUnicodeVersion(r,o){return this._proxy.setUnicodeVersion(r,o)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,o){return this._proxy.installAutoReply(r,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,o,n,i=!1){const s=await this._shellEnv;return(0,d.detectAvailableProfiles)(o,n,i,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}getRevivedPtyNewId(r){return this._proxy.getRevivedPtyNewId(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,o){return this._proxy.requestDetachInstance(r,o)}async acceptDetachInstanceReply(r,o){return this._proxy.acceptDetachInstanceReply(r,o)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,o){return this._proxy.reviveTerminalProcesses(r,o)}async refreshProperty(r,o){return this._proxy.refreshProperty(r,o)}async updateProperty(r,o,n){return this._proxy.updateProperty(r,o,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.FirstWaitMultiplier+I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${I.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:o})}async acceptPtyHostResolvedVariables(r,o){this._resolveVariablesRequestStore.acceptReply(r,o)}};l=Ae([_e(1,p.IConfigurationService),_e(2,E.IEnvironmentService),_e(3,w.ILogService)],l),e.PtyHostService=l}),define(ve[39],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,b.createDecorator)("IUriIdentityService")}),define(ve[232],we([0,1,7,2,4,29,34,17,13,39]),function(oe,e,b,t,D,C,k,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let T=class extends t.Disposable{constructor(w,v,h,I,y){super();this.extensionsManagementService=w,this.logService=I,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(c=>c.identifier),this.startTimestamp=Date.now()}),this._register(w.onInstallExtension(g=>this.onInstallExtension(g))),this._register(w.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(w.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const d=D.URI.file(h.extensionsPath);this._register(v.watch(d)),this._register(b.Event.filter(v.onDidFilesChange,g=>g.rawChanges.some(c=>this.doesChangeAffects(c,d)))(()=>this.onDidChange()))}doesChangeAffects(w,v){return w.type!==1&&w.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(w.resource),v)?!1:this.uriIdentityService.extUri.isEqual(w.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(w.resource).startsWith(".")}onInstallExtension(w){this.addInstallingExtension(w.identifier)}onDidInstallExtensions(w){for(const v of w)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(w){w.error||this.removeInstalledExtension(w.identifier)}addInstallingExtension(w){this.removeInstallingExtension(w),this.installingExtensions.push(w)}removeInstallingExtension(w){this.installingExtensions=this.installingExtensions.filter(v=>!(0,k.areSameExtensions)(v,w))}addInstalledExtension(w){this.installedExtensions&&(this.removeInstalledExtension(w),this.installedExtensions.push(w))}removeInstalledExtension(w){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,k.areSameExtensions)(v,w)))}async onDidChange(){if(this.installedExtensions){const w=await this.extensionsManagementService.getInstalled(),v=w.filter(I=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,k.areSameExtensions)(y,I.identifier))?!1:I.installedTimestamp&&I.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",I.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",I.identifier.id),!1)),h=this.installedExtensions.filter(I=>this.installingExtensions.some(y=>(0,k.areSameExtensions)(y,I))?!1:w.every(y=>!(0,k.areSameExtensions)(y.identifier,I))?(this.logService.info("Detected extension removed from another source",I.id),!0):!1);this.installedExtensions=w.map(I=>I.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};T=Ae([_e(1,S.IFileService),_e(2,C.INativeEnvironmentService),_e(3,p.ILogService),_e(4,E.IUriIdentityService)],T),e.ExtensionsWatcher=T}),define(ve[114],we([0,1,39,193,17,19,136,7,2]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(w){this.uri=w,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let T=class{constructor(w){this._fileService=w,this._dispooables=new p.DisposableStore,this._limit=2**16;const v=new Map,h=I=>{let y=v.get(I.scheme);return y===void 0&&(y=w.hasProvider(I)&&!this._fileService.hasCapability(I,1024),v.set(I.scheme,y)),y};this._dispooables.add(S.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(I=>{v.delete(I.scheme)})),this.extUri=new C.ExtUri(h),this._canonicalUris=new k.SkipList((I,y)=>this.extUri.compare(I,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(w){this._fileService.hasProvider(w)&&(w=(0,C.normalizePath)(w));const v=this._canonicalUris.get(w);return v?v.touch().uri.with({fragment:w.fragment}):(this._canonicalUris.set(w,new E(w)),this._checkTrim(),w)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const w=[...this._canonicalUris.entries()].sort((h,I)=>h[1].touch<I[1].touch?1:h[1].touch>I[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(w[h][0],w[h][1].touch())}};T=Ae([_e(0,D.IFileService)],T),e.UriIdentityService=T,(0,t.registerSingleton)(b.IUriIdentityService,T,!0)}),define(ve[78],we([0,1,180,6,24,19,4,5,8]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function E(n){const i=n;return typeof i?.id=="string"&&k.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=E;function T(n){if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=T;function R(n){const i=n;return typeof i?.id=="string"&&k.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=R;function w(n){const i=n;if(i?.uri)return{id:i.id,uri:k.URI.revive(i.uri)};const s=n;if(s?.configPath)return{id:s.id,configPath:k.URI.revive(s.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=w;var v;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=h;function I(n){const i=n;return!!(i&&typeof i=="object"&&k.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=I;class y{constructor(i,s,a,u,m){this._id=i,this._transient=a,this._configuration=u,this._ignorePathCasing=m,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class d{constructor(i,s){this.raw=s,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,C.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function g(n){return new d({uri:n,index:0,name:(0,C.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const c=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(n,i){return C.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function f(n){let i;return k.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=f;function r(n,i){return!l(n,i)&&!f(n)}e.isSavedWorkspace=r;function o(n){return(typeof n=="string"?(0,t.extname)(n):(0,C.extname)(n))===c}e.hasWorkspaceFileExtension=o}),define(ve[37],we([0,1,86,7,2,19,12,4,179,29,17,5,13,78,24,39,14,23,15]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function c(o){const n=o;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&S.URI.isUri(n.location)&&S.URI.isUri(n.globalStorageHome)&&S.URI.isUri(n.settingsResource)&&S.URI.isUri(n.keybindingsResource)&&S.URI.isUri(n.tasksResource)&&S.URI.isUri(n.snippetsHome)&&((0,k.isUndefined)(n.extensionsResource)||S.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=c,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function l(o,n){return{id:o.id,isDefault:o.isDefault,name:o.name,location:S.URI.revive(o.location).with({scheme:n}),globalStorageHome:S.URI.revive(o.globalStorageHome).with({scheme:n}),settingsResource:S.URI.revive(o.settingsResource).with({scheme:n}),keybindingsResource:S.URI.revive(o.keybindingsResource).with({scheme:n}),tasksResource:S.URI.revive(o.tasksResource).with({scheme:n}),snippetsHome:S.URI.revive(o.snippetsHome).with({scheme:n}),extensionsResource:S.URI.revive(o.extensionsResource)?.with({scheme:n}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.reviveProfile=l,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function f(o,n,i,s){return{id:(0,b.hash)(n.path).toString(16),name:o,location:n,isDefault:!1,globalStorageHome:(0,C.joinPath)(n,"globalStorage"),settingsResource:(0,C.joinPath)(n,"settings.json"),keybindingsResource:(0,C.joinPath)(n,"keybindings.json"),tasksResource:(0,C.joinPath)(n,"tasks.json"),snippetsHome:(0,C.joinPath)(n,"snippets"),extensionsResource:(0,C.joinPath)(n,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:i,isTransient:s}}e.toUserDataProfile=f;let r=class extends D.Disposable{constructor(n,i,s,a){super();this.environmentService=n,this.fileService=i,this.uriIdentityService=s,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,C.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(u=>f(u.name,u.location,u.useDefaultFlags)):[];let i;const s=new h.ResourceMap,a=f((0,p.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),n.length){const u=this.getStoredProfileAssociations();if(u.workspaces)for(const[m,P]of Object.entries(u.workspaces)){const F=S.URI.parse(m),q=S.URI.parse(P),Y=n.find(se=>this.uriIdentityService.extUri.isEqual(se.location,q));Y&&s.set(F,Y)}if(u.emptyWindow){const m=S.URI.parse(u.emptyWindow);i=n.find(P=>this.uriIdentityService.extUri.isEqual(P.location,m))}}this._profilesObject={profiles:n,workspaces:s,emptyWindow:i}}return this._profilesObject}async createTransientProfile(n){const i="Temp",s=new RegExp(`${(0,g.escapeRegExpCharacters)(i)}\\s(\\d+)`);let a=0;for(const m of this.profiles){const P=s.exec(m.name),F=P?parseInt(P[1]):0;a=F>a?F:a}const u=`${i} ${a+1}`;return this.createProfile(u,void 0,n,!0)}async createProfile(n,i,s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.doCreateProfile(n,i,a);return s&&await this.setProfileForWorkspace(s,u),u}async doCreateProfile(n,i,s){let a=this.profileCreationPromises.get(n);return a||(a=(async()=>{try{const u=this.profiles.find(F=>F.name===n);if(u)return u;const m=f(n,(0,C.joinPath)(this.profilesHome,(0,b.hash)((0,d.generateUuid)()).toString(16)),i,s);await this.fileService.createFolder(m.location);const P=[];return this._onWillCreateProfile.fire({profile:m,join(F){P.push(F)}}),await y.Promises.settled(P),this.updateProfiles([m],[],[]),m}finally{this.profileCreationPromises.delete(n)}})(),this.profileCreationPromises.set(n,a)),a}async updateProfile(n,i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(u=>u.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=f(i,a.location,s),this.updateProfiles([],[],[a]),a}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(a=>a.id===n.id);if(!i)throw new Error(`Profile '${n.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:i,join(a){s.push(a)}}),await y.Promises.settled(s),i.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])i.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[i],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(i.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(n,i=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(n);return s||(s=i,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,s)),s}async setProfileForWorkspace(n,i){this.setProfileForWorkspaceSync(n,i)}setProfileForWorkspaceSync(n,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(a=>a.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);this.updateWorkspaceAssociation(n,s)}unsetWorkspace(n,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,i)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(i=>i.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,i.resource))).map(i=>this.fileService.del(i.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(i=>!this.isProfileAssociatedToWorkspace(i));await Promise.allSettled(n.map(i=>this.removeProfile(i)))}getProfileForWorkspace(n){const i=this.getWorkspace(n);return S.URI.isUri(i)?this.transientProfilesObject.workspaces.get(i)??this.profilesObject.workspaces.get(i):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(i=>this.uriIdentityService.extUri.isEqual(i.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(i=>this.uriIdentityService.extUri.isEqual(i.location,n.location)))}updateProfiles(n,i,s){const a=[...this.profiles,...n],u=[];this.transientProfilesObject.profiles=[];for(let m of a)m.isDefault||i.some(P=>m.id===P.id)||(m=s.find(P=>m.id===P.id)??m,m.isTransient?this.transientProfilesObject.profiles.push(m):u.push({location:m.location,name:m.name,useDefaultFlags:m.useDefaultFlags}));this.saveStoredProfiles(u),this._profilesObject=void 0,this.triggerProfilesChanges(n,i,s)}triggerProfilesChanges(n,i,s){this._onDidChangeProfiles.fire({added:n,removed:i,updated:s,all:this.profiles})}updateWorkspaceAssociation(n,i,s){s=i?.isTransient?!0:s,s||this.updateWorkspaceAssociation(n,void 0,!0);const a=this.getWorkspace(n),u=s?this.transientProfilesObject:this.profilesObject;S.URI.isUri(a)?(u.workspaces.delete(a),i&&u.workspaces.set(a,i)):u.emptyWindow=i,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[s,a]of this.profilesObject.workspaces.entries())n[s.toString()]=a.location.toString();const i=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:i}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};r.PROFILES_KEY="userDataProfiles",r.PROFILE_ASSOCIATIONS_KEY="profileAssociations",r=Ae([_e(0,E.IEnvironmentService),_e(1,T.IFileService),_e(2,I.IUriIdentityService),_e(3,w.ILogService)],r),e.UserDataProfilesService=r}),define(ve[233],we([0,1,18,14,20,11,7,2,3,4,160,31,34,36,13,26,32,37]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends S.Disposable{constructor(n,i,s,a,u){super();this.galleryService=n,this.telemetryService=i,this.logService=s,this.productService=a,this.userDataProfilesService=u,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,S.toDisposable)(()=>{this.installingExtensions.forEach(m=>m.cancel()),this.uninstallingExtensions.forEach(m=>m.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const i=await this.getTargetPlatform();return n.allTargetPlatforms.some(s=>(0,R.isTargetPlatformCompatible)(s,n.allTargetPlatforms,i))}async installFromGallery(n,i={}){try{if(!this.galleryService.isEnabled())throw new R.ExtensionManagementError(T.localize(0,null),R.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(n,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,i)}catch(s){throw f(this.telemetryService,"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(n),error:s}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(s),l(s)}}async uninstall(n,i={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,i)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const i=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:i,compatible:!0},D.CancellationToken.None);if(!s)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,i,s){const a=q=>`${w.ExtensionKey.create(q).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!E.URI.isUri(i)){const q=this.installingExtensions.get(a(i));if(q){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:Y}=await q.waitUntilTaskIsFinished();return Y}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const u=[],m=[],P=this.createInstallExtensionTask(n,i,s);E.URI.isUri(i)||this.installingExtensions.set(a(i),P),this._onInstallExtension.fire({identifier:P.identifier,source:i,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",P.identifier.id),u.push({task:P,manifest:n});let F=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",P.identifier.id);else try{const Y=await this.getAllDepsAndPackExtensionsToInstall(P.identifier,n,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation);for(const{gallery:se,manifest:_}of Y){F=F||!!_.extensionDependencies?.some(te=>(0,w.areSameExtensions)({id:te},P.identifier));const G=a(se);if(this.installingExtensions.has(G))this.logService.info("Extension is already requested to install",se.identifier.id);else{const te=this.createInstallExtensionTask(_,se,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(G,te),this._onInstallExtension.fire({identifier:te.identifier,source:se,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",te.identifier.id),u.push({task:te,manifest:_})}}}catch(Y){if(E.URI.isUri(P.source))(0,b.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",P.identifier.id,Y.message),(0,b.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",P.identifier.id,Y.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",P.identifier.id),Y}const q=u.reduce((Y,{task:se,manifest:_})=>(Y.set(se.identifier.id.toLowerCase(),{task:se,manifest:_}),Y),new Map);for(;q.size;){let Y;const se=[...q.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(G=>q.has(G.toLowerCase())));se.length?Y=q.size===1?se:se.filter(({task:_})=>!(_===P&&!F)):(this.logService.info("Found extensions with circular dependencies",se.map(({task:_})=>_.identifier.id)),Y=[...q.values()]),await this.joinAllSettled(Y.map(async({task:_})=>{const G=new Date().getTime();try{const{local:te}=await _.run();if(await this.joinAllSettled(this.participants.map(j=>j.postInstall(te,_.source,s,D.CancellationToken.None))),!E.URI.isUri(_.source)){const j=_.operation===3,he=j?void 0:(new Date().getTime()-_.source.lastUpdated)/1e3;if(f(this.telemetryService,j?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(_.source),duration:new Date().getTime()-G,durationSinceUpdate:he}),p.isWeb&&_.operation!==3)try{await this.galleryService.reportStatistic(te.manifest.publisher,te.manifest.name,te.manifest.version,"install")}catch{}}m.push({local:te,identifier:_.identifier,operation:_.operation,source:_.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:te.isApplicationScoped})}catch(te){throw E.URI.isUri(_.source)||f(this.telemetryService,_.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(_.source),duration:new Date().getTime()-G,error:te}),this.logService.error("Error while installing the extension:",_.identifier.id),te}finally{q.delete(_.identifier.id.toLowerCase())}}))}return m.forEach(({identifier:Y})=>this.logService.info("Extension installed successfully:",Y.id)),this._onDidInstallExtensions.fire(m),m.filter(({identifier:Y})=>(0,w.areSameExtensions)(Y,P.identifier))[0].local}catch(q){if(u.forEach(({task:Y})=>Y.cancel()),m.length)try{const Y=await Promise.allSettled(m.map(({local:se})=>this.createUninstallExtensionTask(se,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let se=0;se<Y.length;se++){const _=Y[se],{identifier:G}=m[se];_.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",G.id):this.logService.warn("Rollback: Error while uninstalling extension",G.id,(0,C.getErrorMessage)(_.reason))}}catch(Y){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(Y),m.map(({identifier:se})=>se.id))}throw this._onDidInstallExtensions.fire(u.map(({task:Y})=>({identifier:Y.identifier,operation:2,source:Y.source,context:s.context,profileLocation:s.profileLocation}))),q}finally{for(const{task:q}of u)if(!E.URI.isUri(q.source)){const Y=a(q.source);this.installingExtensions.delete(Y)||this.logService.warn("Installation task is not found in the cache",Y)}}}async joinAllSettled(n){const i=[],s=[],a=await Promise.allSettled(n);for(const u of a)u.status==="fulfilled"?i.push(u.value):s.push(u.reason);if(s.length)throw c(s);return i}async getAllDepsAndPackExtensionsToInstall(n,i,s,a,u){if(!this.galleryService.isEnabled())return[];let m=await this.getInstalled(void 0,u);const P=[n,...m.map(Y=>Y.identifier)],F=[],q=async(Y,se)=>{const _=se.extensionDependencies||[],G=[..._];if(se.extensionPack){const te=s?m.find(j=>(0,w.areSameExtensions)(j.identifier,Y)):void 0;for(const j of se.extensionPack)te&&te.manifest.extensionPack&&te.manifest.extensionPack.some(he=>(0,w.areSameExtensions)({id:he},{id:j}))||G.every(he=>!(0,w.areSameExtensions)({id:he},{id:j}))&&G.push(j)}if(G.length){const te=[...P,...F.map(he=>he.gallery.identifier)],j=G.filter(he=>te.every(J=>!(0,w.areSameExtensions)(J,{id:he})));if(j.length){const he=await this.galleryService.getExtensions(j.map(J=>({id:J,preRelease:a})),D.CancellationToken.None);for(const J of he){if(te.find(B=>(0,w.areSameExtensions)(B,J.identifier)))continue;const U=_.some(B=>(0,w.areSameExtensions)({id:B},J.identifier));let M;try{M=await this.checkAndGetCompatibleVersion(J,!1,a)}catch(B){if(B instanceof R.ExtensionManagementError&&B.code===R.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",J.identifier.id);continue}else throw B}F.push({gallery:M.extension,manifest:M.manifest}),await q(M.extension.identifier,M.manifest)}}}};return await q(n,i),m=await this.getInstalled(void 0,u),F.filter(Y=>!m.some(se=>(0,w.areSameExtensions)(se.identifier,Y.gallery.identifier)))}async checkAndGetCompatibleVersion(n,i,s){if((await this.getExtensionsControlManifest()).malicious.some(P=>(0,w.areSameExtensions)(n.identifier,P)))throw new R.ExtensionManagementError(T.localize(3,null,n.identifier.id),R.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const P=await this.getTargetPlatform();throw new R.ExtensionManagementError(T.localize(4,null,n.identifier.id,this.productService.nameLong,(0,R.TargetPlatformToString)(P)),R.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.getCompatibleVersion(n,i,s);if(u){if(s&&!i&&n.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new R.ExtensionManagementError(T.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],D.CancellationToken.None))[0]?new R.ExtensionManagementError(T.localize(6,null,n.identifier.id),R.ExtensionManagementErrorCode.ReleaseVersionNotFound):new R.ExtensionManagementError(T.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",u.identifier.id);const m=await this.galleryService.getManifest(u,D.CancellationToken.None);if(m===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,R.ExtensionManagementErrorCode.Invalid);if(m.version!==u.version)throw new R.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,R.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:m}}async getCompatibleVersion(n,i,s){const a=await this.getTargetPlatform();let u=null;return!i&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==s&&(u=(await this.galleryService.getExtensions([{...n.identifier,preRelease:s}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null),!u&&await this.galleryService.isExtensionCompatible(n,s,a)&&(u=n),u||(i?u=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null:u=await this.galleryService.getCompatibleExtension(n,s,a)),u}async uninstallExtension(n,i){const s=q=>`${q.id.toLowerCase()}${i.versionOnly?`-${n.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,a=this.uninstallingExtensions.get(s(n.identifier));if(a)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),a.waitUntilTaskIsFinished();const u=(q,Y)=>{const se=this.createUninstallExtensionTask(q,Y);return this.uninstallingExtensions.set(s(se.extension.identifier),se),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${q.identifier.id}@${q.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${q.identifier.id}@${q.manifest.version}`),this._onUninstallExtension.fire({identifier:q.identifier,profileLocation:i.profileLocation,applicationScoped:q.isApplicationScoped}),se},m=(q,Y)=>{Y?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${q.identifier.id}@${q.manifest.version}`,i.profileLocation.toString(),Y.message):this.logService.error("Failed to uninstall extension:",`${q.identifier.id}@${q.manifest.version}`,Y.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${q.identifier.id}@${q.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${q.identifier.id}@${q.manifest.version}`),f(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,w.getLocalExtensionTelemetryData)(q),error:Y}),this._onDidUninstallExtension.fire({identifier:q.identifier,version:q.manifest.version,error:Y?.code,profileLocation:i.profileLocation,applicationScoped:q.isApplicationScoped})},P=[],F=[];try{P.push(u(n,i));const q=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const Y=this.getAllPackExtensionsToUninstall(n,q);for(const se of Y)this.uninstallingExtensions.has(s(se.identifier))?this.logService.info("Extensions is already requested to uninstall",se.identifier.id):P.push(u(se,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(P.map(Y=>Y.extension),q,n),await this.joinAllSettled(P.map(async Y=>{try{if(await Y.run(),await this.joinAllSettled(this.participants.map(se=>se.postUninstall(Y.extension,i,D.CancellationToken.None))),Y.extension.identifier.uuid)try{await this.galleryService.reportStatistic(Y.extension.manifest.publisher,Y.extension.manifest.name,Y.extension.manifest.version,"uninstall")}catch{}m(Y.extension)}catch(se){const _=se instanceof R.ExtensionManagementError?se:new R.ExtensionManagementError((0,C.getErrorMessage)(se),R.ExtensionManagementErrorCode.Internal);throw m(Y.extension,_),_}finally{F.push(Y)}}))}catch(q){const Y=q instanceof R.ExtensionManagementError?q:new R.ExtensionManagementError((0,C.getErrorMessage)(q),R.ExtensionManagementErrorCode.Internal);for(const se of P){try{se.cancel()}catch{}F.includes(se)||m(se.extension,Y)}throw Y}finally{for(const q of P)this.uninstallingExtensions.delete(s(q.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",q.extension.identifier.id)}}checkForDependents(n,i,s){for(const a of n){const u=this.getDependents(a,i);if(u.length){const m=u.filter(P=>!n.some(F=>(0,w.areSameExtensions)(F.identifier,P.identifier)));if(m.length)throw new Error(this.getDependentsErrorMessage(a,m,s))}}}getDependentsErrorMessage(n,i,s){return s===n?i.length===1?T.localize(8,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?T.localize(9,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):T.localize(10,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?T.localize(11,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?T.localize(12,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):T.localize(13,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(n,i,s=[]){if(s.indexOf(n)!==-1)return[];s.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const u=i.filter(P=>!P.isBuiltin&&a.some(F=>(0,w.areSameExtensions)({id:F},P.identifier))),m=[];for(const P of u)m.push(...this.getAllPackExtensionsToUninstall(P,i,s));return[...u,...m]}return[]}getDependents(n,i){return i.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(a=>(0,w.areSameExtensions)({id:a},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(n,i,s){return s.profileLocation&&(0,v.isApplicationScopedExtension)(n)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(n,i,s)}createUninstallExtensionTask(n,i){return i.profileLocation&&n.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(n,i)}};g=Ae([_e(0,R.IExtensionGalleryService),_e(1,y.ITelemetryService),_e(2,h.ILogService),_e(3,I.IProductService),_e(4,d.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function c(o){const n=Array.isArray(o)?o:[o];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((i,s)=>new Error(`${i.message}${i.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=c;function l(o){if(o instanceof R.ExtensionManagementError)return o;const n=new R.ExtensionManagementError(o.message,R.ExtensionManagementErrorCode.Internal);return n.stack=o.stack,n}function f(o,n,{extensionData:i,duration:s,error:a,durationSinceUpdate:u}){const m=a?a instanceof R.ExtensionManagementError?a.code:R.ExtensionManagementErrorCode.Internal:void 0;o.publicLog(n,{...i,success:!a,duration:s,errorcode:m,durationSinceUpdate:u})}e.reportTelemetry=f;class r{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((i,s)=>{const a=n.onCancellationRequested(()=>{a.dispose(),s(new C.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r}),define(ve[55],we([0,1,18,14,22,16,11,65,155,2,8,6,3,19,50,67,12,4,164,29,34,36,70,17,5,13,26,7,42,53,37,39,191]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c,l,f,r,o,n,i,s,a,u,m,P,F,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Y;(function(J){function U(M,B){if(M===B)return!0;const Q=Object.keys(M),ae=new Set;for(const fe of Object.keys(B))ae.add(fe);if(Q.length!==ae.size)return!1;for(const fe of Q){if(M[fe]!==B[fe])return!1;ae.delete(fe)}return ae.size===0}J.equals=U})(Y=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let se=class extends E.Disposable{constructor(U,M,B,Q,ae,fe,X,re,L,O,x){super();this.systemExtensionsLocation=U,this.userExtensionsLocation=M,this.extensionsControlLocation=B,this.cacheLocation=Q,this.userDataProfilesService=ae,this.extensionsProfileScannerService=fe,this.fileService=X,this.logService=re,this.environmentService=L,this.productService=O,this.instantiationService=x,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(te,(0,v.joinPath)(this.cacheLocation,f.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(te,(0,v.joinPath)(this.cacheLocation,f.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(G,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(U,M,B){const[Q,ae]=await Promise.all([this.scanSystemExtensions(U),this.scanUserExtensions(M)]),fe=B?await this.scanExtensionsUnderDevelopment(U,[...Q,...ae]):[];return this.dedupExtensions(Q,ae,fe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(U){const M=[];M.push(this.scanDefaultSystemExtensions(!!U.useCache,U.language)),M.push(this.scanDevSystemExtensions(U.language,!!U.checkControlFile));const[B,Q]=await Promise.all(M);return this.applyScanOptions([...B,...Q],0,U,!1)}async scanUserExtensions(U){this.logService.trace("Started scanning user extensions");const M=await this.createExtensionScannerInput(U.profileLocation??this.userExtensionsLocation,!!U.profileLocation,1,!U.includeUninstalled,U.language);let Q=await(U.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(M);return Q=await this.applyScanOptions(Q,1,U,!0),this.logService.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(U,M){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const B=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(Q=>Q.scheme===T.Schemas.file).map(async Q=>{const ae=await this.createExtensionScannerInput(Q,!1,1,!0,U.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ae)).map(X=>(X.type=M.find(re=>(0,l.areSameExtensions)(re.identifier,X.identifier))?.type??X.type,this.extensionsScanner.validate(X,ae)))}))).flat();return this.applyScanOptions(B,"development",U,!0)}return[]}async scanExistingExtension(U,M,B){const Q=await this.createExtensionScannerInput(U,!1,M,!0,B.language),ae=await this.extensionsScanner.scanExtension(Q);return!ae||!B.includeInvalid&&!ae.isValid?null:ae}async scanOneOrMultipleExtensions(U,M,B){const Q=await this.createExtensionScannerInput(U,!1,M,!0,B.language),ae=await this.extensionsScanner.scanOneOrMultipleExtensions(Q);return this.applyScanOptions(ae,M,B,!0)}async scanMetadata(U){const M=(0,v.joinPath)(U,"package.json"),B=(await this.fileService.readFile(M)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(U,M){const B=(0,v.joinPath)(U,"package.json"),Q=(await this.fileService.readFile(B)).value.toString(),ae=JSON.parse(Q);M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,M.installedTimestamp=M.installedTimestamp||void 0,ae.__metadata={...ae.__metadata,...M},await this.fileService.writeFile((0,v.joinPath)(U,"package.json"),C.VSBuffer.fromString(JSON.stringify(ae,null,"	")))}async applyScanOptions(U,M,B,Q){return B.includeAllVersions||(U=this.dedupExtensions(M===0?U:void 0,M===1?U:void 0,M==="development"?U:void 0,await this.getTargetPlatform(),Q)),B.includeInvalid||(U=U.filter(ae=>ae.isValid)),U.sort((ae,fe)=>{const X=R.basename(ae.location.fsPath),re=R.basename(fe.location.fsPath);return X<re?-1:X>re?1:0})}dedupExtensions(U,M,B,Q,ae){const fe=(re,L,O)=>{if(re.isValid&&!L.isValid)return!1;if(re.isValid===L.isValid){if(ae&&h.gt(re.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(h.eq(re.manifest.version,L.manifest.version)){if(re.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===Q)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${re.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${re.location.path} with ${L.location.path}.`),!0},X=new Map;return U?.forEach(re=>{const L=f.ExtensionIdentifier.toKey(re.identifier.id),O=X.get(L);(!O||fe(O,re,!1))&&X.set(L,re)}),M?.forEach(re=>{const L=f.ExtensionIdentifier.toKey(re.identifier.id),O=X.get(L);if(!O&&U&&re.type===0){this.logService.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!O||fe(O,re,!1))&&X.set(L,re)}),B?.forEach(re=>{const L=f.ExtensionIdentifier.toKey(re.identifier.id),O=X.get(L);(!O||fe(O,re,!0))&&X.set(L,re),X.set(L,re)}),[...X.values()]}async scanDefaultSystemExtensions(U,M){this.logService.trace("Started scanning system extensions");const B=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,M),ae=await(U&&!B.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return this.logService.trace("Scanned system extensions:",ae.length),ae}async scanDevSystemExtensions(U,M){const B=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!B?.length)return[];this.logService.trace("Started scanning dev system extensions");const Q=M?await this.getBuiltInExtensionControl():{},ae=[],fe=d.URI.file(R.normalize(R.join(T.FileAccess.asFileUri("",oe).fsPath,"..",".build","builtInExtensions")));for(const re of B){const L=Q[re.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":ae.push((0,v.joinPath)(fe,re.name));break;default:ae.push(d.URI.file(L));break}}const X=await Promise.all(ae.map(async re=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(re,!1,0,!0,U))));return this.logService.trace("Scanned dev system extensions:",X.length),(0,b.coalesce)(X)}async getBuiltInExtensionControl(){try{const U=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(U.value.toString())}catch{return{}}}async createExtensionScannerInput(U,M,B,Q,ae,fe=!0){const X=await this.getTranslations(ae??w.language),re=await this.getMtime(U),L=M?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new _(U,re,L,O,M,B,Q,fe,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ae,X)}async getMtime(U){try{const M=await this.fileService.stat(U);if(typeof M.mtime=="number")return M.mtime}catch{}}};se=Ae([_e(4,P.IUserDataProfilesService),_e(5,m.IExtensionsProfileScannerService),_e(6,o.IFileService),_e(7,i.ILogService),_e(8,c.IEnvironmentService),_e(9,s.IProductService),_e(10,n.IInstantiationService)],se),e.AbstractExtensionsScannerService=se;class _{constructor(U,M,B,Q,ae,fe,X,re,L,O,x,ne,ue,pe){this.location=U,this.mtime=M,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=Q,this.profile=ae,this.type=fe,this.excludeObsolete=X,this.validate=re,this.productVersion=L,this.productDate=O,this.productCommit=x,this.devMode=ne,this.language=ue,this.translations=pe}static createNlsConfiguration(U){return{language:U.language,pseudo:U.language==="pseudo",devMode:U.devMode,translations:U.translations}}static equals(U,M){return(0,v.isEqual)(U.location,M.location)&&U.mtime===M.mtime&&(0,v.isEqual)(U.applicationExtensionslocation,M.applicationExtensionslocation)&&U.applicationExtensionslocationMtime===M.applicationExtensionslocationMtime&&U.profile===M.profile&&U.type===M.type&&U.excludeObsolete===M.excludeObsolete&&U.validate===M.validate&&U.productVersion===M.productVersion&&U.productDate===M.productDate&&U.productCommit===M.productCommit&&U.devMode===M.devMode&&U.language===M.language&&Y.equals(U.translations,M.translations)}}let G=class extends E.Disposable{constructor(U,M,B,Q,ae){super();this.obsoleteFile=U,this.extensionsProfileScannerService=M,this.uriIdentityService=B,this.fileService=Q,this.logService=ae}async scanExtensions(U){const M=U.profile?await this.scanExtensionsFromProfile(U):await this.scanExtensionsFromLocation(U);let B={};if(U.excludeObsolete&&U.type===1)try{const Q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();B=JSON.parse(Q)}catch{}return(0,y.isEmptyObject)(B)?M:M.filter(Q=>!B[l.ExtensionKey.create(Q).toString()])}async scanExtensionsFromLocation(U){const M=await this.fileService.resolve(U.location);if(!M.children?.length)return[];const B=await Promise.all(M.children.map(async Q=>{if(!Q.isDirectory||U.type===1&&(0,v.basename)(Q.resource).indexOf(".")===0)return null;const ae=new _(Q.resource,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(ae)}));return(0,b.coalesce)(B).sort((Q,ae)=>Q.location.path<ae.location.path?-1:1)}async scanExtensionsFromProfile(U){let M=await this.scanExtensionsFromProfileResource(U.location,()=>!0,U);if(U.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(U.location,U.applicationExtensionslocation)){M=M.filter(Q=>!Q.metadata?.isApplicationScoped);const B=await this.scanExtensionsFromProfileResource(U.applicationExtensionslocation,Q=>!!Q.metadata?.isApplicationScoped,U);M.push(...B)}return M}async scanExtensionsFromProfileResource(U,M,B){const Q=await this.extensionsProfileScannerService.scanProfileExtensions(U);if(!Q.length)return[];const ae=await Promise.all(Q.map(async fe=>{if(M(fe)){const X=new _(fe.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(X,fe.metadata)}return null}));return(0,b.coalesce)(ae)}async scanOneOrMultipleExtensions(U){try{if(await this.fileService.exists((0,v.joinPath)(U.location,"package.json"))){const M=await this.scanExtension(U);return M?[M]:[]}else return await this.scanExtensions(U)}catch(M){return this.logService.error(`Error scanning extensions at ${U.location.path}:`,(0,k.getErrorMessage)(M)),[]}}async scanExtension(U,M){try{let B=await this.scanExtensionManifest(U.location);if(B){B.publisher||(B.publisher=f.UNDEFINED_PUBLISHER),M=M??B.__metadata,delete B.__metadata;const Q=(0,l.getGalleryExtensionId)(B.publisher,B.name),ae=M?.id?{id:Q,uuid:M.id}:{id:Q},fe=M?.isSystem?0:U.type,X=fe===0||!!M?.isBuiltin;B=await this.translateManifest(U.location,B,_.createNlsConfiguration(U));const re={type:fe,identifier:ae,manifest:B,location:U.location,isBuiltin:X,targetPlatform:M?.targetPlatform??"undefined",metadata:M,isValid:!0,validations:[]};return U.validate?this.validate(re,U):re}}catch(B){U.type!==0&&this.logService.error(B)}return null}validate(U,M){let B=!0;const Q=(0,r.validateExtensionManifest)(M.productVersion,M.productDate,M.location,U.manifest,U.isBuiltin);for(const[ae,fe]of Q)ae===I.default.Error&&(B=!1,this.logService.error(this.formatMessage(M.location,fe)));return U.isValid=B,U.validations=Q,U}async scanExtensionManifest(U){const M=(0,v.joinPath)(U,"package.json");let B;try{B=(await this.fileService.readFile(M)).value.toString()}catch(ae){return(0,o.toFileOperationResult)(ae)!==1&&this.logService.error(this.formatMessage(U,(0,g.localize)(0,null,M.path,ae.message))),null}let Q;try{Q=JSON.parse(B)}catch{const fe=[];(0,S.parse)(B,fe);for(const X of fe)this.logService.error(this.formatMessage(U,(0,g.localize)(1,null,M.path,X.offset,X.length,(0,p.getParseErrorMessage)(X.error))));return null}return(0,S.getNodeType)(Q)!=="object"?(this.logService.error(this.formatMessage(U,(0,g.localize)(2,null,M.path))),null):Q}async translateManifest(U,M,B){const Q=await this.getLocalizedMessages(U,M,B);if(Q)try{const ae=[],fe=await this.resolveOriginalMessageBundle(Q.default,ae);if(ae.length>0)return ae.forEach(re=>{this.logService.error(this.formatMessage(U,(0,g.localize)(3,null,Q.default?.path,(0,p.getParseErrorMessage)(re.error))))}),M;if((0,S.getNodeType)(Q)!=="object")return this.logService.error(this.formatMessage(U,(0,g.localize)(4,null,Q.default?.path))),M;const X=Q.values||Object.create(null);return(0,q.localizeManifest)(M,X,fe)}catch{}return M}async getLocalizedMessages(U,M,B){const Q=(0,v.joinPath)(U,"package.nls.json"),ae=(L,O)=>{O.forEach(x=>{this.logService.error(this.formatMessage(U,(0,g.localize)(5,null,L?.path,(0,p.getParseErrorMessage)(x.error))))})},fe=L=>{this.logService.error(this.formatMessage(U,(0,g.localize)(6,null,L?.path)))},X=`${M.publisher}.${M.name}`,re=B.translations[X];if(re)try{const L=d.URI.file(re),O=(await this.fileService.readFile(L)).value.toString(),x=[],ne=(0,S.parse)(O,x);return x.length>0?(ae(L,x),{values:void 0,default:Q}):(0,S.getNodeType)(ne)!=="object"?(fe(L),{values:void 0,default:Q}):{values:ne.contents?ne.contents.package:void 0,default:Q}}catch{return{values:void 0,default:Q}}else{if(!await this.fileService.exists(Q))return;let O;try{O=await this.findMessageBundles(U,B)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const x=(await this.fileService.readFile(O.localized)).value.toString(),ne=[],ue=(0,S.parse)(x,ne);return ne.length>0?(ae(O.localized,ne),{values:void 0,default:O.original}):(0,S.getNodeType)(ue)!=="object"?(fe(O.localized),{values:void 0,default:O.original}):{values:ue,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(U,M){if(U)try{const B=(await this.fileService.readFile(U)).value.toString();return(0,S.parse)(B,M)}catch{}}findMessageBundles(U,M){return new Promise((B,Q)=>{const ae=fe=>{const X=(0,v.joinPath)(U,`package.nls.${fe}.json`);this.fileService.exists(X).then(re=>{re&&B({localized:X,original:(0,v.joinPath)(U,"package.nls.json")});const L=fe.lastIndexOf("-");L===-1?B({localized:(0,v.joinPath)(U,"package.nls.json"),original:null}):(fe=fe.substring(0,L),ae(fe))})};if(M.devMode||M.pseudo||!M.language)return B({localized:(0,v.joinPath)(U,"package.nls.json"),original:null});ae(M.language)})}formatMessage(U,M){return`[${U.path}]: ${M}`}};G=Ae([_e(1,m.IExtensionsProfileScannerService),_e(2,F.IUriIdentityService),_e(3,o.IFileService),_e(4,i.ILogService)],G);let te=class extends G{constructor(U,M,B,Q,ae,fe){super(M,B,Q,ae,fe);this.cacheFile=U,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(U){const M=await this.readExtensionCache();if(this.input=U,M&&M.input&&_.equals(M.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),M.result.map(Q=>(Q.location=d.URI.revive(Q.location),Q));const B=await super.scanExtensions(U);return await this.writeExtensionCache({input:U,result:B}),B}async readExtensionCache(){try{const U=await this.fileService.readFile(this.cacheFile),M=JSON.parse(U.value.toString());return{result:M.result,input:(0,u.revive)(M.input)}}catch(U){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(U))}return null}async writeExtensionCache(U){try{await this.fileService.writeFile(this.cacheFile,C.VSBuffer.fromString(JSON.stringify(U)))}catch(M){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(M))}}async validateCache(){if(!this.input)return;const U=await this.readExtensionCache();if(!U)return;const M=U.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(B,M))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(Q){this.logService.error(Q)}}};te=Ae([_e(2,m.IExtensionsProfileScannerService),_e(3,F.IUriIdentityService),_e(4,o.IFileService),_e(5,i.ILogService)],te);function j(J,U){const M=(0,l.getExtensionId)(J.manifest.publisher,J.manifest.name);return{id:M,identifier:new f.ExtensionIdentifier(M),isBuiltin:J.type===0,isUserBuiltin:J.type===1&&J.isBuiltin,isUnderDevelopment:U,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,...J.manifest}}e.toExtensionDescription=j;class he extends se{constructor(U,M,B,Q,ae,fe,X,re,L,O,x){super(U,M,(0,v.joinPath)(B,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(Q,f.MANIFEST_CACHE_FOLDER),ae,fe,X,re,L,O,x);this.translationsPromise=(async()=>{if(w.translationsConfigFile)try{const ne=await this.fileService.readFile(d.URI.file(w.translationsConfigFile));return JSON.parse(ne.value.toString())}catch{}return Object.create(null)})()}getTranslations(U){return this.translationsPromise}}e.NativeExtensionsScannerService=he}),define(ve[234],we([0,1,48,14,38,7,2,8,6,21,13,37]),function(oe,e,b,t,D,C,k,S,p,E,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let w=class extends k.Disposable{constructor(h,I){super();this.userDataProfilesService=h,this.logService=I,this.processesLimiter=new t.Limiter(5)}async postUninstall(h){const I=this.parseScript(h,"uninstall");return I&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(I.script,"uninstall",I.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${y}`)))),E.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(h,I){const y=`vscode:${I}`;if(h.location.scheme===S.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[y]=="string"){const d=h.manifest.scripts[y].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${y} should be a node script`),null):{script:(0,p.join)(h.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(h,I,y,d,g){return new Promise((c,l)=>{const f=this.start(h,I,y,g);let r;const o=n=>{r&&(clearTimeout(r),r=null),n?l(n):c(void 0)};f.on("error",n=>{o((0,D.toErrorMessage)(n)||"Unknown")}),f.on("exit",(n,i)=>{o(n?`post-${I} process exited with code ${n}`:void 0)}),d&&(r=setTimeout(()=>{r=null,f.kill(),l("timed out")},5e3))})}start(h,I,y,d){const g={silent:!0,execArgv:void 0},c=(0,b.fork)(h,[`--type=extension-post-${I}`,...y],g);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const l=C.Event.fromNodeEventEmitter(c.stdout,"data"),f=C.Event.fromNodeEventEmitter(c.stderr,"data");l(n=>this.logService.info(d.identifier.id,d.manifest.version,`post-${I}`,n)),f(n=>this.logService.error(d.identifier.id,d.manifest.version,`post-${I}`,n));const r=C.Event.any(C.Event.map(l,n=>({data:`%c${n}`,format:[""]})),C.Event.map(f,n=>({data:`%c${n}`,format:["color: red"]})));return C.Event.debounce(r,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),c}getExtensionStoragePath(h){return(0,p.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};w=Ae([_e(0,R.IUserDataProfilesService),_e(1,T.ILogService)],w),e.ExtensionsLifecycle=w}),define(ve[235],we([0,1,14,7,2,47,12,148,5,37]),function(oe,e,b,t,D,C,k,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const T="__$__targetStorageMarker";e.IStorageService=(0,p.createDecorator)("storageService");var R;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(R=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var v;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));class h extends D.Disposable{constructor(c={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=c,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new b.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,b.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,l){if(l===T){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:l,target:this.getKeyTargets(c)[l]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,l,f){return this.getStorage(l)?.get(c,f)}getBoolean(c,l,f){return this.getStorage(l)?.getBoolean(c,f)}getNumber(c,l,f){return this.getStorage(l)?.getNumber(c,f)}store(c,l,f,r){if((0,k.isUndefinedOrNull)(l)){this.remove(c,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,f,r),this.getStorage(f)?.set(c,l)})}remove(c,l){this.withPausedEmitters(()=>{this.updateKeyTarget(c,l,void 0),this.getStorage(l)?.delete(c)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,l){const f=[],r=this.getKeyTargets(c);for(const o of Object.keys(r))r[o]===l&&f.push(o);return f}updateKeyTarget(c,l,f){const r=this.getKeyTargets(l);typeof f=="number"?r[c]!==f&&(r[c]=f,this.getStorage(l)?.set(T,JSON.stringify(r))):typeof r[c]=="number"&&(delete r[c],this.getStorage(l)?.set(T,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const l=this.get(T,c);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=R.NONE){this._onWillSaveState.fire({reason:c});const l=this.getStorage(-1),f=this.getStorage(0),r=this.getStorage(1);switch(c){case R.NONE:await b.Promises.settled([l?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await b.Promises.settled([l?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return d(c,l,f,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(c,l){return this.emitWillSaveState(R.NONE),(0,E.isUserDataProfile)(c)?this.switchToProfile(c,l):this.switchToWorkspace(c,l)}canSwitchProfile(c,l){return!(c.id===l.id||I(l)&&I(c))}switchData(c,l,f,r){this.withPausedEmitters(()=>{if(r)for(const[o,n]of c)l.set(o,n);else{const o=new Set;for(const[n,i]of c)o.add(n),l.get(n)!==i&&this.emitDidChangeValue(f,n);for(const[n]of l.items)o.has(n)||this.emitDidChangeValue(f,n)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function I(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=I;class y extends h{constructor(){super();this.applicationStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.profileStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=y;async function d(g,c,l,f,r,o){const n=Y=>{try{return JSON.parse(Y)}catch{return Y}},i=new Map,s=new Map;g.forEach((Y,se)=>{i.set(se,Y),s.set(se,n(Y))});const a=new Map,u=new Map;c.forEach((Y,se)=>{a.set(se,Y),u.set(se,n(Y))});const m=new Map,P=new Map;l.forEach((Y,se)=>{m.set(se,Y),P.set(se,n(Y))}),console.group(f!==r?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const F=[];if(i.forEach((Y,se)=>{F.push({key:se,value:Y})}),console.table(F),console.groupEnd(),console.log(s),f!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const Y=[];a.forEach((se,_)=>{Y.push({key:_,value:se})}),console.table(Y),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${o})`);const q=[];m.forEach((Y,se)=>{q.push({key:se,value:Y})}),console.table(q),console.groupEnd(),console.log(P)}e.logStorage=d}),define(ve[115],we([0,1,18,20,11,3,27,12,4,25,29,31,34,70,17,13,26,54,218,235,32]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const f=C.isWeb?"web":(0,R.getTargetPlatform)(C.platform,k.arch);var r;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function o(...L){return String(L.reduce((O,x)=>O|x,0))}var n;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class m{constructor(O=u){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,x=this.state.pageSize){return new m({...this.state,pageNumber:O,pageSize:x})}withFilter(O,...x){const ne=[...this.state.criteria,...x.length?x.map(ue=>({filterType:O,value:ue})):[{filterType:O}]];return new m({...this.state,criteria:ne})}withSortBy(O){return new m({...this.state,sortBy:O})}withSortOrder(O){return new m({...this.state,sortOrder:O})}withFlags(...O){return new m({...this.state,flags:O.reduce((x,ne)=>x|ne,0)})}withAssetTypes(...O){return new m({...this.state,assetTypes:O})}withSource(O){return new m({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:x,pageSize:ne,sortBy:ue,sortOrder:pe,flags:W,assetTypes:Z}=this.state;return{filters:[{criteria:O,pageNumber:x,pageSize:ne,sortBy:ue,sortOrder:pe}],assetTypes:Z,flags:W}}get searchText(){const O=this.state.criteria.filter(x=>x.filterType===n.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function P(L,O){const x=(L||[]).filter(ne=>ne.statisticName===O)[0];return x?x.value:0}function F(L){const O="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(ne=>ne.assetType.indexOf(O)===0).reduce((ne,ue)=>{const pe=se(L,ue.assetType);return pe&&ne.push([ue.assetType.substring(O.length),pe]),ne},[])}function q(L){if(L.properties){const O=L.properties.filter(ue=>ue.key===i.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ne=O.filter(ue=>x.test(ue.value))[0];return ne?{uri:ne.value,fallbackUri:ne.value}:null}return se(L,i.Repository)}function Y(L){return{uri:`${L.fallbackAssetUri}/${i.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${i.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function se(L,O){return L.files.filter(ne=>ne.assetType===O)[0]?{uri:`${L.assetUri}/${O}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${O}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function _(L,O){const x=L.properties?L.properties.filter(ue=>ue.key===O):[],ne=x.length>0&&x[0].value;return ne?ne.split(",").map(ue=>(0,w.adoptToGalleryExtensionId)(ue)):[]}function G(L){const O=L.properties?L.properties.filter(x=>x.key===s.Engine):[];return O.length>0&&O[0].value||""}function te(L){const O=L.properties?L.properties.filter(x=>x.key===s.PreRelease):[];return O.length>0&&O[0].value==="true"}function j(L){const O=L.properties?L.properties.filter(ne=>ne.key===s.LocalizedLanguages):[],x=O.length>0&&O[0].value||"";return x?x.split(","):[]}function he(L){return L.properties?.find(O=>O.key===s.SponsorLink)?.value}function J(L){return L.indexOf("preview")!==-1}function U(L){return L.targetPlatform?(0,R.toTargetPlatform)(L.targetPlatform):"undefined"}function M(L){const O=(0,b.distinct)(L.versions.map(U)),x=!!L.tags?.includes(R.WEB_EXTENSION_TAG),ne=O.indexOf("web");return x?ne===-1&&O.push("web"):ne!==-1&&O.splice(ne,1),O}function B(L,O){const x=(0,R.getFallbackTargetPlarforms)(O);for(let ne=0;ne<L.length;ne++){const ue=L[ne];if(ue.version===L[ne-1]?.version){let pe=ne;const W=U(ue);if(W===O)for(;pe>0&&L[pe-1].version===ue.version;)pe--;else if(x.includes(W))for(;pe>0&&L[pe-1].version===ue.version&&U(L[pe-1])!==O;)pe--;pe!==ne&&(L.splice(ne,1),L.splice(pe,0,ue))}}return L}e.sortExtensionVersions=B;function Q(L,O,x){L.telemetryData={index:O,querySource:x}}function ae(L,O,x){const ne=L.versions[0],ue={manifest:se(O,i.Manifest),readme:se(O,i.Details),changelog:se(O,i.Changelog),license:se(O,i.License),repository:q(O),download:Y(O),icon:se(O,i.Icon),coreTranslations:F(O)};return{identifier:{id:(0,w.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:O.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:he(ne),description:L.shortDescription||"",installCount:P(L.statistics,"install"),rating:P(L.statistics,"averagerating"),ratingCount:P(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:x,assets:ue,properties:{dependencies:_(O,s.Dependency),extensionPack:_(O,s.ExtensionPack),engine:G(O),localizedLanguages:j(O),targetPlatform:U(O),isPreReleaseVersion:te(O)},hasPreReleaseVersion:te(ne),hasReleaseVersion:!0,preview:J(L.flags)}}let fe=class{constructor(O,x,ne,ue,pe,W,Z,ie){this.requestService=x,this.logService=ne,this.environmentService=ue,this.telemetryService=pe,this.fileService=W,this.productService=Z,this.configurationService=ie;const z=Z.extensionsGallery;this.extensionsGalleryUrl=z&&z.serviceUrl,this.extensionsControlUrl=z&&z.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(Z.version,Z,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,x,ne){const ue=t.CancellationToken.isCancellationToken(x)?{}:x,pe=t.CancellationToken.isCancellationToken(x)?x:ne,W=[],Z=[],ie=[],z=[];let V=!0;for(const le of O){le.uuid?Z.push(le.uuid):W.push(le.id);const ge=!!(le.version||le.preRelease);ie.push({id:le.id,uuid:le.uuid,includePreRelease:ge}),le.version&&z.push({id:le.id,uuid:le.uuid,version:le.version}),V=V&&!!le.hasPreRelease&&!ge}if(!Z.length&&!W.length)return[];let $=new m().withPage(1,O.length);Z.length&&($=$.withFilter(n.ExtensionId,...Z)),W.length&&($=$.withFilter(n.ExtensionName,...W)),(ue.queryAllVersions||V)&&($=$.withFlags($.flags,r.IncludeVersions)),ue.source&&($=$.withSource(ue.source));const{extensions:K}=await this.queryGalleryExtensions($,{targetPlatform:ue.targetPlatform??f,includePreRelease:ie,versions:z,compatible:!!ue.compatible},pe);return ue.source&&K.forEach((le,ge)=>Q(le,ge,ue.source)),K}async getCompatibleExtension(O,x,ne){if((0,R.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,ne))return null;if(await this.isExtensionCompatible(O,x,ne))return O;const ue=new m().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,O.identifier.uuid),{extensions:pe}=await this.queryGalleryExtensions(ue,{targetPlatform:ne,compatible:!0,includePreRelease:x},t.CancellationToken.None);return pe[0]||null}async isExtensionCompatible(O,x,ne){if(!(0,R.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,ne)||!x&&O.properties.isPreReleaseVersion)return!1;let ue=O.properties.engine;if(!ue){const pe=await this.getManifest(O,t.CancellationToken.None);if(!pe)throw new Error("Manifest was not found");ue=pe.engines.vscode}return(0,v.isEngineValid)(ue,this.productService.version,this.productService.date)}async isValidVersion(O,x,ne,ue,pe){if(!(0,R.isTargetPlatformCompatible)(U(O),ue,pe)||x!=="any"&&te(O)!==(x==="prerelease"))return!1;if(ne)try{const W=await this.getEngine(O);if(!(0,v.isEngineValid)(W,this.productService.version,this.productService.date))return!1}catch(W){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,D.getErrorMessage)(W)),!1}return!0}async query(O,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ne=O.text||"";const ue=O.pageSize??50;let pe=new m().withPage(1,ue);ne?(ne=ne.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,$,K)=>(pe=pe.withFilter(n.Category,K||$),"")),ne=ne.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,$,K)=>(pe=pe.withFilter(n.Tag,K||$),"")),ne=ne.replace(/\bfeatured(\s+|\b|$)/g,()=>(pe=pe.withFilter(n.Featured),"")),ne=ne.trim(),ne&&(ne=ne.length<200?ne:ne.substring(0,200),pe=pe.withFilter(n.SearchText,ne)),pe=pe.withSortBy(0)):O.ids?pe=pe.withFilter(n.ExtensionId,...O.ids):O.names?pe=pe.withFilter(n.ExtensionName,...O.names):pe=pe.withSortBy(4),typeof O.sortBy=="number"&&(pe=pe.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(pe=pe.withSortOrder(O.sortOrder)),O.source&&(pe=pe.withSource(O.source));const W=async(V,$)=>{const{extensions:K,total:le}=await this.queryGalleryExtensions(V,{targetPlatform:f,compatible:!1,includePreRelease:!!O.includePreRelease},$);return K.forEach((ge,Pe)=>Q(ge,(V.pageNumber-1)*V.pageSize+Pe,O.source)),{extensions:K,total:le}},{extensions:Z,total:ie}=await W(pe,x),z=async(V,$)=>{if($.isCancellationRequested)throw new D.CancellationError;const{extensions:K}=await W(pe.withPage(V+1),$);return K};return{firstPage:Z,total:ie,pageSize:pe.pageSize,getPage:z}}async queryGalleryExtensions(O,x,ne){const ue=O.flags;!!(O.flags&r.IncludeLatestVersionOnly)&&!!(O.flags&r.IncludeVersions)&&(O=O.withFlags(O.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(O.flags&r.IncludeLatestVersionOnly)&&!(O.flags&r.IncludeVersions)&&(O=O.withFlags(O.flags,r.IncludeLatestVersionOnly)),x.versions?.length&&(O=O.withFlags(O.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),O=O.withFlags(O.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:pe,total:W}=await this.queryRawGalleryExtensions(O,ne);if(!(O.flags&r.IncludeLatestVersionOnly)){const V=[];for(const $ of pe){const K=await this.toGalleryExtensionWithCriteria($,x);K&&V.push(K)}return{extensions:V,total:W}}const ie=[],z=new Map;for(let V=0;V<pe.length;V++){const $=pe[V],K={id:(0,w.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},le=(0,S.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Pe=>(0,w.areSameExtensions)(Pe,K))?.includePreRelease;if(x.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(M($),x.targetPlatform))continue;const ge=await this.toGalleryExtensionWithCriteria($,x);!ge||ge.properties.isPreReleaseVersion&&(!le||!ge.hasReleaseVersion)||!ge.properties.isPreReleaseVersion&&ge.properties.targetPlatform!==x.targetPlatform&&ge.hasPreReleaseVersion?z.set($.extensionId,V):ie.push([V,ge])}if(z.size){const V=new Date().getTime(),$=new m().withFlags(ue&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,z.size).withFilter(n.ExtensionId,...z.keys()),{extensions:K}=await this.queryGalleryExtensions($,x,ne);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-V,count:z.size});for(const le of K){const ge=z.get(le.identifier.uuid);ie.push([ge,le])}}return{extensions:ie.sort((V,$)=>V[0]-$[0]).map(([,V])=>V),total:W}}async toGalleryExtensionWithCriteria(O,x){const ne={id:(0,w.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},ue=x.versions?.find(ie=>(0,w.areSameExtensions)(ie,ne))?.version,pe=(0,S.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ie=>(0,w.areSameExtensions)(ie,ne))?.includePreRelease,W=M(O),Z=B(O.versions,x.targetPlatform);if(x.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(W,x.targetPlatform))return null;for(let ie=0;ie<Z.length;ie++){const z=Z[ie];if(!(ue&&z.version!==ue)){if(await this.isValidVersion(z,pe?"any":"release",x.compatible,W,x.targetPlatform))return ae(O,z,W);if(ue&&z.version===ue)return null}}return ue||x.compatible?null:ae(O,O.versions[0],W)}async queryRawGalleryExtensions(O,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,o(r.Unpublished));const ne=await this.commonHeadersPromise,ue=JSON.stringify(O.raw),pe={...ne,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},W=new Date().getTime();let Z,ie,z=0;try{if(Z=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:pe},x),Z.res.statusCode&&Z.res.statusCode>=400&&Z.res.statusCode<500)return{galleryExtensions:[],total:z};const V=await(0,d.asJson)(Z);if(V){const $=V.results[0],K=$.extensions,le=$.resultMetadata&&$.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return z=le&&le.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:K,total:z}}return{galleryExtensions:[],total:z}}catch(V){throw ie=V,V}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-W,success:!!Z&&(0,d.isSuccess)(Z),responseBodySize:Z?.res.headers["Content-Length"],statusCode:Z?String(Z.res.statusCode):void 0,errorCode:ie?(0,D.isCancellationError)(ie)?"canceled":(0,D.getErrorMessage)(ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(z)})}}async reportStatistic(O,x,ne,ue){if(!this.isEnabled())return;const pe=C.isWeb?this.api(`/itemName/${O}.${x}/version/${ne}/statType/${ue==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${x}/${ne}/stats?statType=${ue}`),W=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ie={...await this.commonHeadersPromise,Accept:W};try{await this.requestService.request({type:"POST",url:pe,headers:ie},t.CancellationToken.None)}catch{}}async download(O,x,ne){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const ue=(0,w.getGalleryExtensionTelemetryData)(O),pe=new Date().getTime(),W=V=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ue,duration:V}),Z=ne===2?"install":ne===3?"update":"",ie=Z?{uri:`${O.assets.download.uri}${p.URI.parse(O.assets.download.uri).query?"&":"?"}${Z}=true`,fallbackUri:`${O.assets.download.fallbackUri}${p.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${Z}=true`}:O.assets.download,z=await this.getAsset(ie);await this.fileService.writeFile(x,z.stream),W(new Date().getTime()-pe)}async getReadme(O,x){if(O.assets.readme){const ne=await this.getAsset(O.assets.readme,{},x);return await(0,d.asTextOrError)(ne)||""}return""}async getManifest(O,x){if(O.assets.manifest){const ne=await this.getAsset(O.assets.manifest,{},x),ue=await(0,d.asTextOrError)(ne);return ue?JSON.parse(ue):null}return null}async getManifestFromRawExtensionVersion(O,x){const ne=se(O,i.Manifest);if(!ne)throw new Error("Manifest was not found");const ue={"Accept-Encoding":"gzip"},pe=await this.getAsset(ne,{headers:ue});return await(0,d.asJson)(pe)}async getCoreTranslation(O,x){const ne=O.assets.coreTranslations.filter(ue=>ue[0]===x.toUpperCase())[0];if(ne){const ue=await this.getAsset(ne[1]),pe=await(0,d.asTextOrError)(ue);return pe?JSON.parse(pe):null}return null}async getChangelog(O,x){if(O.assets.changelog){const ne=await this.getAsset(O.assets.changelog,{},x);return await(0,d.asTextOrError)(ne)||""}return""}async getAllCompatibleVersions(O,x,ne){let ue=new m().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?ue=ue.withFilter(n.ExtensionId,O.identifier.uuid):ue=ue.withFilter(n.ExtensionName,O.identifier.id);const{galleryExtensions:pe}=await this.queryRawGalleryExtensions(ue,t.CancellationToken.None);if(!pe.length)return[];const W=M(pe[0]);if((0,R.isNotWebExtensionInWebTargetPlatform)(W,ne))return[];const Z=[];await Promise.all(pe[0].versions.map(async V=>{try{await this.isValidVersion(V,x?"any":"release",!0,W,ne)&&Z.push(V)}catch{}}));const ie=[],z=new Set;for(const V of B(Z,ne))z.has(V.version)||(z.add(V.version),ie.push({version:V.version,date:V.lastUpdated,isPreReleaseVersion:te(V)}));return ie}async getAsset(O,x={},ne=t.CancellationToken.None){const ue=await this.commonHeadersPromise,pe={type:"GET"},W={...ue,...x.headers||{}};x={...x,...pe,headers:W};const Z=O.uri,ie=O.fallbackUri,z={...x,url:Z};try{const V=await this.requestService.request(z,ne);if(V.res.statusCode===200)return V;const $=await(0,d.asTextOrError)(V);throw new Error(`Expected 200, got back ${V.res.statusCode} instead.

${$}`)}catch(V){if((0,D.isCancellationError)(V))throw V;const $=(0,D.getErrorMessage)(V);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Z,message:$});const K={...x,url:ie};return this.requestService.request(K,ne)}}async getEngine(O){let x=G(O);if(!x){const ne=await this.getManifestFromRawExtensionVersion(O,t.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");x=ne.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,d.asJson)(O),ne=[],ue={};if(x){for(const pe of x.malicious)ne.push({id:pe});if(x.migrateToPreRelease)for(const[pe,W]of Object.entries(x.migrateToPreRelease))(!W.engine||(0,v.isEngineValid)(W.engine,this.productService.version,this.productService.date))&&(ue[pe.toLowerCase()]={disallowInstall:!0,extension:{id:W.id,displayName:W.displayName,autoMigrate:{storage:!!W.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[pe,W]of Object.entries(x.deprecated))W&&(ue[pe.toLowerCase()]=(0,S.isBoolean)(W)?{}:W)}return{malicious:ne,deprecated:ue}}};fe=Ae([_e(1,d.IRequestService),_e(2,I.ILogService),_e(3,T.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,h.IFileService),_e(6,y.IProductService),_e(7,E.IConfigurationService)],fe);let X=class extends fe{constructor(O,x,ne,ue,pe,W,Z,ie){super(O,x,ne,ue,pe,W,Z,ie)}};X=Ae([_e(0,c.IStorageService),_e(1,d.IRequestService),_e(2,I.ILogService),_e(3,T.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,h.IFileService),_e(6,y.IProductService),_e(7,E.IConfigurationService)],X),e.ExtensionGalleryService=X;let re=class extends fe{constructor(O,x,ne,ue,pe,W,Z){super(void 0,O,x,ne,ue,pe,W,Z)}};re=Ae([_e(0,d.IRequestService),_e(1,I.ILogService),_e(2,T.IEnvironmentService),_e(3,l.ITelemetryService),_e(4,h.IFileService),_e(5,y.IProductService),_e(6,E.IConfigurationService)],re),e.ExtensionGalleryServiceWithNoStorageService=re}),define(ve[116],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,b.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(C,k){this._exitInfo.set(C,k)}getExitInfo(C){return this._exitInfo.get(C)||null}}e.ExtensionHostStatusService=t}),define(ve[236],we([0,1,7,14]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function D(k){let S=0,p=0,E=0;k>=1e3&&(E=Math.floor(k/1e3),k-=E*1e3),E>=60&&(p=Math.floor(E/60),E-=p*60),p>=60&&(S=Math.floor(p/60),p-=S*60);const T=S?`${S}h`:"",R=p?`${p}m`:"",w=E?`${E}s`:"",v=k?`${k}ms`:"";return`${T}${R}${w}${v}`}e.printTime=D;class C{constructor(S,p,E,T){this._logService=S,this._reconnectionToken=p,this._onClose=new b.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=E,this.protocol=T,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${D(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${D(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${D(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(S){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${S}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${D(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const S=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),S.end(),this._onClose.fire(void 0)}acceptReconnection(S,p,E){this._remoteAddress=S,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(p,E),this.protocol.endAcceptReconnection()}}e.ManagementConnection=C}),define(ve[79],we([0,1,30,8,6,143,51]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const S=D.join(t.FileAccess.asFileUri("",oe).fsPath,"nls.metadata.json"),p=new Map;function E(h){return new Promise(I=>b.exists(h,I))}function T(h,I){return E(S).then(y=>{if(!y||!k.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const d=`${h}||${I}`;let g=p.get(d);return g||(g=C.getNLSConfiguration(k.default.commit,I,S,h).then(c=>(R.is(c)&&(c._languagePackSupport=!0),c.locale!=="en"&&c.locale!=="en-us"&&Object.keys(c.availableLanguages).length===0&&p.delete(d),c)),p.set(d,g)),g})}e.getNLSConfiguration=T;var R;(function(h){function I(y){const d=y;return d&&typeof d._languagePackId=="string"}h.is=I})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const w=async h=>{try{const I=v(await b.promises.readFile(h,"utf8"));return JSON.parse(I).locale}catch(I){return I.code!=="ENOENT"&&console.warn(I),"en"}};e.getLocaleFromConfig=w;const v=h=>{const I=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return h.replace(I,(y,d,g,c,l)=>{if(c)return"";if(l){const f=l.length;return f>2&&l[f-1]===`
`?l[f-2]==="\r"?`\r
`:`
`:""}else return y})}}),define(ve[117],we([0,1,19,4,29,53,55,36,17,5,13,26,37,79]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let h=class extends k.AbstractExtensionsScannerService{constructor(y,d,g,c,l,f,r){super(t.URI.file(l.builtinExtensionsPath),t.URI.file(l.extensionsPath),(0,b.joinPath)(l.userHome,".vscode-oss-dev","extensions","control.json"),(0,b.joinPath)(t.URI.file(l.userDataPath),S.MANIFEST_CACHE_FOLDER),y,d,g,c,l,f,r);this.nativeEnvironmentService=l}async getTranslations(y){const d=await(0,v.getNLSConfiguration)(y,this.nativeEnvironmentService.userDataPath);if(v.InternalNLSConfiguration.is(d))try{const g=await this.fileService.readFile(t.URI.file(d._translationsConfigFile));return JSON.parse(g.value.toString())}catch{}return Object.create(null)}};h=Ae([_e(0,w.IUserDataProfilesService),_e(1,C.IExtensionsProfileScannerService),_e(2,p.IFileService),_e(3,T.ILogService),_e(4,D.INativeEnvironmentService),_e(5,R.IProductService),_e(6,E.IInstantiationService)],h),e.ExtensionsScannerService=h}),define(ve[237],we([0,1,238,30,6,23,8,21]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const p=/^[0-9A-Za-z-]+$/;var E;(function(d){d[d.None=0]="None",d[d.Optional=1]="Optional",d[d.Mandatory=2]="Mandatory"})(E=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(g){return!0}}e.NoneServerConnectionToken=T;class R{constructor(g){this.value=g,this.type=1}validate(g){return g===this.value}}e.OptionalServerConnectionToken=R;class w{constructor(g){this.value=g,this.type=2}validate(g){return g===this.value}}e.MandatoryServerConnectionToken=w;class v{constructor(g){this.message=g}}e.ServerConnectionTokenParseError=v;async function h(d,g){const c=d["without-connection-token"],l=d["connection-token"],f=d["connection-token-file"],r=d.compatibility==="1.63";if(c)return typeof l!="undefined"||typeof f!="undefined"?new v("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof f!="undefined"){if(typeof l!="undefined")return new v("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let o;try{o=t.readFileSync(f).toString().replace(/\r?\n$/,"")}catch{return new v(`Unable to read the connection token file at '${f}'.`)}return p.test(o)?new w(o):new v(`The connection token defined in '${f} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof l!="undefined"?p.test(l)?r?new R(l):new w(l):new v(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):r?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new R(await g())):new w(await g())}e.parseServerConnectionToken=h;async function I(d){return h(d,async()=>{if(!d["user-data-dir"])return(0,C.generateUuid)();const c=D.join(d["user-data-dir"],"token");try{const r=(await S.Promises.readFile(c)).toString().replace(/\r?\n$/,"");if(p.test(r))return r}catch{}const l=(0,C.generateUuid)();try{await S.Promises.writeFile(c,l,{mode:384})}catch{}return l})}e.determineServerConnectionToken=I;function y(d,g,c){if(d.validate(c.query[k.connectionTokenQueryName]))return!0;const l=b.parse(g.headers.cookie||"");return d.validate(l[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=y}),define(ve[40],we([0,1,181,190,58,5,29]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},host:{type:"string",cat:"o",args:"ip-address",description:b.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:b.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:b.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:b.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:b.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:b.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:b.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:b.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:b.localize(8,null)},"user-data-dir":D.OPTIONS["user-data-dir"],"enable-smoke-test-driver":D.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":D.OPTIONS["disable-telemetry"],"disable-workspace-trust":D.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:D.OPTIONS.log,logsPath:D.OPTIONS.logsPath,"force-disable-user-env":D.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:b.localize(9,null)},"default-workspace":{type:"string",description:b.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":D.OPTIONS["extensions-dir"],"extensions-download-dir":D.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":D.OPTIONS["builtin-extensions-dir"],"install-extension":D.OPTIONS["install-extension"],"install-builtin-extension":D.OPTIONS["install-builtin-extension"],"uninstall-extension":D.OPTIONS["uninstall-extension"],"list-extensions":D.OPTIONS["list-extensions"],"locate-extension":D.OPTIONS["locate-extension"],"show-versions":D.OPTIONS["show-versions"],category:D.OPTIONS.category,force:D.OPTIONS.force,"do-not-sync":D.OPTIONS["do-not-sync"],"pre-release":D.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:b.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:D.OPTIONS.help,version:D.OPTIONS.version,"locate-shell-integration-path":D.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:D.OPTIONS._},e.IServerEnvironmentService=(0,C.refineServiceDecorator)(k.IEnvironmentService);class S extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=S}),define(ve[239],we([0,1,71,13,40,26,204,23,18]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let E=class extends k.BaseCredentialsMainService{constructor(R,w,v){super(R);this.environmentMainService=w,this.productService=v,this.environmentMainService.args["github-auth"]&&this.storeGitHubToken(this.environmentMainService.args["github-auth"]).catch(h=>{this.logService.error("Failed to store provided GitHub token",h)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new b.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((R,w)=>{oe(["keytar"],R,w)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(R){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${R.message??R}`),this._keytarCache=new b.InMemoryCredentialsProvider}return this._keytarCache}async storeGitHubToken(R){const w="vscode.github-authentication",v=`${await this.getSecretStoragePrefix()}${w}`,h="github.auth",y=[["read:user","user:email","repo"]].map(c=>({id:(0,S.generateUuid)(),scopes:c.sort(),accessToken:R})),d=await this.getPassword(v,h);let g;if(d)try{const c=JSON.parse(d);c.content=JSON.parse(c.content),g=c}catch(c){this.logService.error("Failed to parse existing GitHub credentials",c)}return g?.content&&(g.content=g.content.filter(c=>{const l=c.scopes.sort();return!y.find(f=>(0,p.equals)(l,f.scopes)&&f.account?.label===c.account?.label)})),this.setPassword(v,h,JSON.stringify({extensionId:w,...g||{},content:JSON.stringify([...y,...g?.content||[]])}))}};E=Ae([_e(0,t.ILogService),_e(1,D.IServerEnvironmentService),_e(2,C.IProductService)],E),e.CredentialsWebMainService=E}),define(ve[240],we([0,1,270,223,241,28]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class k extends b.AppInsightsCore{constructor(p){super();this.endpoint=p}track(p){const E=p.baseData||{};E.properties||(E.properties={}),E.measurements||(E.measurements={});try{const T=C.cpus();E.measurements.cores=T.length,E.properties["common.cpuModel"]=T[0].model}catch{}try{E.measurements.memoryFree=C.freemem(),E.measurements.memoryTotal=C.totalmem()}catch{}try{E.properties["common.shell"]=C.userInfo().shell,E.properties["common.release"]=C.release(),E.properties["common.arch"]=C.arch()}catch{}try{const T=(/^http:/.test(this.endpoint)?D:t).request(this.endpoint,{method:"POST",headers:{"Content-Type":"application/json"}});T.on("error",()=>{}),T.write(JSON.stringify(E)),T.end()}catch{}}}e.TelemetryClient=k}),define(ve[242],we([0,1,30,89,76,238,110,35,66,3,13,40,6,8,23,26,54,20,4,16,12,79,75]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c,l,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(Y,se,_,G){se.writeHead(_,{"Content-Type":"text/plain"}),se.end(G)}e.serveError=n;var i;(function(Y){Y[Y.NO_CACHING=0]="NO_CACHING",Y[Y.ETAG=1]="ETAG",Y[Y.NO_EXPIRY=2]="NO_EXPIRY"})(i=e.CacheControl||(e.CacheControl={}));async function s(Y,se,_,G,te,j){try{const he=await b.promises.stat(Y);if(se===1){const J=`W/"${[he.ino,he.size,he.mtime.getTime()].join("-")}"`;if(G.headers["if-none-match"]===J)return te.writeHead(304),te.end();j.Etag=J}else se===2?j["Cache-Control"]="public, max-age=31536000":se===0&&(j["Cache-Control"]="no-store");j["Content-Type"]=o[(0,w.extname)(Y)]||(0,p.getMediaMime)(Y)||"text/plain",te.writeHead(200,j),(0,b.createReadStream)(Y).pipe(te)}catch(he){return he.code!=="ENOENT"?(_.error(he),console.error(he.toString())):console.error(`File not found: ${Y}`),te.writeHead(404,{"Content-Type":"text/plain"}),te.end("Not found")}}e.serveFile=s;const a=(0,w.dirname)(v.FileAccess.asFileUri("",oe).fsPath);let u=class{constructor(se,_,G,te,j){this._connectionToken=se,this._environmentService=_,this._logService=G,this._requestService=te,this._productService=j,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?g.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0;const he=(0,r.getRemoteServerRootPath)(j);this._staticRoute=`${he}/static`,this._callbackRoute=`${he}/callback`,this._webExtensionRoute="/web-extension-resource"}async handle(se,_,G){try{const te=G.pathname;return te.startsWith(this._staticRoute)&&te.charCodeAt(this._staticRoute.length)===47?this._handleStatic(se,_,G):te==="/"?this._handleRoot(se,_,G):te===this._callbackRoute?this._handleCallback(_):te.startsWith(this._webExtensionRoute)&&te.charCodeAt(this._webExtensionRoute.length)===47?this._handleWebExtensionResource(se,_,G):n(se,_,404,"Not found.")}catch(te){return this._logService.error(te),console.error(te.toString()),n(se,_,500,"Internal Server Error.")}}async _handleStatic(se,_,G){const te=Object.create(null),he=decodeURIComponent(G.pathname).substring(this._staticRoute.length+1),J=(0,w.join)(a,he);return(0,S.isEqualOrParent)(J,a,!E.isLinux)?s(J,this._environmentService.isBuilt?2:1,this._logService,se,_,te):n(se,_,400,"Bad request.")}_getResourceURLTemplateAuthority(se){const _=se.authority.indexOf(".");return _!==-1?se.authority.substring(_+1):void 0}async _handleWebExtensionResource(se,_,G){if(!this._webExtensionResourceUrlTemplate)return n(se,_,500,"No extension gallery service configured.");const te=decodeURIComponent(G.pathname),j=(0,w.normalize)(te.substring(this._webExtensionRoute.length+1)),he=g.URI.parse(j).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:j.substring(0,j.indexOf("/")),path:j.substring(j.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(he))return n(se,_,403,"Request Forbidden");const J={},U=X=>{const re=se.headers[X];re&&((0,l.isString)(re)||re[0])?J[X]=(0,l.isString)(re)?re:re[0]:X!==X.toLowerCase()&&U(X.toLowerCase())};U("X-Client-Name"),U("X-Client-Version"),U("X-Machine-Id"),U("X-Client-Commit");const M=await this._requestService.request({type:"GET",url:he.toString(!0),headers:J},d.CancellationToken.None),B=M.res.statusCode||500;if(B!==200){let X=null;try{X=await(0,y.asTextOrError)(M)}catch{}return n(se,_,B,X||`Request failed with status ${B}`)}const Q=Object.create(null),ae=X=>{const re=M.res.headers[X];re?Q[X]=re:X!==X.toLowerCase()&&ae(X.toLowerCase())};ae("Cache-Control"),ae("Content-Type"),_.writeHead(200,Q);const fe=await(0,c.streamToBuffer)(M.stream);return _.end(fe.buffer)}async _handleRoot(se,_,G){const te=G.query[v.connectionTokenQueryName];if(typeof te=="string"){const pe=Object.create(null);pe["Set-Cookie"]=C.serialize(v.connectionTokenCookieName,te,{sameSite:"lax",maxAge:60*60*24*7});const W=Object.create(null);for(const ie in G.query)ie!==v.connectionTokenQueryName&&(W[ie]=G.query[ie]);const Z=D.format({pathname:"/",query:W});return pe.Location=Z,_.writeHead(302,pe),_.end()}const j="remote";if(!j)return n(se,_,400,"Bad request.");function he(pe){return JSON.stringify(pe).replace(/"/g,"&quot;")}let J;this._environmentService.args["enable-smoke-test-driver"]&&(J=!1);const U=pe=>pe&&g.URI.file(t.resolve(pe)).with({scheme:v.Schemas.vscodeRemote,authority:j}),M=v.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",oe).fsPath,B=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,h.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,Q=(0,e.relativeRoot)((0,e.getOriginalUrl)(se)),ae=(0,e.relativePath)((0,e.getOriginalUrl)(se)),fe=this._environmentService.args.locale||await(0,f.getLocaleFromConfig)(this._environmentService.argvResource.fsPath),X=await(0,f.getNLSConfiguration)(fe,this._environmentService.userDataPath),re={remoteAuthority:j,webviewEndpoint:ae+this._staticRoute+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this._environmentService.userDataPath,isEnabledFileDownloads:!this._environmentService.args["disable-file-downloads"],_wrapWebWorkerExtHostInIframe:J,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this._logService.getLevel()},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:U(this._environmentService.args["default-folder"]),workspaceUri:U(this._environmentService.args["default-workspace"]),productConfiguration:{codeServerVersion:this._productService.codeServerVersion,rootEndpoint:Q,updateEndpoint:this._environmentService.args["disable-update-check"]?void 0:Q+"/update/check",logoutEndpoint:this._environmentService.args.auth&&this._environmentService.args.auth!=="none"?Q+"/logout":void 0,proxyEndpointTemplate:Q+"/proxy/{{port}}",serviceWorker:{scope:ae+"/",path:Q+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this._productService.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this._productService.extensionsGallery},callbackRoute:this._callbackRoute},L=this._productService.extensionsGallery?.nlsBaseUrl,O={WORKBENCH_WEB_CONFIGURATION:he(re),WORKBENCH_AUTH_SESSION:B?he(B):"",WORKBENCH_WEB_BASE_URL:ae+this._staticRoute,WORKBENCH_NLS_BASE_URL:ae+(L?`${L}${L.endsWith("/")?"":"/"}${this._productService.commit}/${this._productService.version}/`:""),BASE:Q,VS_BASE:ae,NLS_CONFIGURATION:he(X)};let x;try{x=(await b.promises.readFile(M)).toString().replace(/\{\{([^}]+)\}\}/g,(W,Z)=>O[Z]??"undefined")}catch{return _.writeHead(404,{"Content-Type":"text/plain"}),_.end("Not found")}const ne=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(x).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=';`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),ue={"Content-Type":"text/html","Content-Security-Policy":ne};return this._connectionToken.type!==0&&(ue["Set-Cookie"]=C.serialize(v.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),_.writeHead(200,ue),_.end(x)}_getScriptCspHashes(se){const _=/<script>([\s\S]+?)<\/script>/img,G=[];let te;for(;te=_.exec(se);){const j=k.createHash("sha256"),he=te[1].replace(/\r\n/g,`
`),J=j.update(Buffer.from(he)).digest().toString("base64");G.push(`'sha256-${J}'`)}return G}async _handleCallback(se){const _=v.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",oe).fsPath,G=(await b.promises.readFile(_)).toString(),te=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(G).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return se.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":te}),se.end(G)}};u=Ae([_e(1,R.IServerEnvironmentService),_e(2,T.ILogService),_e(3,y.IRequestService),_e(4,I.IProductService)],u),e.WebClientServer=u;const m=(Y,se=!1)=>Y.replace(/\/\/+/g,"/").replace(/\/+$/,se?"/":"");e.normalizeUrlPath=m;const P=Y=>{const se=(Y.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(se>1?"../".repeat(se-1):""))};e.relativeRoot=P;const F=Y=>{const se=Y.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+se[se.length-1])};e.relativePath=F;const q=Y=>Y.originalUrl||Y.url;e.getOriginalUrl=q}),define(ve[243],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class t{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.dispose=C.dispose.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=t});var At=this&&this.__classPrivateFieldSet||function(oe,e,b,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,b):D?D.value=b:e.set(oe,b),b},nt=this&&this.__classPrivateFieldGet||function(oe,e,b,t){if(b==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?t:b==="a"?t.call(oe):t?t.value:e.get(oe)};define(ve[118],we([0,1,18,11,88,24,66,15,12,4,23,17,107]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w){"use strict";var v,h,I,y,d,g,c,l,f,r,o,n,i,s,a,u,m,P,F,q,Y,se,_;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function G(N){function A(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(A,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(A,N),Object.setPrototypeOf(A.prototype,N.prototype),A}let te=g=class{constructor(A){v.set(this,void 0),At(this,v,A,"f")}static from(...A){let ee=A;return new g(function(){if(ee){for(const Ee of ee)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ee=void 0}})}dispose(){typeof nt(this,v,"f")=="function"&&(nt(this,v,"f").call(this),At(this,v,void 0,"f"))}};v=new WeakMap,te=g=Ae([G],te),e.Disposable=te;let j=c=class{constructor(A,ee){if(A<0)throw(0,t.illegalArgument)("line must be non-negative");if(ee<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=A,this._character=ee}static Min(...A){if(A.length===0)throw new TypeError;let ee=A[0];for(let Ee=1;Ee<A.length;Ee++){const ze=A[Ee];ze.isBefore(ee)&&(ee=ze)}return ee}static Max(...A){if(A.length===0)throw new TypeError;let ee=A[0];for(let Ee=1;Ee<A.length;Ee++){const ze=A[Ee];ze.isAfter(ee)&&(ee=ze)}return ee}static isPosition(A){if(!A)return!1;if(A instanceof c)return!0;const{line:ee,character:Ee}=A;return typeof ee=="number"&&typeof Ee=="number"}static of(A){if(A instanceof c)return A;if(this.isPosition(A))return new c(A.line,A.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<A._character}isBeforeOrEqual(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<=A._character}isAfter(A){return!this.isBeforeOrEqual(A)}isAfterOrEqual(A){return!this.isBefore(A)}isEqual(A){return this._line===A._line&&this._character===A._character}compareTo(A){return this._line<A._line?-1:this._line>A.line?1:this._character<A._character?-1:this._character>A._character?1:0}translate(A,ee=0){if(A===null||ee===null)throw(0,t.illegalArgument)();let Ee;return typeof A=="undefined"?Ee=0:typeof A=="number"?Ee=A:(Ee=typeof A.lineDelta=="number"?A.lineDelta:0,ee=typeof A.characterDelta=="number"?A.characterDelta:0),Ee===0&&ee===0?this:new c(this.line+Ee,this.character+ee)}with(A,ee=this.character){if(A===null||ee===null)throw(0,t.illegalArgument)();let Ee;return typeof A=="undefined"?Ee=this.line:typeof A=="number"?Ee=A:(Ee=typeof A.line=="number"?A.line:this.line,ee=typeof A.character=="number"?A.character:this.character),Ee===this.line&&ee===this.character?this:new c(Ee,ee)}toJSON(){return{line:this.line,character:this.character}}};j=c=Ae([G],j),e.Position=j;let he=l=class{constructor(A,ee,Ee,ze){let xe,Je;if(typeof A=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof ze=="number"?(xe=new j(A,ee),Je=new j(Ee,ze)):j.isPosition(A)&&j.isPosition(ee)&&(xe=j.of(A),Je=j.of(ee)),!xe||!Je)throw new Error("Invalid arguments");xe.isBefore(Je)?(this._start=xe,this._end=Je):(this._start=Je,this._end=xe)}static isRange(A){return A instanceof l?!0:A?j.isPosition(A.start)&&j.isPosition(A.end):!1}static of(A){if(A instanceof l)return A;if(this.isRange(A))return new l(A.start,A.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(A){return l.isRange(A)?this.contains(A.start)&&this.contains(A.end):j.isPosition(A)?!(j.of(A).isBefore(this._start)||this._end.isBefore(A)):!1}isEqual(A){return this._start.isEqual(A._start)&&this._end.isEqual(A._end)}intersection(A){const ee=j.Max(A.start,this._start),Ee=j.Min(A.end,this._end);if(!ee.isAfter(Ee))return new l(ee,Ee)}union(A){if(this.contains(A))return this;if(A.contains(this))return A;const ee=j.Min(A.start,this._start),Ee=j.Max(A.end,this.end);return new l(ee,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(A,ee=this.end){if(A===null||ee===null)throw(0,t.illegalArgument)();let Ee;return A?j.isPosition(A)?Ee=A:(Ee=A.start||this.start,ee=A.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ee.isEqual(this.end)?this:new l(Ee,ee)}toJSON(){return[this.start,this.end]}};he=l=Ae([G],he),e.Range=he;let J=f=class extends he{constructor(A,ee,Ee,ze){let xe,Je;if(typeof A=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof ze=="number"?(xe=new j(A,ee),Je=new j(Ee,ze)):j.isPosition(A)&&j.isPosition(ee)&&(xe=j.of(A),Je=j.of(ee)),!xe||!Je)throw new Error("Invalid arguments");super(xe,Je);this._anchor=xe,this._active=Je}static isSelection(A){return A instanceof f?!0:A?he.isRange(A)&&j.isPosition(A.anchor)&&j.isPosition(A.active)&&typeof A.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};J=f=Ae([G],J),e.Selection=J;class U{constructor(A,ee,Ee){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,t.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,t.illegalArgument)("connectionToken");this.host=A,this.port=Math.round(ee),this.connectionToken=Ee}}e.ResolvedAuthority=U;class M extends Error{constructor(A,ee=w.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(A);this._message=A,this._code=ee,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static NotAvailable(A,ee){return new M(A,w.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(A){return new M(A,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=M;var B;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var Q;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(Q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ae=r=class{constructor(A,ee){this._range=A,this._newText=ee}static isTextEdit(A){return A instanceof r?!0:A?he.isRange(A)&&typeof A.newText=="string":!1}static replace(A,ee){return new r(A,ee)}static insert(A,ee){return r.replace(new he(A,A),ee)}static delete(A){return r.replace(A,"")}static setEndOfLine(A){const ee=new r(new he(new j(0,0),new j(0,0)),"");return ee.newEol=A,ee}get range(){return this._range}set range(A){if(A&&!he.isRange(A))throw(0,t.illegalArgument)("range");this._range=A}get newText(){return this._newText||""}set newText(A){if(A&&typeof A!="string")throw(0,t.illegalArgument)("newText");this._newText=A}get newEol(){return this._newEol}set newEol(A){if(A&&typeof A!="number")throw(0,t.illegalArgument)("newEol");this._newEol=A}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ae=r=Ae([G],ae),e.TextEdit=ae;let fe=o=class{constructor(A,ee){this.range=A,this.newCells=ee}static isNotebookCellEdit(A){return A instanceof o?!0:A?It.isNotebookRange(A)&&Array.isArray(A.newCells):!1}static replaceCells(A,ee){return new o(A,ee)}static insertCells(A,ee){return new o(new It(A,A),ee)}static deleteCells(A){return new o(A,[])}static updateCellMetadata(A,ee){const Ee=new o(new It(A,A),[]);return Ee.newCellMetadata=ee,Ee}static updateNotebookMetadata(A){const ee=new o(new It(0,0),[]);return ee.newNotebookMetadata=A,ee}};fe=o=Ae([G],fe),e.NotebookEdit=fe;var X;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace",N[N.Snippet=6]="Snippet"})(X=e.FileEditType||(e.FileEditType={}));let re=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(A,ee,Ee,ze){this._edits.push({_type:1,from:A,to:ee,options:Ee,metadata:ze})}createFile(A,ee,Ee){this._edits.push({_type:1,from:void 0,to:A,options:ee,metadata:Ee})}deleteFile(A,ee,Ee){this._edits.push({_type:1,from:A,to:void 0,options:ee,metadata:Ee})}replaceNotebookMetadata(A,ee,Ee){this._edits.push({_type:3,metadata:Ee,uri:A,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(A,ee,Ee,ze,xe){let Je,et,ot=[],ct;if(It.isNotebookRange(ee)&&Rt.isNotebookCellDataArray(Ee)&&!Rt.isNotebookCellDataArray(ze)?(Je=ee.start,et=ee.end,ot=Ee,ct=ze):typeof ee=="number"&&typeof Ee=="number"&&Rt.isNotebookCellDataArray(ze)&&(Je=ee,et=Ee,ot=ze,ct=xe),Je===void 0||et===void 0)throw new Error("Invalid arguments");(Je!==et||ot.length>0)&&this._edits.push({_type:5,uri:A,index:Je,count:et-Je,cells:ot,metadata:ct})}replaceNotebookCellMetadata(A,ee,Ee,ze){this._edits.push({_type:3,metadata:ze,uri:A,edit:{editType:8,index:ee,metadata:Ee}})}replace(A,ee,Ee,ze){typeof Ee=="string"?this._edits.push({_type:2,uri:A,edit:new ae(ee,Ee),metadata:ze}):this._edits.push({_type:6,uri:A,range:ee,edit:Ee,metadata:ze})}insert(A,ee,Ee,ze){this.replace(A,new he(ee,ee),Ee,ze)}delete(A,ee,Ee){this.replace(A,ee,"",Ee)}has(A){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===A.toString())}set(A,ee){if(ee)for(const Ee of ee)Ee&&(fe.isNotebookCellEdit(Ee)?Ee.newCellMetadata?this.replaceNotebookCellMetadata(A,Ee.range.start,Ee.newCellMetadata):Ee.newNotebookMetadata?this.replaceNotebookMetadata(A,Ee.newNotebookMetadata):this.replaceNotebookCells(A,Ee.range,Ee.newCells):this._edits.push({_type:2,uri:A,edit:Ee}));else{for(let Ee=0;Ee<this._edits.length;Ee++){const ze=this._edits[Ee];ze._type===2&&ze.uri.toString()===A.toString()&&(this._edits[Ee]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(A){const ee=[];for(const Ee of this._edits)Ee._type===2&&Ee.uri.toString()===A.toString()&&ee.push(Ee.edit);return ee}entries(){const A=new C.ResourceMap;for(const ee of this._edits)if(ee._type===2){let Ee=A.get(ee.uri);Ee||(Ee=[ee.uri,[]],A.set(ee.uri,Ee)),Ee[1].push(ee.edit)}return[...A.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};re=Ae([G],re),e.WorkspaceEdit=re;let L=n=class{constructor(A){this._tabstop=1,this.value=A||""}static isSnippetString(A){return A instanceof n?!0:A?typeof A.value=="string":!1}static _escape(A){return A.replace(/\$|}|\\/g,"\\$&")}appendText(A){return this.value+=n._escape(A),this}appendTabstop(A=this._tabstop++){return this.value+="$",this.value+=A,this}appendPlaceholder(A,ee=this._tabstop++){if(typeof A=="function"){const Ee=new n;Ee._tabstop=this._tabstop,A(Ee),this._tabstop=Ee._tabstop,A=Ee.value}else A=n._escape(A);return this.value+="${",this.value+=ee,this.value+=":",this.value+=A,this.value+="}",this}appendChoice(A,ee=this._tabstop++){const Ee=A.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(A,ee){if(typeof ee=="function"){const Ee=new n;Ee._tabstop=this._tabstop,ee(Ee),this._tabstop=Ee._tabstop,ee=Ee.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=A,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};L=n=Ae([G],L),e.SnippetString=L;var O;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(O=e.DiagnosticTag||(e.DiagnosticTag={}));var x;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(x=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ne=i=class{constructor(A,ee){if(this.uri=A,ee)if(he.isRange(ee))this.range=he.of(ee);else if(j.isPosition(ee))this.range=new he(ee,ee);else throw new Error("Illegal argument")}static isLocation(A){return A instanceof i?!0:A?he.isRange(A.range)&&E.URI.isUri(A.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ne=i=Ae([G],ne),e.Location=ne;let ue=class{constructor(A,ee){this.location=A,this.message=ee}static is(A){return A?typeof A.message=="string"&&A.location&&he.isRange(A.location.range)&&E.URI.isUri(A.location.uri):!1}static isEqual(A,ee){return A===ee?!0:!A||!ee?!1:A.message===ee.message&&A.location.range.isEqual(ee.location.range)&&A.location.uri.toString()===ee.location.uri.toString()}};ue=Ae([G],ue),e.DiagnosticRelatedInformation=ue;let pe=class{constructor(A,ee,Ee=x.Error){if(!he.isRange(A))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=A,this.message=ee,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(A,ee){return A===ee?!0:!A||!ee?!1:A.message===ee.message&&A.severity===ee.severity&&A.code===ee.code&&A.severity===ee.severity&&A.source===ee.source&&A.range.isEqual(ee.range)&&(0,b.equals)(A.tags,ee.tags)&&(0,b.equals)(A.relatedInformation,ee.relatedInformation,ue.isEqual)}};pe=Ae([G],pe),e.Diagnostic=pe;let W=class{constructor(A,ee){if(!A)throw new Error("Illegal argument, contents must be defined");Array.isArray(A)?this.contents=A:this.contents=[A],this.range=ee}};W=Ae([G],W),e.Hover=W;var Z;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Z=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ie=class{constructor(A,ee=Z.Text){this.range=A,this.kind=ee}toJSON(){return{range:this.range,kind:Z[this.kind]}}};ie=Ae([G],ie),e.DocumentHighlight=ie;var z;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(z=e.SymbolKind||(e.SymbolKind={}));var V;(function(N){N[N.Deprecated=1]="Deprecated"})(V=e.SymbolTag||(e.SymbolTag={}));let $=s=class{constructor(A,ee,Ee,ze,xe){this.name=A,this.kind=ee,this.containerName=xe,typeof Ee=="string"&&(this.containerName=Ee),ze instanceof ne?this.location=ze:Ee instanceof he&&(this.location=new ne(ze,Ee)),s.validate(this)}static validate(A){if(!A.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:z[this.kind],location:this.location,containerName:this.containerName}}};$=s=Ae([G],$),e.SymbolInformation=$;let K=a=class{constructor(A,ee,Ee,ze,xe){this.name=A,this.detail=ee,this.kind=Ee,this.range=ze,this.selectionRange=xe,this.children=[],a.validate(this)}static validate(A){if(!A.name)throw new Error("name must not be falsy");if(!A.range.contains(A.selectionRange))throw new Error("selectionRange must be contained in fullRange");A.children?.forEach(a.validate)}};K=a=Ae([G],K),e.DocumentSymbol=K;var le;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(le=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ge=class{constructor(A,ee){this.title=A,this.kind=ee}};ge=Ae([G],ge),e.CodeAction=ge;let Pe=u=class{constructor(A){this.value=A}append(A){return new u(this.value?this.value+u.sep+A:A)}intersects(A){return this.contains(A)||A.contains(this)}contains(A){return this.value===A.value||A.value.startsWith(this.value+u.sep)}};Pe.sep=".",Pe=u=Ae([G],Pe),e.CodeActionKind=Pe,Pe.Empty=new Pe(""),Pe.QuickFix=Pe.Empty.append("quickfix"),Pe.Refactor=Pe.Empty.append("refactor"),Pe.RefactorExtract=Pe.Refactor.append("extract"),Pe.RefactorInline=Pe.Refactor.append("inline"),Pe.RefactorRewrite=Pe.Refactor.append("rewrite"),Pe.Source=Pe.Empty.append("source"),Pe.SourceOrganizeImports=Pe.Source.append("organizeImports"),Pe.SourceFixAll=Pe.Source.append("fixAll");let Te=class{constructor(A,ee){if(this.range=A,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Te=Ae([G],Te),e.SelectionRange=Te;class Ne{constructor(A,ee,Ee,ze,xe,Je){this.kind=A,this.name=ee,this.detail=Ee,this.uri=ze,this.range=xe,this.selectionRange=Je}}e.CallHierarchyItem=Ne;class Ue{constructor(A,ee){this.fromRanges=ee,this.from=A}}e.CallHierarchyIncomingCall=Ue;class me{constructor(A,ee){this.fromRanges=ee,this.to=A}}e.CallHierarchyOutgoingCall=me;var be;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(be=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ye=class{constructor(A,ee){this.range=A,this.command=ee}get isResolved(){return!!this.command}};ye=Ae([G],ye),e.CodeLens=ye;let Oe=m=class{constructor(A,ee=!1){h.set(this,void 0),At(this,h,new D.MarkdownString(A,{supportThemeIcons:ee}),"f")}static isMarkdownString(A){return A instanceof m?!0:A&&A.appendCodeblock&&A.appendMarkdown&&A.appendText&&A.value!==void 0}get value(){return nt(this,h,"f").value}set value(A){nt(this,h,"f").value=A}get isTrusted(){return nt(this,h,"f").isTrusted}set isTrusted(A){nt(this,h,"f").isTrusted=A}get supportThemeIcons(){return nt(this,h,"f").supportThemeIcons}set supportThemeIcons(A){nt(this,h,"f").supportThemeIcons=A}get supportHtml(){return nt(this,h,"f").supportHtml}set supportHtml(A){nt(this,h,"f").supportHtml=A}get baseUri(){return nt(this,h,"f").baseUri}set baseUri(A){nt(this,h,"f").baseUri=A}appendText(A){return nt(this,h,"f").appendText(A),this}appendMarkdown(A){return nt(this,h,"f").appendMarkdown(A),this}appendCodeblock(A,ee){return nt(this,h,"f").appendCodeblock(ee??"",A),this}};h=new WeakMap,Oe=m=Ae([G],Oe),e.MarkdownString=Oe;let Me=class{constructor(A,ee){this.label=A,this.documentation=ee}};Me=Ae([G],Me),e.ParameterInformation=Me;let Ke=class{constructor(A,ee){this.label=A,this.documentation=ee,this.parameters=[]}};Ke=Ae([G],Ke),e.SignatureInformation=Ke;let $e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};$e=Ae([G],$e),e.SignatureHelp=$e;var Ze;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Ze=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ge;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Ge=e.InlayHintKind||(e.InlayHintKind={}));let je=class{constructor(A){this.value=A}};je=Ae([G],je),e.InlayHintLabelPart=je;let We=class{constructor(A,ee,Ee){this.position=A,this.label=ee,this.kind=Ee}};We=Ae([G],We),e.InlayHint=We;var ce;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ce;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var ke;(function(N){N[N.Deprecated=1]="Deprecated"})(ke=e.CompletionItemTag||(e.CompletionItemTag={}));let Fe=class{constructor(A,ee){this.label=A,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Fe=Ae([G],Fe),e.CompletionItem=Fe;let Re=class{constructor(A=[],ee=!1){this.items=A,this.isIncomplete=ee}};Re=Ae([G],Re),e.CompletionList=Re;let Be=class{constructor(A,ee,Ee){this.insertText=A,this.range=ee,this.command=Ee}};Be=Ae([G],Be),e.InlineSuggestion=Be;let He=class{constructor(A){this.commands=void 0,this.items=A}};He=Ae([G],He),e.InlineSuggestionList=He;let Qe=class{constructor(A,ee,Ee){this.insertText=A,this.range=ee,this.command=Ee}};Qe=Ae([G],Qe),e.InlineSuggestionNew=Qe;let Xe=class{constructor(A,ee){this.items=A,this.commands=ee}};Xe=Ae([G],Xe),e.InlineSuggestionsNew=Xe;var tt;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var it;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(it=e.StatusBarAlignment||(e.StatusBarAlignment={}));var rt;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ut;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ut=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pt;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var yt;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(yt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var _t;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(_t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function A(ee){switch(ee){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=A}(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ht=class{constructor(A,ee){if(ee&&!E.URI.isUri(ee))throw(0,t.illegalArgument)("target");if(!he.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.target=ee}};ht=Ae([G],ht),e.DocumentLink=ht;let Et=class{constructor(A,ee,Ee,ze){this.red=A,this.green=ee,this.blue=Ee,this.alpha=ze}};Et=Ae([G],Et),e.Color=Et;let kt=class{constructor(A,ee){if(ee&&!(ee instanceof Et))throw(0,t.illegalArgument)("color");if(!he.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.color=ee}};kt=Ae([G],kt),e.ColorInformation=kt;let st=class{constructor(A){if(!A||typeof A!="string")throw(0,t.illegalArgument)("label");this.label=A}};st=Ae([G],st),e.ColorPresentation=st;var St;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(St=e.ColorFormat||(e.ColorFormat={}));var dt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(dt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var mt;(function(N){N[N.Unknown=0]="Unknown",N[N.Shutdown=1]="Shutdown",N[N.Process=2]="Process",N[N.User=3]="User",N[N.Extension=4]="Extension"})(mt=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(A,ee,Ee){if(this.startIndex=A,this.length=ee,this.tooltip=Ee,typeof A!="number"||A<0)throw(0,t.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,t.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Se;var Ie;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Ie=e.TerminalLocation||(e.TerminalLocation={}));class de{constructor(A){if(this.options=A,typeof A!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=de;var H;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(H=e.TaskRevealKind||(e.TaskRevealKind={}));var De;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(De=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=P=class{constructor(A,ee){if(this.label=ee,typeof A!="string"||typeof ee!="string")throw(0,t.illegalArgument)("name");this._id=A}static from(A){switch(A){case"clean":return P.Clean;case"build":return P.Build;case"rebuild":return P.Rebuild;case"test":return P.Test;default:return}}get id(){return this._id}};Le.Clean=new P("clean","Clean"),Le.Build=new P("build","Build"),Le.Rebuild=new P("rebuild","Rebuild"),Le.Test=new P("test","Test"),Le=P=Ae([G],Le),e.TaskGroup=Le;function Ye(N){let A="";for(let ee=0;ee<N.length;ee++)A+=N[ee].replace(/,/g,",,")+",";return A}let qe=class{constructor(A,ee,Ee){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=A,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=Ee):this._options=ee)}get process(){return this._process}set process(A){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._process=A}get args(){return this._args}set args(A){Array.isArray(A)||(A=[]),this._args=A}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("process"),this._process!==void 0&&A.push(this._process),this._args&&this._args.length>0)for(const ee of this._args)A.push(ee);return Ye(A)}};qe=Ae([G],qe),e.ProcessExecution=qe;let Ve=class{constructor(A,ee,Ee){if(this._args=[],Array.isArray(ee)){if(!A)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A,this._args=ee,this._options=Ee}else{if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(A){if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A}get command(){return this._command?this._command:""}set command(A){if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A}get args(){return this._args}set args(A){this._args=A||[]}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("shell"),this._commandLine!==void 0&&A.push(this._commandLine),this._command!==void 0&&A.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ee of this._args)A.push(typeof ee=="string"?ee:ee.value);return Ye(A)}};Ve=Ae([G],Ve),e.ShellExecution=Ve;var lt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(lt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class vt{constructor(A){this._callback=A}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(A){this._callback=A}get callback(){return this._callback}}e.CustomExecution=vt;let at=F=class{constructor(A,ee,Ee,ze,xe,Je){this.__deprecated=!1,this._definition=this.definition=A;let et;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=Ee,this.execution=ze,et=xe,this.__deprecated=!0):ee===bt.Global||ee===bt.Workspace?(this.target=ee,this._name=this.name=Ee,this._source=this.source=ze,this.execution=xe,et=Je):(this.target=ee,this._name=this.name=Ee,this._source=this.source=ze,this.execution=xe,et=Je),typeof et=="string"?(this._problemMatchers=[et],this._hasDefinedMatchers=!0):Array.isArray(et)?(this._problemMatchers=et,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(A){this.__id=A}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:F.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ve?this._definition={type:F.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:F.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:F.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(A){if(A==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=A}get scope(){return this._scope}set target(A){this.clear(),this._scope=A}get name(){return this._name}set name(A){if(typeof A!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=A}get execution(){return this._execution}set execution(A){A===null&&(A=void 0),this.clear(),this._execution=A;const ee=this._definition.type;(F.EmptyType===ee||F.ProcessType===ee||F.ShellType===ee||F.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(A){if(Array.isArray(A))this.clear(),this._problemMatchers=A,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(A){A!==!0&&A!==!1&&(A=!1),this.clear(),this._isBackground=A}get source(){return this._source}set source(A){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=A}get group(){return this._group}set group(A){A===null&&(A=void 0),this.clear(),this._group=A}get detail(){return this._detail}set detail(A){A===null&&(A=void 0),this._detail=A}get presentationOptions(){return this._presentationOptions}set presentationOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._presentationOptions=A}get runOptions(){return this._runOptions}set runOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._runOptions=A}};at.ExtensionCallbackType="customExecution",at.ProcessType="process",at.ShellType="shell",at.EmptyType="$empty",at=F=Ae([G],at),e.Task=at;var Ct;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Ct=e.ProgressLocation||(e.ProgressLocation={}));let $t=q=class{constructor(A,ee=Mt.None){this.collapsibleState=ee,E.URI.isUri(A)?this.resourceUri=A:this.label=A}static isTreeItem(A){if(A instanceof q)return!0;const ee=A;if(ee.label!==void 0&&!(0,p.isString)(ee.label)&&!ee.label?.label)return console.log("INVALID tree item, invalid label",ee.label),!1;if(ee.id!==void 0&&!(0,p.isString)(ee.id))return console.log("INVALID tree item, invalid id",ee.id),!1;if(ee.iconPath!==void 0&&!(0,p.isString)(ee.iconPath)&&!E.URI.isUri(ee.iconPath)&&(!ee.iconPath||!(0,p.isString)(ee.iconPath.id))){const Ee=ee.iconPath;if(!Ee||!(0,p.isString)(Ee.light)&&!E.URI.isUri(Ee.light)&&!(0,p.isString)(Ee.dark)&&!E.URI.isUri(Ee.dark))return console.log("INVALID tree item, invalid iconPath",ee.iconPath),!1}return ee.description!==void 0&&!(0,p.isString)(ee.description)&&typeof ee.description!="boolean"?(console.log("INVALID tree item, invalid description",ee.description),!1):ee.resourceUri!==void 0&&!E.URI.isUri(ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ee.resourceUri),!1):ee.tooltip!==void 0&&!(0,p.isString)(ee.tooltip)&&!(ee.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",ee.tooltip),!1):ee.command!==void 0&&!ee.command.command?(console.log("INVALID tree item, invalid command",ee.command),!1):ee.collapsibleState!==void 0&&ee.collapsibleState<Mt.None&&ee.collapsibleState>Mt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ee.collapsibleState),!1):ee.contextValue!==void 0&&!(0,p.isString)(ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",ee.contextValue),!1):ee.accessibilityInformation!==void 0&&!ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ee.accessibilityInformation),!1):!0}};$t=q=Ae([G],$t),e.TreeItem=$t;var Mt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Wt=class{constructor(A){this.value=A}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Wt=Ae([G],Wt),e.DataTransferItem=Wt;let Ht=class{constructor(A){I.set(this,new Map);for(const[ee,Ee]of A??[]){const ze=nt(this,I,"f").get(ee);ze?ze.push(Ee):nt(this,I,"f").set(ee,[Ee])}}get(A){return nt(this,I,"f").get(A)?.[0]}set(A,ee){nt(this,I,"f").set(A,[ee])}forEach(A,ee){for(const[Ee,ze]of nt(this,I,"f"))for(const xe of ze)A.call(ee,xe,Ee,this)}*[(I=new WeakMap,Symbol.iterator)](){for(const[A,ee]of nt(this,I,"f"))for(const Ee of ee)yield[A,Ee]}};Ht=Ae([G],Ht),e.DataTransfer=Ht;let jt=class{constructor(A){this.insertText=A}};jt=Ae([G],jt),e.DocumentDropEdit=jt;let Vt=class{constructor(A){this.insertText=A}};Vt=Ae([G],Vt),e.DocumentPasteEdit=Vt;let Tt=class{constructor(A,ee){this.id=A,this.color=ee}};Tt=Ae([G],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let qt=class{constructor(A){this.id=A}};qt=Ae([G],qt),e.ThemeColor=qt;var En;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(En=e.ConfigurationTarget||(e.ConfigurationTarget={}));let xt=class{constructor(A,ee){if(typeof A!="string"&&(!A||!E.URI.isUri(A)&&!E.URI.isUri(A.uri)))throw(0,t.illegalArgument)("base");if(typeof ee!="string")throw(0,t.illegalArgument)("pattern");typeof A=="string"?this.baseUri=E.URI.file(A):E.URI.isUri(A)?this.baseUri=A:this.baseUri=A.uri,this.pattern=ee}get base(){return this._base}set base(A){this._base=A,this._baseUri=E.URI.file(A)}get baseUri(){return this._baseUri}set baseUri(A){this._baseUri=A,this._base=A.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};xt=Ae([G],xt),e.RelativePattern=xt;let Lt=class{constructor(A,ee,Ee,ze){this.enabled=typeof A=="boolean"?A:!0,typeof ee=="string"&&(this.condition=ee),typeof Ee=="string"&&(this.hitCondition=Ee),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Lt=Ae([G],Lt),e.Breakpoint=Lt;let Gt=class extends Lt{constructor(A,ee,Ee,ze,xe){super(ee,Ee,ze,xe);if(A===null)throw(0,t.illegalArgument)("location");this.location=A}};Gt=Ae([G],Gt),e.SourceBreakpoint=Gt;let Kt=class extends Lt{constructor(A,ee,Ee,ze,xe){super(ee,Ee,ze,xe);this.functionName=A}};Kt=Ae([G],Kt),e.FunctionBreakpoint=Kt;let Qt=class extends Lt{constructor(A,ee,Ee,ze,xe,Je,et){super(ze,xe,Je,et);if(!ee)throw(0,t.illegalArgument)("dataId");this.label=A,this.dataId=ee,this.canPersist=Ee}};Qt=Ae([G],Qt),e.DataBreakpoint=Qt;let Yt=class{constructor(A,ee,Ee){this.command=A,this.args=ee||[],this.options=Ee}};Yt=Ae([G],Yt),e.DebugAdapterExecutable=Yt;let Xt=class{constructor(A,ee){this.port=A,this.host=ee}};Xt=Ae([G],Xt),e.DebugAdapterServer=Xt;let Jt=class{constructor(A){this.path=A}};Jt=Ae([G],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(A){this.implementation=A}};Zt=Ae([G],Zt),e.DebugAdapterInlineImplementation=Zt;let en=class{constructor(A,ee){this.range=A,this.expression=ee}};en=Ae([G],en),e.EvaluatableExpression=en;var Sn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(Sn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var bn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(bn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let tn=class{constructor(A,ee){this.range=A,this.text=ee}};tn=Ae([G],tn),e.InlineValueText=tn;let nn=class{constructor(A,ee,Ee=!0){this.range=A,this.variableName=ee,this.caseSensitiveLookup=Ee}};nn=Ae([G],nn),e.InlineValueVariableLookup=nn;let rn=class{constructor(A,ee){this.range=A,this.expression=ee}};rn=Ae([G],rn),e.InlineValueEvaluatableExpression=rn;let sn=class{constructor(A,ee){this.frameId=A,this.stoppedLocation=ee}};sn=Ae([G],sn),e.InlineValueContext=sn;var Cn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Cn=e.FileChangeType||(e.FileChangeType={}));let on=Y=class extends Error{constructor(A,ee=R.FileSystemProviderErrorCode.Unknown,Ee){super(E.URI.isUri(A)?A.toString(!0):A);this.code=Ee?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Y.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(A){return new Y(A,R.FileSystemProviderErrorCode.FileExists,Y.FileExists)}static FileNotFound(A){return new Y(A,R.FileSystemProviderErrorCode.FileNotFound,Y.FileNotFound)}static FileNotADirectory(A){return new Y(A,R.FileSystemProviderErrorCode.FileNotADirectory,Y.FileNotADirectory)}static FileIsADirectory(A){return new Y(A,R.FileSystemProviderErrorCode.FileIsADirectory,Y.FileIsADirectory)}static NoPermissions(A){return new Y(A,R.FileSystemProviderErrorCode.NoPermissions,Y.NoPermissions)}static Unavailable(A){return new Y(A,R.FileSystemProviderErrorCode.Unavailable,Y.Unavailable)}};on=Y=Ae([G],on),e.FileSystemError=on;let an=class{constructor(A,ee,Ee){this.start=A,this.end=ee,this.kind=Ee}};an=Ae([G],an),e.FoldingRange=an;var In;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(In=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Dn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Dn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Pn=e.CommentMode||(e.CommentMode={}));var kn;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(kn=e.CommentThreadState||(e.CommentThreadState={}));class Tn{constructor(A,ee=[]){this.tokenTypes=A,this.tokenModifiers=ee}}e.SemanticTokensLegend=Tn;function Rn(N){return typeof N=="undefined"||(0,p.isStringArray)(N)}class ln{constructor(A){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,A){this._hasLegend=!0;for(let ee=0,Ee=A.tokenTypes.length;ee<Ee;ee++)this._tokenTypeStrToInt.set(A.tokenTypes[ee],ee);for(let ee=0,Ee=A.tokenModifiers.length;ee<Ee;ee++)this._tokenModifierStrToInt.set(A.tokenModifiers[ee],ee)}}push(A,ee,Ee,ze,xe){if(typeof A=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof ze=="number"&&(typeof xe=="number"||typeof xe=="undefined"))return typeof xe=="undefined"&&(xe=0),this._pushEncoded(A,ee,Ee,ze,xe);if(he.isRange(A)&&typeof ee=="string"&&Rn(Ee))return this._push(A,ee,Ee);throw(0,t.illegalArgument)()}_push(A,ee,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(A.start.line!==A.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const ze=A.start.line,xe=A.start.character,Je=A.end.character-A.start.character,et=this._tokenTypeStrToInt.get(ee);let ot=0;if(Ee)for(const ct of Ee){if(!this._tokenModifierStrToInt.has(ct))throw new Error("`tokenModifier` is not in the provided legend");const pt=this._tokenModifierStrToInt.get(ct);ot|=1<<pt>>>0}this._pushEncoded(ze,xe,Je,et,ot)}_pushEncoded(A,ee,Ee,ze,xe){if(this._dataIsSortedAndDeltaEncoded&&(A<this._prevLine||A===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const ot=this._data.length/5|0;let ct=0,pt=0;for(let wt=0;wt<ot;wt++){let Dt=this._data[5*wt],Ot=this._data[5*wt+1];Dt===0?(Dt=ct,Ot+=pt):Dt+=ct,this._data[5*wt]=Dt,this._data[5*wt+1]=Ot,ct=Dt,pt=Ot}}let Je=A,et=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Je-=this._prevLine,Je===0&&(et-=this._prevChar)),this._data[this._dataLen++]=Je,this._data[this._dataLen++]=et,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=xe,this._prevLine=A,this._prevChar=ee}static _sortAndDeltaEncode(A){const ee=[],Ee=A.length/5|0;for(let et=0;et<Ee;et++)ee[et]=et;ee.sort((et,ot)=>{const ct=A[5*et],pt=A[5*ot];if(ct===pt){const wt=A[5*et+1],Dt=A[5*ot+1];return wt-Dt}return ct-pt});const ze=new Uint32Array(A.length);let xe=0,Je=0;for(let et=0;et<Ee;et++){const ot=5*ee[et],ct=A[ot+0],pt=A[ot+1],wt=A[ot+2],Dt=A[ot+3],Ot=A[ot+4],yn=ct-xe,hi=yn===0?pt-Je:pt,Nt=5*et;ze[Nt+0]=yn,ze[Nt+1]=hi,ze[Nt+2]=wt,ze[Nt+3]=Dt,ze[Nt+4]=Ot,xe=ct,Je=pt}return ze}build(A){return this._dataIsSortedAndDeltaEncoded?new cn(new Uint32Array(this._data),A):new cn(ln._sortAndDeltaEncode(this._data),A)}}e.SemanticTokensBuilder=ln;class cn{constructor(A,ee){this.resultId=ee,this.data=A}}e.SemanticTokens=cn;class An{constructor(A,ee,Ee){this.start=A,this.deleteCount=ee,this.data=Ee}}e.SemanticTokensEdit=An;class _n{constructor(A,ee){this.resultId=ee,this.edits=A}}e.SemanticTokensEdits=_n;var Ln;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Ln=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Ut=class{constructor(){}};Ut.Back={iconPath:new Tt("arrow-left")},Ut=Ae([G],Ut),e.QuickInputButtons=Ut;var Fn;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(Fn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var On;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(On=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Nn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Nn=e.ExtensionKind||(e.ExtensionKind={}));class Mn{constructor(A,ee,Ee){this.badge=A,this.tooltip=ee,this.color=Ee}static validate(A){if(A.badge){let ee=(0,S.nextCharLength)(A.badge,0);if(ee<A.badge.length&&(ee+=(0,S.nextCharLength)(A.badge,ee)),A.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!A.color&&!A.badge&&!A.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Mn;let un=class{constructor(A){this.kind=A}};un=Ae([G],un),e.ColorTheme=un;var Un;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(Un=e.ColorThemeKind||(e.ColorThemeKind={}));class It{constructor(A,ee){if(A<0)throw(0,t.illegalArgument)("start must be positive");if(ee<0)throw(0,t.illegalArgument)("end must be positive");A<=ee?(this._start=A,this._end=ee):(this._start=ee,this._end=A)}static isNotebookRange(A){return A instanceof It?!0:A?typeof A.start=="number"&&typeof A.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(A){let ee=this._start,Ee=this._end;return A.start!==void 0&&(ee=A.start),A.end!==void 0&&(Ee=A.end),ee===this._start&&Ee===this._end?this:new It(ee,Ee)}}e.NotebookRange=It;class Rt{constructor(A,ee,Ee,ze,xe,Je,et){this.kind=A,this.value=ee,this.languageId=Ee,this.mime=ze,this.outputs=xe??[],this.metadata=Je,this.executionSummary=et,Rt.validate(this)}static validate(A){if(typeof A.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof A.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof A.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(A){return Array.isArray(A)&&A.every(ee=>Rt.isNotebookCellData(ee))}static isNotebookCellData(A){return!0}}e.NotebookCellData=Rt;class Bn{constructor(A){this.cells=A}}e.NotebookData=Bn;class gt{constructor(A,ee){this.data=A,this.mime=ee;const Ee=(0,k.normalizeMimeType)(ee,!0);if(!Ee)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(A){return A instanceof gt?!0:A?typeof A.mime=="string"&&A.data instanceof Uint8Array:!1}static error(A){const ee={name:A.name,message:A.message,stack:A.stack};return gt.json(ee,"application/vnd.code.notebook.error")}static stdout(A){return gt.text(A,"application/vnd.code.notebook.stdout")}static stderr(A){return gt.text(A,"application/vnd.code.notebook.stderr")}static bytes(A,ee="application/octet-stream"){return new gt(A,ee)}static text(A,ee=k.Mimes.text){const Ee=nt(gt,y,"f",d).encode(String(A));return new gt(Ee,ee)}static json(A,ee="text/x-json"){const Ee=JSON.stringify(A,void 0,"	");return gt.text(Ee,ee)}}e.NotebookCellOutputItem=gt,y=gt,d={value:new TextEncoder};class Bt{constructor(A,ee,Ee){this.items=Bt.ensureUniqueMimeTypes(A,!0),typeof ee=="string"?(this.id=ee,this.metadata=Ee):(this.id=(0,T.generateUuid)(),this.metadata=ee??Ee)}static isNotebookCellOutput(A){return A instanceof Bt?!0:!A||typeof A!="object"?!1:typeof A.id=="string"&&Array.isArray(A.items)}static ensureUniqueMimeTypes(A,ee=!1){const Ee=new Set,ze=new Set;for(let xe=0;xe<A.length;xe++){const Je=A[xe],et=(0,k.normalizeMimeType)(Je.mime);if(!Ee.has(et)){Ee.add(et);continue}ze.add(xe),ee&&console.warn(`DUPLICATED mime type '${Je.mime}' will be dropped`)}return ze.size===0?A:A.filter((xe,Je)=>!ze.has(Je))}}e.NotebookCellOutput=Bt;var zn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(zn=e.NotebookCellKind||(e.NotebookCellKind={}));var $n;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})($n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Wn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Wn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Hn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Hn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class jn{constructor(A,ee){this.text=A,this.alignment=ee}}e.NotebookCellStatusBarItem=jn;var Vn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Vn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class qn{constructor(A,ee=[]){this.uri=A,this.provides=(0,b.asArray)(ee)}}e.NotebookRendererScript=qn;let fn=class{constructor(A,ee){this.label=A,this.timestamp=ee}};fn=Ae([G],fn),e.TimelineItem=fn;var xn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(xn=e.ExtensionMode||(e.ExtensionMode={}));var Gn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Gn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Kn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(Kn=e.StandardTokenType||(e.StandardTokenType={}));class Qn{constructor(A,ee){this.ranges=A,this.wordPattern=ee}}e.LinkedEditingRanges=Qn;class Yn{constructor(A,ee){this._port=A,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Yn;var Xn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Xn=e.TestResultState||(e.TestResultState={}));var Jn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Jn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let hn=class{constructor(A=void 0,ee=void 0,Ee=void 0){this.include=A,this.exclude=ee,this.profile=Ee}};hn=Ae([G],hn),e.TestRunRequest=hn;let dn=se=class{constructor(A){this.message=A}static diff(A,ee,Ee){const ze=new se(A);return ze.expectedOutput=ee,ze.actualOutput=Ee,ze}};dn=se=Ae([G],dn),e.TestMessage=dn;let mn=class{constructor(A){this.id=A}};mn=Ae([G],mn),e.TestTag=mn;let Ft=class{constructor(A,ee){this.covered=A,this.total=ee}};Ft=Ae([G],Ft),e.CoveredCount=Ft;let gn=_=class{constructor(A,ee,Ee,ze){this.uri=A,this.statementCoverage=ee,this.branchCoverage=Ee,this.functionCoverage=ze}static fromDetails(A,ee){const Ee=new Ft(0,0),ze=new Ft(0,0),xe=new Ft(0,0);for(const et of ee)if("branches"in et){Ee.total+=1,Ee.covered+=et.executionCount>0?1:0;for(const ot of et.branches)ze.total+=1,ze.covered+=ot.executionCount>0?1:0}else xe.total+=1,xe.covered+=et.executionCount>0?1:0;const Je=new _(A,Ee,ze.total>0?ze:void 0,xe.total>0?xe:void 0);return Je.detailedCoverage=ee,Je}};gn=_=Ae([G],gn),e.FileCoverage=gn;let pn=class{constructor(A,ee,Ee=[]){this.executionCount=A,this.location=ee,this.branches=Ee}};pn=Ae([G],pn),e.StatementCoverage=pn;let vn=class{constructor(A,ee){this.executionCount=A,this.location=ee}};vn=Ae([G],vn),e.BranchCoverage=vn;let wn=class{constructor(A,ee){this.executionCount=A,this.location=ee}};wn=Ae([G],wn),e.FunctionCoverage=wn;var Zn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ei;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(ei=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ti;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(ti=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ni{constructor(A,ee,Ee,ze,xe,Je){this.kind=A,this.name=ee,this.detail=Ee,this.uri=ze,this.range=xe,this.selectionRange=Je}}e.TypeHierarchyItem=ni;class ii{constructor(A){this.uri=A}}e.TextTabInput=ii;class ri{constructor(A,ee){this.original=A,this.modified=ee}}e.TextDiffTabInput=ri;class si{constructor(A,ee,Ee,ze){this.base=A,this.input1=ee,this.input2=Ee,this.result=ze}}e.TextMergeTabInput=si;class oi{constructor(A,ee){this.uri=A,this.viewType=ee}}e.CustomEditorTabInput=oi;class ai{constructor(A){this.viewType=A}}e.WebviewEditorTabInput=ai;class li{constructor(A,ee){this.uri=A,this.notebookType=ee}}e.NotebookEditorTabInput=li;class ci{constructor(A,ee,Ee){this.original=A,this.modified=ee,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=ci;class ui{constructor(){}}e.TerminalEditorTabInput=ui;class fi{constructor(A,ee){this.uri=A,this.inputBoxUri=ee}}e.InteractiveWindowInput=fi}),define(ve[63],we([0,1,69]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(C){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:C,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function D(C){return new b.URITransformer(t(C))}e.createURITransformer=D}),define(ve[244],we([0,1,4,63,61,6,206]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class S extends k.AbstractDiskFileSystemProviderChannel{constructor(T,R){super(new D.DiskFileSystemProvider(T),T);this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(T){let R=this.uriTransformerCache.get(T.remoteAuthority);return R||(R=(0,t.createURITransformer)(T.remoteAuthority),this.uriTransformerCache.set(T.remoteAuthority,R)),R}transformIncoming(T,R,w=!1){if(w&&R.path==="/vscode-resource"&&R.query){const v=JSON.parse(R.query).requestResourcePath;return b.URI.from({scheme:"file",path:v})}return b.URI.revive(T.transformIncoming(R))}createSessionFileWatcher(T,R){return new p(T,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=S;class p extends k.AbstractSessionFileWatcher{constructor(T,R,w,v){super(T,R,w,v)}getRecursiveWatcherOptions(T){const R=T.args["file-watcher-polling"];if(R){const w=R.split(C.delimiter),v=Number(w[0]);if(v>0)return{usePolling:w.length>1?w.slice(1):!0,pollingInterval:v}}}getExtraExcludes(T){if(T.extensionsPath)return[C.posix.join(T.extensionsPath,"**")]}}}),define(ve[80],we([0,1,182,12,4,2,5,33,17,18,8]),function(oe,e,b,t,D,C,k,S,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,b.localize)(0,null),providerDisplayName:(0,b.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(U){U[U.PROGRAMMATIC=1]="PROGRAMMATIC",U[U.USER=2]="USER",U[U.EDIT=3]="EDIT",U[U.NAVIGATION=4]="NAVIGATION",U[U.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var w;(function(U){U[U.IDENTICAL=1]="IDENTICAL",U[U.SIMILAR=2]="SIMILAR",U[U.DIFFERENT=3]="DIFFERENT"})(w=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function v(U){const M=U;return!!M&&typeof M.getSelection=="function"&&!!M.onDidChangeSelection}e.isEditorPaneWithSelection=v;function h(U,M,B){for(const Q of B.visibleEditorPanes)if(Q.group.id===M&&U.matches(Q.input))return Q.getViewState()}e.findViewStateForEditor=h;function I(U){if(i(U))return!1;const M=U;return D.URI.isUri(M?.resource)}e.isResourceEditorInput=I;function y(U){if(i(U))return!1;const M=U;return M?.original!==void 0&&M.modified!==void 0}e.isResourceDiffEditorInput=y;function d(U){if(i(U)||y(U))return!1;const M=U;return M?.primary!==void 0&&M.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function g(U){if(i(U))return!1;const M=U;return M?M.resource===void 0||M.resource.scheme===T.Schemas.untitled||M.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;function c(U){if(i(U))return!1;const M=U;return D.URI.isUri(M?.base?.resource)&&D.URI.isUri(M?.input1?.resource)&&D.URI.isUri(M?.input2?.resource)&&D.URI.isUri(M?.result?.resource)}e.isResourceMergeEditorInput=c;var l;(function(U){U[U.SHORT=0]="SHORT",U[U.MEDIUM=1]="MEDIUM",U[U.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var f;(function(U){U[U.EXPLICIT=1]="EXPLICIT",U[U.AUTO=2]="AUTO",U[U.FOCUS_CHANGE=3]="FOCUS_CHANGE",U[U.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.mapIdToSaveSource=new Map}registerSource(M,B){let Q=this.mapIdToSaveSource.get(M);return Q||(Q={source:M,label:B},this.mapIdToSaveSource.set(M,Q)),Q.source}getSourceLabel(M){return this.mapIdToSaveSource.get(M)?.label??M}}e.SaveSourceRegistry=new r;var o;(function(U){U[U.None=0]="None",U[U.Readonly=2]="Readonly",U[U.Untitled=4]="Untitled",U[U.Singleton=8]="Singleton",U[U.RequiresTrust=16]="RequiresTrust",U[U.CanSplitInGroup=32]="CanSplitInGroup",U[U.ForceDescription=64]="ForceDescription",U[U.CanDropIntoEditor=128]="CanDropIntoEditor",U[U.MultipleEditors=256]="MultipleEditors"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends C.Disposable{}e.AbstractEditorInput=n;function i(U){return U instanceof n}e.isEditorInput=i;function s(U){const M=U;return D.URI.isUri(M?.preferredResource)}function a(U){const M=U;return i(M?.primary)&&i(M?.secondary)}e.isSideBySideEditorInput=a;function u(U){const M=U;return i(M?.modified)&&i(M?.original)}e.isDiffEditorInput=u;function m(U){return i(U?.editor)}e.isEditorInputWithOptions=m;function P(U){const M=U;return m(U)&&M?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function F(U){const M=U;return typeof M?.groupId=="number"&&i(M.editor)}e.isEditorIdentifier=F;var q;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.REPLACE=1]="REPLACE",U[U.MOVE=2]="MOVE",U[U.UNPIN=3]="UNPIN"})(q=e.EditorCloseContext||(e.EditorCloseContext={}));var Y;(function(U){U[U.GROUP_ACTIVE=0]="GROUP_ACTIVE",U[U.GROUP_INDEX=1]="GROUP_INDEX",U[U.GROUP_LOCKED=2]="GROUP_LOCKED",U[U.EDITOR_OPEN=3]="EDITOR_OPEN",U[U.EDITOR_CLOSE=4]="EDITOR_CLOSE",U[U.EDITOR_MOVE=5]="EDITOR_MOVE",U[U.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",U[U.EDITOR_LABEL=7]="EDITOR_LABEL",U[U.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",U[U.EDITOR_PIN=9]="EDITOR_PIN",U[U.EDITOR_STICKY=10]="EDITOR_STICKY",U[U.EDITOR_DIRTY=11]="EDITOR_DIRTY",U[U.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(Y=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var se;(function(U){U[U.PRIMARY=1]="PRIMARY",U[U.SECONDARY=2]="SECONDARY",U[U.BOTH=3]="BOTH",U[U.ANY=4]="ANY"})(se=e.SideBySideEditor||(e.SideBySideEditor={}));class _{getOriginalUri(M,B){if(!M)return;if(c(M))return e.EditorResourceAccessor.getOriginalUri(M.result,B);if(B?.supportSideBySide){const{primary:ae,secondary:fe}=this.getSideEditors(M);if(ae&&fe){if(B?.supportSideBySide===se.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(fe,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===se.ANY)return this.getOriginalUri(ae,{filterByScheme:B.filterByScheme})??this.getOriginalUri(fe,{filterByScheme:B.filterByScheme});M=B.supportSideBySide===se.PRIMARY?ae:fe}}if(y(M)||d(M)||c(M))return;const Q=s(M)?M.preferredResource:M.resource;return!Q||!B||!B.filterByScheme?Q:this.filterUri(Q,B.filterByScheme)}getSideEditors(M){return a(M)||d(M)?{primary:M.primary,secondary:M.secondary}:u(M)||y(M)?{primary:M.modified,secondary:M.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(M,B){if(!M)return;if(c(M))return e.EditorResourceAccessor.getCanonicalUri(M.result,B);if(B?.supportSideBySide){const{primary:ae,secondary:fe}=this.getSideEditors(M);if(ae&&fe){if(B?.supportSideBySide===se.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(fe,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===se.ANY)return this.getCanonicalUri(ae,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(fe,{filterByScheme:B.filterByScheme});M=B.supportSideBySide===se.PRIMARY?ae:fe}}if(y(M)||d(M)||c(M))return;const Q=M.resource;return!Q||!B||!B.filterByScheme?Q:this.filterUri(Q,B.filterByScheme)}filterUri(M,B){if(Array.isArray(B)){if(B.some(Q=>M.scheme===Q))return M}else if(B===M.scheme)return M}}e.EditorResourceAccessor=new _;var G;(function(U){U[U.LEFT=0]="LEFT",U[U.RIGHT=1]="RIGHT"})(G=e.CloseDirection||(e.CloseDirection={}));class te{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(M){const B=this.instantiationService=M.get(k.IInstantiationService);for(const[Q,ae]of this.editorSerializerConstructors)this.createEditorSerializer(Q,ae,B);this.editorSerializerConstructors.clear()}createEditorSerializer(M,B,Q){const ae=Q.createInstance(B);this.editorSerializerInstances.set(M,ae)}registerFileEditorFactory(M){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=M}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(M,B){if(this.editorSerializerConstructors.has(M)||this.editorSerializerInstances.has(M))throw new Error(`A editor serializer with type ID '${M}' was already registered.`);return this.instantiationService?this.createEditorSerializer(M,B,this.instantiationService):this.editorSerializerConstructors.set(M,B),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(M),this.editorSerializerInstances.delete(M)})}getEditorSerializer(M){return this.editorSerializerInstances.get(typeof M=="string"?M:M.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new te);async function j(U,M){if(!U||!U.length)return[];const B=await Promise.all(U.map(async Q=>{const ae=D.URI.revive(Q.fileUri);if(!ae||!await M.canHandleResource(ae))return;let X=Q.exists,re=Q.type;if(typeof X!="boolean"||typeof re!="number")try{re=(await M.stat(ae)).isDirectory?p.FileType.Directory:p.FileType.Unknown,X=!0}catch{X=!1}if(!X&&Q.openOnlyIfExists||re===p.FileType.Directory)return;const L={...Q.options,pinned:!0};let O;return X?O={resource:ae,options:L}:O={resource:ae,options:L,forceUntitled:!0},O}));return(0,E.coalesce)(B)}e.pathsToEditors=j;var he;(function(U){U[U.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",U[U.SEQUENTIAL=1]="SEQUENTIAL"})(he=e.EditorsOrder||(e.EditorsOrder={}));function J(U){const M=U;if(!M)return!1;const B=M;if(B.modified)return J(B.modified);const Q=M;return!!(Q.contributionsState&&Q.viewState&&Array.isArray(Q.cursorState))}e.isTextEditorViewState=J}),define(ve[245],we([0,1,16,68,45,66,8,6,3,99]),function(oe,e,b,t,D,C,k,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var T;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",C.Mimes.latex,C.Mimes.markdown,"image/png","image/jpeg",C.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[C.Mimes.latex,C.Mimes.markdown,"application/json",C.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(a){a[a.Unconfirmed=1]="Unconfirmed",a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var I;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeCellLanguage=5]="ChangeCellLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var y;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(y=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var g;(function(a){a.scheme=k.Schemas.vscodeNotebookCell;const u=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${u.join("")}]+`),P=7;function F(j,he){const J=he.toString(P),M=`${J.length<u.length?u[J.length-1]:"z"}${J}s${(0,b.encodeBase64)(b.VSBuffer.fromString(j.scheme),!0,!0)}`;return j.with({scheme:a.scheme,fragment:M})}a.generate=F;function q(j){if(j.scheme!==a.scheme)return;const he=j.fragment.indexOf("s");if(he<0)return;const J=parseInt(j.fragment.substring(0,he).replace(m,""),P),U=(0,b.decodeBase64)(j.fragment.substring(he+1)).toString();if(!isNaN(J))return{handle:J,notebook:j.with({scheme:U,fragment:null})}}a.parse=q;const Y=/^(\d{8,})(\w[\w\d+.-]*)$/;function se(j,he){return j.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${he??""},${j.scheme!==k.Schemas.file?j.scheme:""}`})}a.generateCellOutputUri=se;function _(j){if(j.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const he=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(j.fragment);if(!he)return;const J=he[1]&&he[1]!==""?he[1]:void 0,U=he[2];return{outputId:J,notebook:j.with({scheme:U||k.Schemas.file,fragment:null})}}a.parseCellOutputUri=_;function G(j,he,J){return j.with({scheme:J,fragment:`ch${he.toString().padStart(7,"0")}${j.scheme!==k.Schemas.file?j.scheme:""}`})}a.generateCellUri=G;function te(j,he){if(j.scheme!==he)return;const J=Y.exec(j.fragment);return J?{handle:Number(J[1]),notebook:j.with({scheme:j.fragment.substring(J[0].length)||k.Schemas.file,fragment:null})}:void 0}a.parseCellUri=te})(g=e.CellUri||(e.CellUri={}));const c=a=>p.isWindows?a.replace(/\//g,"\\"):a;class l{constructor(u=[],m=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=m,this.order=[...new Set(u)].map(P=>({pattern:P,matches:t.parse(c(P))}))}sort(u){const m=new Map(D.Iterable.map(u,F=>[F,c(F)]));let P=[];for(const{matches:F}of this.order)for(const[q,Y]of m)if(F(Y)){P.push(q),m.delete(q);break}return m.size&&(P=P.concat([...m.keys()].sort((F,q)=>this.defaultOrder.indexOf(F)-this.defaultOrder.indexOf(q)))),P}prioritize(u,m){const P=this.findIndex(u);if(P===-1){this.order.unshift({pattern:u,matches:t.parse(c(u))});return}const F=new Set(m.map(Y=>this.findIndex(Y,P)));F.delete(-1);const q=Array.from(F).sort();this.order.splice(P+1,0,...q.map(Y=>this.order[Y]));for(let Y=q.length-1;Y>=0;Y--)this.order.splice(q[Y],1)}toArray(){return this.order.map(u=>u.pattern)}findIndex(u,m=this.order.length){const P=c(u);for(let F=0;F<m;F++)if(this.order[F].matches(P))return F;return-1}}e.MimeTypeDisplayOrder=l;function f(a,u,m,P=(F,q)=>F===q){const F=[];function q(_,G,te){if(G===0&&te.length===0)return;const j=F[F.length-1];j&&j.start+j.deleteCount===_?(j.deleteCount+=G,j.toInsert.push(...te)):F.push({start:_,deleteCount:G,toInsert:te})}let Y=0,se=0;for(;;){if(Y===a.length){q(Y,0,u.slice(se));break}if(se===u.length){q(Y,a.length-Y,[]);break}const _=a[Y],G=u[se];if(P(_,G)){Y+=1,se+=1;continue}m(G)?(q(Y,1,[]),Y+=1):(q(Y,0,[G]),se+=1)}return F}e.diff=f,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(a){a.default="default",a.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(a){const u=a;return!!((typeof u.include=="string"||t.isRelativePattern(u.include))&&(typeof u.exclude=="string"||t.isRelativePattern(u.exclude)))}e.isDocumentExcludePattern=o;function n(a,u,m){if(Array.isArray(a.viewType)&&a.viewType.indexOf(u)>=0||a.viewType===u)return!0;if(a.filenamePattern){const P=o(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,F=o(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(t.match(P,(0,S.basename)(m.fsPath).toLowerCase()))return!(F&&t.match(F,(0,S.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(u){return`${s._prefix}${u}`}static parse(u){if(u.startsWith(s._prefix))return u.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(ve[119],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,b.createDecorator)("environmentVariableService");var t;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ve[246],we([0,1,3,119]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class D{constructor(p){this.collections=p,this.map=new Map,p.forEach((E,T)=>{const R=E.map.entries();let w=R.next();for(;!w.done;){const v=w.value[0];let h=this.map.get(v);if(h||(h=[],this.map.set(v,h)),h.length>0&&h[0].type===t.EnvironmentVariableMutatorType.Replace){w=R.next();continue}const I=w.value[1];h.unshift({extensionIdentifier:T,value:I.value,type:I.type}),w=R.next()}})}async applyToProcessEnvironment(p,E){let T;b.isWindows&&(T={},Object.keys(p).forEach(R=>T[R.toLowerCase()]=R));for(const[R,w]of this.map){const v=b.isWindows&&T[R.toLowerCase()]||R;for(const h of w){const I=E?await E(h.value):h.value;switch(h.type){case t.EnvironmentVariableMutatorType.Append:p[v]=(p[v]||"")+I;break;case t.EnvironmentVariableMutatorType.Prepend:p[v]=I+(p[v]||"");break;case t.EnvironmentVariableMutatorType.Replace:p[v]=I;break}}}}diff(p){const E=new Map,T=new Map,R=new Map;if(p.map.forEach((w,v)=>{const h=this.map.get(v),I=C(w,h);I&&E.set(v,I)}),this.map.forEach((w,v)=>{const h=p.map.get(v),I=C(w,h);I&&R.set(v,I)}),this.map.forEach((w,v)=>{const h=p.map.get(v),I=k(w,h);I&&T.set(v,I)}),!(E.size===0&&T.size===0&&R.size===0))return{added:E,changed:T,removed:R}}}e.MergedEnvironmentVariableCollection=D;function C(S,p){if(!p)return S;const E=new Set;p.forEach(R=>E.add(R.extensionIdentifier));const T=[];return S.forEach(R=>{E.has(R.extensionIdentifier)||T.push(R)}),T.length===0?void 0:T}function k(S,p){if(!p)return;const E=new Map;p.forEach(R=>E.set(R.extensionIdentifier,R));const T=[];return S.forEach(R=>{const w=E.get(R.extensionIdentifier);w&&(R.type!==w.type||R.value!==w.value)&&T.push(w)}),T.length===0?void 0:T}}),define(ve[120],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=b;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t;function D(k){return Array.from(k.entries()).map(S=>[S[0],b(S[1].map)])}e.serializeEnvironmentVariableCollections=D;function C(k){return new Map(k.map(S=>[S[0],{map:t(S[1])}]))}e.deserializeEnvironmentVariableCollections=C}),define(ve[247],we([0,1,6,56,3]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function C(l,f){if(!!f)if(D.isWindows)for(const r in f){let o=r;for(const i in l)if(r.toLowerCase()===i.toLowerCase()){o=i;break}const n=f[r];n!==void 0&&k(l,o,n)}else Object.keys(f).forEach(r=>{const o=f[r];o!==void 0&&k(l,r,o)})}e.mergeEnvironments=C;function k(l,f,r){typeof r=="string"?l[f]=r:delete l[f]}function S(l,f,r,o){l.TERM_PROGRAM="vscode",f&&(l.TERM_PROGRAM_VERSION=f),T(l,o)&&(l.LANG=R(r)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=S;function p(l,f){if(!!f)for(const r of Object.keys(f)){const o=f[r];o&&(l[r]=o)}}async function E(l,f){return await Promise.all(Object.entries(f).map(async([r,o])=>{if(typeof o=="string")try{f[r]=await l(o)}catch{f[r]=o}})),f}function T(l,f){if(f==="on")return!0;if(f==="auto"){const r=l.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function R(l){const f=l?l.split("-"):[],r=f.length;if(r===0)return"en_US.UTF-8";if(r===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};f[0]in o&&f.push(o[f[0]])}else f[1]=f[1].toUpperCase();return f.join("_")+".UTF-8"}e.getLangEnvVariable=R;async function w(l,f,r,o,n,i){if(l.cwd){const a=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,u=await v(a,r);return h(u||a)}let s;return!l.ignoreConfigurationCwd&&n&&(r&&(n=await v(n,r,i)),n&&(b.isAbsolute(n)?s=n:o&&(s=b.join(o.fsPath,n)))),s||(s=o?o.fsPath:f||""),h(s)}e.getCwd=w;async function v(l,f,r){if(f)try{return await f(l)}catch(o){r?.error("Could not resolve terminal cwd",o);return}return l}function h(l){return D.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function I(l,f,r){if(!!r)return o=>r.resolveWithEnvironment(f,l,o)}e.createVariableResolver=I;async function y(l,f,r,o,n,i,s,a=D.platform){let u;s&&(u=g(l,"automationShell",a)),u||(u=g(l,"shell",a));let m=u||f;if(a===3&&!r&&o){const P=b.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();m&&m.toLowerCase().indexOf(P)===0&&(m=b.join(o,"System32",m.substr(P.length+1)))}if(m&&a===3&&(m=m.replace(/\//g,"\\")),n)try{m=await n(m)}catch(P){i.error("Could not resolve shell",P)}return m}e.getDefaultShell=y;async function d(l,f,r,o,n=D.platform){if(f&&g(l,"automationShell",n))return[];const i=n===3?"windows":n===1?"osx":"linux";let s=l(`terminal.integrated.shellArgs.${i}`);if(!s)return[];if(typeof s=="string"&&n===3)return r?await r(s):s;if(r){const a=[];for(const u of s)try{a.push(await r(u))}catch(m){o.error(`Could not resolve terminal.integrated.shellArgs.${i}`,m),a.push(u)}s=a}return s}e.getDefaultShellArgs=d;function g(l,f,r=D.platform){return l(`terminal.integrated.${f}.${r===3?"windows":r===1?"osx":"linux"}`)}async function c(l,f,r,o,n,i){const s={};if(l.strictEnv)p(s,l.env);else{p(s,i);const a={...f};r&&(a&&await E(r,a),l.env&&await E(r,l.env)),(0,t.sanitizeProcessEnvironment)(s,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),C(s,a),C(s,l.env),S(s,o,D.locale,n)}return s}e.createTerminalEnvironment=c}),define(ve[81],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var b;(function(C){C.Delimiter="\0"})(b=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{constructor(k,S=k.length){if(this.path=k,this.viewEnd=S,k.length===0||S<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,S,p=k.parent){if(k.id===S)return new D([S]);const E=[k.id];for(let T=p;T&&T.id!==S;T=T.parent)E.push(T.id);return E.push(S),new D(E.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const S=k.indexOf("\0");return S===-1?k:k.slice(0,S)}static fromString(k){return new D(k.split("\0"))}static join(k,S){return new D([...k.path,S])}static joinToString(k,S){return k.toString()+"\0"+S}static compare(k,S){return k===S?0:S.startsWith(k+"\0")?2:k.startsWith(S+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new D(this.path,k)}compare(k){if(typeof k=="string")return D.compare(this.toString(),k);for(let S=0;S<k.viewEnd&&S<this.viewEnd;S++)if(k.path[S]!==this.path[S])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=D}),define(ve[82],we([0,1,4,49]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var C;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(s){s.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),s.deserialize=a=>({range:t.Range.lift(a.range),uri:b.URI.revive(a.uri)})})(k=e.IRichLocation||(e.IRichLocation={}));var S;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var p;(function(s){s.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&k.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&k.deserialize(a.location)})})(p=e.ITestErrorMessage||(e.ITestErrorMessage={}));var E;(function(s){s.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&k.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&k.deserialize(a.location)})})(E=e.ITestOutputMessage||(e.ITestOutputMessage={}));var T;(function(s){s.serialize=a=>a.type===0?p.serialize(a):E.serialize(a),s.deserialize=a=>a.type===0?p.deserialize(a):E.deserialize(a)})(T=e.ITestMessage||(e.ITestMessage={}));var R;(function(s){s.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),s.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(T.serialize)}),s.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(T.deserialize)})})(R=e.ITestTaskState||(e.ITestTaskState={}));const w="\0",v=(s,a)=>s+w+a;e.namespaceTestTag=v;const h=s=>{const a=s.indexOf(w);return{ctrlId:s.slice(0,a),tagId:s.slice(a+1)}};e.denamespaceTestTag=h;var I;(function(s){s.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),s.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?b.URI.revive(a.uri):void 0,range:a.range?t.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(I=e.ITestItem||(e.ITestItem={}));var y;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));var d;(function(s){s.serialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:I.serialize(a.item)}),s.deserialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:I.deserialize(a.item)})})(d=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(s){s.serialize=a=>{let u;return a.item&&(u={},a.item.label!==void 0&&(u.label=a.item.label),a.item.tags!==void 0&&(u.tags=a.item.tags),a.item.busy!==void 0&&(u.busy=a.item.busy),a.item.uri!==void 0&&(u.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(u.range=a.item.range?.toJSON()),a.item.description!==void 0&&(u.description=a.item.description),a.item.error!==void 0&&(u.error=a.item.error),a.item.sortText!==void 0&&(u.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:u}},s.deserialize=a=>{let u;return a.item&&(u={},a.item.label!==void 0&&(u.label=a.item.label),a.item.tags!==void 0&&(u.tags=a.item.tags),a.item.busy!==void 0&&(u.busy=a.item.busy),a.item.range!==void 0&&(u.range=a.item.range?t.Range.lift(a.item.range):null),a.item.description!==void 0&&(u.description=a.item.description),a.item.error!==void 0&&(u.error=a.item.error),a.item.sortText!==void 0&&(u.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:u}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const c=(s,a)=>{a.expand!==void 0&&(s.expand=a.expand),a.item!==void 0&&(s.item=s.item?Object.assign(s.item,a.item):a.item)};e.applyTestItemUpdate=c;var l;(function(s){s.serializeWithoutMessages=a=>({...d.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(R.serializeWithoutMessages),retired:a.retired}),s.serialize=a=>({...d.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(R.serialize),retired:a.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var f;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(f=e.DetailType||(e.DetailType={}));var r;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(s){s.deserialize=a=>a.op===0?{op:a.op,item:d.deserialize(a.item)}:a.op===1?{op:a.op,item:g.deserialize(a.item)}:a,s.serialize=a=>a.op===0?{op:a.op,item:d.serialize(a.item)}:a.op===1?{op:a.op,item:g.serialize(a.item)}:a})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(a){}update(a){}remove(a,u){}complete(){}}e.IncrementalChangeCollector=n;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const u=this.createChangeCollector();for(const m of a)switch(m.op){case 0:{const P=d.deserialize(m.item);if(P.parent){if(this.items.has(P.parent)){const F=this.items.get(P.parent);F.children.add(P.item.extId);const q=this.createItem(P,F);this.items.set(P.item.extId,q),u.add(q)}}else{const F=this.createItem(P);this.roots.add(F),this.items.set(P.item.extId,F),u.add(F)}P.expand===2&&this.busyControllerCount++;break}case 1:{const P=g.deserialize(m.item),F=this.items.get(P.extId);if(!F)break;P.expand!==void 0&&(F.expand===2&&this.busyControllerCount--,P.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(F,P),u.update(F);break}case 2:{const P=this.items.get(m.itemId);if(!P)break;P.parent?this.items.get(P.parent).children.delete(P.item.extId):this.roots.delete(P);const F=[[m.itemId]];for(;F.length;)for(const q of F.pop()){const Y=this.items.get(q);Y&&(F.push(Y.children),this.items.delete(q),u.remove(Y,Y!==P),Y.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}u.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=i}),define(ve[121],we([0,1,14,7,2,83,82,81]),function(oe,e,b,t,D,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk"})(p=e.TestItemEventOp||(e.TestItemEventOp={}));const E=(d,g)=>d===g,T={range:(d,g)=>d===g?!0:!d||!g?!1:d.equalsRange(g),busy:E,label:E,description:E,error:E,tags:(d,g)=>!(d.length!==g.length||d.some(c=>!g.includes(c)))},R=(d,g)=>{let c;for(const[l,f]of Object.entries(T))f(d[l],g[l])||(c?c[l]=g[l]:c={[l]:g[l]});return c};class w extends D.Disposable{constructor(g){super();this.options=g,this.debounceSendDiff=this._register(new b.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(g){this._resolveHandler=g;for(const c of this.tree.values())this.updateExpandability(c)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const c=this.diff[this.diff.length-1];if(c&&g.op===1){if(c.op===1&&c.item.extId===g.item.extId){(0,k.applyTestItemUpdate)(c.item,g.item);return}if(c.op===0&&c.item.item.extId===g.item.extId){(0,k.applyTestItemUpdate)(c.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,c){const l=this.tree.get(g);if(!!l){if((l.expandLevels===void 0||c>l.expandLevels)&&(l.expandLevels=c),l.expand===1){const f=this.resolveChildren(l);return f.isOpen()?this.expandChildren(l,c-1):f.wait().then(()=>this.expandChildren(l,c-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,c-1)):this.expandChildren(l,c-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,c){switch(c.op){case 3:this.removeItem(S.TestId.joinToString(g.fullId,c.id));break;case 0:this.upsertItem(c.item,g);break;case 5:for(const l of c.ops)this.onTestItemEvent(g,l);break;case 1:this.diffTagRefs(c.new,c.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:c.update}});break;default:(0,C.assertNever)(c)}}upsertItem(g,c){const l=S.TestId.fromExtHostTestItem(g,this.root.id,c?.actual),f=this.options.getApiFor(g);f.parent&&f.parent!==c?.actual&&this.options.getChildren(f.parent).delete(g.id);let r=this.tree.get(l.toString());if(!r){r={fullId:l,actual:g,parent:c?l.parentId:null,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(g,c),this.pushDiff({op:0,item:{parent:r.parent&&r.parent.toString(),controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,r,c);return}if(r.actual===g){this.connectItem(g,r,c);return}const o=this.options.getChildren(r.actual),n=r.actual,i=R(this.options.toITestItem(n),this.options.toITestItem(g));this.options.getApiFor(n).listener=void 0,r.actual=g,r.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,n.tags,l.toString()),delete i.tags),this.onTestItemEvent(r,{op:4,update:i})),this.connectItemAndChildren(g,r,c);for(const[s,a]of o)this.options.getChildren(g).get(a.id)||this.removeItem(S.TestId.joinToString(l,a.id))}diffTagRefs(g,c,l){const f=new Set(c.map(r=>r.id));for(const r of g)f.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:l,item:{tags:g.map(r=>(0,k.namespaceTestTag)(this.options.controllerId,r.id))}}}),f.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const c=this.tags.get(g.id);c?c.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,k.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const c=this.tags.get(g);c&&!--c.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,k.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,c){this.options.getApiFor(g).parent=c&&c.actual!==this.root?c.actual:void 0}connectItem(g,c,l){this.setItemParent(g,l);const f=this.options.getApiFor(g);f.parent=l?.actual,f.listener=r=>this.onTestItemEvent(c,r),this.updateExpandability(c)}connectItemAndChildren(g,c,l){this.connectItem(g,c,l);for(const[f,r]of this.options.getChildren(g))this.upsertItem(r,c)}updateExpandability(g){let c;this._resolveHandler?g.resolveBarrier?c=g.resolveBarrier.isOpen()?3:2:c=g.actual.canResolveChildren?1:0:c=0,c!==g.expand&&(g.expand=c,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:c}}),c===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,c){if(c<0)return;const l=[];for(const[f,r]of this.options.getChildren(g.actual)){const o=this.expand(S.TestId.joinToString(g.fullId,r.id),c);(0,b.isThenable)(o)&&l.push(o)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const r=new b.Barrier;return r.open(),r}g.expand=2,this.pushExpandStateUpdate(g);const c=g.resolveBarrier=new b.Barrier,l=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let f;try{f=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(r){l(r)}return(0,b.isThenable)(f)?f.catch(l).then(()=>{c.open(),this.updateExpandability(g)}):(c.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const c=this.tree.get(g);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const l=[c];for(;l.length;){const f=l.pop();if(!!f){this.options.getApiFor(f.actual).listener=void 0;for(const r of f.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(f.fullId.toString());for(const[r,o]of this.options.getChildren(f.actual))l.push(this.tree.get(S.TestId.joinToString(f.fullId,o.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=w;class v extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=v;class h extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class I extends Error{constructor(g,c,l){super(`TestItem with ID "${g}" is from controller "${c}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=I;const y=(d,g,c)=>{let l=new Map;return{get size(){return l.size},forEach(f,r){for(const o of l.values())f.call(r,o,this)},[Symbol.iterator](){return l.entries()},replace(f){const r=new Map,o=new Set(l.keys()),n={op:5,ops:[]};for(const i of f){if(!(i instanceof c))throw new h(i.id);const s=g(i).controllerId;if(s!==d.controllerId)throw new I(i.id,s,d.controllerId);if(r.has(i.id))throw new v(i.id);r.set(i.id,i),o.delete(i.id),n.ops.push({op:0,item:i})}for(const i of o.keys())n.ops.push({op:3,id:i});d.listener?.(n),l=r},add(f){if(!(f instanceof c))throw new h(f.id);l.set(f.id,f),d.listener?.({op:0,item:f})},delete(f){l.delete(f)&&d.listener?.({op:3,id:f})},get(f){return l.get(f)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=y}),define(ve[122],we([0,1,121]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(k,S)=>{const p={controllerId:S};return t.set(k,p),p};e.createPrivateApiFor=D;const C=k=>{const S=t.get(k);if(!S)throw new b.InvalidTestItemError(k?.id||"<unknown>");return S};e.getPrivateApiFor=C}),define(ve[248],we([0,1,25,5]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(b.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ve[123],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,b.createDecorator)("configurationResolverService");var t;(function(C){C.Unknown="unknown",C.Env="env",C.Config="config",C.Command="command",C.Input="input",C.ExtensionInstallFolder="extensionInstallFolder",C.WorkspaceFolder="workspaceFolder",C.Cwd="cwd",C.WorkspaceFolderBasename="workspaceFolderBasename",C.UserHome="userHome",C.LineNumber="lineNumber",C.SelectedText="selectedText",C.File="file",C.FileWorkspaceFolder="fileWorkspaceFolder",C.RelativeFile="relativeFile",C.RelativeFileDirname="relativeFileDirname",C.FileDirname="fileDirname",C.FileExtname="fileExtname",C.FileBasename="fileBasename",C.FileBasenameNoExtension="fileBasenameNoExtension",C.FileDirnameBasename="fileDirnameBasename",C.ExecPath="execPath",C.ExecInstallFolder="execInstallFolder",C.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(k,S){super(S);this.variable=k}}e.VariableError=D}),define(ve[249],we([0,1,6,27,12,22,3,142,183,123,15]),function(oe,e,b,t,D,C,k,S,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(v,h,I,y){this._contributedVariables=new Map,this._context=v,this._labelService=h,this._userHomePromise=I,y&&(this._envVariablesPromise=y.then(d=>this.prepareEnv(d)))}prepareEnv(v){if(k.isWindows){const h=Object.create(null);return Object.keys(v).forEach(I=>{h[I.toLowerCase()]=v[I]}),h}return v}resolveWithEnvironment(v,h,I){return this.recursiveResolve({env:this.prepareEnv(v),userHome:void 0},h?h.uri:void 0,I)}async resolveAsync(v,h){const I={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(I,v?v.uri:void 0,h)}async resolveAnyBase(v,h,I,y){const d=C.deepClone(h);k.isWindows&&d.windows?Object.keys(d.windows).forEach(c=>d[c]=d.windows[c]):k.isMacintosh&&d.osx?Object.keys(d.osx).forEach(c=>d[c]=d.osx[c]):k.isLinux&&d.linux&&Object.keys(d.linux).forEach(c=>d[c]=d.linux[c]),delete d.windows,delete d.osx,delete d.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,v?v.uri:void 0,d,I,y)}async resolveAnyAsync(v,h,I){return this.resolveAnyBase(v,h,I)}async resolveAnyMap(v,h,I){const y=new Map;return{newConfig:await this.resolveAnyBase(v,h,I,y),resolvedVariables:y}}resolveWithInteractionReplace(v,h,I,y){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,h,I,y){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,h){if(this._contributedVariables.has(v))throw new Error("Variable "+v+" is contributed twice.");this._contributedVariables.set(v,h)}async recursiveResolve(v,h,I,y,d){if(D.isString(I))return this.resolveString(v,h,I,y,d);if(Array.isArray(I))return Promise.all(I.map(g=>this.recursiveResolve(v,h,g,y,d)));if(D.isObject(I)){const g=Object.create(null),c=await Promise.all(Object.keys(I).map(async l=>[await this.resolveString(v,h,l,y,d),await this.recursiveResolve(v,h,I[l],y,d)]));for(const[l,f]of c)g[l]=f;return g}return I}resolveString(v,h,I,y,d){return(0,T.replaceAsync)(I,R.VARIABLE_REGEXP,async(g,c)=>{if(c.includes(R.VARIABLE_LHS))return g;let l=await this.evaluateSingleVariable(v,g,c,h,y);return d?.set(c,l),l!==g&&D.isString(l)&&l.match(R.VARIABLE_REGEXP)&&(l=await this.resolveString(v,h,l,y,d)),l})}fsPath(v){return this._labelService?this._labelService.getUriLabel(v,{noPrefix:!0}):v.fsPath}async evaluateSingleVariable(v,h,I,y,d){let g;const c=I.split(":");c.length>1&&(I=c[0],g=c[1]);const l=o=>{const n=this._context.getFilePath();if(n)return n;throw new E.VariableError(o,(0,p.localize)(0,null,h))},f=o=>{const n=l(o);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new E.VariableError(o,(0,p.localize)(1,null,h,b.basename(n)))},r=o=>{if(g){const n=this._context.getFolderUri(g);if(n)return n;throw new E.VariableError(o,(0,p.localize)(2,null,h,g))}if(y)return y;throw this._context.getWorkspaceFolderCount()>1?new E.VariableError(o,(0,p.localize)(3,null,h)):new E.VariableError(o,(0,p.localize)(4,null,h))};switch(I){case"env":if(g){if(v.env){const o=v.env[k.isWindows?g.toLowerCase():g];if(D.isString(o))return o}return""}throw new E.VariableError(E.VariableKind.Env,(0,p.localize)(5,null,h));case"config":if(g){const o=this._context.getConfigurationValue(y,g);if(D.isUndefinedOrNull(o))throw new E.VariableError(E.VariableKind.Config,(0,p.localize)(6,null,h,g));if(D.isObject(o))throw new E.VariableError(E.VariableKind.Config,(0,p.localize)(7,null,h,g));return o}throw new E.VariableError(E.VariableKind.Config,(0,p.localize)(8,null,h));case"command":return this.resolveFromMap(E.VariableKind.Command,h,g,d,"command");case"input":return this.resolveFromMap(E.VariableKind.Input,h,g,d,"input");case"extensionInstallFolder":if(g){const o=await this._context.getExtension(g);if(!o)throw new E.VariableError(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,h,g));return this.fsPath(o.extensionLocation)}throw new E.VariableError(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,h));default:switch(I){case"workspaceRoot":case"workspaceFolder":return(0,S.normalizeDriveLetter)(this.fsPath(r(E.VariableKind.WorkspaceFolder)));case"cwd":return y||g?(0,S.normalizeDriveLetter)(this.fsPath(r(E.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(r(E.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(v.userHome)return v.userHome;throw new E.VariableError(E.VariableKind.UserHome,(0,p.localize)(11,null,h))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new E.VariableError(E.VariableKind.LineNumber,(0,p.localize)(12,null,h))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new E.VariableError(E.VariableKind.SelectedText,(0,p.localize)(13,null,h))}case"file":return l(E.VariableKind.File);case"fileWorkspaceFolder":return f(E.VariableKind.FileWorkspaceFolder);case"relativeFile":return y||g?b.relative(this.fsPath(r(E.VariableKind.RelativeFile)),l(E.VariableKind.RelativeFile)):l(E.VariableKind.RelativeFile);case"relativeFileDirname":{const o=b.dirname(l(E.VariableKind.RelativeFileDirname));if(y||g){const n=b.relative(this.fsPath(r(E.VariableKind.RelativeFileDirname)),o);return n.length===0?".":n}return o}case"fileDirname":return b.dirname(l(E.VariableKind.FileDirname));case"fileExtname":return b.extname(l(E.VariableKind.FileExtname));case"fileBasename":return b.basename(l(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=b.basename(l(E.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-b.extname(o).length)}case"fileDirnameBasename":return b.basename(b.dirname(l(E.VariableKind.FileDirnameBasename)));case"execPath":{const o=this._context.getExecPath();return o||h}case"execInstallFolder":{const o=this._context.getAppRoot();return o||h}case"pathSeparator":return b.sep;default:try{const o=g?`${I}:${g}`:I;return this.resolveFromMap(E.VariableKind.Unknown,h,o,d,void 0)}catch{return h}}}}resolveFromMap(v,h,I,y,d){if(I&&y){const g=d===void 0?y[I]:y[d+":"+I];if(typeof g=="string")return g;throw new E.VariableError(v,(0,p.localize)(14,null,h))}return h}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[250],we([0,1,5,80]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var D;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var S;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var p;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(p=e.MergeGroupMode||(e.MergeGroupMode={}));function E(h){const I=h;return(0,t.isEditorInput)(I?.editor)&&(0,t.isEditorInput)(I?.replacement)}e.isEditorReplacement=E;var T;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function w(h){const I=h;return!!I&&typeof I.id=="number"&&Array.isArray(I.editors)}e.isEditorGroup=w;function v(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(ve[124],we([0,1,5,250]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(C){const k=C;return typeof C=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=D}),define(ve[125],we([0,1,18,16,88,24,135,42,22,12,4,49,150,207,122,80,245,81,82,124,118,64]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Se){function Ie(H){const{selectionStartLineNumber:De,selectionStartColumn:Le,positionLineNumber:Ye,positionColumn:qe}=H,Ve=new l.Position(De-1,Le-1),lt=new l.Position(Ye-1,qe-1);return new l.Selection(Ve,lt)}Se.to=Ie;function de(H){const{anchor:De,active:Le}=H;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=de})(r=e.Selection||(e.Selection={}));var o;(function(Se){function Ie(H){if(!H)return;const{start:De,end:Le}=H;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=Ie;function de(H){if(!H)return;const{startLineNumber:De,startColumn:Le,endLineNumber:Ye,endColumn:qe}=H;return new l.Range(De-1,Le-1,Ye-1,qe-1)}Se.to=de})(o=e.Range||(e.Range={}));var n;(function(Se){function Ie(de){switch(de){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Se.to=Ie})(n=e.TokenType||(e.TokenType={}));var i;(function(Se){function Ie(H){return new l.Position(H.lineNumber-1,H.column-1)}Se.to=Ie;function de(H){return{lineNumber:H.line+1,column:H.character+1}}Se.from=de})(i=e.Position||(e.Position={}));var s;(function(Se){function Ie(De,Le){return(0,b.coalesce)((0,b.asArray)(De).map(Ye=>de(Ye,Le)))}Se.from=Ie;function de(De,Le){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:H(De.scheme,Le),pattern:ce.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType}}function H(De,Le){return Le&&typeof De=="string"?Le.transformOutgoingScheme(De):De}})(s=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function Ie(H){switch(H){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function de(H){switch(H){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Se.to=de})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(Se){function Ie(H){let De;return H.code&&((0,E.isString)(H.code)||(0,E.isNumber)(H.code)?De=String(H.code):De={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:De,severity:P.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(m.from),tags:Array.isArray(H.tags)?(0,b.coalesce)(H.tags.map(a.from)):void 0}}Se.from=Ie;function de(H){const De=new l.Diagnostic(o.to(H),H.message,P.to(H.severity));return De.source=H.source,De.code=(0,E.isString)(H.code)?H.code:H.code?.value,De.relatedInformation=H.relatedInformation&&H.relatedInformation.map(m.to),De.tags=H.tags&&(0,b.coalesce)(H.tags.map(a.to)),De}Se.to=de})(u=e.Diagnostic||(e.Diagnostic={}));var m;(function(Se){function Ie(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Se.from=Ie;function de(H){return new l.DiagnosticRelatedInformation(new l.Location(H.resource,o.to(H)),H.message)}Se.to=de})(m=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var P;(function(Se){function Ie(H){switch(H){case l.DiagnosticSeverity.Error:return v.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return v.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return v.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return v.MarkerSeverity.Hint}return v.MarkerSeverity.Error}Se.from=Ie;function de(H){switch(H){case v.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case v.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case v.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case v.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Se.to=de})(P=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var F;(function(Se){function Ie(H){return typeof H=="number"&&H>=l.ViewColumn.One?H-1:H===l.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}Se.from=Ie;function de(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=de})(F=e.ViewColumn||(e.ViewColumn={}));function q(Se){return typeof Se.range!="undefined"}function Y(Se){return Se.length===0?!0:!!q(Se[0])}e.isDecorationOptionsArr=Y;var se;(function(Se){function Ie(qe){return qe.map(Se.from)}Se.fromMany=Ie;function de(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function H(qe){let Ve;if(de(qe)){const{language:at,value:Ct}=qe;Ve={value:"```"+at+`
`+Ct+"\n```\n"}}else l.MarkdownString.isMarkdownString(qe)?Ve={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?Ve={value:qe}:Ve={value:""};const lt=Object.create(null);Ve.uris=lt;const bt=at=>{try{let Ct=T.URI.parse(at,!0);Ct=Ct.with({query:De(Ct.query,lt)}),lt[at]=Ct}catch{}return""},vt=new k.marked.Renderer;return vt.link=bt,vt.image=at=>typeof at=="string"?bt(D.parseHrefAndDimensions(at).href):"",(0,k.marked)(Ve.value,{renderer:vt}),Ve}Se.from=H;function De(qe,Ve){if(!qe)return qe;let lt;try{lt=(0,S.parse)(qe)}catch{}if(!lt)return qe;let bt=!1;return lt=(0,p.cloneAndChange)(lt,vt=>{if(T.URI.isUri(vt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ve[at]=vt,bt=!0,at}else return}),bt?JSON.stringify(lt):qe}function Le(qe){const Ve=new l.MarkdownString(qe.value,qe.supportThemeIcons);return Ve.isTrusted=qe.isTrusted,Ve.supportHtml=qe.supportHtml,Ve.baseUri=qe.baseUri?T.URI.from(qe.baseUri):void 0,Ve}Se.to=Le;function Ye(qe){if(!!qe)return typeof qe=="string"?qe:Se.from(qe)}Se.fromStrict=Ye})(se=e.MarkdownString||(e.MarkdownString={}));function _(Se){return Y(Se)?Se.map(Ie=>({range:o.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?se.fromMany(Ie.hoverMessage):Ie.hoverMessage?se.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:o.from(Ie)}))}e.fromRangeOrRangeWithMessage=_;function G(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?T.URI.file(Se):Se}e.pathOrURIToURI=G;var te;(function(Se){function Ie(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?G(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Se.from=Ie})(te=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var j;(function(Se){function Ie(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?G(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?te.from(de.before):void 0,after:de.after?te.from(de.after):void 0}}Se.from=Ie})(j=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var he;(function(Se){function Ie(de){if(typeof de=="undefined")return de;switch(de){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})(he=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var J;(function(Se){function Ie(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?he.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?j.from(de.light):void 0,dark:de.dark?j.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?G(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?te.from(de.before):void 0,after:de.after?te.from(de.after):void 0}}Se.from=Ie})(J=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(Se){function Ie(H){return{text:H.newText,eol:H.newEol&&$e.from(H.newEol),range:o.from(H.range)}}Se.from=Ie;function de(H){const De=new l.TextEdit(o.to(H.range),H.text);return De.newEol=typeof H.eol=="undefined"?void 0:$e.to(H.eol),De}Se.to=de})(U=e.TextEdit||(e.TextEdit={}));var M;(function(Se){function Ie(H,De,Le){const Ye={edits:[]};if(H instanceof l.WorkspaceEdit){const qe=new C.ResourceSet;for(const Ve of H._allEntries())Ve._type===1&&T.URI.isUri(Ve.to)&&Ve.from===void 0&&qe.add(Ve.to);for(const Ve of H._allEntries())if(Ve._type===1)Ye.edits.push({oldResource:Ve.from,newResource:Ve.to,options:Ve.options,metadata:Ve.metadata});else if(Ve._type===2)Ye.edits.push({resource:Ve.uri,textEdit:U.from(Ve.edit),versionId:qe.has(Ve.uri)?void 0:De?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata});else if(Ve._type===6){if(!Le){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Ve);continue}Ye.edits.push({resource:Ve.uri,textEdit:{range:o.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:qe.has(Ve.uri)?void 0:De?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata})}else Ve._type===3?Ye.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Ye.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:De?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Qe.from)}})}return Ye}Se.from=Ie;function de(H){const De=new l.WorkspaceEdit;for(const Le of H.edits)Le.textEdit?De.replace(T.URI.revive(Le.resource),o.to(Le.textEdit.range),Le.textEdit.text):De.renameFile(T.URI.revive(Le.oldResource),T.URI.revive(Le.newResource),Le.options);return De}Se.to=de})(M=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(Se){const Ie=Object.create(null);Ie[l.SymbolKind.File]=0,Ie[l.SymbolKind.Module]=1,Ie[l.SymbolKind.Namespace]=2,Ie[l.SymbolKind.Package]=3,Ie[l.SymbolKind.Class]=4,Ie[l.SymbolKind.Method]=5,Ie[l.SymbolKind.Property]=6,Ie[l.SymbolKind.Field]=7,Ie[l.SymbolKind.Constructor]=8,Ie[l.SymbolKind.Enum]=9,Ie[l.SymbolKind.Interface]=10,Ie[l.SymbolKind.Function]=11,Ie[l.SymbolKind.Variable]=12,Ie[l.SymbolKind.Constant]=13,Ie[l.SymbolKind.String]=14,Ie[l.SymbolKind.Number]=15,Ie[l.SymbolKind.Boolean]=16,Ie[l.SymbolKind.Array]=17,Ie[l.SymbolKind.Object]=18,Ie[l.SymbolKind.Key]=19,Ie[l.SymbolKind.Null]=20,Ie[l.SymbolKind.EnumMember]=21,Ie[l.SymbolKind.Struct]=22,Ie[l.SymbolKind.Event]=23,Ie[l.SymbolKind.Operator]=24,Ie[l.SymbolKind.TypeParameter]=25;function de(De){return typeof Ie[De]=="number"?Ie[De]:6}Se.from=de;function H(De){for(const Le in Ie)if(Ie[Le]===De)return Number(Le);return l.SymbolKind.Property}Se.to=H})(B=e.SymbolKind||(e.SymbolKind={}));var Q;(function(Se){function Ie(H){switch(H){case l.SymbolTag.Deprecated:return 1}}Se.from=Ie;function de(H){switch(H){case 1:return l.SymbolTag.Deprecated}}Se.to=de})(Q=e.SymbolTag||(e.SymbolTag={}));var ae;(function(Se){function Ie(H){return{name:H.name,kind:B.from(H.kind),tags:H.tags&&H.tags.map(Q.from),containerName:H.containerName,location:O.from(H.location)}}Se.from=Ie;function de(H){const De=new l.SymbolInformation(H.name,B.to(H.kind),H.containerName,O.to(H.location));return De.tags=H.tags&&H.tags.map(Q.to),De}Se.to=de})(ae=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var fe;(function(Se){function Ie(H){const De={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:B.from(H.kind),tags:H.tags?.map(Q.from)??[]};return H.children&&(De.children=H.children.map(Ie)),De}Se.from=Ie;function de(H){const De=new l.DocumentSymbol(H.name,H.detail,B.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,b.isNonEmptyArray)(H.tags)&&(De.tags=H.tags.map(Q.to)),H.children&&(De.children=H.children.map(de)),De}Se.to=de})(fe=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(Se){function Ie(H){const De=new l.CallHierarchyItem(B.to(H.kind),H.name,H.detail||"",T.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return De._sessionId=H._sessionId,De._itemId=H._itemId,De}Se.to=Ie;function de(H,De,Le){if(De=De??H._sessionId,Le=Le??H._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,name:H.name,detail:H.detail,kind:B.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(Q.from)}}Se.from=de})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var re;(function(Se){function Ie(de){return new l.CallHierarchyIncomingCall(X.to(de.from),de.fromRanges.map(H=>o.to(H)))}Se.to=Ie})(re=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(Se){function Ie(de){return new l.CallHierarchyOutgoingCall(X.to(de.to),de.fromRanges.map(H=>o.to(H)))}Se.to=Ie})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(Se){function Ie(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Se.from=Ie;function de(H){return new l.Location(T.URI.revive(H.uri),o.to(H.range))}Se.to=de})(O=e.location||(e.location={}));var x;(function(Se){function Ie(H){const De=H,Le=H;return{originSelectionRange:De.originSelectionRange?o.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Le.uri,range:o.from(De.targetRange?De.targetRange:Le.range),targetSelectionRange:De.targetSelectionRange?o.from(De.targetSelectionRange):void 0}}Se.from=Ie;function de(H){return{targetUri:T.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Se.to=de})(x=e.DefinitionLink||(e.DefinitionLink={}));var ne;(function(Se){function Ie(H){return{range:o.from(H.range),contents:se.fromMany(H.contents)}}Se.from=Ie;function de(H){return new l.Hover(H.contents.map(se.to),o.to(H.range))}Se.to=de})(ne=e.Hover||(e.Hover={}));var ue;(function(Se){function Ie(H){return{range:o.from(H.range),expression:H.expression}}Se.from=Ie;function de(H){return new l.EvaluatableExpression(o.to(H.range),H.expression)}Se.to=de})(ue=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(Se){function Ie(H){if(H instanceof l.InlineValueText)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof l.InlineValueVariableLookup)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function de(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Se.to=de})(pe=e.InlineValue||(e.InlineValue={}));var W;(function(Se){function Ie(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Se.from=Ie;function de(H){return new l.InlineValueContext(H.frameId,o.to(H.stoppedLocation))}Se.to=de})(W=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Se){function Ie(H){return{range:o.from(H.range),kind:H.kind}}Se.from=Ie;function de(H){return new l.DocumentHighlight(o.to(H.range),H.kind)}Se.to=de})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var ie;(function(Se){function Ie(de){switch(de){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Se.to=Ie})(ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var z;(function(Se){function Ie(de){return{triggerKind:ie.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Se.to=Ie})(z=e.CompletionContext||(e.CompletionContext={}));var V;(function(Se){function Ie(H){switch(H){case l.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function de(H){switch(H){case 1:return l.CompletionItemTag.Deprecated}}Se.to=de})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(Se){const Ie=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function de(Le){return Ie.get(Le)??9}Se.from=de;const H=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function De(Le){return H.get(Le)??l.CompletionItemKind.Property}Se.to=De})($=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Se){function Ie(de,H){const De=new l.CompletionItem(de.label);return De.insertText=de.insertText,De.kind=$.to(de.kind),De.tags=de.tags?.map(V.to),De.detail=de.detail,De.documentation=D.isMarkdownString(de.documentation)?se.to(de.documentation):de.documentation,De.sortText=de.sortText,De.filterText=de.filterText,De.preselect=de.preselect,De.commitCharacters=de.commitCharacters,R.Range.isIRange(de.range)?De.range=o.to(de.range):typeof de.range=="object"&&(De.range={inserting:o.to(de.range.insert),replacing:o.to(de.range.replace)}),De.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?De.insertText=new l.SnippetString(de.insertText):(De.insertText=de.insertText,De.textEdit=De.range instanceof l.Range?new l.TextEdit(De.range,De.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(De.additionalTextEdits=de.additionalTextEdits.map(Le=>U.to(Le))),De.command=H&&de.command?H.fromInternal(de.command):void 0,De}Se.to=Ie})(K=e.CompletionItem||(e.CompletionItem={}));var le;(function(Se){function Ie(H){return{label:H.label,documentation:se.fromStrict(H.documentation)}}Se.from=Ie;function de(H){return{label:H.label,documentation:D.isMarkdownString(H.documentation)?se.to(H.documentation):H.documentation}}Se.to=de})(le=e.ParameterInformation||(e.ParameterInformation={}));var ge;(function(Se){function Ie(H){return{label:H.label,documentation:se.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(le.from):[],activeParameter:H.activeParameter}}Se.from=Ie;function de(H){return{label:H.label,documentation:D.isMarkdownString(H.documentation)?se.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(le.to):[],activeParameter:H.activeParameter}}Se.to=de})(ge=e.SignatureInformation||(e.SignatureInformation={}));var Pe;(function(Se){function Ie(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ge.from):[]}}Se.from=Ie;function de(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ge.to):[]}}Se.to=de})(Pe=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Se){function Ie(de,H){const De=new l.InlayHint(i.to(H.position),typeof H.label=="string"?H.label:H.label.map(Ne.to.bind(void 0,de)),H.kind&&Ue.to(H.kind));return De.textEdits=H.textEdits&&H.textEdits.map(U.to),De.tooltip=D.isMarkdownString(H.tooltip)?se.to(H.tooltip):H.tooltip,De.paddingLeft=H.paddingLeft,De.paddingRight=H.paddingRight,De}Se.to=Ie})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(Se){function Ie(de,H){const De=new l.InlayHintLabelPart(H.label);return De.tooltip=D.isMarkdownString(H.tooltip)?se.to(H.tooltip):H.tooltip,w.Command.is(H.command)&&(De.command=de.fromInternal(H.command)),H.location&&(De.location=O.to(H.location)),De}Se.to=Ie})(Ne=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ue;(function(Se){function Ie(H){return H}Se.from=Ie;function de(H){return H}Se.to=de})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var me;(function(Se){function Ie(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Se.from=Ie;function de(H){let De;if(H.url)try{De=typeof H.url=="string"?T.URI.parse(H.url,!0):T.URI.revive(H.url)}catch{}return new l.DocumentLink(o.to(H.range),De)}Se.to=de})(me=e.DocumentLink||(e.DocumentLink={}));var be;(function(Se){function Ie(H){const De=new l.ColorPresentation(H.label);return H.textEdit&&(De.textEdit=U.to(H.textEdit)),H.additionalTextEdits&&(De.additionalTextEdits=H.additionalTextEdits.map(Le=>U.to(Le))),De}Se.to=Ie;function de(H){return{label:H.label,textEdit:H.textEdit?U.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(De=>U.from(De)):void 0}}Se.from=de})(be=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Se){function Ie(H){return new l.Color(H[0],H[1],H[2],H[3])}Se.to=Ie;function de(H){return[H.red,H.green,H.blue,H.alpha]}Se.from=de})(ye=e.Color||(e.Color={}));var Oe;(function(Se){function Ie(H){return{range:o.from(H.range)}}Se.from=Ie;function de(H){return new l.SelectionRange(o.to(H.range))}Se.to=de})(Oe=e.SelectionRange||(e.SelectionRange={}));var Me;(function(Se){function Ie(de){switch(de){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(Me=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(Se){function Ie(H){switch(H){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function de(H){switch(H){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Se.to=de})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var $e;(function(Se){function Ie(H){if(H===l.EndOfLine.CRLF)return 1;if(H===l.EndOfLine.LF)return 0}Se.from=Ie;function de(H){if(H===1)return l.EndOfLine.CRLF;if(H===0)return l.EndOfLine.LF}Se.to=de})($e=e.EndOfLine||(e.EndOfLine={}));var Ze;(function(Se){function Ie(de){if(typeof de=="object")return de.viewId;switch(de){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(Ze=e.ProgressLocation||(e.ProgressLocation={}));var Ge;(function(Se){function Ie(de){const H={start:de.start+1,end:de.end+1};return de.kind&&(H.kind=je.from(de.kind)),H}Se.from=Ie})(Ge=e.FoldingRange||(e.FoldingRange={}));var je;(function(Se){function Ie(de){if(de)switch(de){case l.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}Se.from=Ie})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(Se){function Ie(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?o.from(de.selection):void 0,override:typeof de.override=="boolean"?I.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Ie})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ce;(function(Se){function Ie(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:de(Le)||H(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=Ie;function de(Le){const Ye=Le;return Ye?T.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function H(Le){const Ye=Le;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function De(Le){return typeof Le=="string"?Le:new l.RelativePattern(T.URI.revive(Le.baseUri),Le.pattern)}Se.to=De})(ce=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(Se){function Ie(de){if(de){if(Array.isArray(de))return de.map(Ie);if(typeof de=="string")return de;{const H=de;return{language:H.language,scheme:H.scheme,pattern:ce.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Se.from=Ie})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var ke;(function(Se){function Ie(H){return{start:H.start,end:H.end}}Se.from=Ie;function de(H){return new l.NotebookRange(H.start,H.end)}Se.to=de})(ke=e.NotebookRange||(e.NotebookRange={}));var Fe;(function(Se){function Ie(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Se.to=Ie;function de(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Se.from=de})(Fe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Re;(function(Se){function Ie(de){if(de===y.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(de===y.NotebookCellExecutionState.Pending)return;if(de===y.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Se.to=Ie})(Re=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Be;(function(Se){function Ie(H){switch(H){case l.NotebookCellKind.Markup:return y.CellKind.Markup;case l.NotebookCellKind.Code:default:return y.CellKind.Code}}Se.from=Ie;function de(H){switch(H){case y.CellKind.Markup:return l.NotebookCellKind.Markup;case y.CellKind.Code:default:return l.NotebookCellKind.Code}}Se.to=de})(Be=e.NotebookCellKind||(e.NotebookCellKind={}));var He;(function(Se){function Ie(H){const De={metadata:H.metadata??Object.create(null),cells:[]};for(const Le of H.cells)l.NotebookCellData.validate(Le),De.cells.push(Qe.from(Le));return De}Se.from=Ie;function de(H){const De=new l.NotebookData(H.cells.map(Qe.to));return(0,E.isEmptyObject)(H.metadata)||(De.metadata=H.metadata),De}Se.to=de})(He=e.NotebookData||(e.NotebookData={}));var Qe;(function(Se){function Ie(H){return{cellKind:Be.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Fe.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(tt.from):[]}}Se.from=Ie;function de(H){return new l.NotebookCellData(Be.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(tt.to):void 0,H.metadata,H.internalMetadata?Fe.to(H.internalMetadata):void 0)}Se.to=de})(Qe=e.NotebookCellData||(e.NotebookCellData={}));var Xe;(function(Se){function Ie(H){return{mime:H.mime,valueBytes:t.VSBuffer.wrap(H.data)}}Se.from=Ie;function de(H){return new l.NotebookCellOutputItem(H.valueBytes.buffer,H.mime)}Se.to=de})(Xe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var tt;(function(Se){function Ie(H){return{outputId:H.id,items:H.items.map(Xe.from),metadata:H.metadata}}Se.from=Ie;function de(H){const De=H.items.map(Xe.to);return new l.NotebookCellOutput(De,H.outputId,H.metadata)}Se.to=de})(tt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Se){function Ie(De){return H(De)?{include:(0,E.withNullAsUndefined)(ce.from(De.include)),exclude:(0,E.withNullAsUndefined)(ce.from(De.exclude))}:(0,E.withNullAsUndefined)(ce.from(De))}Se.from=Ie;function de(De){return H(De)?{include:ce.to(De.include),exclude:ce.to(De.exclude)}:ce.to(De)}Se.to=de;function H(De){const Le=De;return Le?!(0,E.isUndefinedOrNull)(Le.include)&&!(0,E.isUndefinedOrNull)(Le.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Se){function Ie(de,H,De){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Le,De),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Se.from=Ie})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Se){function Ie(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{}}}Se.from=Ie})(ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ut;(function(Se){function Ie(H){return{uri:H.uri,provides:H.provides}}Se.from=Ie;function de(H){return new l.NotebookRendererScript(T.URI.revive(H.uri),H.provides)}Se.to=de})(ut=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(Se){function Ie(H){return{message:se.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Se.from=Ie;function de(H){const De=new l.TestMessage(typeof H.message=="string"?H.message:se.to(H.message));return De.actualOutput=H.actual,De.expectedOutput=H.expected,De.location=H.location?O.to(H.location):void 0,De}Se.to=de})(Pt=e.TestMessage||(e.TestMessage={}));var yt;(function(Se){Se.namespace=g.namespaceTestTag,Se.denamespace=g.denamespaceTestTag})(yt=e.TestTag||(e.TestTag={}));var _t;(function(Se){function Ie(H){const De=(0,h.getPrivateApiFor)(H).controllerId;return{extId:d.TestId.fromExtHostTestItem(H,De).toString(),label:H.label,uri:T.URI.revive(H.uri),busy:!1,tags:H.tags.map(Le=>yt.namespace(De,Le.id)),range:R.Range.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&se.fromStrict(H.error)||null}}Se.from=Ie;function de(H){return{parent:void 0,error:void 0,id:d.TestId.fromString(H.extId).localId,label:H.label,uri:T.URI.revive(H.uri),tags:(H.tags||[]).map(De=>{const{tagId:Le}=yt.denamespace(De);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:!1,description:H.description||void 0,sortText:H.sortText||void 0}}Se.toPlain=de})(_t=e.TestItem||(e.TestItem={})),function(Se){function Ie(H){return{id:H.id}}Se.from=Ie;function de(H){return new l.TestTag(H.id)}Se.to=de}(yt=e.TestTag||(e.TestTag={}));var ht;(function(Se){const Ie=(H,De)=>{const Le=[];for(const[qe,Ve]of De)d.TestId.compare(Ve.item.extId,qe)===2&&(De.delete(qe),Le.push(Ve));const Ye={..._t.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(Ve=>Ve.type===0).map(Pt.to)})),children:Le.map(qe=>Ie(qe,De))};for(const qe of Ye.children)qe.parent=Ye;return Ye};function de(H){const De=[],Le=new Map;for(const Ye of H.items)Le.set(Ye.item.extId,Ye),H.request.targets.some(qe=>qe.controllerId===Ye.controllerId&&qe.testIds.includes(Ye.item.extId))&&De.push(Ye);return{completedAt:H.completedAt,results:De.map(Ye=>Ie(Ye,Le))}}Se.to=de})(ht=e.TestResults||(e.TestResults={}));var Et;(function(Se){function Ie(Le){return{covered:Le.covered,total:Le.covered}}function de(Le){return"line"in Le?i.from(Le):o.from(Le)}function H(Le){return"branches"in Le?{count:Le.executionCount,location:de(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&de(Ye.location)})):void 0}:{type:0,count:Le.executionCount,location:de(Le.location)}}Se.fromDetailed=H;function De(Le){return{uri:Le.uri,statement:Ie(Le.statementCoverage),branch:Le.branchCoverage&&Ie(Le.branchCoverage),function:Le.functionCoverage&&Ie(Le.functionCoverage),details:Le.detailedCoverage?.map(H)}}Se.fromFile=De})(Et=e.TestCoverage||(e.TestCoverage={}));var kt;(function(Se){function Ie(de){switch(de){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Se.to=Ie})(kt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var st;(function(Se){function Ie(H){const De=new l.TypeHierarchyItem(B.to(H.kind),H.name,H.detail||"",T.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return De._sessionId=H._sessionId,De._itemId=H._itemId,De}Se.to=Ie;function de(H,De,Le){if(De=De??H._sessionId,Le=Le??H._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,kind:B.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(Q.from)}}Se.from=de})(st=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var St;(function(Se){function Ie(de){if(!!de)return{value:de.value,tooltip:de.tooltip}}Se.from=Ie})(St=e.ViewBadge||(e.ViewBadge={}));var dt;(function(Se){function Ie(de,H){const De=de.fileData;return De?new class extends l.DataTransferItem{asFile(){return{name:De.name,uri:T.URI.revive(De.uri),data:(0,f.once)(()=>H())}}}(""):new l.DataTransferItem(de.asString)}Se.toDataTransferItem=Ie})(dt=e.DataTransferItem||(e.DataTransferItem={}));var mt;(function(Se){function Ie(H,De){const Le=H.items.map(([Ye,qe],Ve)=>[Ye,dt.toDataTransferItem(qe,()=>De(Ve))]);return new l.DataTransfer(Le)}Se.toDataTransfer=Ie;async function de(H){const De={items:[]},Le=[];return H.forEach((Ye,qe)=>{Le.push((async()=>{const Ve=await Ye.asString(),lt=Ye.asFile();De.items.push([qe,{asString:Ve,fileData:lt?{name:lt.name,uri:lt.uri}:void 0}])})())}),await Promise.all(Le),De}Se.toDataTransferDTO=de})(mt=e.DataTransfer||(e.DataTransfer={}))}),define(ve[251],we([0,1,49,122,81,121,82,125,4]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const E=(c,l,f,r)=>{let o=l;return{enumerable:!0,configurable:!1,get(){return o},set(n){if(!f(o,n)){const i=o;o=n,c.listener?.(r(n,i))}}}},T=(c,l)=>c===l,R={range:(c,l)=>c===l?!0:!c||!l?!1:c.isEqual(l),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(c,l)=>!(c.length!==l.length||c.some(f=>!l.find(r=>f.id===r.id)))},w=c=>l=>({op:4,update:c(l)}),v=(c,l)=>({range:E(c,void 0,R.range,w(f=>({range:b.Range.lift(S.Range.from(f))}))),label:E(c,l,R.label,w(f=>({label:f}))),description:E(c,void 0,R.description,w(f=>({description:f}))),sortText:E(c,void 0,R.sortText,w(f=>({sortText:f}))),canResolveChildren:E(c,!1,R.canResolveChildren,f=>({op:2,state:f})),busy:E(c,!1,R.busy,w(f=>({busy:f}))),error:E(c,void 0,R.error,w(f=>({error:S.MarkdownString.fromStrict(f)||null}))),tags:E(c,[],R.tags,(f,r)=>({op:1,new:f.map(S.TestTag.from),old:r.map(S.TestTag.from)}))}),h=c=>{const l=D.TestId.fromString(c.extId),f=new y(l.controllerId,l.localId,c.label,p.URI.revive(c.uri)||void 0);return f.range=S.Range.to(c.range||void 0),f.description=c.description||void 0,f.sortText=c.sortText||void 0,f.tags=c.tags.map(r=>S.TestTag.to({id:(0,k.denamespaceTestTag)(r).tagId})),f},I=c=>{let l;for(const f of c.tests){const r=h(f.item);(0,t.getPrivateApiFor)(r).parent=l,l=r}return l};e.toItemFromContext=I;class y{constructor(l,f,r,o){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const n=(0,t.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof d?void 0:n.parent}},children:{value:(0,C.createTestItemChildren)(n,t.getPrivateApiFor,y),enumerable:!0,writable:!1},...v(n,r)})}}e.TestItemImpl=y;class d extends y{constructor(l,f){super(l,l,f,void 0)}}e.TestItemRootImpl=d;class g extends C.TestItemCollection{constructor(l,f){super({controllerId:l,getApiFor:t.getPrivateApiFor,getChildren:r=>r.children,root:new d(l,f),toITestItem:S.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(ve[252],we([0,1,12,248,13,107,78,120,123,80,124,8,203,119]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let h=class{constructor(y,d,g,c,l,f,r,o,n,i){this._remoteAuthority=y,this._channel=d,this._configurationService=g,this._workspaceContextService=c,this._resolverService=l,this._environmentVariableService=f,this._remoteAuthorityResolverService=r,this._logService=o,this._editorService=n,this._labelService=i}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(y,d,g,c,l,f,r,o){await this._configurationService.whenRemoteConfigurationLoaded();const n=Object.create(null),i=g?(0,b.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(g)):void 0;let s;try{s=(await this._resolverService.resolveAnyMap(i,{shellLaunchConfig:y,configuration:d})).resolvedVariables}catch(_){this._logService.error(_)}if(s)for(const[_,G]of s.entries())(/^config:/.test(_)||_==="selectedText"||_==="lineNumber")&&(n[_]=G);const a=[];for(const[_,G]of this._environmentVariableService.collections.entries())a.push([_,(0,S.serializeEnvironmentVariableCollection)(G.map)]);const u=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),m=u.options&&u.options.extensionHostEnv,P=this._workspaceContextService.getWorkspace(),F=P.folders,q=g?this._workspaceContextService.getWorkspaceFolder(g):null,Y=E.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:E.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.vscodeUserData,R.Schemas.vscodeRemote]}),se={configuration:d,resolvedVariables:n,envVariableCollections:a,shellLaunchConfig:y,workspaceId:P.id,workspaceName:this._labelService.getWorkspaceLabel(P),workspaceFolders:F,activeWorkspaceFolder:q,activeFileResource:Y,shouldPersistTerminal:l,options:c,cols:f,rows:r,unicodeVersion:o,resolverEnv:m};return await this._channel.call("$createProcess",se)}requestDetachInstance(y,d){return this._channel.call("$requestDetachInstance",[y,d])}acceptDetachInstanceReply(y,d){return this._channel.call("$acceptDetachInstanceReply",[y,d])}attachToProcess(y){return this._channel.call("$attachToProcess",[y])}detachFromProcess(y,d){return this._channel.call("$detachFromProcess",[y,d])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(y,d){return this._channel.call("$processBinary",[y,d])}start(y){return this._channel.call("$start",[y])}input(y,d){return this._channel.call("$input",[y,d])}acknowledgeDataEvent(y,d){return this._channel.call("$acknowledgeDataEvent",[y,d])}setUnicodeVersion(y,d){return this._channel.call("$setUnicodeVersion",[y,d])}shutdown(y,d){return this._channel.call("$shutdown",[y,d])}resize(y,d,g){return this._channel.call("$resize",[y,d,g])}getInitialCwd(y){return this._channel.call("$getInitialCwd",[y])}getCwd(y){return this._channel.call("$getCwd",[y])}orphanQuestionReply(y){return this._channel.call("$orphanQuestionReply",[y])}sendCommandResult(y,d,g){return this._channel.call("$sendCommandResult",[y,d,g])}installAutoReply(y,d){return this._channel.call("$installAutoReply",[y,d])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(y){return this._channel.call("$getDefaultSystemShell",[y])}getProfiles(y,d,g){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,y,d,g])}acceptPtyHostResolvedVariables(y,d){return this._channel.call("$acceptPtyHostResolvedVariables",[y,d])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(y){return this._channel.call("$getWslPath",[y])}setTerminalLayoutInfo(y){const g={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:y?y.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",g)}updateTitle(y,d,g){return this._channel.call("$updateTitle",[y,d,g])}updateIcon(y,d,g){return this._channel.call("$updateIcon",[y,d,g])}refreshProperty(y,d){return this._channel.call("$refreshProperty",[y,d])}updateProperty(y,d,g){return this._channel.call("$updateProperty",[y,d,g])}getTerminalLayoutInfo(){const d={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",d)}reviveTerminalProcesses(y,d){return this._channel.call("$reviveTerminalProcesses",[y,d])}getRevivedPtyNewId(y){return this._channel.call("$getRevivedPtyNewId",[y])}serializeTerminalState(y){return this._channel.call("$serializeTerminalState",[y])}};h=Ae([_e(2,t.IWorkbenchConfigurationService),_e(3,k.IWorkspaceContextService),_e(4,p.IConfigurationResolverService),_e(5,v.IEnvironmentVariableService),_e(6,C.IRemoteAuthorityResolverService),_e(7,D.ILogService),_e(8,T.IEditorService),_e(9,w.ILabelService)],h),e.RemoteTerminalChannelClient=h}),define(ve[253],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var b;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(b=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(R){this.pipeName=R,this.type=1}serialize(R){R[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(R){R[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class C{constructor(){this.type=3}serialize(R){R[C.ENV_KEY]="1"}}e.MessagePortExtHostConnection=C,C.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(T){delete T[t.ENV_KEY],delete T[D.ENV_KEY],delete T[C.ENV_KEY]}function S(T,R){k(R),T.serialize(R)}e.writeExtHostConnection=S;function p(T){if(T[t.ENV_KEY])return E(T,new t(T[t.ENV_KEY]));if(T[D.ENV_KEY])return E(T,new D);if(T[C.ENV_KEY])return E(T,new C);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=p;function E(T,R){return k(T),R}}),define(ve[126],we([0,1,48,91,79,8,6,16,7,57,77,13,40,3,56,116,2,253]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function g(n={},i,s,a,u){const m=await(0,D.getNLSConfiguration)(s,a.userDataPath);let P={};if(i)try{P=await(0,T.getResolvedShellEnv)(u,a.args,process.env)}catch(G){u.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",G)}const q={...process.env,...P,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(m,void 0,0),...n},Y=a.isBuilt?(0,k.join)(a.appRoot,"bin"):(0,k.join)(a.appRoot,"resources","server","bin-dev"),se=(0,k.join)(Y,"remote-cli");let _=f(q,"PATH");return _?_=se+k.delimiter+_:_=se,r(q,"PATH",_),a.args["without-browser-env-var"]||(q.BROWSER=(0,k.join)(Y,"helpers",v.isWindows?"browser.cmd":"browser.sh")),o(q),q}e.buildUserEnvironment=g;class c{constructor(i,s){this.socket=i,this.initialDataChunk=s}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let i,s,a;return this.socket instanceof E.NodeSocket?(i=!0,s=!1,a=S.VSBuffer.alloc(0)):(i=!1,s=this.socket.permessageDeflate,a=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:i,permessageDeflate:s,inflateBytes:a.buffer.toString("base64")}}}let l=class{constructor(i,s,a,u,m,P,F){this._reconnectionToken=i,this._environmentService=m,this._logService=P,this._extensionHostStatusService=F,this._onClose=new p.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!v.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=s,this._extensionHostProcess=null,this._connectionData=new c(a,u),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(i){this._logService.info(`${this._logPrefix}${i}`)}_logError(i){this._logService.error(`${this._logPrefix}${i}`)}async _pipeSockets(i,s){const a=new y.DisposableStore;a.add(s.socket),a.add((0,y.toDisposable)(()=>{i.destroy()}));const u=()=>{a.dispose()};a.add(s.socket.onEnd(u)),a.add(s.socket.onClose(u)),a.add(p.Event.fromNodeEventEmitter(i,"end")(u)),a.add(p.Event.fromNodeEventEmitter(i,"close")(u)),a.add(p.Event.fromNodeEventEmitter(i,"error")(u)),a.add(s.socket.onData(m=>i.write(m.buffer))),a.add(p.Event.fromNodeEventEmitter(i,"data")(m=>{s.socket.write(S.VSBuffer.wrap(m))})),s.initialDataChunk.byteLength>0&&i.write(s.initialDataChunk.buffer)}async _sendSocketToExtensionHost(i,s){await s.socketDrain();const a=s.toIExtHostSocketMessage();let u;s.socket instanceof E.NodeSocket?u=s.socket.socket:u=s.socket.socket.socket,i.send(a,u)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const i={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(i)}acceptReconnection(i,s,a){this._remoteAddress=i,this._log("The client has reconnected.");const u=new c(s,a);if(!this._extensionHostProcess){this._connectionData=u;return}this._sendSocketToExtensionHost(this._extensionHostProcess,u)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(i){try{let s=process.execArgv?process.execArgv.filter(_=>!/^--inspect(-brk)?=/.test(_)):[];i.port&&!process.pkg&&(s=[`--inspect${i.break?"-brk":""}=${i.port}`]);const a=await g(i.env,!0,i.language,this._environmentService,this._logService);(0,h.removeDangerousEnvVariables)(a);let u;if(this._canSendSocket)(0,d.writeExtHostConnection)(new d.SocketExtHostConnection,a),u=null;else{const{namedPipeServer:_,pipeName:G}=await this._listenOnPipe();(0,d.writeExtHostConnection)(new d.IPCExtHostConnection(G),a),u=_}const m={env:a,execArgv:s,silent:!0},P=["--type=extensionHost","--transformURIs"],F=this._environmentService.args["use-host-proxy"];P.push(`--useHostProxy=${F?"true":"false"}`),this._extensionHostProcess=b.fork(C.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,P,m);const q=this._extensionHostProcess.pid;this._log(`<${q}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const Y=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),se=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if(Y(_=>this._log(`<${q}> ${_}`)),se(_=>this._log(`<${q}><stderr> ${_}`)),this._extensionHostProcess.on("error",_=>{this._logError(`<${q}> Extension Host Process had an error`),this._logService.error(_),this._cleanResources()}),this._extensionHostProcess.on("exit",(_,G)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:_,signal:G}),this._log(`<${q}> Extension Host Process exited with code: ${_}, signal: ${G}.`),this._cleanResources()}),u)u.on("connection",_=>{u.close(),this._pipeSockets(_,this._connectionData)});else{const _=G=>{G.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",_),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",_)}}catch(s){console.error("ExtensionHostConnection errored"),s&&console.error(s)}}_listenOnPipe(){return new Promise((i,s)=>{const a=(0,E.createRandomIPCHandle)(),u=t.createServer();u.on("error",s),u.listen(a,()=>{u?.removeListener("error",s),i({pipeName:a,namedPipeServer:u})})})}};l=Ae([_e(4,w.IServerEnvironmentService),_e(5,R.ILogService),_e(6,I.IExtensionHostStatusService)],l),e.ExtensionHostConnection=l;function f(n,i){const s=Object.keys(n).filter(u=>u.toLowerCase()===i.toLowerCase()),a=s.length>0?s[0]:i;return n[a]}function r(n,i,s){const a=Object.keys(n).filter(m=>m.toLowerCase()===i.toLowerCase()),u=a.length>0?a[0]:i;n[u]=s}function o(n){for(const i of Object.keys(n))n[i]===null&&delete n[i]}}),define(ve[254],we([0,1,36,184,50]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function C(k,S,p,E){const T=new Map;k.forEach(w=>{const v=b.ExtensionIdentifier.toKey(w.identifier),h=T.get(v);h&&E.warn((0,t.localize)(0,null,h.extensionLocation.fsPath,w.extensionLocation.fsPath)),T.set(v,w)}),S.forEach(w=>{const v=b.ExtensionIdentifier.toKey(w.identifier),h=T.get(v);if(h)if(h.isBuiltin){if(D.gte(h.version,w.version)){E.warn(`Skipping extension ${w.extensionLocation.path} in favour of the builtin extension ${h.extensionLocation.path}.`);return}w.isBuiltin=!0}else E.warn((0,t.localize)(1,null,h.extensionLocation.fsPath,w.extensionLocation.fsPath));else if(w.isBuiltin){E.warn(`Skipping obsolete builtin extension ${w.extensionLocation.path}`);return}T.set(v,w)}),p.forEach(w=>{E.info((0,t.localize)(2,null,w.extensionLocation.fsPath));const v=b.ExtensionIdentifier.toKey(w.identifier),h=T.get(v);h&&h.isBuiltin&&(w.isBuiltin=!0),T.set(v,w)});const R=[];return T.forEach(w=>R.push(w)),R}e.dedupExtensions=C}),define(ve[255],we([0,1,3,47,4,63,8,69,99,94,217,6,27,55,254]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class I{constructor(d,g,c,l,f,r,o){if(this._connectionToken=d,this._environmentService=g,this._userDataProfilesService=c,this._logService=f,this._extensionHostStatusService=r,this._extensionsScannerService=o,g.args["install-builtin-extension"]){const i={isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]};this.whenExtensionsReady=l.installExtensions([],g.args["install-builtin-extension"],i,!!g.args.force).then(null,s=>{f.error(s)})}else this.whenExtensionsReady=Promise.resolve();const n=g.args["install-extension"];if(n){const i=n.map(s=>/\.vsix$/i.test(s)?D.URI.file((0,R.isAbsolute)(s)?s:(0,R.join)((0,w.cwd)(),s)):s);this.whenExtensionsReady.then(()=>l.installExtensions(i,[],{isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]},!!g.args.force)).then(null,s=>{f.error(s)})}}async call(d,g,c){switch(g){case"getEnvironmentData":{const l=c,f=(0,C.createURITransformer)(l.remoteAuthority);let r=await this._getEnvironmentData();return r=(0,S.transformOutgoingURIs)(r,f),r}case"getExtensionHostExitInfo":{const l=c;return this._extensionHostStatusService.getExitInfo(l.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const l=c,f=l.language;this._logService.trace(`Scanning extensions using UI language: ${f}`);const r=(0,C.createURITransformer)(l.remoteAuthority),o=l.extensionDevelopmentPath&&l.extensionDevelopmentPath.map(s=>D.URI.revive(r.transformIncoming(s))),n=o?o.filter(s=>s.scheme===k.Schemas.file).map(s=>s.fsPath):void 0;let i=await this._scanExtensions(f,n);return i=(0,S.transformOutgoingURIs)(i,r),this._logService.trace("Scanned Extensions",i),I._massageWhenConditions(i),i}case"scanSingleExtension":{await this.whenExtensionsReady;const l=c,f=l.language,r=l.isBuiltin,o=(0,C.createURITransformer)(l.remoteAuthority),n=D.URI.revive(o.transformIncoming(l.extensionLocation)),i=n.scheme===k.Schemas.file?n.fsPath:null;if(!i)return null;let s=await this._scanSingleExtension(i,r,f);return s?(s=(0,S.transformOutgoingURIs)(s,o),I._massageWhenConditions([s]),s):null}case"getDiagnosticInfo":{const l=c,f={machineInfo:(0,T.getMachineInfo)()},r=l.includeProcesses?(0,E.listProcesses)(process.pid):Promise.resolve();let o=[];const n={};if(l.folders){const i=(0,C.createURITransformer)("");o=l.folders.map(a=>D.URI.revive(i.transformIncoming(a))).filter(a=>a.scheme==="file").map(a=>(0,T.collectWorkspaceStats)(a.fsPath,["node_modules",".git"]).then(u=>{n[(0,R.basename)(a.fsPath)]=u}))}return Promise.all([r,...o]).then(([i,s])=>(f.processes=i||void 0,f.workspaceMetadata=l.folders?n:void 0,f))}}throw new Error(`IPC Command ${g} not found`)}listen(d,g,c){throw new Error("Not supported")}static _massageWhenConditions(d){const g=(n,i)=>n.replace(/file/g,"vscode-remote"),c=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(g(n.source,!0),i)},l=new class{mapDefined(n){return p.ContextKeyDefinedExpr.create(n)}mapNot(n){return p.ContextKeyNotExpr.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.ContextKeyEqualsExpr.create(n,g(i,!1)):p.ContextKeyEqualsExpr.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.ContextKeyNotEqualsExpr.create(n,g(i,!1)):p.ContextKeyNotEqualsExpr.create(n,i)}mapGreater(n,i){return p.ContextKeyGreaterExpr.create(n,i)}mapGreaterEquals(n,i){return p.ContextKeyGreaterEqualsExpr.create(n,i)}mapSmaller(n,i){return p.ContextKeySmallerExpr.create(n,i)}mapSmallerEquals(n,i){return p.ContextKeySmallerEqualsExpr.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?p.ContextKeyRegexExpr.create(n,c(i)):p.ContextKeyRegexExpr.create(n,i)}mapIn(n,i){return p.ContextKeyInExpr.create(n,i)}mapNotIn(n,i){return p.ContextKeyNotInExpr.create(n,i)}},f=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=p.ContextKeyExpr.deserialize(n.when);if(!i)return;const s=i.map(l);n.when=s.serialize()},r=n=>{if(Array.isArray(n))for(const i of n)f(i);else f(n)},o=n=>{for(const i in n)r(n[i])};d.forEach(n=>{n.contributes&&(n.contributes.menus&&o(n.contributes.menus),n.contributes.keybindings&&r(n.contributes.keybindings),n.contributes.views&&o(n.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:D.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:D.URI.file(this._environmentService.logsPath),extensionsPath:D.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:D.URI.file((0,R.join)(this._environmentService.logsPath,`exthost${I._namePool++}`)),globalStorageHome:this._userDataProfilesService.defaultProfile.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:b.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(d,g){const[c,l,f]=await Promise.all([this._scanBuiltinExtensions(d),this._scanInstalledExtensions(d),this._scanDevelopedExtensions(d,g)]);return(0,h.dedupExtensions)(c,l,f,this._logService)}async _scanDevelopedExtensions(d,g){return g?(await Promise.all(g.map(c=>this._extensionsScannerService.scanOneOrMultipleExtensions(D.URI.file((0,R.resolve)(c)),1,{language:d})))).flat().map(c=>(0,v.toExtensionDescription)(c,!0)):[]}async _scanBuiltinExtensions(d){return(await this._extensionsScannerService.scanSystemExtensions({language:d,useCache:!0})).map(c=>(0,v.toExtensionDescription)(c,!1))}async _scanInstalledExtensions(d){return(await this._extensionsScannerService.scanUserExtensions({language:d,useCache:!0})).map(c=>(0,v.toExtensionDescription)(c,!1))}async _scanSingleExtension(d,g,c){const l=D.URI.file((0,R.resolve)(d)),f=g?0:1,r=await this._extensionsScannerService.scanExistingExtension(l,f,{language:c});return r?(0,v.toExtensionDescription)(r,!1):null}}e.RemoteAgentEnvironmentChannel=I,I._namePool=1}),define(ve[127],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const t=[];function D(S){const p=new b(S);return t[p.nid]=p,p}e.createProxyIdentifier=D;function C(S){return t[S].sid}e.getStringIdentifierForProxy=C;class k{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=k}),define(ve[256],we([0,1,42,127]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var k;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(k=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var p;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(p=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(g){return g._id=w._n++,g}}e.IdObject=w,w._n=0;var v;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function I(d){return d&&d.edits&&(0,b.revive)(d),d}e.reviveWorkspaceEditDto=I;var y;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,t.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,t.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,t.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,t.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,t.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,t.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,t.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,t.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,t.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,t.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,t.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,t.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,t.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,t.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,t.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,t.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,t.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,t.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,t.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,t.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,t.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,t.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,t.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,t.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,t.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,t.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,t.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,t.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,t.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,t.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,t.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,t.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,t.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,t.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,t.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,t.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,t.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,t.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,t.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,t.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,t.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,t.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,t.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,t.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,t.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,t.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,t.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,t.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,t.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,t.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,t.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,t.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,t.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,t.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,t.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,t.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,t.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,t.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,t.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,t.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,t.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,t.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,t.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,t.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,t.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,t.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,t.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,t.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,t.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,t.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,t.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,t.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,t.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,t.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,t.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,t.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,t.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,t.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,t.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,t.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,t.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,t.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,t.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,t.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,t.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,t.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,t.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,t.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,t.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,t.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,t.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,t.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,t.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,t.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,t.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,t.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,t.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,t.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,t.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,t.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,t.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,t.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,t.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,t.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,t.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,t.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,t.createProxyIdentifier)("ExtHostTelemetry")}});var At=this&&this.__classPrivateFieldSet||function(oe,e,b,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,b):D?D.value=b:e.set(oe,b),b},nt=this&&this.__classPrivateFieldGet||function(oe,e,b,t){if(b==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?t:b==="a"?t.call(oe):t?t.value:e.get(oe)};define(ve[257],we([0,1,12,118,125,22,256,18,13,42,49,97,4,2,5,243,251,16,127,38]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c){"use strict";var l,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(u,m){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,f.set(this,void 0),At(this,l,u.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=m,At(this,f,u.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new o(this,P=>{const F=this._apiCommands.get(P);return F?.result===i.Void?F:void 0},m),this._argumentProcessors=[{processArgument(P){return(0,E.revive)(P)}},{processArgument(P){return(0,C.cloneAndChange)(P,function(F){if(T.Range.isIRange(F))return D.Range.to(F);if(R.Position.isIPosition(F))return D.Position.to(F);if(T.Range.isIRange(F.range)&&w.URI.isUri(F.uri))return D.location.to(F);if(F instanceof d.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const m=this.registerCommand(!1,u.id,async(...P)=>{const F=u.args.map((Y,se)=>{if(!Y.validate(P[se]))throw new Error(`Invalid argument '${Y.name}' when running '${u.id}', received: ${P[se]}`);return Y.convert(P[se])}),q=await this.executeCommand(u.internalId,...F);return u.result.convert(q,P,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new t.Disposable(()=>{m.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,m,P,F,q,Y){if(this._logService.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this._commands.has(m))throw new Error(`command '${m}' already exists`);return this._commands.set(m,{callback:P,thisArg:F,description:q,extension:Y}),u&&nt(this,l,"f").$registerCommand(m),new t.Disposable(()=>{this._commands.delete(m)&&u&&nt(this,l,"f").$unregisterCommand(m)})}executeCommand(u,...m){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,m,!0)}async _doExecuteCommand(u,m,P){if(this._commands.has(u))return nt(this,l,"f").$fireCommandActivationEvent(u),this._executeContributedCommand(u,m,!1);{let F=!1;const q=(0,C.cloneAndChange)(m,function(Y){if(Y instanceof t.Position)return D.Position.from(Y);if(Y instanceof t.Range)return D.Range.from(Y);if(Y instanceof t.Location)return D.location.from(Y);if(t.NotebookRange.isNotebookRange(Y))return D.NotebookRange.from(Y);if(Y instanceof ArrayBuffer)return F=!0,d.VSBuffer.wrap(new Uint8Array(Y));if(Y instanceof Uint8Array)return F=!0,d.VSBuffer.wrap(Y);if(Y instanceof d.VSBuffer)return F=!0,Y;if(!Array.isArray(Y))return Y});try{const Y=await nt(this,l,"f").$executeCommand(u,F?new g.SerializableObjectWithBuffers(q):q,P);return(0,E.revive)(Y)}catch(Y){if(Y instanceof Error&&Y.message==="$executeCommand:retry")return this._doExecuteCommand(u,m,!1);throw Y}}}async _executeContributedCommand(u,m,P){const F=this._commands.get(u);if(!F)throw new Error("Unknown command");this._reportTelemetry(F,u);const{callback:q,thisArg:Y,description:se}=F;if(se)for(let _=0;_<se.args.length;_++)try{(0,b.validateConstraint)(m[_],se.args[_].constraint)}catch{throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${se.args[_].name}' - ${se.args[_].description}`)}try{return await q.apply(Y,m)}catch(_){if(u===this.converter.delegatingCommandId){const G=this.converter.getActualCommand(...m);G&&(u=G.command)}throw this._logService.error(_,u,F.extension?.identifier),P?new class extends Error{constructor(){super((0,c.toErrorMessage)(_));this.id=u,this.source=F.extension?.displayName??F.extension?.name}}:_}}_reportTelemetry(u,m){!u.extension||u.extension.isBuiltin||nt(this,f,"f").$publicLog2("Extension:ActionExecuted",{extensionId:u.extension.identifier.value,id:m})}$executeContributedCommand(u,...m){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(m=m.map(P=>this._argumentProcessors.reduce((F,q)=>q.processArgument(F),P)),this._executeContributedCommand(u,m,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),nt(this,l,"f").$getCommands().then(m=>(u&&(m=m.filter(P=>P[0]!=="_")),m))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(const[m,P]of this._commands){const{description:F}=P;F&&(u[m]=F)}return Promise.resolve(u)}};l=new WeakMap,f=new WeakMap,r=Ae([_e(0,I.IExtHostRpcService),_e(1,p.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class o{constructor(u,m,P){this._commands=u,this._lookupApiCommand=m,this._logService=P,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,m){if(!u)return;const P={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return P;const F=this._lookupApiCommand(u.command);if(F)P.id=F.internalId,P.arguments=F.args.map((q,Y)=>q.convert(u.arguments&&u.arguments[Y]));else if((0,S.isNonEmptyArray)(u.arguments)){const q=++this._cachIdPool;this._cache.set(q,u),m.add((0,v.toDisposable)(()=>{this._cache.delete(q),this._logService.trace("CommandsConverter#DISPOSE",q)})),P.$ident=q,P.id=this.delegatingCommandId,P.arguments=[q],this._logService.trace("CommandsConverter#CREATE",u.command,q)}return P}fromInternal(u){return typeof u.$ident=="number"?this._cache.get(u.$ident):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const m=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],m?m.command:"MISSING"),m?this._commands.executeCommand(m.command,...m.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class n{constructor(u,m,P,F){this.name=u,this.description=m,this.validate=P,this.convert=F}optional(){return new n(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,m){return new n(u??this.name,m??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",a=>w.URI.isUri(a),a=>a),n.Position=new n("position","A position in a text document",a=>t.Position.isPosition(a),D.Position.from),n.Range=new n("range","A range in a text document",a=>t.Range.isRange(a),D.Range.from),n.Selection=new n("selection","A selection in a text document",a=>t.Selection.isSelection(a),D.Selection.from),n.Number=new n("number","",a=>typeof a=="number",a=>a),n.String=new n("string","",a=>typeof a=="string",a=>a),n.CallHierarchyItem=new n("item","A call hierarchy item",a=>a instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",a=>a instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",a=>a instanceof y.TestItemImpl,D.TestItem.from);class i{constructor(u,m){this.description=u,this.convert=m}}e.ApiCommandResult=i,i.Void=new i("no result",a=>a);class s{constructor(u,m,P,F,q){this.id=u,this.internalId=m,this.description=P,this.args=F,this.result=q}}e.ApiCommand=s}),define(ve[258],we([0,1,57,241,30,257,4,13,78]),function(oe,e,b,t,D,C,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class E{constructor(w,v,h){this._commands=w,this.logService=v,this._ipcHandlePath=h,this._server=t.createServer((I,y)=>this.onRequest(I,y)),this.setup().catch(I=>(v.error(I),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",w=>this.logService.error(w))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(w,v){const h=(y,d)=>{v.writeHead(y,{"content-type":"application/json"}),v.end(JSON.stringify(d||null),g=>g&&this.logService.error(g))},I=[];w.setEncoding("utf8"),w.on("data",y=>I.push(y)),w.on("end",async()=>{try{const y=JSON.parse(I.join(""));let d;switch(y.type){case"open":d=await this.open(y);break;case"openExternal":d=await this.openExternal(y);break;case"status":d=await this.getStatus(y);break;case"extensionManagement":d=await this.manageExtensions(y);break;default:h(404,`Unknown message type: ${y.type}`);break}h(200,d)}catch(y){const d=y instanceof Error?y.message:JSON.stringify(y);h(500,d),this.logService.error("Error while processing pipe request",y)}})}async open(w){const{fileURIs:v,folderURIs:h,forceNewWindow:I,diffMode:y,mergeMode:d,addMode:g,forceReuseWindow:c,gotoLineMode:l,waitMarkerFilePath:f,remoteAuthority:r}=w,o=[];if(Array.isArray(h))for(const a of h)try{o.push({folderUri:k.URI.parse(a)})}catch{}if(Array.isArray(v))for(const a of v)try{(0,p.hasWorkspaceFileExtension)(a)?o.push({workspaceUri:k.URI.parse(a)}):o.push({fileUri:k.URI.parse(a)})}catch{}const n=f?k.URI.file(f):void 0,s={forceNewWindow:I,diffMode:y,mergeMode:d,addMode:g,gotoLineMode:l,forceReuseWindow:c,preferNewWindow:!c&&!n&&!g,waitMarkerFileURI:n,remoteAuthority:r};return this._commands.executeCommand("_remoteCLI.windowOpen",o,s),""}async openExternal(w){for(const v of w.uris){const h=k.URI.parse(v),I=h.scheme==="file"?h:v;await this._commands.executeCommand("_remoteCLI.openExternal",I)}}async manageExtensions(w){const v=I=>I?.map(y=>/\.vsix$/i.test(y)?k.URI.parse(y):y),h={list:w.list,install:v(w.install),uninstall:v(w.uninstall),force:w.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",h)}async getStatus(w){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=E;let T=class extends E{constructor(w,v){super(w,v,(0,b.createRandomIPCHandle)())}};T=Ae([_e(0,C.IExtHostCommands),_e(1,S.ILogService)],T),e.CLIServer=T}),define(ve[259],we([0,1,28,7,22,2,6,3,4,57,63,258,246,120,247,249,126]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class d extends I.AbstractVariableResolverService{constructor(l,f,r,o,n){super({getFolderUri:i=>{const s=f.filter(a=>a.name===i);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(i,s)=>o[`config:${s}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(r)return k.normalize(r.fsPath)},getSelectedText:()=>o.selectedText,getLineNumber:()=>o.lineNumber,getExtension:async i=>{const a=(await n.getInstalled()).find(u=>u.identifier.id===i);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(b.homedir()),Promise.resolve(l))}}class g extends C.Disposable{constructor(l,f,r,o,n){super();this._environmentService=l,this._logService=f,this._ptyService=r,this._productService=o,this._extensionManagementService=n,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(l,f,r){switch(f){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,r);case"$createProcess":{const o=(0,T.createURITransformer)(l.remoteAuthority);return this._createProcess(o,r)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,r);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,r);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,r);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,r);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,r);case"$start":return this._ptyService.start.apply(this._ptyService,r);case"$input":return this._ptyService.input.apply(this._ptyService,r);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,r);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,r);case"$resize":return this._ptyService.resize.apply(this._ptyService,r);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,r);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,r);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,r);case"$sendCommandResult":return this._sendCommandResult(r[0],r[1],r[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,r);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,r);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,r);case"$getProfiles":return this._getProfiles.apply(this,r);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(r[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(r);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,r);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,r);case"$getRevivedPtyNewId":return this._ptyService.getRevivedPtyNewId.apply(this._ptyService,r);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,r);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,r);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,r);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,r);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,r);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(r[0],r[1])}throw new Error(`IPC Command ${f} not found`)}listen(l,f,r){switch(f){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(l,f){const r={name:f.shellLaunchConfig.name,executable:f.shellLaunchConfig.executable,args:f.shellLaunchConfig.args,cwd:typeof f.shellLaunchConfig.cwd=="string"||typeof f.shellLaunchConfig.cwd=="undefined"?f.shellLaunchConfig.cwd:p.URI.revive(l.transformIncoming(f.shellLaunchConfig.cwd)),env:f.shellLaunchConfig.env,useShellEnvironment:f.shellLaunchConfig.useShellEnvironment,reconnectionProperties:f.shellLaunchConfig.reconnectionProperties,type:f.shellLaunchConfig.type,isFeatureTerminal:f.shellLaunchConfig.isFeatureTerminal},o=await(0,y.buildUserEnvironment)(f.resolverEnv,!!f.shellLaunchConfig.useShellEnvironment,S.language,this._environmentService,this._logService);this._logService.trace("baseEnv",o);const n=j=>({uri:p.URI.revive(l.transformIncoming(j.uri)),name:j.name,index:j.index,toResource:()=>{throw new Error("Not implemented")}}),i=f.workspaceFolders.map(n),s=f.activeWorkspaceFolder?n(f.activeWorkspaceFolder):void 0,a=f.activeFileResource?p.URI.revive(l.transformIncoming(f.activeFileResource)):void 0,u=new d(o,i,a,f.resolvedVariables,this._extensionManagementService),m=h.createVariableResolver(s,process.env,u),P=await h.getCwd(r,b.homedir(),m,s?.uri,f.configuration["terminal.integrated.cwd"],this._logService);r.cwd=P;const F=S.isWindows?"terminal.integrated.env.windows":S.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",q=f.configuration[F],Y=await h.createTerminalEnvironment(r,q,m,this._productService.version,f.configuration["terminal.integrated.detectLocale"],o);if(!r.strictEnv){const j=[];for(const[U,M]of f.envVariableCollections)j.push([U,{map:(0,v.deserializeEnvironmentVariableCollection)(M)}]);const he=new Map(j);await new w.MergedEnvironmentVariableCollection(he).applyToProcessEnvironment(Y,m)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:P,cols:f.cols,rows:f.rows,env:Y});const se=(0,E.createRandomIPCHandle)();Y.VSCODE_IPC_HOOK_CLI=se;const _=await this._ptyService.createProcess(r,P,f.cols,f.rows,f.unicodeVersion,Y,o,f.options,f.shouldPersistTerminal,f.workspaceId,f.workspaceName),G={executeCommand:(j,...he)=>this._executeCommand(_,j,he,l)},te=new R.CLIServerBase(G,this._logService,se);return this._ptyService.onProcessExit(j=>j.id===_&&te.dispose()),{persistentTerminalId:_,resolvedShellLaunchConfig:r}}_executeCommand(l,f,r,o){let n,i;const s=new Promise((m,P)=>{n=m,i=P}),a=++this._lastReqId;this._pendingCommands.set(a,{resolve:n,reject:i,uriTransformer:o});const u=(0,D.cloneAndChange)(r,m=>{if(m&&m.$mid===1)return o.transformOutgoing(m);if(m&&m instanceof p.URI)return o.transformOutgoingURI(m)});return this._onExecuteCommand.fire({reqId:a,persistentProcessId:l,commandId:f,commandArgs:u}),s}_sendCommandResult(l,f,r){const o=this._pendingCommands.get(l);if(!o)return;this._pendingCommands.delete(l);const n=(0,D.cloneAndChange)(r,i=>{if(i&&i.$mid===1)return o.uriTransformer.transformIncoming(i)});f?o.reject(n):o.resolve(n)}_getDefaultSystemShell(l){return this._ptyService.getDefaultSystemShell(l)}async _getProfiles(l,f,r,o){return this._ptyService.getProfiles?.(l,f,r,o)||[]}_getEnvironment(){return{...process.env}}_getWslPath(l){return this._ptyService.getWslPath(l)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=g}),define(ve[128],we([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(ve[260],we([0,1,11,2,8,198]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class k extends C.DiskFileSystemProviderClient{static register(p,E,T){const R=p.getConnection();if(!R)return t.Disposable.None;const w=new t.DisposableStore,v=(async()=>{try{const h=await p.getRawEnvironment();h?E.registerProvider(D.Schemas.vscodeRemote,w.add(new k(h,R))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(h){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,b.getErrorMessage)(h))}})();return w.add(E.onWillActivateFileSystemProvider(h=>{h.scheme===D.Schemas.vscodeRemote&&h.join(v)})),w}constructor(p,E){super(E.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:p.os===3})}}e.RemoteFileSystemProviderClient=k}),define(ve[129],we([0,1,30,14,6,12,21,156,271,272]),function(oe,e,b,t,D,C,k,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(r,o){let n=o.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=o}}e.ExtractError=T;function R(f){const r=f.externalFileAttributes>>16||33188;return[448,56,7].map(o=>r&o).reduce((o,n)=>o+n,r&61440)}function w(f){if(f instanceof T)return f;let r;return/end of central directory record signature not found/.test(f.message)&&(r="CorruptZip"),new T(r,f)}function v(f,r,o,n,i,s){const a=D.dirname(r),u=D.join(n,a);if(!u.startsWith(n))return Promise.reject(new Error(S.localize(0,null,r)));const m=D.join(n,r);let P;return s.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(k.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((F,q)=>{if(!s.isCancellationRequested)try{P=(0,b.createWriteStream)(m,{mode:o}),P.once("close",()=>F()),P.once("error",q),f.once("error",q),f.pipe(P)}catch(Y){q(Y)}}))}function h(f,r,o,n){let i=(0,t.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{i.cancel(),f.close()}),new Promise((a,u)=>{const m=new t.Sequencer,P=F=>{F.isCancellationRequested||(s++,f.readEntry())};f.once("error",u),f.once("close",()=>i.then(()=>{n.isCancellationRequested||f.entryCount===s?a():u(new T("Incomplete",new Error(S.localize(1,null,s,f.entryCount))))},u)),f.readEntry(),f.on("entry",F=>{if(n.isCancellationRequested)return;if(!o.sourcePathRegex.test(F.fileName)){P(n);return}const q=F.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(q)){const _=D.join(r,q);i=(0,t.createCancelablePromise)(G=>k.Promises.mkdir(_,{recursive:!0}).then(()=>P(G)).then(void 0,u));return}const Y=y(f,F),se=R(F);i=(0,t.createCancelablePromise)(_=>m.queue(()=>Y.then(G=>v(G,q,se,r,o,_).then(()=>P(_)))).then(null,u))})})}function I(f,r=!1){return new Promise((o,n)=>{(0,p.open)(f,r?{lazyEntries:!0}:void 0,(i,s)=>{i?n(w(i)):o((0,C.assertIsDefined)(s))})})}function y(f,r){return new Promise((o,n)=>{f.openReadStream(r,(i,s)=>{i?n(w(i)):o((0,C.assertIsDefined)(s))})})}function d(f,r){return new Promise((o,n)=>{const i=new E.ZipFile;r.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const s=(0,b.createWriteStream)(f);i.outputStream.pipe(s),i.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>o(f))})}e.zip=d;function g(f,r,o={},n){const i=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=I(f,!0);return o.overwrite&&(s=s.then(a=>k.Promises.rm(r).then(()=>a))),s.then(a=>h(a,r,{sourcePathRegex:i},n))}e.extract=g;function c(f,r){return I(f).then(o=>new Promise((n,i)=>{o.on("entry",s=>{s.fileName===r&&y(o,s).then(a=>n(a),a=>i(a))}),o.once("close",()=>i(new Error(S.localize(2,null,r))))}))}function l(f,r){return c(f,r).then(o=>new Promise((n,i)=>{const s=[];o.once("error",i),o.on("data",a=>s.push(a)),o.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=l}),define(ve[261],we([0,1,129,166]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(C){return(0,b.buffer)(C,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=D}),define(ve[130],we([0,1,14,38,11,2,8,6,3,19,50,12,4,23,21,129,165,72,29,233,31,34,53,55,210,234,261,211,232,36,70,17,5,13,26,32,39,37]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c,l,f,r,o,n,i,s,a,u,m,P,F,q,Y,se,_,G,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,q.refineServiceDecorator)(l.IServerExtensionManagementService);let j=class extends c.AbstractExtensionManagementService{constructor(X,re,L,O,x,ne,ue,pe,W,Z,ie,z){super(X,re,L,Z,z);this.extensionsScannerService=x,this.extensionsProfileScannerService=ne,this.downloadService=ue,this.fileService=W,this.installGalleryExtensionsTasks=new Map;const V=this._register(pe.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(pe.createInstance(he,K=>V.postUninstall(K))),this.manifestCache=this._register(new a.ExtensionsManifestCache(O,this)),this.extensionsDownloader=this._register(pe.createInstance(n.ExtensionsDownloader));const $=this._register(new u.ExtensionsWatcher(this,W,O,L,ie));this._register($.onDidChangeExtensionsByAnotherSource(({added:K,removed:le})=>{K.length&&this._onDidInstallExtensions.fire(K.map(ge=>({identifier:ge.identifier,operation:1,local:ge}))),le.forEach(ge=>this._onDidUninstallExtension.fire({identifier:ge}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(X){this.logService.trace("ExtensionManagementService#zip",X.identifier.id);const re=await this.collectFiles(X),L=await(0,I.zip)((0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,re);return w.URI.file(L)}async unzip(X){return this.logService.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const{location:re,cleanup:L}=await this.downloadVsix(X),O=S.resolve(re.fsPath);try{return await(0,s.getManifest)(O)}finally{await L()}}getInstalled(X,re){return this.extensionsScanner.scanExtensions(X??null,re)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(X,re={}){this.logService.trace("ExtensionManagementService#install",X.toString());const{location:L,cleanup:O}=await this.downloadVsix(X);try{const x=await(0,s.getManifest)(S.resolve(L.fsPath));if(x.engines&&x.engines.vscode&&!(0,P.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,f.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return await this.installExtension(x,L,re)}finally{await O()}}getMetadata(X){return this.extensionsScannerService.scanMetadata(X.location)}async updateMetadata(X,re){this.logService.trace("ExtensionManagementService#updateMetadata",X.identifier.id);const L={...re};return re.isPreReleaseVersion&&(L.preRelease=!0),X=await this.extensionsScanner.updateMetadata(X,L),this.manifestCache.invalidate(),X}async updateExtensionScope(X,re){return this.logService.trace("ExtensionManagementService#updateExtensionScope",X.identifier.id),X=await this.extensionsScanner.updateMetadata(X,{isMachineScoped:re}),this.manifestCache.invalidate(),X}removeUninstalledExtensions(X){return this.extensionsScanner.cleanUp(X)}async downloadVsix(X){if(X.scheme===k.Schemas.file)return{location:X,async cleanup(){}};this.logService.trace("Downloading extension from",X.toString());const re=(0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(X,re),this.logService.info("Downloaded extension to",re.toString()),{location:re,cleanup:async()=>{try{await this.fileService.del(re)}catch(O){this.logService.error(O)}}}}doCreateInstallExtensionTask(X,re,L){let O;if(w.URI.isUri(re))O=new M(X,re,L,this.galleryService,this.extensionsScanner,this.logService);else{const x=f.ExtensionKey.create(re).toString();O=this.installGalleryExtensionsTasks.get(x),O||(this.installGalleryExtensionsTasks.set(x,O=new U(X,re,L,this.extensionsDownloader,this.extensionsScanner,this.logService)),O.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(x)))}return L.profileLocation?new B(O,L.profileLocation,this.extensionsProfileScannerService):O}doCreateUninstallExtensionTask(X,re){return re.profileLocation?new ae(X,re.profileLocation,this.extensionsProfileScannerService):new Q(X,re,this.extensionsScanner)}async collectFiles(X){const re=async O=>{let x=await h.Promises.readdir(O);x=x.map(pe=>S.join(O,pe));const ne=await Promise.all(x.map(pe=>h.Promises.stat(pe)));let ue=Promise.resolve([]);return ne.forEach((pe,W)=>{const Z=x[W];pe.isFile()&&(ue=ue.then(ie=>[...ie,Z])),pe.isDirectory()&&(ue=ue.then(ie=>re(Z).then(z=>[...ie,...z])))}),ue};return(await re(X.location.fsPath)).map(O=>({path:`extension/${S.relative(X.location.fsPath,O)}`,localPath:O}))}};j=Ae([_e(0,l.IExtensionGalleryService),_e(1,_.ITelemetryService),_e(2,Y.ILogService),_e(3,g.INativeEnvironmentService),_e(4,o.IExtensionsScannerService),_e(5,r.IExtensionsProfileScannerService),_e(6,d.IDownloadService),_e(7,q.IInstantiationService),_e(8,F.IFileService),_e(9,se.IProductService),_e(10,G.IUriIdentityService),_e(11,te.IUserDataProfilesService)],j),e.ExtensionManagementService=j;let he=class extends C.Disposable{constructor(X,re,L,O){super();this.beforeRemovingExtension=X,this.fileService=re,this.extensionsScannerService=L,this.logService=O,this.uninstalledPath=(0,E.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new b.Queue}async cleanUp(X){await this.removeUninstalledExtensions(),X&&await this.removeOutdatedExtensions()}async scanExtensions(X,re){const L={includeInvalid:!0,profileLocation:re};let O=[];return X===null||X===0?O.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},L,!1)):X===1&&O.push(...await this.extensionsScannerService.scanUserExtensions(L)),O=X!==null?O.filter(x=>x.type===X):O,Promise.all(O.map(x=>this.toLocalExtension(x)))}async scanUserExtensions(X){const re=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return Promise.all(re.map(L=>this.toLocalExtension(L)))}async extractUserExtension(X,re,L,O){const x=X.toString(),ne=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),ue=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,x);try{await h.Promises.rm(ue)}catch{throw new l.ExtensionManagementError(y.localize(1,null,ue,X.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(X,re,ne,O),L={...L,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(w.URI.file(ne),L);try{await this.rename(X,ne,ue,Date.now()+2*60*1e3),this.logService.info("Renamed to",ue)}catch(pe){try{await h.Promises.rm(ne)}catch{}if(pe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(pe)}. Deleted from extracted location`,ne),pe}return this.scanLocalExtension(w.URI.file(ue),1)}async updateMetadata(X,re){return await this.extensionsScannerService.updateMetadata(X.location,re),this.scanLocalExtension(X.location,X.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...X){const re=X.map(L=>f.ExtensionKey.create(L));await this.withUninstalledExtensions(L=>{re.forEach(O=>L[O.toString()]=!0)})}async setInstalled(X){await this.withUninstalledExtensions(O=>delete O[X.toString()]);const L=(await this.scanUserExtensions(!0)).find(O=>f.ExtensionKey.create(O).equals(X))||null;return L?this.updateMetadata(L,{installedTimestamp:Date.now()}):null}async removeExtension(X,re){this.logService.trace(`Deleting ${re} extension from disk`,X.identifier.id,X.location.fsPath),await h.Promises.rm(X.location.fsPath),this.logService.info("Deleted from disk",X.identifier.id,X.location.fsPath)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.withUninstalledExtensions(re=>delete re[f.ExtensionKey.create(X).toString()])}async withUninstalledExtensions(X){return this.uninstalledFileLimiter.queue(async()=>{let re;try{re=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let L={};if(re)try{L=JSON.parse(re)}catch{}return X&&(X(L),Object.keys(L).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(L)):await h.Promises.rm(this.uninstalledPath)),L})}async extractAtLocation(X,re,L,O){this.logService.trace(`Started extracting the extension from ${re} to ${L}`);try{await h.Promises.rm(L)}catch(x){throw new l.ExtensionManagementError(this.joinErrors(x).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,I.extract)(re,L,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${L}:`,X.id)}catch(x){try{await h.Promises.rm(L)}catch{}let ne=l.ExtensionManagementErrorCode.Extract;throw x instanceof I.ExtractError&&(x.type==="CorruptZip"?ne=l.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(ne=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(x.message,ne)}}async rename(X,re,L,O){try{await h.Promises.rename(re,L)}catch(x){if(p.isWindows&&x&&x.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${re} to ${L} with 'EPERM' error. Trying again...`,X.id),this.rename(X,re,L,O);throw new l.ExtensionManagementError(x.message||y.localize(2,null,re,L),x.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(X,re){const L=await this.extensionsScannerService.scanExistingExtension(X,re,{includeInvalid:!0});if(L)return this.toLocalExtension(L);throw new Error(y.localize(3,null,X.path))}async toLocalExtension(X){const re=await this.fileService.resolve(X.location);let L,O;return re.children&&(L=re.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,O=re.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:L,changelogUrl:O,publisherDisplayName:X.metadata?.publisherDisplayName||null,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated}}async removeUninstalledExtensions(){const X=await this.getUninstalledExtensions(),re=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const ne of re)X[f.ExtensionKey.create(ne).toString()]||L.add(ne.identifier.id.toLowerCase());const O=(0,f.groupByExtension)(re,ne=>ne.identifier);await b.Promises.settled(O.map(async ne=>{const ue=ne.sort((pe,W)=>T.rcompare(pe.manifest.version,W.manifest.version))[0];L.has(ue.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ue))}));const x=re.filter(ne=>X[f.ExtensionKey.create(ne).toString()]);await b.Promises.settled(x.map(ne=>this.removeUninstalledExtension(ne)))}async removeOutdatedExtensions(){const X=await this.extensionsScannerService.scanSystemExtensions({}),re=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=[],O=await this.extensionsScannerService.getTargetPlatform(),x=(0,f.groupByExtension)(re,ne=>ne.identifier);for(const ne of x)if(ne.length>1&&L.push(...ne.sort((ue,pe)=>{const W=T.rcompare(ue.manifest.version,pe.manifest.version);return W!==0?W:ue.targetPlatform===O?-1:1}).slice(1)),ne[0].type===0){const ue=X.find(pe=>(0,f.areSameExtensions)(pe.identifier,ne[0].identifier));(!ue||T.gte(ue.manifest.version,ne[0].manifest.version))&&L.push(ne[0])}await b.Promises.settled(L.map(ne=>this.removeExtension(ne,"outdated")))}joinErrors(X){const re=Array.isArray(X)?X:[X];return re.length===1?re[0]instanceof Error?re[0]:new Error(re[0]):re.reduce((L,O)=>new Error(`${L.message}${L.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}};he=Ae([_e(1,F.IFileService),_e(2,o.IExtensionsScannerService),_e(3,Y.ILogService)],he);class J extends c.AbstractExtensionTask{constructor(X,re,L,O,x){super();this.identifier=X,this.source=re,this.options=L,this.extensionsScanner=O,this.logService=x,this._operation=2}get operation(){return(0,R.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(X,re){try{const L=await this.unsetUninstalledAndGetLocal(X.key);if(L)return X.metadata?this.extensionsScanner.updateMetadata(L,X.metadata):L}catch{throw p.isMacintosh?new l.ExtensionManagementError(y.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(y.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(X,re)}async unsetUninstalledAndGetLocal(X){if(!await this.isUninstalled(X))return null;this.logService.trace("Removing the extension from uninstalled list:",X.id);const L=await this.extensionsScanner.setInstalled(X);return this.logService.info("Removed the extension from uninstalled list:",X.id),L}async isUninstalled(X){return!!(await this.extensionsScanner.getUninstalledExtensions())[X.toString()]}async extract({zipPath:X,key:re,metadata:L},O){const x=await this.extensionsScanner.extractUserExtension(re,X,L,O);return this.logService.info("Extracting completed.",re.id),x}}class U extends J{constructor(X,re,L,O,x,ne){super(re.identifier,re,L,x,ne);this.manifest=X,this.gallery=re,this.extensionsDownloader=O}async doRun(X){const L=(await this.extensionsScanner.scanExtensions(null,void 0)).find(ne=>(0,f.areSameExtensions)(ne.identifier,this.gallery.identifier));L&&(this._operation=3);const O={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,m.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,R.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:L?.preRelease)};if(L?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(L,O),metadata:O};const x=await this.downloadExtension(this.gallery,this._operation);try{const ne=await this.installExtension({zipPath:x,key:f.ExtensionKey.create(this.gallery),metadata:O},X);return L&&!this.options.profileLocation&&(L.targetPlatform!==ne.targetPlatform||T.neq(L.manifest.version,ne.manifest.version))&&await this.extensionsScanner.setUninstalled(L),{local:ne,metadata:O}}catch(ne){throw await this.deleteDownloadedVSIX(x),ne}}async deleteDownloadedVSIX(X){try{await this.extensionsDownloader.delete(w.URI.file(X))}catch(re){this.logService.warn("Error while deleting the downloaded vsix",X.toString(),(0,D.getErrorMessage)(re))}}async downloadExtension(X,re){let L;try{this.logService.trace("Started downloading extension:",X.identifier.id),L=(await this.extensionsDownloader.downloadExtension(X,re)).fsPath,this.logService.info("Downloaded extension:",X.identifier.id,L)}catch(O){throw new l.ExtensionManagementError((0,c.joinErrors)(O).message,l.ExtensionManagementErrorCode.Download)}try{return await(0,s.getManifest)(L),L}catch(O){throw await this.deleteDownloadedVSIX(L),new l.ExtensionManagementError((0,c.joinErrors)(O).message,l.ExtensionManagementErrorCode.Invalid)}}}class M extends J{constructor(X,re,L,O,x,ne){super({id:(0,f.getGalleryExtensionId)(X.publisher,X.name)},re,L,x,ne);this.manifest=X,this.location=re,this.galleryService=O}async doRun(X){const re=new f.ExtensionKey(this.identifier,this.manifest.version),O=(await this.extensionsScanner.scanExtensions(1,void 0)).find(ue=>(0,f.areSameExtensions)(this.identifier,ue.identifier)),x=await this.getMetadata(this.identifier.id,this.manifest.version,X);if(x.isApplicationScoped=(0,m.isApplicationScopedExtension)(this.manifest),x.isMachineScoped=this.options.isMachineScoped||O?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||O?.isBuiltin,O)if(this._operation=3,re.equals(new f.ExtensionKey(O.identifier,O.manifest.version)))try{await this.extensionsScanner.removeExtension(O,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&T.gt(O.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(O);else{const ue=await this.unsetUninstalledAndGetLocal(re);if(ue)try{await this.extensionsScanner.removeExtension(ue,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:S.resolve(this.location.fsPath),key:re,metadata:x},X),metadata:x}}async getMetadata(X,re,L){try{let[O]=await this.galleryService.getExtensions([{id:X,version:re}],L);if(O||([O]=await this.galleryService.getExtensions([{id:X}],L)),O)return{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B{constructor(X,re,L){this.task=X,this.profileLocation=re,this.extensionsProfileScannerService=L,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const X=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[X.local,X.metadata]],this.profileLocation),X}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Q extends c.AbstractExtensionTask{constructor(X,re,L){super();this.extension=X,this.options=re,this.extensionsScanner=L}async doRun(X){const re=[],L=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const O=f.ExtensionKey.create(this.extension);re.push(...L.filter(x=>O.equals(f.ExtensionKey.create(x))))}else re.push(...L.filter(O=>(0,f.areSameExtensions)(O.identifier,this.extension.identifier)));if(!re.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...re),this.options.remove)for(const O of re)try{X.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(O)}catch(x){throw new Error(y.localize(9,null,(0,t.toErrorMessage)(x)))}}}class ae extends c.AbstractExtensionTask{constructor(X,re,L){super();this.extension=X,this.profileLocation=re,this.extensionsProfileScannerService=L}async doRun(X){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ve[131],we([0,1,76,14,16,11,2,12,25,29,77,13,214,273]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let h=class extends k.Disposable{constructor(y,d,g){super();this.environmentService=d,this.logService=g,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,d){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:g,strictSSL:c}=this;let l;try{l=await(0,T.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const f={...process.env,...l},r=y.agent?y.agent:await(0,w.getProxyAgent)(y.url||"",f,{proxyUrl:g,strictSSL:c});y.agent=r,y.strictSSL=c,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(y,d);return this.logService.trace("RequestService#request (node) - success",y.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",y.url,o),o}}async getNodeRequest(y){return((0,b.parse)(y.url).protocol==="https:"?await new Promise((c,l)=>{oe(["https"],c,l)}):await new Promise((c,l)=>{oe(["http"],c,l)})).request}_request(y,d){return t.Promises.withAsyncBody(async(g,c)=>{const l=(0,b.parse)(y.url),f=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),r={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,S.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(r.auth=y.user+":"+y.password);const o=f(r,n=>{const i=(0,S.isNumber)(y.followRedirects)?y.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...y,url:n.headers.location,followRedirects:i-1},d).then(g,c);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,v.createGunzip)())),g({res:n,stream:(0,D.streamToBufferReadableStream)(s)})}});o.on("error",c),y.timeout&&o.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&o.write(y.data),o.end(),d.onCancellationRequested(()=>{o.abort(),c(new C.CancellationError)})})}async resolveProxy(y){}};h=Ae([_e(0,p.IConfigurationService),_e(1,E.INativeEnvironmentService),_e(2,R.ILogService)],h),e.RequestService=h}),define(ve[262],we([0,1,73,13,59,106,25,54,131,44,32,31,115,130,101,51,2,102,61,8,17,26,104,128,40,108,74,109,11,4,6,27,212,72,39,114,58,3,55,117,37,53,62]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c,l,f,r,o,n,i,s,a,u,m,P,F,q,Y,se,_,G,te,j,he,J,U,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class B extends y.Disposable{constructor(X,re){super();this.args=X,this.remoteDataFolder=re,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async re=>{const L=re.get(t.ILogService),O=re.get(R.IExtensionManagementCLIService);try{await this.doRun(O)}catch(x){throw L.error(x),console.error((0,u.getErrorMessage)(x)),x}})}async initServices(){const X=new b.ServiceCollection,re={_serviceBrand:void 0,...I.default};X.set(f.IProductService,re);const L=new n.ServerEnvironmentService(this.args,re);X.set(n.IServerEnvironmentService,L);const O=new t.LogService(new r.SpdLogLogger(o.RemoteExtensionLogFileName,(0,P.join)(L.logsPath,`${o.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(L)));X.set(t.ILogService,O),O.trace(`Remote configuration data at ${this.remoteDataFolder}`),O.trace("process arguments:",this.args);const x=this._register(new d.FileService(O));X.set(l.IFileService,x),x.registerProvider(c.Schemas.file,this._register(new g.DiskFileSystemProvider(O)));const ne=new _.UriIdentityService(x);X.set(se.IUriIdentityService,ne);const ue=this._register(new J.UserDataProfilesService(L,x,ne,O));X.set(J.IUserDataProfilesService,ue);const pe=this._register(new C.ConfigurationService(ue.defaultProfile.settingsResource,x,new M.NullPolicyService,O));return await pe.initialize(),X.set(k.IConfigurationService,pe),X.set(S.IRequestService,new D.SyncDescriptor(p.RequestService)),X.set(Y.IDownloadService,new D.SyncDescriptor(q.DownloadService)),X.set(T.ITelemetryService,E.NullTelemetryService),X.set(R.IExtensionGalleryService,new D.SyncDescriptor(w.ExtensionGalleryServiceWithNoStorageService)),X.set(U.IExtensionsProfileScannerService,new D.SyncDescriptor(U.ExtensionsProfileScannerService)),X.set(j.IExtensionsScannerService,new D.SyncDescriptor(he.ExtensionsScannerService)),X.set(v.INativeServerExtensionManagementService,new D.SyncDescriptor(v.ExtensionManagementService)),X.set(R.IExtensionManagementCLIService,new D.SyncDescriptor(i.ExtensionManagementCLIService)),X.set(s.ILanguagePackService,new D.SyncDescriptor(a.NativeLanguagePackService)),new h.InstantiationService(X)}async doRun(X){if(this.args["list-extensions"])return X.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const re={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return X.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],re,!!this.args.force)}else{if(this.args["uninstall-extension"])return X.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return X.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(X){return X.map(re=>/\.vsix$/i.test(re)?m.URI.file((0,P.isAbsolute)(re)?re:(0,P.join)((0,F.cwd)(),re)):re)}}function Q(fe){setTimeout(()=>process.exit(fe),0)}async function ae(fe,X,re){if(fe.help){const O=I.default.serverApplicationName+(te.isWindows?".cmd":"");console.log((0,G.buildHelpMessage)(I.default.nameLong,O,I.default.version,re,{noInputFiles:!0,noPipe:!0}));return}if(fe.version){console.log((0,G.buildVersionMessage)(I.default.version,I.default.commit));return}const L=new B(fe,X);try{await L.run(),Q(0)}catch{Q(1)}finally{L.dispose()}}e.run=ae}),define(ve[263],we([0,1,28,7,2,8,6,90,21,43,25,106,71,239,185,72,186,196,187,29,115,31,108,197,130,17,102,61,59,101,73,74,109,13,103,104,51,26,54,213,131,111,32,44,224,112,231,39,114,255,244,216,221,259,63,40,252,128,260,116,55,117,53,37,240,62,222]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c,l,f,r,o,n,i,s,a,u,m,P,F,q,Y,se,_,G,te,j,he,J,U,M,B,Q,ae,fe,X,re,L,O,x,ne,ue,pe,W,Z,ie,z,V,$,K,le,ge,Pe,Te,Ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Ue="monacoworkbench";async function me(Ge,je,We,ce){const Ce=new P.ServiceCollection,ke=new Oe,Fe={_serviceBrand:void 0,...G.default};Ce.set(te.IProductService,Fe);const Re=new W.ServerEnvironmentService(je,Fe);Ce.set(c.IEnvironmentService,Re),Ce.set(c.INativeEnvironmentService,Re);const Be=new Y.LogService(new _.SpdLogLogger(ie.RemoteExtensionLogFileName,k.join(Re.logsPath,`${ie.RemoteExtensionLogFileName}.log`),!0,!1,(0,Y.getLogLevel)(Re))),He=new Y.MultiplexLogService([new Me((0,Y.getLogLevel)(Re)),Be]);Ce.set(Y.ILogService,He),setTimeout(()=>Ze(Re.logsPath).then(null,st=>He.error(st)),1e4),He.trace(`Remote configuration data at ${We}`),He.trace("process arguments:",Re.args),Array.isArray(Fe.serverGreeting)&&Be.info(`

${Fe.serverGreeting.join(`
`)}

`),ke.registerChannel(h.ExtensionHostDebugBroadcastChannel.ChannelName,new h.ExtensionHostDebugBroadcastChannel);const Qe=new E.StaticRouter(st=>st.clientId==="renderer");ke.registerChannel("logger",new se.LogLevelChannel(He));const Xe=ce.add(new s.FileService(He));Ce.set(i.IFileService,Xe),Xe.registerProvider(C.Schemas.file,ce.add(new a.DiskFileSystemProvider(He)));const tt=new re.UriIdentityService(Xe);Ce.set(X.IUriIdentityService,tt);const it=new ge.UserDataProfilesService(Re,Xe,tt,He);Ce.set(ge.IUserDataProfilesService,it);const rt=new R.ConfigurationService(Re.machineSettingsResource,Xe,new Te.NullPolicyService,He);Ce.set(T.IConfigurationService,rt),await rt.initialize();const ft=new V.ExtensionHostStatusService;Ce.set(V.IExtensionHostStatusService,ft),Ce.set(j.IRequestService,new u.SyncDescriptor(J.RequestService));let ut=B.NullAppender;const Pt=await(0,S.getMachineId)(),yt=(0,B.isInternalTelemetry)(Fe,rt);if((0,B.supportsTelemetry)(Fe,Re)){const st=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";st?ut=new Ne.OneDataSystemAppender(!1,Ue,null,()=>new Pe.TelemetryClient(st)):Fe.aiConfig&&Fe.aiConfig.ariaKey&&(ut=new Ne.OneDataSystemAppender(yt,Ue,null,Fe.aiConfig.ariaKey)),ce.add((0,D.toDisposable)(()=>ut?.flush()));const St={appenders:[ut],commonProperties:(0,U.resolveCommonProperties)(Xe,(0,b.release)(),(0,b.hostname)(),process.arch,Fe.commit,Fe.version+"-remote",Pt,yt,Re.installSourcePath,"remoteAgent"),piiPaths:(0,B.getPiiPathsFromEnvironment)(Re)},dt=Re.args["telemetry-level"];let mt=3;dt==="all"?mt=3:dt==="error"?mt=2:dt==="crash"?mt=1:dt!==void 0&&(mt=0),Ce.set(ne.IServerTelemetryService,new u.SyncDescriptor(ne.ServerTelemetryService,[St,mt]))}else Ce.set(ne.IServerTelemetryService,ne.ServerNullTelemetryService);Ce.set(f.IExtensionGalleryService,new u.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService));const _t=ke.getChannel("download",Qe);Ce.set(I.IDownloadService,new y.DownloadServiceChannelClient(_t,()=>ye("renderer"))),Ce.set(le.IExtensionsProfileScannerService,new u.SyncDescriptor(le.ExtensionsProfileScannerService)),Ce.set($.IExtensionsScannerService,new u.SyncDescriptor(K.ExtensionsScannerService)),Ce.set(n.INativeServerExtensionManagementService,new u.SyncDescriptor(n.ExtensionManagementService));const ht=new m.InstantiationService(Ce);Ce.set(F.ILanguagePackService,ht.createInstance(q.NativeLanguagePackService));const Et=ht.createInstance(r.ExtensionManagementCLIService);Ce.set(f.IExtensionManagementCLIService,Et);const kt=ht.createInstance(fe.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:rt.getValue("terminal.integrated.persistentSessionScrollback")??100});return Ce.set(ae.IPtyService,kt),Ce.set(d.IEncryptionMainService,new u.SyncDescriptor(g.EncryptionMainService,[Pt])),Ce.set(w.ICredentialsMainService,new u.SyncDescriptor(v.CredentialsWebMainService)),ht.invokeFunction(st=>{const St=st.get(n.INativeServerExtensionManagementService),dt=st.get($.IExtensionsScannerService),mt=new L.RemoteAgentEnvironmentChannel(Ge,Re,it,Et,He,ft,dt);ke.registerChannel("remoteextensionsenvironment",mt);const Se=new x.ServerTelemetryChannel(st.get(ne.IServerTelemetryService),ut);ke.registerChannel("telemetry",Se),ke.registerChannel(Z.REMOTE_TERMINAL_CHANNEL_NAME,new ue.RemoteTerminalChannel(Re,He,kt,Fe,St));const Ie=new O.RemoteAgentFileSystemProviderChannel(He,Re);ke.registerChannel(z.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Ie),ke.registerChannel("request",new he.RequestChannel(st.get(j.IRequestService)));const de=new o.ExtensionManagementChannel(St,Ye=>ye(Ye.remoteAuthority));ke.registerChannel("extensions",de);const H=E.ProxyChannel.fromService(st.get(F.ILanguagePackService));ke.registerChannel("languagePacks",H);const De=E.ProxyChannel.fromService(st.get(d.IEncryptionMainService));ke.registerChannel("encryption",De);const Le=E.ProxyChannel.fromService(st.get(w.ICredentialsMainService));return ke.registerChannel("credentials",Le),St.removeUninstalledExtensions(!0),ce.add(new Q.default(st.get(M.ITelemetryService))),{telemetryService:st.get(M.ITelemetryService)}}),{socketServer:ke,instantiationService:ht}}e.setupServerServices=me;const be=Object.create(null);function ye(Ge){return be[Ge]||(be[Ge]=(0,pe.createURITransformer)(Ge)),be[Ge]}class Oe extends E.IPCServer{constructor(){const je=new t.Emitter;super(je.event);this._onDidConnectEmitter=je}acceptConnection(je,We){this._onDidConnectEmitter.fire({protocol:je,onDidClientDisconnect:We})}}e.SocketServer=Oe;class Me extends Y.AbstractLogger{constructor(je=Y.DEFAULT_LOG_LEVEL){super();this.setLevel(je),this.useColors=Boolean(process.stdout.isTTY)}trace(je,...We){this.getLevel()<=Y.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Ke()}][0m`,je,...We):console.log(`[${Ke()}]`,je,...We))}debug(je,...We){this.getLevel()<=Y.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Ke()}][0m`,je,...We):console.log(`[${Ke()}]`,je,...We))}info(je,...We){this.getLevel()<=Y.LogLevel.Info&&(this.useColors?console.log(`[90m[${Ke()}][0m`,je,...We):console.log(`[${Ke()}]`,je,...We))}warn(je,...We){this.getLevel()<=Y.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Ke()}][0m`,je,...We):console.warn(`[${Ke()}]`,je,...We))}error(je,...We){this.getLevel()<=Y.LogLevel.Error&&(this.useColors?console.error(`[91m[${Ke()}][0m`,je,...We):console.error(`[${Ke()}]`,je,...We))}critical(je,...We){this.getLevel()<=Y.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Ke()}][0m`,je,...We):console.error(`[${Ke()}]`,je,...We))}dispose(){}flush(){}}function Ke(){const Ge=new Date;return`${$e(Ge.getHours())}:${$e(Ge.getMinutes())}:${$e(Ge.getSeconds())}`}function $e(Ge){return Ge<10?`0${Ge}`:String(Ge)}async function Ze(Ge){const je=k.basename(Ge),We=k.dirname(Ge),ke=(await p.Promises.readdir(We)).filter(Re=>/^\d{8}T\d{6}$/.test(Re)).sort().filter(Re=>Re!==je),Fe=ke.slice(0,Math.max(0,ke.length-9));await Promise.all(Fe.map(Re=>p.Promises.rm(k.join(We,Re))))}}),define(ve[264],we([0,1,110,30,91,265,76,132,16,11,35,2,8,6,47,3,15,4,23,146,95,57,5,13,26,75,32,126,236,237,40,263,242]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w,v,h,I,y,d,g,c,l,f,r,o,n,i,s,a,u,m,P,F,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const Y=5*60*1e3;let se=class extends R.Disposable{constructor(j,he,J,U,M,B,Q,ae){super();this._socketServer=j,this._connectionToken=he,this._vsdaMod=J,this._environmentService=M,this._productService=B,this._logService=Q,this._instantiationService=ae,this._webEndpointOriginChecker=G.create(this._productService),this._serverRootPath=(0,i.getRemoteServerRootPath)(B),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=U?this._instantiationService.createInstance(q.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(j,he){if(j.method!=="GET")return(0,q.serveError)(j,he,405,`Unsupported method ${j.method}`);if(!j.url)return(0,q.serveError)(j,he,400,"Bad request.");const J=k.parse(j.url,!0);let U=J.pathname;if(!U)return(0,q.serveError)(j,he,400,"Bad request.");if(U.startsWith(this._serverRootPath)&&U.charCodeAt(this._serverRootPath.length)===47&&(U=U.substring(this._serverRootPath.length)),U==="/version")return he.writeHead(200,{"Content-Type":"text/plain"}),he.end(this._productService.commit||"");if(U==="/delay-shutdown")return this._delayShutdown(),he.writeHead(200),he.end("OK");if(!(0,m.requestHasValidConnectionToken)(this._connectionToken,j,J))return(0,q.serveError)(j,he,403,"Forbidden.");if(U==="/vscode-remote-resource"){const M=J.query.path;if(typeof M!="string")return(0,q.serveError)(j,he,400,"Bad request.");let B;try{B=d.URI.from({scheme:w.Schemas.file,path:M}).fsPath}catch{return(0,q.serveError)(j,he,400,"Bad request.")}const Q=Object.create(null);this._environmentService.isBuilt&&((0,T.isEqualOrParent)(B,this._environmentService.builtinExtensionsPath,!I.isLinux)||(0,T.isEqualOrParent)(B,this._environmentService.extensionsPath,!I.isLinux))&&(Q["Cache-Control"]="public, max-age=31536000"),Q.Vary="Origin";const ae=j.headers.origin;return ae&&this._webEndpointOriginChecker.matches(ae)&&(Q["Access-Control-Allow-Origin"]=ae),(0,q.serveFile)(B,1,this._logService,j,he,Q)}if(this._webClientServer){this._webClientServer.handle(j,he,J);return}return he.writeHead(404,{"Content-Type":"text/plain"}),he.end("Not found")}handleUpgrade(j,he){let J=(0,g.generateUuid)(),U=!1,M=!1;if(j.url){const re=k.parse(j.url,!0).query;typeof re.reconnectionToken=="string"&&(J=re.reconnectionToken),re.reconnection==="true"&&(U=!0),re.skipWebSocketFrames==="true"&&(M=!0)}if(j.headers.upgrade===void 0||j.headers.upgrade.toLowerCase()!=="websocket"){he.end("HTTP/1.1 400 Bad Request");return}const B=j.headers["sec-websocket-key"],Q=b.createHash("sha1");Q.update(B+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ae=Q.digest("base64"),fe=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ae}`];let X=!1;if(!M&&!this._environmentService.args["disable-websocket-compression"]&&j.headers["sec-websocket-extensions"]){const re=Array.isArray(j.headers["sec-websocket-extensions"])?j.headers["sec-websocket-extensions"]:[j.headers["sec-websocket-extensions"]];for(const L of re)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(L)){if(/\b(permessage-deflate)\b/.test(L)){X=!0,fe.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(L)){X=!0,fe.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}he.write(fe.join(`\r
`)+`\r
\r
`),he.setTimeout(0),he.setNoDelay(!0),M?this._handleWebSocketConnection(new f.NodeSocket(he,`server-connection-${J}`),U,J):this._handleWebSocketConnection(new f.WebSocketNodeSocket(new f.NodeSocket(he,`server-connection-${J}`),X,null,!0),U,J)}handleServerError(j){this._logService.error("Error occurred in server"),this._logService.error(j)}_getRemoteAddress(j){let he;return j instanceof f.NodeSocket?he=j.socket:he=j.socket.socket,he.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(j,he,J){const U=he.getSocket();this._logService.error(`${j} ${J}.`);const M={type:"error",reason:J};he.sendControl(p.VSBuffer.fromString(JSON.stringify(M))),he.dispose(),await U.drain(),U.dispose()}_handleWebSocketConnection(j,he,J){const U=this._getRemoteAddress(j),M=`[${U}][${J.substr(0,8)}]`,B=new l.PersistentProtocol(j),Q=this._vsdaMod?new this._vsdaMod.validator:null,ae=this._vsdaMod?new this._vsdaMod.signer:null;let fe;(function(O){O[O.WaitingForAuth=0]="WaitingForAuth",O[O.WaitingForConnectionType=1]="WaitingForConnectionType",O[O.Done=2]="Done",O[O.Error=3]="Error"})(fe||(fe={}));let X=0;const re=O=>{X=3,L.dispose(),this._rejectWebSocketConnection(M,B,O)},L=B.onControlMessage(O=>{if(X===0){let x;try{x=JSON.parse(O.toString())}catch{return re("Malformed first message")}if(x.type!=="auth")return re("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(x.auth))return re("Unauthorized client refused: auth mismatch");let ne=(0,g.generateUuid)();if(ae)try{ne=ae.sign(x.data)}catch{}let ue=(0,g.generateUuid)();if(Q)try{ue=Q.createNewMessage(ue)}catch{}const pe={type:"sign",data:ue,signedData:ne};B.sendControl(p.VSBuffer.fromString(JSON.stringify(pe))),X=1}else if(X===1){let x;try{x=JSON.parse(O.toString())}catch{return re("Malformed second message")}if(x.type!=="connectionType")return re("Invalid second message");if(typeof x.signedData!="string")return re("Invalid second message field type");const ne=x.commit,ue=this._productService.commit;if(ne&&ue&&ne!==ue)return re("Client refused: version mismatch");let pe=!1;if(!Q)pe=!0;else if(this._connectionToken.validate(x.signedData))pe=!0;else try{pe=Q.validate(x.signedData)==="ok"}catch{}if(!pe){if(this._environmentService.isBuilt)return re("Unauthorized client refused");this._logService.error(`${M} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const W in this._managementConnections)this._managementConnections[W].shortenReconnectionGraceTimeIfNecessary();for(const W in this._extHostConnections)this._extHostConnections[W].shortenReconnectionGraceTimeIfNecessary();X=2,L.dispose(),this._handleConnectionType(U,M,B,j,he,J,x)}})}async _handleConnectionType(j,he,J,U,M,B,Q){const ae=Q.desiredConnectionType===1?`${he}[ManagementConnection]`:Q.desiredConnectionType===2?`${he}[ExtensionHostConnection]`:he;if(Q.desiredConnectionType===1)if(M){if(!this._managementConnections[B])return this._allReconnectionTokens.has(B)?this._rejectWebSocketConnection(ae,J,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ae,J,"Unknown reconnection token (never seen)");J.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const fe=J.readEntireBuffer();J.dispose(),this._managementConnections[B].acceptReconnection(j,U,fe)}else{if(this._managementConnections[B])return this._rejectWebSocketConnection(ae,J,"Duplicate reconnection token");J.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const fe=new u.ManagementConnection(this._logService,B,j,J);this._socketServer.acceptConnection(fe.protocol,fe.onClose),this._managementConnections[B]=fe,this._allReconnectionTokens.add(B),fe.onClose(()=>{delete this._managementConnections[B]})}else if(Q.desiredConnectionType===2){const fe=Q.args||{language:"en"},X=await this._updateWithFreeDebugPort(fe);if(X.port&&this._logService.trace(`${ae} - startParams debug port ${X.port}`),this._logService.trace(`${ae} - startParams language: ${X.language}`),this._logService.trace(`${ae} - startParams env: ${JSON.stringify(X.env)}`),M){if(!this._extHostConnections[B])return this._allReconnectionTokens.has(B)?this._rejectWebSocketConnection(ae,J,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ae,J,"Unknown reconnection token (never seen)");J.sendPause(),J.sendControl(p.VSBuffer.fromString(JSON.stringify(X.port?{debugPort:X.port}:{})));const re=J.readEntireBuffer();J.dispose(),this._extHostConnections[B].acceptReconnection(j,U,re)}else{if(this._extHostConnections[B])return this._rejectWebSocketConnection(ae,J,"Duplicate reconnection token");J.sendPause(),J.sendControl(p.VSBuffer.fromString(JSON.stringify(X.port?{debugPort:X.port}:{})));const re=J.readEntireBuffer();J.dispose();const L=this._instantiationService.createInstance(a.ExtensionHostConnection,B,j,U,re);this._extHostConnections[B]=L,this._allReconnectionTokens.add(B),L.onClose(()=>{delete this._extHostConnections[B],this._onDidCloseExtHostConnection()}),L.start(X)}}else if(Q.desiredConnectionType===3){const fe=Q.args;this._createTunnel(J,fe)}else return this._rejectWebSocketConnection(ae,J,"Unknown initial data received")}async _createTunnel(j,he){const J=j.getSocket().socket,U=j.readEntireBuffer();j.dispose(),J.pause();const M=await this._connectTunnelSocket(he.host,he.port);U.byteLength>0&&M.write(U.buffer),M.on("end",()=>J.end()),M.on("close",()=>J.end()),M.on("error",()=>J.destroy()),J.on("end",()=>M.end()),J.on("close",()=>M.end()),J.on("error",()=>M.destroy()),M.pipe(J),J.pipe(M)}_connectTunnelSocket(j,he){return new Promise((J,U)=>{const M=D.createConnection({host:j,port:he},()=>{M.removeListener("error",U),M.pause(),J(M)});M.once("error",U)})}_updateWithFreeDebugPort(j){return typeof j.port=="number"?(0,c.findFreePort)(j.port,10,5e3).then(he=>(j.port=he,j)):(j.debugId=void 0,j.port=void 0,j.break=void 0,Promise.resolve(j))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},Y))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};se=Ae([_e(4,P.IServerEnvironmentService),_e(5,n.IProductService),_e(6,o.ILogService),_e(7,r.IInstantiationService)],se),e.RemoteExtensionHostAgentServer=se;async function _(te,j,he){const J=await(0,m.determineServerConnectionToken)(j);J instanceof m.ServerConnectionTokenParseError&&(console.warn(J.message),process.exit(1));const U=new R.DisposableStore,{socketServer:M,instantiationService:B}=await(0,F.setupServerServices)(J,j,he,U);B.invokeFunction(x=>{const ne=x.get(o.ILogService);(0,E.setUnexpectedErrorHandler)(ue=>{ue&&ue.code==="EPIPE"&&ue.syscall==="write"&&ue.stack&&/unexpectedErrorHandler/.test(ue.stack)||ne.error(ue)}),process.on("SIGPIPE",()=>{(0,E.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),B.invokeFunction(x=>{const ne=x.get(o.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const ue=(0,v.join)(process.env.HOMEDRIVE,"node_modules"),pe=(0,v.dirname)((0,v.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),W=(0,v.join)(pe,"node_modules");if(t.existsSync(ue)||t.existsSync(W)){const Z=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${ue}
* ${W}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;ne.warn(Z),console.warn(Z),process.exit(0)}}});const Q=B.invokeFunction(x=>{const ne=x.get(o.ILogService);if(t.existsSync((0,v.join)(w.FileAccess.asFileUri("",oe).fsPath,"../node_modules/vsda")))try{return oe.__$__nodeRequire("vsda")}catch(pe){ne.error(pe)}return null}),ae=t.existsSync(w.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",oe).fsPath);if(ae&&te&&typeof te!="string"){const x=J.type!==0?`?${w.connectionTokenQueryName}=${J.value}`:"";console.log(`Web UI available at http://localhost${te.port===80?"":`:${te.port}`}/${x}`)}const fe=B.createInstance(se,M,J,Q,ae);h.mark("code/server/ready");const X=C.performance.now(),re=global.vscodeServerStartTime,L=global.vscodeServerListenTime,O=global.vscodeServerCodeLoadedTime;if(B.invokeFunction(x=>{x.get(s.ITelemetryService).publicLog2("serverStart",{startTime:re,startedTime:L,codeLoadedTime:O,readyTime:X})}),j["print-startup-performance"]){const x=S.LoaderStats.get();let ne="";ne+=`

### Load AMD-module
`,ne+=S.LoaderStats.toMarkdownTable(["Module","Duration"],x.amdLoad),ne+=`

### Load commonjs-module
`,ne+=S.LoaderStats.toMarkdownTable(["Module","Duration"],x.nodeRequire),ne+=`

### Invoke AMD-module factory
`,ne+=S.LoaderStats.toMarkdownTable(["Module","Duration"],x.amdInvoke),ne+=`

### Invoke commonjs-module
`,ne+=S.LoaderStats.toMarkdownTable(["Module","Duration"],x.nodeEval),ne+=`Start-up time: ${L-re}
`,ne+=`Code loading time: ${O-re}
`,ne+=`Initialized time: ${X-re}
`,ne+=`
`,console.log(ne)}return fe}e.createServer=_;class G{constructor(j){this._originRegExp=j}static create(j){const he=j.webEndpointUrlTemplate,J=j.commit,U=j.quality;if(!he||!J||!U)return new G(null);const M=(0,g.generateUuid)(),Q=new URL(he.replace("{{uuid}}",M).replace("{{commit}}",J).replace("{{quality}}",U)).origin,ae=(0,y.escapeRegExpCharacters)(Q).replace(M,"[a-zA-Z0-9\\-]+");try{const fe=(0,y.createRegExp)(`^${ae}$`,!0,{matchCase:!1});return new G(fe)}catch{return new G(null)}}matches(j){return this._originRegExp?this._originRegExp.test(j):!1}}}),define(ve[274],we([0,1,28,30,8,262,264,58,6,265,40,51,47]),function(oe,e,b,t,D,C,k,S,p,E,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,w.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=E.performance.now();const v={onMultipleValues:(g,c)=>{console.error(`Option '${g}' can only be defined once. Using value ${c}.`)},onEmptyValue:g=>{console.error(`Ignoring option '${g}': Value must not be empty.`)},onUnknownOption:g=>{console.error(`Ignoring option '${g}': not supported for server.`)},onDeprecatedOption:(g,c)=>{console.warn(`Option '${g}' is deprecated: ${c}`)}};function h(){return(0,S.parseArgs)(process.argv.slice(2),T.serverOptions,v)}function I(g){const c=g["server-data-dir"]||g["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,p.join)(b.homedir(),R.default.serverDataFolderName||".vscode-remote"),l=g["user-data-dir"]||(0,p.join)(c,"data"),f=(0,p.join)(l,"User"),r=(0,p.join)(f,"globalStorage"),o=(0,p.join)(f,"History"),n=(0,p.join)(l,"Machine");g["user-data-dir"]=l;const i=(0,p.dirname)(D.FileAccess.asFileUri("",oe).fsPath),s=g["builtin-extensions-dir"]||(0,p.join)(i,"extensions");return g["builtin-extensions-dir"]=s,g["extensions-dir"]=g["extensions-dir"]||(0,p.join)(c,"extensions"),[c,g["extensions-dir"],l,f,n,r,o].forEach(a=>{try{t.existsSync(a)||t.mkdirSync(a,{mode:448})}catch(u){console.error(u)}}),c}function y(g=h()){return(0,C.run)(g,I(g),T.serverOptions)}e.spawnCli=y;function d(g,c=h()){return(0,k.createServer)(g,c,I(c))}e.createServer=d})}).call(this);

//# sourceMappingURL=server.main.js.map
